/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Bubble/index.ts
var Bubble_exports = {};
__export(Bubble_exports, {
  computeVizProps: () => computeVizProps,
  config: () => config_default,
  default: () => Bubble_default,
  themes: () => themes3
});
module.exports = __toCommonJS(Bubble_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport2 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-color-palettes
var visualization_color_palettes_exports = {};
__export(visualization_color_palettes_exports, {
  default: () => visualization_color_palettes_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-color-palettes"));
__reExport(visualization_color_palettes_exports, require("@splunk/visualization-color-palettes"));
var visualization_color_palettes_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport4 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport5 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:react-event-listener
var react_event_listener_exports = {};
__export(react_event_listener_exports, {
  default: () => react_event_listener_default
});
var defaultImport6 = __toESM(require("react-event-listener"));
__reExport(react_event_listener_exports, require("react-event-listener"));
var react_event_listener_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualizations-shared/i18n
var i18n_exports2 = {};
__export(i18n_exports2, {
  default: () => i18n_default2
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/i18n"));
__reExport(i18n_exports2, require("@splunk/visualizations-shared/i18n"));
var i18n_default2 = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/charting-bundle
var charting_bundle_exports = {};
__export(charting_bundle_exports, {
  default: () => charting_bundle_default
});
var defaultImport8 = __toESM(require("@splunk/charting-bundle"));
__reExport(charting_bundle_exports, require("@splunk/charting-bundle"));
var charting_bundle_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport9 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport10 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport11 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/themes/useSplunkTheme
var useSplunkTheme_exports = {};
__export(useSplunkTheme_exports, {
  default: () => useSplunkTheme_default
});
var defaultImport13 = __toESM(require("@splunk/themes/useSplunkTheme"));
__reExport(useSplunkTheme_exports, require("@splunk/themes/useSplunkTheme"));
var useSplunkTheme_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/visualizations-shared/themeUtils
var themeUtils_exports = {};
__export(themeUtils_exports, {
  default: () => themeUtils_default
});
var defaultImport14 = __toESM(require("@splunk/visualizations-shared/themeUtils"));
__reExport(themeUtils_exports, require("@splunk/visualizations-shared/themeUtils"));
var themeUtils_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport15 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/common/ChartingApi.ts
var ChartingApiFunctional = class {
  // eslint-disable-next-line no-useless-constructor
  constructor(chartRef) {
    this.chartRef = chartRef;
  }
  /**
   * Allows users to programmatically highlight a point on the chart
   *
   * @memberof ChartingApiFunctional
   */
  highlight({ xValue, seriesName } = { xValue: "", seriesName: "" }) {
    this.getChart().highlight(xValue, seriesName);
  }
  /**
   * Allows users to programmatically unhighlight all points on the chart
   *
   * @memberof ChartingApiFunctional
   */
  unHighlight() {
    this.getChart().unHighlight();
  }
  // returns chart object
  getChart() {
    var _a;
    return (_a = this.chartRef) == null ? void 0 : _a.current;
  }
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useEventCallback.tsx
var useEventCallback = (fn) => {
  const ref = (0, react_exports.useRef)(fn);
  (0, react_exports.useLayoutEffect)(() => {
    ref.current = fn;
  });
  return (0, react_exports.useCallback)((...args) => ref.current(...args), []);
};
var useEventCallback_default = useEventCallback;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport16 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/utils/dataUtils.ts
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var calculateThresholdOnRangeSelect = ({
  firstIndex,
  lastIndex,
  dataSources,
  width
}) => {
  var _a, _b, _c;
  const window2 = lastIndex - firstIndex + 1;
  const ratio = Math.round(Number(((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns[0]) == null ? void 0 : _c.length) / window2) * 10) / 10;
  return Math.round(ratio * Number(width));
};
var calculateDownsamplingThreshold = ({
  enableSearchZoom,
  dataSources,
  selectChartEvent,
  width,
  xField
}) => {
  var _a, _b, _c;
  if (enableSearchZoom || !selectChartEvent) {
    return Number(width);
  }
  const primaryDataSource = dataSources == null ? void 0 : dataSources.primary;
  if (!primaryDataSource) {
    return null;
  }
  const { startXIndex, endXIndex, currentTarget } = selectChartEvent;
  try {
    const xFieldIndex = (_a = primaryDataSource == null ? void 0 : primaryDataSource.data) == null ? void 0 : _a.fields.findIndex((field) => {
      const name = typeof field === "string" ? field : field.name;
      return name === xField;
    });
    const downsampledXFieldIndex = (_b = currentTarget.dataSet) == null ? void 0 : _b.fields.findIndex((field) => field === xField);
    if (xFieldIndex === -1 || downsampledXFieldIndex === -1) {
      return null;
    }
    const fullSeries = (_c = primaryDataSource == null ? void 0 : primaryDataSource.data) == null ? void 0 : _c.columns[xFieldIndex];
    const downsampledSeries = currentTarget.dataSet.seriesList[downsampledXFieldIndex];
    const firstIndex = fullSeries.findIndex((x) => {
      return downsampledSeries[startXIndex] === x;
    });
    const lastIndex = fullSeries.findIndex((x) => {
      return downsampledSeries[endXIndex] === x;
    });
    if (firstIndex >= 0 && lastIndex >= 0 && firstIndex <= lastIndex) {
      return calculateThresholdOnRangeSelect({
        firstIndex,
        lastIndex,
        dataSources,
        width
      });
    }
  } catch (e) {
    console.error("Error occurred while setting downsample threshold on range select event", e);
  }
  return null;
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport17 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// src/common/hooks/useTrellisEnabled.ts
var useTrellisFeatureFlagOn = () => {
  const context = (0, react_exports.useContext)(FeatureFlagContext_default);
  return Boolean(context == null ? void 0 : context.visualizations_enableTrellis);
};
var useTrellisEnabled = (layoutType = visualization_schemas_exports.LAYOUT_TYPE.Off) => {
  const trellisFeatureEnabled = useTrellisFeatureFlagOn();
  return trellisFeatureEnabled && layoutType === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};

// src/common/components/TrellisTitle.tsx
var TRELLIS_TITLE_HEIGHT = 28;
var TrellisTitleText = styled_components_default.div`
    margin-left: 10px;
    margin-right: 10px;
    padding-top: 8px;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
`;
var TrellisTitleDiv = styled_components_default.div`
    height: ${TRELLIS_TITLE_HEIGHT}px;
    font-size: 14px;
    font-weight: 700;
    color: ${(props) => props.fontColor};
    background-color: ${(props) => props.backgroundColor};
    box-shadow: 0 1px ${(props) => props.backgroundColor}; // this is added to avoid a 1px gap between title and viz divs that showed up intermittently because of pixel rounding error in chrome.
`;
var TrellisTitle = (props) => {
  const titleText = String(props.trellisKey).toString();
  return /* @__PURE__ */ react_exports.createElement(
    TrellisTitleDiv,
    {
      fontColor: props.fontColor,
      backgroundColor: props.backgroundColor,
      "data-test": "trellis-title",
      title: titleText
    },
    /* @__PURE__ */ react_exports.createElement(TrellisTitleText, null, titleText)
  );
};

// src/common/Charting.tsx
var NO_INPLACE_PROPS = [
  "chart",
  "chart.orientation",
  "layout.splitSeries",
  "chart.style",
  "legend.placement"
];
var appendTrellisToPayload = (props, payload) => {
  if (props.trellisSplitBy) {
    payload["trellis.name"] = props.trellisSplitBy;
  }
  if (props.trellisKey) {
    payload["trellis.value"] = props.trellisKey;
  }
  return payload;
};
var changedOptions = (curOptions, nextOptions) => Object.keys(curOptions).filter((key) => !(key in nextOptions)).concat(
  Object.keys(nextOptions).filter(
    (key) => !(key in curOptions) || curOptions[key] !== nextOptions[key]
  )
);
var canUpdateInPlace = (curOptions, nextOptions) => {
  if (!curOptions || !nextOptions) {
    return false;
  }
  return !NO_INPLACE_PROPS.some((p) => curOptions[p] !== nextOptions[p]) && !changedOptions(curOptions, nextOptions).some((p) => p.toLowerCase().endsWith("color"));
};
var updateRowPayload = (chartEventRowContext, payload) => {
  Object.keys(chartEventRowContext || {}).forEach((key) => {
    payload[`${key}.value`] = chartEventRowContext[key];
  });
  return payload;
};
var ChartingContainer = styled_components_default.div.attrs((props) => ({
  "data-test": "charting-container",
  width: props.width,
  height: props.height
}))`
    & .highcharts-a11y-proxy-container {
        pointer-events: none;
    }
    overflow: hidden;
    position: relative;
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
`;
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  options: prop_types_exports.object,
  chartData: prop_types_exports.object,
  onEventTrigger: prop_types_exports.func,
  onClick: prop_types_exports.func,
  onSelect: prop_types_exports.func,
  onPointMouseOver: prop_types_exports.func,
  onPointMouseOut: prop_types_exports.func,
  style: prop_types_exports.object,
  colorPalette: prop_types_exports.array,
  visualizationApiRef: prop_types_exports.func,
  themeKey: prop_types_exports.string,
  originalDataSources: prop_types_exports.object,
  onDownsamplingThresholdChange: prop_types_exports.func,
  xField: prop_types_exports.string,
  y2Fields: prop_types_exports.array,
  additionalTooltipFields: prop_types_exports.array,
  splitByLayout: prop_types_exports.oneOf(Object.values(visualization_schemas_exports.LAYOUT_TYPE)),
  trellisKey: prop_types_exports.string,
  trellisSplitBy: prop_types_exports.string,
  backgroundColor: prop_types_exports.string,
  defaultFontColor: prop_types_exports.string
};
var Charting = (props) => {
  var _a, _b;
  const container = (0, react_exports.useRef)(null);
  const needsInit = (0, react_exports.useRef)(true);
  const chart = (0, react_exports.useRef)();
  const needsRedraw = (0, react_exports.useRef)(true);
  const api = (0, react_exports.useRef)(new ChartingApiFunctional(chart));
  const timezone = (0, react_exports.useContext)(TimezoneContext_default);
  const selectChartEvent = (0, react_exports.useRef)(null);
  const trellisEnabled = useTrellisEnabled(props.splitByLayout);
  const computeChartingSize = () => {
    if (container.current) {
      const rect = container.current.getBoundingClientRect();
      return {
        height: rect.height,
        width: rect.width
      };
    }
    return {};
  };
  const splunkTheme = useSplunkTheme_default();
  const themeKey = props.themeKey ? props.themeKey : (0, themeUtils_exports.getChartingThemeKey)({ splunkThemeV1: splunkTheme });
  const {
    width,
    height,
    style,
    chartData,
    options,
    colorPalette,
    onClick,
    onSelect,
    onPointMouseOut,
    onPointMouseOver,
    onEventTrigger,
    originalDataSources,
    onDownsamplingThresholdChange,
    xField,
    backgroundColor,
    defaultFontColor,
    trellisKey,
    additionalTooltipFields
  } = props;
  const prevOptions = usePrevious(options);
  const prevTimezone = usePrevious(timezone);
  const handleClick = (chartEvent, type) => {
    let payload = (0, lodash_exports.pick)(
      chartEvent,
      "name2",
      "value2",
      "_span",
      "modifierKey"
    );
    payload.name = payload.name2;
    delete payload.name2;
    if (type === "point.click" /* POINT_CLICK */) {
      payload.value = payload.value2;
      delete payload.value2;
      payload = updateRowPayload(chartEvent.rowContext, payload);
    }
    payload = appendTrellisToPayload(props, payload);
    onClick({
      type,
      originalEvent: chartEvent,
      payload
    });
  };
  const destroyChart = () => {
    if (chart.current) {
      chart.current.destroy();
      chart.current = null;
    }
    needsRedraw.current = true;
    needsInit.current = true;
  };
  const enableSearchZoom = (_b = (_a = chartData == null ? void 0 : chartData.chartDataOptions) == null ? void 0 : _a.enableSearchZoom) != null ? _b : false;
  const recalculateDownsamplingThreshold = react_exports.useCallback(() => {
    if (!onDownsamplingThresholdChange || !xField) {
      return;
    }
    const newThreshold = calculateDownsamplingThreshold({
      enableSearchZoom,
      dataSources: originalDataSources,
      width: Number(width),
      selectChartEvent: selectChartEvent.current,
      xField
    });
    if (Number.isFinite(newThreshold)) {
      onDownsamplingThresholdChange(newThreshold);
    }
  }, [enableSearchZoom, originalDataSources, onDownsamplingThresholdChange, width, xField]);
  react_exports.useEffect(() => {
    recalculateDownsamplingThreshold();
  }, [recalculateDownsamplingThreshold]);
  const handleSelect = useEventCallback_default((chartEvent) => {
    selectChartEvent.current = chartEvent;
    recalculateDownsamplingThreshold();
    const payload = appendTrellisToPayload(
      props,
      (0, lodash_exports.pick)(chartEvent, "startXIndex", "endXIndex", "startXValue", "endXValue")
    );
    if (onSelect && typeof onSelect === "function") {
      onSelect({
        type: "range.select",
        originalEvent: chartEvent,
        payload
      });
      return;
    }
    onEventTrigger({
      type: "range.select",
      originalEvent: chartEvent,
      payload
    });
  });
  const handlePointMouseOut = useEventCallback_default(
    (chartEvent, type) => {
      let payload = (0, lodash_exports.pick)(
        chartEvent,
        "name2",
        "value2",
        "_span",
        "modifierKey",
        "tooltipContext"
      );
      payload.name = payload.name2;
      delete payload.name2;
      payload.value = payload.value2;
      delete payload.value2;
      payload = appendTrellisToPayload(props, updateRowPayload(chartEvent.rowContext, payload));
      onPointMouseOut({
        type,
        originalEvent: chartEvent,
        payload
      });
    }
  );
  const handlePointMouseOver = useEventCallback_default(
    (chartEvent, type) => {
      let payload = (0, lodash_exports.pick)(
        chartEvent,
        "name2",
        "value2",
        "_span",
        "modifierKey",
        "tooltipContext"
      );
      payload.name = payload.name2;
      delete payload.name2;
      payload.value = payload.value2;
      delete payload.value2;
      payload = appendTrellisToPayload(props, updateRowPayload(chartEvent.rowContext, payload));
      onPointMouseOver({
        type,
        originalEvent: chartEvent,
        payload
      });
    }
  );
  const drawChart = () => {
    const updatedOptions = __spreadProps(__spreadValues({}, options), { shouldColorizeTooltipData: false });
    const computedChartSize = computeChartingSize();
    const computedWidth = computedChartSize.width;
    const computedHeight = computedChartSize.height;
    const serializedTimezone = timezone == null ? void 0 : timezone.serializedTimezone;
    const ianaTimezone = timezone == null ? void 0 : timezone.ianaTimezone;
    const utcOffset = timezone == null ? void 0 : timezone.utcOffset;
    if (!computedWidth || !computedHeight) {
      return;
    }
    if (!chartData || !Object.keys(chartData).length) {
      return;
    }
    if (prevOptions) {
      Object.keys(prevOptions).forEach((key) => {
        if (prevOptions[key] && updatedOptions[key] === void 0) {
          updatedOptions[key] = "";
        }
      });
    }
    try {
      if (needsInit.current) {
        destroyChart();
        charting_bundle_default.setTheme(themeKey);
        if (colorPalette.length > 0) {
          charting_bundle_default.setColorPalette(colorPalette);
        }
        chart.current = charting_bundle_default.createChart(container.current, __spreadValues(__spreadValues(__spreadValues(__spreadProps(__spreadValues({}, updatedOptions), {
          drilldown: "all"
        }), typeof serializedTimezone === "string" && {
          "time.serializedTz": serializedTimezone
        }), typeof ianaTimezone === "string" && {
          "time.ianaTimezone": ianaTimezone
        }), typeof utcOffset === "number" && {
          "time.timezoneOffset": utcOffset
        }));
        chart.current.on("pointClick", (e) => {
          handleClick(e, "point.click" /* POINT_CLICK */);
        });
        chart.current.on("pointMouseOver", (e) => {
          handlePointMouseOver(e, "point.mouseover" /* POINT_MOUSE_OVER */);
        });
        chart.current.on("pointMouseOut", (e) => {
          handlePointMouseOut(e, "point.mouseout" /* POINT_MOUSE_OUT */);
        });
        chart.current.on("legendClick", (e) => {
          handleClick(e, "legend.click" /* LEGEND_CLICK */);
        });
        chart.current.on("chartRangeSelect", handleSelect);
      }
      if (needsRedraw.current) {
        charting_bundle_default.setTheme(themeKey);
        if (colorPalette.length > 0) {
          charting_bundle_default.setColorPalette(colorPalette);
        }
        const payload = appendTrellisToPayload(props, {
          width,
          height,
          currentTime: (/* @__PURE__ */ new Date()).getTime()
        });
        chart.current.prepareAndDraw(chartData, updatedOptions, () => {
          onEventTrigger({
            type: "viz.renderedWithData",
            payload
          });
        });
      }
      if (chart.current) {
        if (Math.round(chart.current.height) !== Math.round(computedHeight) || Math.round(chart.current.width) !== Math.round(computedWidth)) {
          chart.current.resize(computedWidth, computedHeight);
        }
      }
      needsInit.current = false;
      needsRedraw.current = false;
    } catch (e) {
      window.console.error("Caught error rendering chart:", e);
    }
  };
  const debouncedDrawChart = (0, lodash_exports.debounce)(drawChart, 5);
  const onContainerMount = (chartingContainer) => {
    container.current = chartingContainer;
    debouncedDrawChart();
  };
  const prevTheme = usePrevious(themeKey);
  const prevOnClick = usePrevious(onClick);
  (0, react_exports.useEffect)(() => {
    debouncedDrawChart();
    props.visualizationApiRef(api.current);
    return () => {
      props.visualizationApiRef(null);
      destroyChart();
    };
  }, []);
  (0, react_exports.useEffect)(() => {
    if (!chart.current || !canUpdateInPlace(prevOptions, options) || // timezone is a simple object so this comparison should be fast
    JSON.stringify(prevTimezone) !== JSON.stringify(timezone) || !props.themeKey && prevTheme !== themeKey || prevOnClick !== onClick) {
      needsInit.current = true;
    }
    needsRedraw.current = true;
    drawChart();
  }, [
    JSON.stringify(options),
    JSON.stringify(chartData.toJSON()),
    JSON.stringify(chartData.annotations),
    timezone == null ? void 0 : timezone.ianaTimezone,
    timezone == null ? void 0 : timezone.utcOffset,
    timezone == null ? void 0 : timezone.serializedTimezone,
    themeKey,
    onClick,
    additionalTooltipFields
  ]);
  return /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, trellisEnabled && /* @__PURE__ */ react_exports.createElement(
    TrellisTitle,
    {
      trellisKey,
      backgroundColor,
      fontColor: defaultFontColor
    }
  ), /* @__PURE__ */ react_exports.createElement(
    ChartingContainer,
    {
      style,
      ref: onContainerMount,
      width,
      height: trellisEnabled ? Number(height) - TRELLIS_TITLE_HEIGHT : height
    },
    /* @__PURE__ */ react_exports.createElement(react_event_listener_default, { target: window, onResize: debouncedDrawChart })
  ));
};
var defaultProps = {
  width: "100%",
  height: 250,
  options: {},
  style: {},
  // todo: need remove it
  onEventTrigger: lodash_exports.noop,
  onClick: lodash_exports.noop,
  onSelect: lodash_exports.noop,
  onPointMouseOver: lodash_exports.noop,
  onPointMouseOut: lodash_exports.noop,
  colorPalette: visualization_color_palettes_exports.VIZ_CATEGORICAL,
  visualizationApiRef: lodash_exports.noop,
  chartData: null,
  themeKey: null,
  onDownsamplingThresholdChange: null,
  originalDataSources: null,
  xField: null,
  y2Fields: [],
  splitByLayout: void 0,
  trellisKey: void 0,
  trellisSplitBy: void 0,
  backgroundColor: "",
  defaultFontColor: "",
  additionalTooltipFields: []
};
Charting.propTypes = propTypes;
Charting.defaultProps = defaultProps;
var ChartingWrapper = (props) => {
  const { chartData } = props;
  if (!chartData) {
    return /* @__PURE__ */ react_exports.createElement(Message_default, { message: (0, i18n_exports._)("No DataSource"), level: "warning" });
  }
  if (!Object.keys(chartData).length) {
    return /* @__PURE__ */ react_exports.createElement(Message_default, { message: (0, i18n_exports._)("No Result"), level: "info" });
  }
  return /* @__PURE__ */ react_exports.createElement(Charting, __spreadValues({}, props));
};
ChartingWrapper.propTypes = propTypes;
ChartingWrapper.defaultProps = defaultProps;
var Charting_default = ChartingWrapper;

// esm-externals:@splunk/visualizations-shared/simpleXMLOptions
var simpleXMLOptions_exports = {};
__export(simpleXMLOptions_exports, {
  default: () => simpleXMLOptions_default
});
var defaultImport18 = __toESM(require("@splunk/visualizations-shared/simpleXMLOptions"));
__reExport(simpleXMLOptions_exports, require("@splunk/visualizations-shared/simpleXMLOptions"));
var simpleXMLOptions_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport19 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport20 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport21 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport22 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport23 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}
var insertLayout = (layout, index, ...layoutItems) => [
  // copy part of the array before the specified index
  ...layout.slice(0, index),
  // inserted layout item
  ...layoutItems,
  // copy part of the array after the specified index
  ...layout.slice(index)
];

// src/common/editorConfig/AxesChartDataConfig.ts
var isTrellisFeatureFlagOn = ({ featureFlags }) => {
  return Boolean(featureFlags == null ? void 0 : featureFlags.visualizations_enableTrellis);
};
var isTrellisEnabled = ({ options, featureFlags }) => {
  const { splitByLayout = visualization_schemas_exports.LAYOUT_TYPE.Off } = options;
  return isTrellisFeatureFlagOn({ featureFlags }) && splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};
var AxesChartDataConfig = {
  label: (0, i18n_exports._)("Data configurations"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("X"),
        option: "x",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Y"),
        option: "y",
        editor: "editor.columnMultiSelector",
        editorProps: {
          dataSourceKey: "primary",
          filterByTypes: ["number"],
          supportsDSL: true,
          expectedDataPrimitive: ["series", "frame"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Additional tooltip fields"),
        option: "additionalTooltipFields",
        editor: "editor.columnMultiSelectionByFieldNameEditor"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Result limit"),
        option: "resultLimit",
        editor: "editor.number",
        editorProps: {
          dataSourceKey: "primary"
        }
      }
    ]
  ]
};
var AxesChartDataConfigBar = {
  label: AxesChartDataConfig.label,
  // insert Y2 after Y
  layout: insertLayout(AxesChartDataConfig.layout, 2, [
    {
      label: (0, i18n_exports._)("Y2"),
      option: "y2",
      editor: "editor.columnMultiSelector",
      editorProps: {
        dataSourceKey: "primary",
        filterByTypes: ["number"],
        supportsDSL: true,
        expectedDataPrimitive: ["series", "frame"]
      },
      isDisabled: isTrellisEnabled
    }
  ])
};
var AxesChartDataConfigScatter = {
  label: AxesChartDataConfig.label,
  layout: [
    [
      {
        label: (0, i18n_exports._)("X"),
        option: "x",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Y"),
        option: "y",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          filterByTypes: ["number"],
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Category"),
        option: "category",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Result limit"),
        option: "resultLimit",
        editor: "editor.number",
        editorProps: {
          dataSourceKey: "primary"
        }
      }
    ]
  ]
};
var AxesChartDataConfigBubble = {
  label: AxesChartDataConfigScatter.label,
  // layout: insert Size after Category
  layout: insertLayout(AxesChartDataConfigScatter.layout, 3, [
    {
      label: (0, i18n_exports._)("Size"),
      option: "size",
      editor: "editor.columnSelector",
      editorProps: {
        dataSourceKey: "primary",
        supportsDSL: true,
        expectedDataPrimitive: ["series"]
      }
    }
  ])
};
var AxesChartDataConfigAreaColumnLine = {
  label: AxesChartDataConfigBar.label,
  layout: [
    ...AxesChartDataConfigBar.layout,
    [
      {
        label: (0, i18n_exports._)("Annotation x"),
        option: "annotationX",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "annotation",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Annotation labels"),
        option: "annotationLabel",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "annotation",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ]
  ]
};

// src/common/editorConfig/AxesChartXGridAndLabels.ts
var AxesChartXGridAndLabelsCommon = {
  label: (0, i18n_exports._)("X-axis grid and labels"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("Axis title"),
        option: "xAxisTitleVisibility",
        editor: "editor.toggle"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis title text"),
        option: "xAxisTitleText",
        editor: "editor.text",
        showEditor: ({ options }) => options.xAxisTitleVisibility === "show" || options.xAxisTitleVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Label visibility"),
        option: "xAxisLabelVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ]
  ]
};
var AxesChartXGridAndLabels = {
  label: AxesChartXGridAndLabelsCommon.label,
  layout: [
    ...AxesChartXGridAndLabelsCommon.layout,
    [
      {
        label: (0, i18n_exports._)("Label rotation"),
        option: "xAxisLabelRotation",
        editor: "editor.select",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("-90"), value: -90 },
            { label: (0, i18n_exports._)("-45"), value: -45 },
            { label: (0, i18n_exports._)("0"), value: 0 },
            { label: (0, i18n_exports._)("45"), value: 45 },
            { label: (0, i18n_exports._)("90"), value: 90 }
          ]
        },
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Number of time label parts"),
        option: "xAxisMaxLabelParts",
        editor: "editor.number",
        editorProps: {
          min: 1,
          max: 3
        },
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis line visibility"),
        option: "xAxisLineVisibility",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major gridlines"),
        option: "showXMajorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick visibility"),
        option: "xAxisMajorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick size (px)"),
        option: "xAxisMajorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.xAxisMajorTickVisibility === "show" || options.xAxisMajorTickVisibility === "auto" || options.xAxisMajorTickVisibility === void 0
      }
    ]
  ]
};
var AxesChartXGridAndLabelsBubbleScatter = {
  label: AxesChartXGridAndLabelsCommon.label,
  layout: [
    ...insertLayout(AxesChartXGridAndLabelsCommon.layout, 2, [
      {
        label: (0, i18n_exports._)("Axis scale"),
        option: "xAxisScale",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Linear"), value: "linear" },
            { label: (0, i18n_exports._)("Log"), value: "log" }
          ]
        }
      }
    ]),
    [
      {
        label: (0, i18n_exports._)("Label rotation"),
        option: "xAxisLabelRotation",
        editor: "editor.select",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("-90"), value: -90 },
            { label: (0, i18n_exports._)("-45"), value: -45 },
            { label: (0, i18n_exports._)("0"), value: 0 },
            { label: (0, i18n_exports._)("45"), value: 45 },
            { label: (0, i18n_exports._)("90"), value: 90 }
          ]
        },
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Round axis labels"),
        option: "showRoundedXAxisLabels",
        editor: "editor.checkbox",
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("SI prefix abbreviation for labels"),
        option: "xAxisAbbreviation",
        editor: "editor.checkbox",
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Include zero"),
        option: "showXAxisWithZero",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Extend to whole grid"),
        option: "showXAxisExtendedRange",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minimum axis value"),
        option: "xAxisMin",
        editor: "editor.number"
      },
      {
        label: (0, i18n_exports._)("Maximum axis value"),
        option: "xAxisMax",
        editor: "editor.number"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis line visibility"),
        option: "xAxisLineVisibility",
        editor: "editor.checkbox"
      }
    ],
    // this option is disabled for bubble and scatter
    // [
    //     {
    //         label: _('Major gridlines'),
    //         option: 'showXMajorGridLines',
    //         editor: 'editor.checkbox',
    //     },
    // ],
    [
      {
        label: (0, i18n_exports._)("Major tick visibility"),
        option: "xAxisMajorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick size (px)"),
        option: "xAxisMajorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.xAxisMajorTickVisibility === "show" || options.xAxisMajorTickVisibility === "auto" || options.xAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick interval spacing"),
        option: "xAxisMajorTickInterval",
        editor: "editor.number",
        showEditor: ({ options }) => options.xAxisMajorTickVisibility === "show" || options.xAxisMajorTickVisibility === "auto" || options.xAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor gridlines"),
        option: "showXMinorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick visibility"),
        option: "xAxisMinorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick size (px)"),
        option: "xAxisMinorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.xAxisMinorTickVisibility === "show" || options.xAxisMinorTickVisibility === "auto" || options.xAxisMinorTickVisibility === void 0
      }
    ]
  ]
};

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes4,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes4
    }
  }
];
var BackgroundColor_default = background;

// src/common/editorConfig/TrellisEditors.ts
var isTrellisFeatureFlagOn2 = ({ featureFlags }) => {
  return Boolean(featureFlags == null ? void 0 : featureFlags.visualizations_enableTrellis);
};
var isTrellisEnabled2 = ({ options, featureFlags }) => {
  const { splitByLayout = visualization_schemas_exports.LAYOUT_TYPE.Off } = options;
  return isTrellisFeatureFlagOn2({ featureFlags }) && splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};
var TrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Split by"),
      option: "trellisSplitBy",
      editor: "editor.trellisSplitBy",
      editorProps: {
        dataSourceKey: "primary"
      },
      showEditor: isTrellisEnabled2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Number of columns"),
      option: "trellisColumns",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      placeholder: (0, i18n_exports._)("Auto"),
      showEditor: isTrellisEnabled2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Min column width"),
      option: "trellisMinColumnWidth",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled2
    },
    {
      label: (0, i18n_exports._)("Row height"),
      option: "trellisRowHeight",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Max number of components per page"),
      option: "trellisPageCount",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled2
    }
  ]
];
var TimechartTrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn2,
      // add help text for timecharts
      editorProps: {
        help: (0, i18n_exports._)(
          "Y2-axis and overlay field configurations are not supported when trellis is enabled."
        ),
        helpFormat: "under"
      }
    }
  ],
  ...TrellisEditorConfig.slice(1),
  [
    {
      label: (0, i18n_exports._)("Shared y-axis scale"),
      option: "trellisSharedScale",
      editor: "editor.checkbox",
      showEditor: isTrellisEnabled2
    }
  ]
];
var TrellisBackgroundColorEditor = {
  label: (0, i18n_exports._)("Trellis background"),
  option: "trellisBackgroundColor",
  editor: "editor.color",
  showEditor: isTrellisEnabled2
};

// src/common/editorConfig/AxesChartColorAndStyle.ts
var themes = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props)
};
var AxesChartColorAndStyle = {
  label: (0, i18n_exports._)("Color and style"),
  layout: [
    BackgroundColor_default({ themes }),
    [
      {
        label: (0, i18n_exports._)("Series colors"),
        option: "seriesColors",
        editor: "editor.seriesColors"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Series colors by field name"),
        option: "seriesColorsByField",
        editor: "editor.seriesColorsByField"
      }
    ]
  ]
};
var AxesChartColorAndStyleWithTrellis = __spreadProps(__spreadValues({}, AxesChartColorAndStyle), {
  layout: [
    AxesChartColorAndStyle.layout[0],
    [
      __spreadProps(__spreadValues({}, TrellisBackgroundColorEditor), {
        editorProps: {
          themes
        }
      })
    ],
    ...AxesChartColorAndStyle.layout.slice(1)
  ]
});
var AxesChartColorAndStyle_default = AxesChartColorAndStyle;

// src/common/editorConfig/AxesChartLegend.ts
var AxesChartLegend = {
  label: (0, i18n_exports._)("Legend"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("Legend display"),
        option: "legendDisplay",
        editor: "editor.select",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Right"), value: "right" },
            { label: (0, i18n_exports._)("Left"), value: "left" },
            { label: (0, i18n_exports._)("Top"), value: "top" },
            { label: (0, i18n_exports._)("Bottom"), value: "bottom" },
            { label: (0, i18n_exports._)("Off"), value: "off" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Legend truncation"),
        option: "legendTruncation",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("A..."), value: "ellipsisEnd" },
            { label: (0, i18n_exports._)("A...Z"), value: "ellipsisMiddle" },
            { label: (0, i18n_exports._)("...Z"), value: "ellipsisStart" },
            { label: (0, i18n_exports._)("Off"), value: "ellipsisOff" }
          ]
        },
        showEditor: ({ options }) => options.legendDisplay === "left" || options.legendDisplay === "right" || options.legendDisplay === "top" || options.legendDisplay === "bottom" || options.legendDisplay === void 0
      }
    ]
  ]
};
var AxesChartLegend_default = AxesChartLegend;

// src/common/editorConfig/AxesChartYGridAndLabels.ts
var AxesChartYGridAndLabels = {
  label: (0, i18n_exports._)("Y-axis grid and labels"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("Axis title"),
        option: "yAxisTitleVisibility",
        editor: "editor.toggle"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis title text"),
        option: "yAxisTitleText",
        editor: "editor.text",
        showEditor: ({ options }) => options.yAxisTitleVisibility === "show" || options.yAxisTitleVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Scale"),
        option: "yAxisScale",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Linear"), value: "linear" },
            { label: (0, i18n_exports._)("Log"), value: "log" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Label visibility"),
        option: "yAxisLabelVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("SI prefix abbreviation for labels"),
        option: "yAxisAbbreviation",
        editor: "editor.checkbox",
        showEditor: ({ options }) => options.yAxisLabelVisibility === "show" || options.yAxisLabelVisibility === "auto" || options.yAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Include zero"),
        option: "showYAxisWithZero",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Extend to whole grid"),
        option: "showYAxisExtendedRange",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minimum axis value"),
        option: "yAxisMin",
        editor: "editor.number"
      },
      {
        label: (0, i18n_exports._)("Maximum axis value"),
        option: "yAxisMax",
        editor: "editor.number"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis line visibility"),
        option: "yAxisLineVisibility",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major gridlines"),
        option: "showYMajorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick visibility"),
        option: "yAxisMajorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick size (px)"),
        option: "yAxisMajorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.yAxisMajorTickVisibility === "show" || options.yAxisMajorTickVisibility === "auto" || options.yAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick interval spacing"),
        option: "yAxisMajorTickInterval",
        editor: "editor.number",
        showEditor: ({ options }) => options.yAxisMajorTickVisibility === "show" || options.yAxisMajorTickVisibility === "auto" || options.yAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor gridlines"),
        option: "showYMinorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick visibility"),
        option: "yAxisMinorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick size (px)"),
        option: "yAxisMinorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.yAxisMinorTickVisibility === "show" || options.yAxisMinorTickVisibility === "auto" || options.yAxisMinorTickVisibility === void 0
      }
    ]
  ]
};
var AxesChartYGridAndLabels_default = AxesChartYGridAndLabels;

// src/Bubble/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [
    // Note: SCP-14090 disable ui for optional datasources. We may need to add it back later
    // {
    //     name: 'annotation',
    //     description: 'DataSource that populates event annotations',
    // },
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {};
var themes2 = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props)
};
var editorConfig = [
  AxesChartDataConfigBubble,
  {
    label: AxesChartColorAndStyle_default.label,
    layout: [
      ...AxesChartColorAndStyle_default.layout.slice(0, 2),
      [
        {
          label: (0, i18n_exports._)("Series colors by category name"),
          option: "seriesColorsByField",
          editor: "editor.seriesColorsByField",
          editorProps: {
            isCategorical: true
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Maximum bubble size"),
          option: "bubbleSizeMax",
          editor: "editor.slider",
          editorProps: {
            min: 0,
            max: 200,
            step: 1
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Minimum bubble size"),
          option: "bubbleSizeMin",
          editor: "editor.slider",
          editorProps: {
            min: 0,
            max: 200,
            step: 1
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Calculation method for bubble size"),
          option: "bubbleSizeMethod",
          editor: "editor.radioBar",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Area"), value: "area" },
              { label: (0, i18n_exports._)("Diameter"), value: "diameter" }
            ]
          }
        }
      ]
    ]
  },
  AxesChartLegend_default,
  AxesChartXGridAndLabelsBubbleScatter,
  AxesChartYGridAndLabels_default
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.bubble",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Bubble"),
  category: "Correlation" /* CORRELATION */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Bubble,
  placeholderIcon: placeholders_exports.Bubble,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.bubbleOptionsSchema,
  editorConfig,
  events: {
    "legend.click": {
      description: "triggered when user clicks on chart legend"
    },
    "point.click": {
      description: "triggered when user clicks on a point in the bubble chart"
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "placeholder" /* PLACEHOLDER */, "events" /* EVENTS */],
  themes: themes2
};
var config_default = enhanceConfig(config);

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport24 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport25 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport26 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport27 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport28 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport29 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport30 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport31 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport32 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport33 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys, target) => keys.filter((k) => isMissing(target[k]));
var propTypes2 = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes2;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes3 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes3;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config: config2 } = Visualization;
  const { themes: themes4 } = config2;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes4 == null ? void 0 : themes4.defaultBackgroundColor) == null ? void 0 : _a.call(themes4, props);
    const icon = (_b = config2.placeholderIcon) != null ? _b : config2.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config2.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport34 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport35 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// src/common/utils/trellisUtils.ts
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn3 = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn3 && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:@splunk/visualizations-shared/propUtils
var propUtils_exports = {};
__export(propUtils_exports, {
  default: () => propUtils_default
});
var defaultImport36 = __toESM(require("@splunk/visualizations-shared/propUtils"));
__reExport(propUtils_exports, require("@splunk/visualizations-shared/propUtils"));
var propUtils_default = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// src/common/chartingUtils.ts
var truncateData = (dataSet, truncationLimit) => {
  if (!dataSet) {
    return null;
  }
  const limit = parseInt(truncationLimit, 10);
  if (!limit || limit <= 0) {
    return dataSet;
  }
  const truncatedData = __spreadValues({}, dataSet);
  truncatedData.columns = truncatedData.columns.map(
    (columnData) => columnData && Array.isArray(columnData) ? columnData.slice(0, limit) : columnData
  );
  return truncatedData;
};
var mapToValues = (optionValuesSCMapping) => (options) => {
  const convertedOptions = __spreadValues({}, options);
  Object.keys(optionValuesSCMapping).forEach((key) => {
    if ((0, lodash_exports.has)(options, key)) {
      const updatedValue = optionValuesSCMapping[key][options[key]];
      if (!(0, lodash_exports.isUndefined)(updatedValue)) {
        convertedOptions[key] = updatedValue;
      }
    }
  });
  return convertedOptions;
};

// src/Bubble/bubbleUtils.ts
var bubbleOptionsSCMapping = {
  xAxisLabelRotation: "xAxisMajorLabelRotation",
  xAxisLabelVisibility: "xAxisMajorLabelVisibility",
  yAxisLabelVisibility: "yAxisMajorLabelVisibility",
  showRoundedXAxisLabels: "roundXAxisLabelsToInteger",
  xAxisLineVisibility: "xAxisVisibility",
  yAxisLineVisibility: "yAxisVisibility",
  showYMajorGridLines: "showMajorYGridLines",
  showXMinorGridLines: "showMinorXGridLines",
  showYMinorGridLines: "showMinorYGridLines",
  xAxisMajorTickInterval: "xAxisMajorUnit",
  yAxisMajorTickInterval: "yAxisMajorUnit",
  showXAxisExtendedRange: "xAxisExtendsAxisRange",
  showYAxisExtendedRange: "yAxisExtendsAxisRange",
  showXAxisWithZero: "xAxisIncludeZero",
  showYAxisWithZero: "yAxisIncludeZero",
  legendTruncation: "legendLabelOverflowMode",
  legendDisplay: "legendPlacement",
  resultLimit: "resultTruncationLimit",
  seriesColorsByField: "fieldColors",
  bubbleSizeMax: "bubbleMaxSize",
  bubbleSizeMin: "bubbleMinSize",
  bubbleSizeMethod: "bubbleSizeBy"
};
var bubbleOptionValuesSCMapping = {
  xAxisTitleVisibility: {
    hide: "collapsed"
  },
  yAxisTitleVisibility: {
    hide: "collapsed"
  },
  yAxisAbbreviation: {
    off: "none"
  },
  legendPlacement: {
    off: "none"
  },
  legendLabelOverflowMode: {
    ellipsisOff: "ellipsisNone"
  }
};
var convertToStringValues = (options) => {
  const updatedOptions = (0, propUtils_exports.convertPropsToString)({
    vizProps: options,
    propNames: ["seriesColors", "fieldColors"]
  });
  return __spreadValues(__spreadValues({}, options), updatedOptions);
};
var mapToOldKey = (options) => (0, lodash_exports.mapKeys)(options, (val, key) => bubbleOptionsSCMapping[key] ? bubbleOptionsSCMapping[key] : key);
var convertToBubbleSCProperties = (originalOptions) => (0, lodash_exports.chain)(mapToOldKey(originalOptions)).thru(mapToValues(bubbleOptionValuesSCMapping)).thru(convertToStringValues).value();

// src/Bubble/Bubble.tsx
var validOptions = Object.keys(config_default.optionsSchema);
var computeVizProps = (_a) => {
  var _b = _a, {
    dataSources,
    onEventTrigger,
    visualizationApiRef,
    x = [],
    y = [],
    size: size2 = [],
    category,
    xField,
    yField,
    sizeField,
    categoryField
  } = _b, otherOptions = __objRest(_b, [
    "dataSources",
    "onEventTrigger",
    "visualizationApiRef",
    "x",
    "y",
    "size",
    "category",
    "xField",
    "yField",
    "sizeField",
    "categoryField"
  ]);
  const computedProps = { visualizationApiRef, onEventTrigger };
  const { hasEventHandlers } = otherOptions;
  computedProps.options = (0, lodash_exports.chain)(otherOptions).pick(validOptions).thru(convertToBubbleSCProperties).thru((options) => __spreadProps(__spreadValues({}, (0, simpleXMLOptions_exports.getSimpleXMLOptionsForProps)(options)), { chart: "bubble" })).value();
  let primaryData = __spreadValues({}, dataSources.primary.data);
  const columns = [x.map(String), y.map(String), size2.map(String)];
  const fields = [{ name: xField }, { name: yField }, { name: sizeField }];
  if (category && categoryField) {
    columns.unshift(category.map(String));
    fields.unshift({ name: categoryField });
  }
  primaryData.columns = columns;
  primaryData.fields = fields;
  const truncationLimit = computedProps.options["chart.resultTruncationLimit"];
  if (truncationLimit) {
    primaryData = truncateData(primaryData, truncationLimit);
  }
  computedProps.chartData = charting_bundle_default.extractChartReadyData(__spreadValues({}, primaryData));
  if (hasEventHandlers) {
    computedProps.onClick = (event) => {
      onEventTrigger(__spreadProps(__spreadValues({}, event), { payload: __spreadProps(__spreadValues({}, event.payload), { name: yField }) }));
    };
  }
  return computedProps;
};
var Bubble = withDashboardViz_default({
  ReactViz: Charting_default,
  computeVizProps,
  vizConfig: config_default
});
var themes3 = null;
var Bubble_default = Bubble;
//# sourceMappingURL=Bubble.js.map
