/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/ChoroplethSvg/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport2 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport3 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport4 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport5 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport7 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport8 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport9 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/StaticBackgroundColorEditor.js
var StaticBackgroundColorEditor = {
  label: (0, i18n_exports._)("Background color"),
  option: "backgroundColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.backgroundColor)
};
var StaticBackgroundColorEditor_default = StaticBackgroundColorEditor;

// src/ChoroplethSvg/config.ts
var dataContract = {
  requiredDataSources: [],
  optionalDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {
  areaColorsGradientConfig: { colors: ["#7EEFDA", "#6484F6", "#C093F9", "#293873"] },
  areaColorsRangeConfig: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ],
  areaColorsMatchConfig: [{ match: "", value: "#5C33FF" }]
};
var themes = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data configurations"),
    layout: [
      [
        {
          label: "Area IDs",
          editor: "editor.columnSelector",
          option: "areaIds",
          context: "areaIdContext",
          // todo: need refactor this
          editorProps: {
            dataSourceKey: "primary"
          }
        }
      ],
      [
        {
          label: "Area values",
          editor: "editor.columnSelector",
          option: "areaValues",
          context: "areaValuesContext",
          // todo: need refactor this
          editorProps: {
            dataSourceKey: "primary"
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Areas"),
          option: "areaColors",
          context: "defaultContext",
          editor: "editor.dynamicColor",
          editorProps: {
            labelPosition: "top",
            flyoutTitle: (0, i18n_exports._)("Dynamic coloring: value"),
            formatters: [
              {
                label: (0, i18n_exports._)("Ranges"),
                value: "rangeValue",
                isDefault: true,
                // show it by default when open dynamic color flyout
                defaults: {
                  areaValues: defaultContext.areaColorsRangeConfig
                }
              },
              {
                label: (0, i18n_exports._)("Matches"),
                value: "matchValue",
                defaults: {
                  areaValues: defaultContext.areaColorsMatchConfig
                }
              }
            ],
            dataSelectors: [
              {
                label: (0, i18n_exports._)("Value"),
                value: "areaValues"
              }
            ],
            defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig
          }
        }
      ],
      [
        __spreadProps(__spreadValues({}, StaticBackgroundColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("SVG content"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("SVG file"),
          option: "svg",
          editor: "editor.image",
          editorProps: {
            validMediaTypes: ["svg"],
            svgRenderAsDom: true
          }
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.choropleth.svg",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Choropleth SVG"),
  category: "Spatial" /* SPATIAL */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.ChoroplethSvg,
  placeholderIcon: placeholders_exports.ChoroplethSvg,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.choroplethSvgOptionsSchema,
  requiredProps: ["svg"],
  editorConfig,
  events: {
    "area.click": {
      description: "trigger when user clicks one area",
      payloadKeys: ["value", "name"]
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */],
  themes
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=ChoroplethSvg.config.js.map
