/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Events/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport4 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport5 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport6 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes2,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes2
    }
  }
];
var BackgroundColor_default = background;

// src/Events/config.ts
var defaultContext = {};
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [
    {
      name: "fieldsummary",
      description: "DataSource that powers the field summary popover on field click"
    }
  ],
  initialRequestParams: {
    primary: (options = {}) => {
      var _a;
      return {
        offset: 0,
        count: options.count ? options.count : 10,
        requestTotalCount: true,
        // this is needed for search-based event highlighting
        output_mode: "json",
        segmentation: (_a = options.highlightFromSource) != null ? _a : "none"
      };
    }
  }
};
var size = {
  initialWidth: 800,
  initialHeight: 500
};
var themes = {
  defaultBackgroundColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.black(props),
      light: themes_exports.variables.backgroundColor(props)
    },
    prisma: themes_exports.variables.backgroundColorSidebar(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Show field summary"),
          option: "showFieldSummary",
          editor: "editor.checkbox",
          editorProps: {
            labelPosition: "right"
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [BackgroundColor_default({ themes })]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.events",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Events"),
  category: "Table" /* TABLE */,
  status: "preview",
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Events,
  placeholderIcon: placeholders_exports.Events,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.eventsOptionsSchema,
  editorConfig,
  events: {
    "eventAction.<actionName>.click": {
      description: "Triggered when a user selects the Event Actions button within an event. An application developer can configure workflow action retrieval and event handling, as described in the Concepts tab."
    },
    "fieldAction.<actionName>.click": {
      description: "Triggered when a user selects an arrow under the Actions column heading. Application developers can configure workflow action retrieval and event handling. For more information, see the Concepts tab."
    },
    "events.search.<fieldSummaryReportActionName>": {
      description: "Triggered when a user selects a report action in the field summary of an event. Application developers must pass context and handle events in their applications. For more information, see the Concepts tab."
    },
    "value.click": {
      description: "Triggered when a user clicks a value in an event."
    },
    "time.click": {
      description: "Triggered when a user clicks to drilldown in the time controls popover."
    },
    "tag.click": {
      description: "Triggered when a user clicks a tag in an event."
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */],
  themes,
  requiredProps: []
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=Events.config.js.map
