/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Events/index.ts
var Events_exports = {};
__export(Events_exports, {
  PureEvents: () => PureEvents_default,
  computeVizProps: () => computeVizProps,
  config: () => config_default,
  default: () => Events_default,
  replaceTokens: () => replaceTokens,
  showPlaceHolderIcon: () => showPlaceHolderIcon,
  themes: () => themes2
});
module.exports = __toCommonJS(Events_exports);

// esm-externals:@splunk/visualizations-shared/dataSourceUtils
var dataSourceUtils_exports = {};
__export(dataSourceUtils_exports, {
  default: () => dataSourceUtils_default
});
var defaultImport = __toESM(require("@splunk/visualizations-shared/dataSourceUtils"));
__reExport(dataSourceUtils_exports, require("@splunk/visualizations-shared/dataSourceUtils"));
var dataSourceUtils_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport2 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport3 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport4 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport5 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport6 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport7 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport8 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport9 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport10 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport11 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport13 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport14 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport15 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport16 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport17 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport18 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport19 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport20 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys, target) => keys.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport21 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config: config2 } = Visualization;
  const { themes: themes3 } = config2;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes3 == null ? void 0 : themes3.defaultBackgroundColor) == null ? void 0 : _a.call(themes3, props);
    const icon = (_b = config2.placeholderIcon) != null ? _b : config2.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config2.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport22 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// src/common/utils/dataUtils.ts
var convertToArrOfObjects = (columns, fields) => {
  if (!columns || !columns[0] || !columns[0].length) return [];
  const data = [];
  for (let i = 0; i < columns[0].length; i += 1) {
    const newObj = {};
    fields.forEach((field, index) => {
      const fieldName = typeof field === "string" ? field : field.name;
      if (columns[index][i] === "") {
        newObj[fieldName] = null;
      } else {
        newObj[fieldName] = columns[index][i];
      }
    });
    data.push(newObj);
  }
  return data;
};
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport23 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport24 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// src/common/utils/trellisUtils.ts
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport25 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport26 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport27 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport28 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport29 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes3,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes3
    }
  }
];
var BackgroundColor_default = background;

// src/Events/config.ts
var defaultContext = {};
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [
    {
      name: "fieldsummary",
      description: "DataSource that powers the field summary popover on field click"
    }
  ],
  initialRequestParams: {
    primary: (options = {}) => {
      var _a;
      return {
        offset: 0,
        count: options.count ? options.count : 10,
        requestTotalCount: true,
        // this is needed for search-based event highlighting
        output_mode: "json",
        segmentation: (_a = options.highlightFromSource) != null ? _a : "none"
      };
    }
  }
};
var size = {
  initialWidth: 800,
  initialHeight: 500
};
var themes = {
  defaultBackgroundColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.black(props),
      light: themes_exports.variables.backgroundColor(props)
    },
    prisma: themes_exports.variables.backgroundColorSidebar(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Show field summary"),
          option: "showFieldSummary",
          editor: "editor.checkbox",
          editorProps: {
            labelPosition: "right"
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [BackgroundColor_default({ themes })]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.events",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Events"),
  category: "Table" /* TABLE */,
  status: "preview",
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Events,
  placeholderIcon: placeholders_exports.Events,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.eventsOptionsSchema,
  editorConfig,
  events: {
    "eventAction.<actionName>.click": {
      description: "Triggered when a user selects the Event Actions button within an event. An application developer can configure workflow action retrieval and event handling, as described in the Concepts tab."
    },
    "fieldAction.<actionName>.click": {
      description: "Triggered when a user selects an arrow under the Actions column heading. Application developers can configure workflow action retrieval and event handling. For more information, see the Concepts tab."
    },
    "events.search.<fieldSummaryReportActionName>": {
      description: "Triggered when a user selects a report action in the field summary of an event. Application developers must pass context and handle events in their applications. For more information, see the Concepts tab."
    },
    "value.click": {
      description: "Triggered when a user clicks a value in an event."
    },
    "time.click": {
      description: "Triggered when a user clicks to drilldown in the time controls popover."
    },
    "tag.click": {
      description: "Triggered when a user clicks a tag in an event."
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */],
  themes,
  requiredProps: []
};
var config_default = enhanceConfig(config);

// esm-externals:@splunk/react-events-viewer/components/EventsViewer
var EventsViewer_exports = {};
__export(EventsViewer_exports, {
  default: () => EventsViewer_default
});
var defaultImport30 = __toESM(require("@splunk/react-events-viewer/components/EventsViewer"));
__reExport(EventsViewer_exports, require("@splunk/react-events-viewer/components/EventsViewer"));
var EventsViewer_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport31 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// esm-externals:@splunk/visualization-context/EventsContext
var EventsContext_exports = {};
__export(EventsContext_exports, {
  default: () => EventsContext_default
});
var defaultImport32 = __toESM(require("@splunk/visualization-context/EventsContext"));
__reExport(EventsContext_exports, require("@splunk/visualization-context/EventsContext"));
var EventsContext_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// esm-externals:@splunk/react-ui/Menu
var Menu_exports = {};
__export(Menu_exports, {
  default: () => Menu_default
});
var defaultImport33 = __toESM(require("@splunk/react-ui/Menu"));
__reExport(Menu_exports, require("@splunk/react-ui/Menu"));
var Menu_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// esm-externals:@splunk/time-range-utils/time
var time_exports = {};
__export(time_exports, {
  default: () => time_default
});
var defaultImport34 = __toESM(require("@splunk/time-range-utils/time"));
__reExport(time_exports, require("@splunk/time-range-utils/time"));
var time_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// src/Events/EventUtils.ts
var EMPTY_DATASOURCE = {
  primary: {
    requestParams: { offset: 0, count: 0 },
    data: {
      fields: [],
      columns: []
    },
    meta: { totalCount: 0 }
  }
};
var convertToPayloadFormat = (obj, initialValue = {}) => {
  if (!obj) return {};
  return Object.keys(obj).reduce((acc, curr) => {
    const key = `row.${curr}.value`;
    return __spreadProps(__spreadValues({}, acc), { [key]: obj[curr] });
  }, initialValue);
};
var getFieldSummaryMapping = (columns, fields) => {
  const arr = convertToArrOfObjects(columns, fields);
  const fieldSummaryData = arr.map((d) => ({
    name: d.field,
    count: +d.count,
    distinctCount: +d.distinct_count,
    numericCount: +d.numeric_count,
    max: d.max === null ? null : +d.max,
    mean: d.mean === null ? null : +d.mean,
    min: d.min === null ? null : +d.min,
    stdev: d.stdev === null ? null : +d.stdev,
    modes: JSON.parse(d.values)
  }));
  const fieldSummaryMapping = fieldSummaryData.reduce((map, fieldData) => {
    return __spreadProps(__spreadValues({}, map), { [fieldData.name]: fieldData });
  }, {});
  return fieldSummaryMapping;
};
var mergeEventActions = (eventActions1, eventActions2) => eventActions1.concat(eventActions2);
var mergeFieldActions = (fieldActions1, fieldActions2) => {
  const fieldActions1WithoutDefault = __spreadValues({}, fieldActions1);
  if ("default" in fieldActions1WithoutDefault) {
    fieldActions1WithoutDefault["*"] = "*" in fieldActions1WithoutDefault ? [...fieldActions1WithoutDefault["*"], ...fieldActions1WithoutDefault.default] : fieldActions1WithoutDefault.default;
    delete fieldActions1WithoutDefault.default;
  }
  const fieldActions2WithoutDefault = __spreadValues({}, fieldActions2);
  if ("default" in fieldActions2WithoutDefault) {
    fieldActions2WithoutDefault["*"] = "*" in fieldActions2WithoutDefault ? [...fieldActions2WithoutDefault["*"], ...fieldActions2WithoutDefault.default] : fieldActions2WithoutDefault.default;
    delete fieldActions2WithoutDefault.default;
  }
  return (0, lodash_exports.mergeWith)(
    fieldActions1WithoutDefault,
    fieldActions2WithoutDefault,
    (fieldAction1value, fieldAction2value) => Array.isArray(fieldAction1value) && Array.isArray(fieldAction2value) ? (0, lodash_exports.union)(fieldAction1value, fieldAction2value) : void 0
  );
};
var replaceTokens = ({
  text,
  tokenReplacementMap,
  allowSpecialParametersEscape,
  allowFieldValuesEscape
}) => {
  let replacedText = text;
  Object.entries(tokenReplacementMap.specialParameters).forEach(([tokenName, tokenValue]) => {
    const maybeEscapedTokenValue = allowSpecialParametersEscape ? encodeURIComponent(tokenValue) : tokenValue;
    replacedText = replacedText.split(`$${tokenName}$`).join(maybeEscapedTokenValue);
  });
  Object.entries(tokenReplacementMap.fields).forEach(([tokenName, tokenValue]) => {
    const maybeEscapedTokenValue = allowFieldValuesEscape ? encodeURIComponent(tokenValue) : tokenValue;
    replacedText = replacedText.split(`$${tokenName}$`).join(maybeEscapedTokenValue);
    replacedText = replacedText.split(`$!${tokenName}$`).join(tokenValue);
  });
  return replacedText;
};
var generateTokenReplacementMap = ({
  dataSources,
  rowIndex,
  pageNumber,
  field,
  value,
  event = {}
}) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j;
  const tokenReplacementMap = {
    specialParameters: {},
    fields: {}
  };
  const count = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.requestParams) == null ? void 0 : _b.count;
  const offset = rowIndex !== void 0 && pageNumber !== void 0 && count !== void 0 ? rowIndex + count * (pageNumber - 1) : void 0;
  if (offset !== void 0) {
    tokenReplacementMap.specialParameters["@offset"] = String(offset);
  }
  if ((_d = (_c = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _c.meta) == null ? void 0 : _d.sid) {
    tokenReplacementMap.specialParameters["@sid"] = (_f = (_e = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _e.meta) == null ? void 0 : _f.sid;
  }
  if ((_h = (_g = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _g.meta) == null ? void 0 : _h.app) {
    tokenReplacementMap.specialParameters["@namespace"] = (_j = (_i = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _i.meta) == null ? void 0 : _j.app;
  }
  if (field) {
    tokenReplacementMap.specialParameters["@field_name"] = field;
  }
  if (value) {
    tokenReplacementMap.specialParameters["@field_value"] = value;
  }
  Object.entries(event).forEach(([fieldName, fieldValue]) => {
    let replacedValue;
    if (fieldName === "_time" && typeof fieldValue === "string") {
      const splunkTime = (0, time_exports.getISOWithTimeZone)(fieldValue);
      const epochTime = getEpochTime(splunkTime);
      replacedValue = Math.floor(epochTime).toString();
    } else if (fieldName === "_raw" && typeof fieldValue === "object") {
      const rawFieldValue = Array.isArray(fieldValue) ? fieldValue[0] : fieldValue == null ? void 0 : fieldValue.value;
      replacedValue = rawFieldValue ? rawFieldValue.toString() : "";
    } else {
      replacedValue = typeof fieldValue === "string" ? fieldValue : JSON.stringify(fieldValue);
    }
    tokenReplacementMap.fields[`${fieldName}`] = replacedValue;
  });
  return tokenReplacementMap;
};
var getEpochTime = (time) => {
  if (!(0, time_exports.isISO)(time)) {
    console.error(`'${time}' is not a valid time string.`);
    return NaN;
  }
  return new Date(time).getTime() / 1e3;
};
var getPredefinedTimeInterval = ({
  time,
  when
}) => {
  const epochTime = getEpochTime(time);
  switch (when) {
    case "before":
      return { latest: epochTime + 1e-3 };
    case "after":
      return { earliest: epochTime, latest: "now" };
    case "at":
      return { earliest: epochTime, latest: epochTime + 1e-3 };
    default:
      return { earliest: epochTime, latest: epochTime + 1e-3 };
  }
};
var getCustomTimeInterval = ({
  time,
  rangeType,
  rangeAmount,
  rangeUnit
}) => {
  const timeRange = (0, time_exports.getAcceleratedTimeRange)(time, rangeAmount, rangeUnit);
  let timeInterval;
  if (rangeType === "plusminus") {
    timeInterval = __spreadValues({}, timeRange);
  } else if (rangeType === "plus") {
    timeInterval = __spreadProps(__spreadValues({}, timeRange), { earliest: time });
  } else if (rangeType === "minus") {
    timeInterval = __spreadProps(__spreadValues({}, timeRange), { latest: time });
  }
  return {
    earliest: getEpochTime(timeInterval.earliest),
    latest: getEpochTime(timeInterval.latest) + 1e-3
  };
};
var truncateString = (stringToTruncate) => {
  const MAX_LENGTH = 100;
  const LEAD_AND_TRAIL_LENGTH = 50;
  let truncatedString = stringToTruncate;
  if (truncatedString.length > MAX_LENGTH) {
    truncatedString = `${truncatedString.substring(
      0,
      LEAD_AND_TRAIL_LENGTH
    )}...${truncatedString.substring(truncatedString.length - LEAD_AND_TRAIL_LENGTH)}`;
  }
  return truncatedString;
};
var convertToHighlightValuesByFieldMap = (highlighted) => {
  const highlightConfig = {};
  Object.keys(highlighted).forEach((field) => {
    const valuesToHighlight = Object.keys(highlighted[field]).filter((value) => highlighted[field][value]);
    if (valuesToHighlight.length > 0) highlightConfig[field] = valuesToHighlight;
  });
  return highlightConfig;
};
var combineHighlighted = (highlightedSource, highlightValuesByField) => {
  const highlightMap = convertToHighlightValuesByFieldMap(highlightedSource);
  Object.keys(highlightValuesByField).forEach((field) => {
    const value = highlightValuesByField[field];
    const valueArray = typeof value === "string" ? [value] : value;
    const combinedValue = highlightMap[field] ? [.../* @__PURE__ */ new Set([...highlightMap[field], ...valueArray])] : valueArray;
    highlightMap[field] = combinedValue;
  });
  return highlightMap;
};

// esm-externals:@splunk/react-ui/Popover
var Popover_exports = {};
__export(Popover_exports, {
  default: () => Popover_default
});
var defaultImport35 = __toESM(require("@splunk/react-ui/Popover"));
__reExport(Popover_exports, require("@splunk/react-ui/Popover"));
var Popover_default = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// esm-externals:@splunk/react-ui/Markdown
var Markdown_exports = {};
__export(Markdown_exports, {
  default: () => Markdown_default
});
var defaultImport36 = __toESM(require("@splunk/react-ui/Markdown"));
__reExport(Markdown_exports, require("@splunk/react-ui/Markdown"));
var Markdown_default = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// esm-externals:@splunk/react-field-summary/components/FieldSummary
var FieldSummary_exports = {};
__export(FieldSummary_exports, {
  default: () => FieldSummary_default
});
var defaultImport37 = __toESM(require("@splunk/react-field-summary/components/FieldSummary"));
__reExport(FieldSummary_exports, require("@splunk/react-field-summary/components/FieldSummary"));
var FieldSummary_default = "default" in defaultImport37 ? defaultImport37.default : defaultImport37;

// esm-externals:@splunk/react-ui/Button
var Button_exports = {};
__export(Button_exports, {
  default: () => Button_default
});
var defaultImport38 = __toESM(require("@splunk/react-ui/Button"));
__reExport(Button_exports, require("@splunk/react-ui/Button"));
var Button_default = "default" in defaultImport38 ? defaultImport38.default : defaultImport38;

// esm-externals:@splunk/react-icons/Cross
var Cross_exports = {};
__export(Cross_exports, {
  default: () => Cross_default
});
var defaultImport39 = __toESM(require("@splunk/react-icons/Cross"));
__reExport(Cross_exports, require("@splunk/react-icons/Cross"));
var Cross_default = "default" in defaultImport39 ? defaultImport39.default : defaultImport39;

// src/Events/PureEvents/FieldSummaryTooltip.tsx
var StyledContainer = styled_components_default.div`
    padding: 20px;
    width: 500px;
    display: flex;
    flex-direction: column;

    > button {
        align-self: end;
    }
`;
var StyledMarkdown = styled_components_default(Markdown_default)`
    /* removes unnecessary margin on the internal paragraph component */
    p {
        margin: 0;
    }
`;
var actionsForField = (field) => {
  const actions = [];
  if (typeof field.mean === "number") {
    actions.push({ name: "avgByTime", label: (0, i18n_exports._)("Average over time") });
    actions.push({ name: "maxByTime", label: (0, i18n_exports._)("Max value over time") });
    actions.push({ name: "minByTime", label: (0, i18n_exports._)("Min value over time") });
  }
  actions.push({ name: "topValues", label: (0, i18n_exports._)("Top values") });
  actions.push({ name: "topValuesByTime", label: (0, i18n_exports._)("Top values by time") });
  actions.push({ name: "rareValues", label: (0, i18n_exports._)("Rare values") });
  actions.push({ name: "allValues", label: (0, i18n_exports._)("Events with this field") });
  return actions;
};
var FieldSummaryTooltip = (props) => {
  var _a, _b;
  const {
    open,
    anchor,
    handleTooltipClose,
    fieldName,
    fieldSummaryMap,
    onActionClicked,
    onFieldValueClicked,
    id,
    dataSources
  } = props;
  const { isSplunkWebAvailable } = (0, react_exports.useContext)(EventsContext_default);
  const getActionsForField = (0, react_exports.useCallback)(
    (field2) => isSplunkWebAvailable ? actionsForField(field2) : [],
    [isSplunkWebAvailable]
  );
  if (!open) return null;
  const field = fieldSummaryMap[fieldName];
  const fieldSummaryExists = !!field;
  const fallbackText = ((_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.meta) == null ? void 0 : _b.isSpl2Search) ? (0, i18n_exports._)(
    `To show field summaries, configure an additional "SPL2 search" data source called \`fieldsummary\` that uses the \`fieldsummary\` command.`
  ) : (0, i18n_exports._)(
    `To show field summaries, configure a "Chain search" data source called \`fieldsummary\` with query \`| fieldsummary maxvals=10\`.`
  );
  return /* @__PURE__ */ react_exports.createElement(
    Popover_default,
    {
      open,
      defaultPlacement: "below",
      anchor,
      takeFocus: true,
      onRequestClose: handleTooltipClose,
      id
    },
    /* @__PURE__ */ react_exports.createElement(StyledContainer, null, /* @__PURE__ */ react_exports.createElement(
      Button_default,
      {
        onClick: handleTooltipClose,
        "data-test": "close-button",
        appearance: "subtle",
        icon: /* @__PURE__ */ react_exports.createElement(Cross_default, null),
        "aria-label": (0, i18n_exports._)("Close")
      }
    ), fieldSummaryExists ? /* @__PURE__ */ react_exports.createElement(
      FieldSummary_default,
      {
        eventCount: field.count,
        field,
        actionsForField: getActionsForField,
        onActionClicked,
        onFieldValueClicked
      }
    ) : /* @__PURE__ */ react_exports.createElement(StyledMarkdown, { text: fallbackText }))
  );
};
FieldSummaryTooltip.defaultProps = {
  open: false,
  anchor: null,
  fieldName: "",
  fieldSummaryMap: {},
  handleTooltipClose: lodash_exports.noop,
  onActionClicked: lodash_exports.noop,
  onFieldValueClicked: lodash_exports.noop,
  id: ""
};
var FieldSummaryTooltip_default = FieldSummaryTooltip;

// esm-externals:@splunk/react-ui/ControlGroup
var ControlGroup_exports = {};
__export(ControlGroup_exports, {
  default: () => ControlGroup_default
});
var defaultImport40 = __toESM(require("@splunk/react-ui/ControlGroup"));
__reExport(ControlGroup_exports, require("@splunk/react-ui/ControlGroup"));
var ControlGroup_default = "default" in defaultImport40 ? defaultImport40.default : defaultImport40;

// esm-externals:@splunk/react-ui/Text
var Text_exports = {};
__export(Text_exports, {
  default: () => Text_default
});
var defaultImport41 = __toESM(require("@splunk/react-ui/Text"));
__reExport(Text_exports, require("@splunk/react-ui/Text"));
var Text_default = "default" in defaultImport41 ? defaultImport41.default : defaultImport41;

// esm-externals:@splunk/react-ui/Message
var Message_exports2 = {};
__export(Message_exports2, {
  default: () => Message_default2
});
var defaultImport42 = __toESM(require("@splunk/react-ui/Message"));
__reExport(Message_exports2, require("@splunk/react-ui/Message"));
var Message_default2 = "default" in defaultImport42 ? defaultImport42.default : defaultImport42;

// esm-externals:@splunk/react-ui/Select
var Select_exports = {};
__export(Select_exports, {
  default: () => Select_default
});
var defaultImport43 = __toESM(require("@splunk/react-ui/Select"));
__reExport(Select_exports, require("@splunk/react-ui/Select"));
var Select_default = "default" in defaultImport43 ? defaultImport43.default : defaultImport43;

// esm-externals:@splunk/react-ui/Link
var Link_exports = {};
__export(Link_exports, {
  default: () => Link_default
});
var defaultImport44 = __toESM(require("@splunk/react-ui/Link"));
__reExport(Link_exports, require("@splunk/react-ui/Link"));
var Link_default = "default" in defaultImport44 ? defaultImport44.default : defaultImport44;

// esm-externals:@splunk/react-ui/Heading
var Heading_exports = {};
__export(Heading_exports, {
  default: () => Heading_default
});
var defaultImport45 = __toESM(require("@splunk/react-ui/Heading"));
__reExport(Heading_exports, require("@splunk/react-ui/Heading"));
var Heading_default = "default" in defaultImport45 ? defaultImport45.default : defaultImport45;

// src/Events/PureEvents/TimeControlsPopover.tsx
var TimePopoverContainer = styled_components_default.div`
    padding: 20px;
    width: ${(props) => pick_default({
  enterprise: "372px",
  prisma: "422px"
})(props)};

    .time-drilldown-header {
        margin: 0px;
    }

    [data-test='nearby-controls'] {
        margin: 0px;
        width: ${(props) => pick_default({
  enterprise: "289.75px",
  prisma: "329.75px"
})(props)};
    }
`;
var TimeTable = styled_components_default.table`
    width: 100%;
    display: table;
    border-collapse: separate;
    box-sizing: border-box;
    text-indent: initial;
    border-spacing: 2px;
    border-color: grey;
`;
var NearbyValueRow = styled_components_default.div`
    display: flex;
    align-items: flex-start;
    justify-content: center;
`;
var SectionHeading = styled_components_default(Heading_default)`
    margin-top: 20px;
`;
var HeadingContainer = styled_components_default.div`
    display: grid;
    grid-template-columns: auto auto;
    justify-content: space-between;
    align-items: center;
`;
var rangeTypeInputStyle = { minWidth: 80 };
var rangeAmountInputStyle = { width: 54.88, minWidth: 48 };
var rangeUnitInputStyle = { width: 154.88, textAlign: "center" };
var applyButtonStyle = { marginLeft: 10 };
var TimeControlsPopover = (props) => {
  const { open, anchor, time, handleTooltipClose, onTimeDrilldown, id } = props;
  const [rangeType, setRangeType] = react_exports.useState("plusminus");
  const [rangeAmount, setRangeAmount] = react_exports.useState("5");
  const [rangeUnit, setRangeUnit] = react_exports.useState("s");
  const [isInvalidInput, setInvalidInput] = react_exports.useState(false);
  const errorMessage = (0, i18n_exports._)("Value must be an integer greater than 0");
  const handleRangeTypeChange = (e, { value }) => {
    setRangeType(value);
  };
  const handleRangeAmountChange = (e, { value }) => {
    setRangeAmount(value);
  };
  const handleRangeUnitChange = (e, { value }) => {
    setRangeUnit(value);
  };
  const handleSubmit = (e) => {
    const parsedIntervalAmount = (0, numberUtils_exports.parseNumber)(rangeAmount);
    if (Number.isNaN(parsedIntervalAmount) || parsedIntervalAmount <= 0 || !Number.isInteger(parsedIntervalAmount)) {
      setInvalidInput(true);
      return;
    }
    setInvalidInput(false);
    const timeInterval = getCustomTimeInterval({
      time,
      rangeType,
      rangeAmount,
      rangeUnit
    });
    onTimeDrilldown(e, timeInterval);
  };
  const handleEventIntervalClick = (e, when) => {
    e.preventDefault();
    const timeInterval = getPredefinedTimeInterval({ time, when });
    onTimeDrilldown(e, timeInterval);
  };
  return /* @__PURE__ */ react_exports.createElement(
    Popover_default,
    {
      open,
      defaultPlacement: "below",
      anchor,
      takeFocus: true,
      onRequestClose: handleTooltipClose,
      id
    },
    /* @__PURE__ */ react_exports.createElement(TimePopoverContainer, { "data-test": "time-controls" }, /* @__PURE__ */ react_exports.createElement(HeadingContainer, null, /* @__PURE__ */ react_exports.createElement(Heading_default, { level: 2, className: "time-drilldown-header" }, "_time"), /* @__PURE__ */ react_exports.createElement(
      Button_default,
      {
        onClick: handleTooltipClose,
        "data-test": "close-button",
        appearance: "subtle",
        icon: /* @__PURE__ */ react_exports.createElement(Cross_default, null),
        "aria-label": (0, i18n_exports._)("Close")
      }
    )), isInvalidInput && /* @__PURE__ */ react_exports.createElement(Message_default2, { type: "error", "data-test": "invalid-time-input-message" }, errorMessage), /* @__PURE__ */ react_exports.createElement(SectionHeading, { level: 4 }, (0, i18n_exports._)("Events Before or After")), /* @__PURE__ */ react_exports.createElement(TimeTable, null, /* @__PURE__ */ react_exports.createElement("tbody", null, /* @__PURE__ */ react_exports.createElement("tr", { className: "before-after-values" }, /* @__PURE__ */ react_exports.createElement("td", null, /* @__PURE__ */ react_exports.createElement(
      Link_default,
      {
        "data-test": "before-time",
        to: "#",
        onClick: (e) => {
          handleEventIntervalClick(e, "before");
        }
      },
      (0, i18n_exports._)("Before this time")
    )), /* @__PURE__ */ react_exports.createElement("td", null, /* @__PURE__ */ react_exports.createElement(
      Link_default,
      {
        "data-test": "after-time",
        to: "#",
        onClick: (e) => {
          handleEventIntervalClick(e, "after");
        }
      },
      (0, i18n_exports._)("After this time")
    )), /* @__PURE__ */ react_exports.createElement("td", null, /* @__PURE__ */ react_exports.createElement(
      Link_default,
      {
        "data-test": "at-time",
        to: "#",
        onClick: (e) => {
          handleEventIntervalClick(e, "at");
        }
      },
      (0, i18n_exports._)("At this time")
    ))))), /* @__PURE__ */ react_exports.createElement(SectionHeading, { level: 4, className: "nearby-header" }, (0, i18n_exports._)("Nearby Events")), /* @__PURE__ */ react_exports.createElement(NearbyValueRow, { className: "nearby-value" }, /* @__PURE__ */ react_exports.createElement(
      ControlGroup_default,
      {
        "data-test": "nearby-controls",
        controlsLayout: "fillJoin",
        label: "Time controls",
        labelPosition: "top",
        hideLabel: true
      },
      /* @__PURE__ */ react_exports.createElement(
        Select_default,
        {
          inline: true,
          value: rangeType,
          onChange: handleRangeTypeChange,
          error: isInvalidInput,
          style: rangeTypeInputStyle,
          "data-test": "type-selection"
        },
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "+", value: "plus" }),
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "-", value: "minus" }),
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "+/-", value: "plusminus" })
      ),
      /* @__PURE__ */ react_exports.createElement(
        Text_default,
        {
          inline: true,
          value: rangeAmount,
          onChange: handleRangeAmountChange,
          error: isInvalidInput,
          style: rangeAmountInputStyle,
          "data-test": "amount-input"
        }
      ),
      /* @__PURE__ */ react_exports.createElement(
        Select_default,
        {
          "data-test": "unit-selection",
          inline: true,
          value: rangeUnit,
          onChange: handleRangeUnitChange,
          error: isInvalidInput,
          style: rangeUnitInputStyle
        },
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "week(s)", value: "w" }),
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "day(s)", value: "d" }),
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "hour(s)", value: "h" }),
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "minute(s)", value: "m" }),
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "second(s)", value: "s" }),
        /* @__PURE__ */ react_exports.createElement(Select_default.Option, { label: "millisecond(s)", value: "ms" })
      )
    ), /* @__PURE__ */ react_exports.createElement(
      Button_default,
      {
        label: (0, i18n_exports._)("Apply"),
        onClick: handleSubmit,
        style: applyButtonStyle,
        "data-test": "apply-custom-time"
      }
    )))
  );
};
TimeControlsPopover.defaultProps = {
  open: false,
  anchor: null,
  time: null,
  handleTooltipClose: lodash_exports.noop,
  onTimeDrilldown: lodash_exports.noop,
  id: ""
};
var TimeControlsPopover_default = TimeControlsPopover;

// src/Events/PureEvents/PureEvents.tsx
var EventsContainer = styled_components_default.div`
    width: ${(props) => (0, lodash_exports.isNumber)(props.width) ? `${props.width}px` : props.width};
    height: ${(props) => (0, lodash_exports.isNumber)(props.height) ? `${props.height}px` : props.height};
    box-sizing: border-box;
    padding: ${pick_default({
  enterprise: variables_default.spacingHalf,
  prisma: variables_default.spacingSmall
})};
    display: flex;
    flex-flow: column nowrap;
    overflow: hidden;

    /* Added, but is technically handled by FixedSizeContainer. */
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor};

    /* Required as odd rows have a transparent background color and would appear as the passed background color otherwise */
    table[data-test='main-table'] {
        background-color: ${pick_default({
  enterprise: variables_default.backgroundColorPage,
  prisma: variables_default.backgroundColorPage
})};
    }

    /* CSS override for word wrapping on raw event value - prevents needing to scroll excessively in cases where raw event values don't have spaces to break. Also to render the newline/ line-breaks properly */
    table[data-test='main-table'] {
        td:nth-child(3) {
            word-break: break-word;
            white-space: pre-wrap; // css override to render text with newline/ line-breaks and tabs/ spaces properly
        }
    }
`;
var SUIEventsViewerContainer = styled_components_default.div`
    box-sizing: border-box;
    flex-grow: 1;
    overflow: hidden;

    ${({ width, height, theme }) => {
  const padding = pick_default({
    enterprise: variables_default.spacingHalf({ theme }),
    prisma: variables_default.spacingSmall({ theme })
  })({ theme });
  const paddingOffset = parseInt(padding, 10) * 2;
  return (0, style_exports.toDimension)({
    width: width - paddingOffset,
    height: height - paddingOffset
  });
}};
`;
var PureEvents = (props) => {
  const {
    width,
    height,
    backgroundColor,
    dataSources = {},
    eventActions: eventActionsProps = [],
    fieldActions: fieldActionsProps = {},
    showFieldSummary,
    footerFields,
    highlightValuesByField,
    onOptionsChange,
    onRequestParamsChange,
    onEventTrigger
  } = props;
  const highlightValuesByFieldCombined = react_exports.useMemo(() => {
    var _a, _b, _c;
    const highlightedSource = (_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.meta) == null ? void 0 : _b.highlighted) != null ? _c : {};
    return combineHighlighted(highlightedSource, highlightValuesByField);
  }, [dataSources, highlightValuesByField]);
  const fieldSummaryMap = react_exports.useMemo(() => {
    var _a, _b, _c, _d;
    if (!showFieldSummary || !(0, lodash_exports.get)(dataSources, "fieldsummary")) {
      return {};
    }
    try {
      const fieldSummaryMapping = getFieldSummaryMapping(
        (_b = (_a = dataSources.fieldsummary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns,
        (_d = (_c = dataSources.fieldsummary) == null ? void 0 : _c.data) == null ? void 0 : _d.fields
      );
      return fieldSummaryMapping;
    } catch (e) {
      console.error(`Unexpected error parsing fieldsummary datasource:  + ${e.message}`);
      return {};
    }
  }, [dataSources, showFieldSummary]);
  const {
    eventActions: eventActionsContext = [],
    fieldActions: fieldActionsContext = {}
  } = (0, react_exports.useContext)(EventsContext_default);
  const eventActions = mergeEventActions(eventActionsProps, eventActionsContext);
  const fieldActions = mergeFieldActions(fieldActionsProps, fieldActionsContext);
  const [fieldSummaryField, setFieldSummaryField] = react_exports.useState(null);
  const [fieldSummaryAnchor, setFieldSummaryAnchor] = react_exports.useState(null);
  const [timeValue, setTimeValue] = react_exports.useState(null);
  const [timeFieldAnchor, setTimeFieldAnchor] = react_exports.useState(null);
  const renderEventActions = react_exports.useMemo(
    () => !Array.isArray(eventActions) ? [] : eventActions.map(({ eventType, label, eventtypeValues = [], fieldFilters = [] }) => {
      const onMenuItemClick = (e, eventActionProps, tokenReplacementMap) => {
        const payload = convertToPayloadFormat(eventActionProps.event, {
          tokenReplacementMap
        });
        onEventTrigger({
          originalEvent: e,
          type: eventType,
          payload
        });
      };
      const eventActionComponent = (eventActionProps) => {
        const { rowIndex, pageNumber, event } = eventActionProps;
        const tokenReplacementMap = generateTokenReplacementMap({
          dataSources,
          rowIndex,
          pageNumber,
          event
        });
        const replacedLabel = replaceTokens({
          text: label,
          tokenReplacementMap,
          allowSpecialParametersEscape: false,
          allowFieldValuesEscape: false
        });
        const truncatedLabel = truncateString(replacedLabel);
        return /* @__PURE__ */ react_exports.createElement(
          Menu_default.Item,
          {
            key: `event-action-${truncatedLabel}`,
            onClick: (e) => onMenuItemClick(e, eventActionProps, tokenReplacementMap)
          },
          truncatedLabel
        );
      };
      return {
        eventtypeValues,
        fieldFilters,
        eventActionComponent
      };
    }),
    [eventActions]
  );
  const renderFieldActions = react_exports.useMemo(() => {
    if (typeof fieldActions !== "object") return {};
    const fieldActionsMap = {};
    Object.entries(fieldActions).forEach(
      ([currentFieldName, currentFieldActions]) => {
        fieldActionsMap[currentFieldName] = currentFieldActions.map(
          ({ eventType, label, eventtypeValues = [] }) => {
            const onMenuItemClick = (e, fieldActionProps, tokenReplacementMap) => {
              const payload = convertToPayloadFormat(fieldActionProps.event, {
                name: fieldActionProps.field,
                value: fieldActionProps.value,
                tokenReplacementMap
              });
              onEventTrigger({
                originalEvent: e,
                type: eventType,
                payload
              });
            };
            const fieldActionComponent = (fieldActionProps) => {
              const { field, value, rowIndex, pageNumber, event } = fieldActionProps;
              const tokenReplacementMap = generateTokenReplacementMap({
                dataSources,
                rowIndex,
                pageNumber,
                field,
                value,
                event
              });
              const replacedLabel = replaceTokens({
                text: label,
                tokenReplacementMap,
                allowSpecialParametersEscape: false,
                allowFieldValuesEscape: false
              });
              const truncatedLabel = truncateString(replacedLabel);
              return /* @__PURE__ */ react_exports.createElement(
                Menu_default.Item,
                {
                  key: `${currentFieldName}-field-action-${truncatedLabel}`,
                  onClick: (e) => onMenuItemClick(e, fieldActionProps, tokenReplacementMap)
                },
                truncatedLabel
              );
            };
            return {
              eventtypeValues,
              fieldActionComponent
            };
          }
        );
      }
    );
    return fieldActionsMap;
  }, [fieldActions]);
  const suiEventsViewerOptions = {
    renderEventActions,
    renderFieldActions,
    footerFields,
    fieldValueHighlightMap: highlightValuesByFieldCombined
  };
  const handleFieldClicked = showFieldSummary && ((e, { field }) => {
    setFieldSummaryField(field);
    setFieldSummaryAnchor(e.currentTarget.parentElement);
  });
  const handleTimeClicked = (e, { time }) => {
    setTimeValue(time);
    setTimeFieldAnchor(e.currentTarget);
  };
  const handleValueClicked = (e, { field, value }) => {
    onEventTrigger({
      originalEvent: e,
      type: "value.click",
      payload: {
        name: field,
        value
      }
    });
  };
  const handleTagClicked = (e, { field, value }) => {
    onEventTrigger({
      originalEvent: e,
      type: "tag.click",
      payload: {
        name: field,
        value
      }
    });
  };
  const handleTimeDrilldown = (e, timeInterval) => {
    onEventTrigger({
      originalEvent: e,
      type: "time.click",
      payload: {
        name: "_time",
        value: timeValue,
        epochTime: getEpochTime(timeValue),
        window: timeInterval
      }
    });
  };
  const handleActionClicked = (event, data) => {
    const { action: actionType, field } = data;
    onEventTrigger({
      originalEvent: event,
      type: `events.search.${actionType}`,
      payload: {
        field
      }
    });
  };
  const fieldPopoverId = react_exports.useMemo(() => (0, id_exports.createDOMID)(), []);
  const timePopoverId = react_exports.useMemo(() => (0, id_exports.createDOMID)(), []);
  return /* @__PURE__ */ react_exports.createElement(
    EventsContainer,
    {
      "data-test": "events-container",
      backgroundColor,
      width,
      height
    },
    /* @__PURE__ */ react_exports.createElement(SUIEventsViewerContainer, { width, height }, /* @__PURE__ */ react_exports.createElement(
      EventsViewer_default,
      {
        options: suiEventsViewerOptions,
        onOptionsChange,
        dataSources,
        onRequestParamsChange,
        onFieldClicked: handleFieldClicked,
        onFieldValueClicked: handleValueClicked,
        onTimeClicked: handleTimeClicked,
        onTagClicked: handleTagClicked,
        fieldAdditionalProps: {
          "aria-haspopup": true,
          "aria-expanded": !!fieldSummaryAnchor && !!fieldSummaryField,
          "aria-controls": fieldPopoverId
        },
        timeFieldAdditionalProps: {
          "aria-haspopup": true,
          "aria-expanded": !!timeFieldAnchor,
          "aria-controls": timePopoverId
        }
      }
    ), /* @__PURE__ */ react_exports.createElement(
      FieldSummaryTooltip_default,
      {
        id: fieldPopoverId,
        open: !!fieldSummaryAnchor && !!fieldSummaryField,
        anchor: fieldSummaryAnchor,
        handleTooltipClose: () => {
          fieldSummaryAnchor.firstChild.focus();
          setFieldSummaryField(null);
          setFieldSummaryAnchor(null);
        },
        fieldName: fieldSummaryField,
        fieldSummaryMap,
        onActionClicked: handleActionClicked,
        onFieldValueClicked: handleValueClicked,
        dataSources
      }
    ), /* @__PURE__ */ react_exports.createElement(
      TimeControlsPopover_default,
      {
        id: timePopoverId,
        open: !!timeFieldAnchor,
        anchor: timeFieldAnchor,
        time: timeValue,
        onTimeDrilldown: handleTimeDrilldown,
        handleTooltipClose: () => {
          timeFieldAnchor.focus();
          setTimeValue(null);
          setTimeFieldAnchor(null);
        }
      }
    ))
  );
};
PureEvents.propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // need this to satisfy props interface
  // eslint-disable-next-line react/no-unused-prop-types
  mode: prop_types_exports.string,
  backgroundColor: prop_types_exports.string,
  eventActions: prop_types_exports.arrayOf(
    prop_types_exports.shape({
      // key to identify this event
      eventType: prop_types_exports.string,
      // label for the menu item
      label: prop_types_exports.string,
      eventtypeValues: prop_types_exports.arrayOf(prop_types_exports.string),
      fieldFilters: prop_types_exports.arrayOf(prop_types_exports.string)
    })
  ),
  fieldActions: prop_types_exports.objectOf(
    prop_types_exports.arrayOf(
      prop_types_exports.shape({
        // key to identify this event
        eventType: prop_types_exports.string,
        // label for the menu item
        label: prop_types_exports.string,
        eventtypeValues: prop_types_exports.arrayOf(prop_types_exports.string)
      })
    )
  ),
  showFieldSummary: prop_types_exports.bool,
  footerFields: prop_types_exports.array,
  highlightValuesByField: prop_types_exports.objectOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.arrayOf(prop_types_exports.string)])),
  onOptionsChange: prop_types_exports.func,
  dataSources: prop_types_exports.any,
  onRequestParamsChange: prop_types_exports.func,
  onEventTrigger: prop_types_exports.func
};
PureEvents.defaultProps = {
  width: 800,
  height: 500,
  mode: "view",
  eventActions: [],
  fieldActions: {},
  dataSources: EMPTY_DATASOURCE,
  showFieldSummary: true,
  footerFields: [],
  highlightValuesByField: {},
  onOptionsChange: lodash_exports.noop,
  onRequestParamsChange: lodash_exports.noop,
  onEventTrigger: lodash_exports.noop
};
var PureEvents_default = FixedSizeContainer_default(PureEvents);

// src/Events/Events.tsx
var showPlaceHolderIcon = (dataSources) => {
  var _a, _b;
  const columns = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns;
  const noColumns = !(Array.isArray(columns) && columns.length);
  const dataSourceState = (0, dataSourceUtils_exports.getDataSourceStateInfo)(dataSources == null ? void 0 : dataSources.primary);
  return dataSourceState.hasError || dataSourceState.isLoading || dataSourceState.isMissing || noColumns;
};
var computeVizProps = (_a) => {
  var props = __objRest(_a, []);
  var _a2;
  const dataSources = (_a2 = props == null ? void 0 : props.dataSources) != null ? _a2 : EMPTY_DATASOURCE;
  return __spreadProps(__spreadValues({}, props), { dataSources });
};
var Events = withDashboardViz_default({
  ReactViz: PureEvents_default,
  vizConfig: config_default,
  computeVizProps,
  disableEditModeCover: true,
  useIconPlaceholder: (dataSources) => showPlaceHolderIcon(dataSources)
});
var { themes: themes2 } = config_default;
var Events_default = Events;
//# sourceMappingURL=Events.js.map
