/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Map/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport2 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport4 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport5 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport7 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport8 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes2,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes2
    }
  }
];
var BackgroundColor_default = background;

// src/Map/config.ts
var defaultContext = {
  colorRangeConfig: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ],
  colorMatchConfig: [{ match: "", value: "#5C33FF" }]
};
var dataContract = {
  requiredDataSources: [],
  optionalDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization."
    }
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 800,
  initialHeight: 600
};
var themes = {
  defaultBackgroundColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.black(props),
      light: themes_exports.variables.backgroundColor(props)
    },
    prisma: themes_exports.variables.backgroundColorSidebar(props)
  })(props),
  controlBackgroundColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.gray22(props),
      light: themes_exports.variables.white(props)
    },
    prisma: themes_exports.variables.backgroundColorPopup(props)
  })(props),
  controlForegroundColor: (props) => (0, themes_exports.pick)({
    enterprise: themes_exports.variables.textColor(props),
    prisma: themes_exports.variables.contentColorDefault(props)
  })(props),
  defaultChoroplethEmptyAreaColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.gray22(props),
      light: themes_exports.variables.gray92(props)
    },
    prisma: {
      dark: themes_exports.variables.interactiveColorBackground(props),
      light: themes_exports.variables.neutral300(props)
    }
  })(props),
  defaultGradientMigrationConfig: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: ["#4D4A5D", themes_exports.variables.syntaxPurple(props)],
      light: ["#D2CFDC", themes_exports.variables.syntaxPurple(props)]
    },
    prisma: {
      dark: ["#484558", themes_exports.variables.syntaxPurple(props)],
      light: ["#D8D4E1", themes_exports.variables.syntaxPurple(props)]
    }
  })(props)
};
var isChoroplethLayer = (options) => {
  var _a, _b;
  return ((_b = (_a = options.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.type) === visualization_schemas_exports.LAYER_TYPE.Choropleth;
};
var isLocalChoroplethLayer = (options) => isChoroplethLayer(options) && (options.layers[0].source === "geo://default/us" || options.layers[0].source === "geo://default/world");
var EDITOR_LABEL_WIDTH = 140;
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data configurations"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Layer type"),
          option: "layers[0].type",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Bubble"), value: visualization_schemas_exports.LAYER_TYPE.Bubble },
              { label: (0, i18n_exports._)("Marker"), value: visualization_schemas_exports.LAYER_TYPE.Marker },
              { label: (0, i18n_exports._)("Choropleth"), value: visualization_schemas_exports.LAYER_TYPE.Choropleth }
            ]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Area IDs"),
          option: "layers[0].areaIds",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false,
            filterByTypes: ["string"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Area values"),
          option: "layers[0].areaValues",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false,
            filterByTypes: ["number"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Latitude"),
          option: "layers[0].latitude",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => !isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Longitude"),
          option: "layers[0].longitude",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => !isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Bubble size"),
          option: "layers[0].bubbleSize",
          editor: "editor.columnMultiSelector",
          showEditor: ({ options }) => !(options.layers && options.layers.length && (options.layers[0].type === "marker" || options.layers[0].type === "choropleth")),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false,
            excludeByNames: ["latitude", "longitude", "geobin"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Additional tooltip fields"),
          option: "layers[0].additionalTooltipFields",
          editor: "editor.columnMultiSelectionByFieldNameEditor"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Tooltip header field"),
          option: "layers[0].tooltipHeaderField",
          editor: "editor.columnSelector",
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Result limit"),
          option: "layers[0].resultLimit",
          editor: "editor.number",
          showEditor: ({ options }) => !isLocalChoroplethLayer(options),
          editorProps: {
            themes,
            labelPosition: "top",
            min: 0
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Latitude (initial map location)"),
          option: "center[0]",
          editor: "editor.number",
          editorProps: {
            themes,
            labelPosition: "top",
            min: -90,
            max: 90
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Longitude (initial map location)"),
          option: "center[1]",
          editor: "editor.number",
          editorProps: {
            themes,
            labelPosition: "top",
            min: -180,
            max: 180
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Zoom (initial map location)"),
          option: "zoom",
          editor: "editor.number",
          editorProps: {
            themes,
            labelPosition: "top",
            min: 0
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Show Latitude and Longitude"),
          option: "showCoordinates",
          editor: "editor.checkbox",
          editorProps: {
            labelPosition: "right",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Show zoom controls"),
          option: "showZoomControls",
          editor: "editor.checkbox",
          editorProps: {
            labelPosition: "right",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Show scale"),
          option: "showScale",
          editor: "editor.toggle",
          editorProps: {
            labelPosition: "right",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Scale unit"),
          option: "scaleUnit",
          editor: "editor.radioBar",
          showEditor: ({ options }) => options.showScale !== false,
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Metric"), value: "metric" },
              { label: (0, i18n_exports._)("Imperial"), value: "imperial" }
            ]
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Data colors"),
          option: "layers[0].dataColors",
          context: "colorRangeConfig",
          editor: "editor.dynamicColorWithPrecedence",
          editorProps: {
            labelPosition: "top",
            flyoutTitle: (0, i18n_exports._)("Dynamic coloring: value"),
            formatters: [
              {
                label: (0, i18n_exports._)("Ranges"),
                value: "rangeValue",
                isDefault: true,
                defaults: {
                  dataValues: defaultContext.colorRangeConfig
                }
              },
              {
                label: (0, i18n_exports._)("Matches"),
                value: "matchValue",
                defaults: {
                  dataValues: defaultContext.colorMatchConfig
                }
              }
            ],
            dataSelectors: [
              {
                label: (0, i18n_exports._)("Data values"),
                value: "dataValues"
              }
            ],
            defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig
          },
          showEditor: ({ options }) => !isChoroplethLayer(options)
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Data values"),
          editor: "editor.columnSelector",
          option: "layers[0].dataValues",
          showEditor: ({ options }) => {
            var _a, _b;
            return !isChoroplethLayer(options) && ((_b = (_a = options.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.dataColors);
          },
          editorProps: {
            dataSourceKey: "primary",
            filterByTypes: ["number"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Series colors"),
          option: "layers[0].seriesColors",
          editor: "editor.seriesColors",
          showEditor: ({ options }) => {
            var _a, _b;
            return !isChoroplethLayer(options) && !((_b = (_a = options.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.dataColors);
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Choropleth empty area"),
          option: "layers[0].choroplethEmptyAreaColor",
          editor: "editor.color",
          showEditor: ({ options }) => isLocalChoroplethLayer(options),
          editorProps: {
            themes
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Choropleth stroke"),
          option: "layers[0].choroplethStrokeColor",
          editor: "editor.color",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            themes
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Choropleth opacity (%)"),
          option: "layers[0].choroplethOpacity",
          editor: "editor.percent",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            themes,
            min: 0
          }
        }
      ],
      // TODO: add support for seriesColorsByField option
      // [
      //     {
      //         label: _('Series colors by field name'),
      //         option: 'seriesColorsByField',
      //         editor: 'editor.seriesColorsByField',
      //     },
      // ],
      BackgroundColor_default({ themes }),
      [
        {
          label: (0, i18n_exports._)("Show base layer"),
          option: "showBaseLayer",
          editor: "editor.toggle"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Base layer tile server"),
          option: "baseLayerTileServer",
          editor: "editor.text",
          showEditor: ({ options }) => options.showBaseLayer !== false
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Base layer tile server type"),
          option: "baseLayerTileServerType",
          editor: "editor.radioBar",
          showEditor: ({ options }) => options.showBaseLayer === false ? false : !(typeof options.baseLayerTileServer === "undefined" || options.baseLayerTileServer === ""),
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Vector"), value: "vector" },
              { label: (0, i18n_exports._)("Raster"), value: "raster" }
            ]
          }
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.map",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Map"),
  category: "Spatial" /* SPATIAL */,
  status: "preview",
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Map,
  placeholderIcon: placeholders_exports.Map,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.mapOptionsSchema,
  editorConfig,
  events: {
    "map.load": {
      description: "triggered when map is fully loaded",
      parentKeys: ["exec"]
    },
    "map.click": {
      description: "trigger when user clicks map layer"
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */],
  themes,
  requiredProps: []
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=Map.config.js.map
