/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Map/index.ts
var Map_exports = {};
__export(Map_exports, {
  PureMap: () => PureMap_default,
  computeVizProps: () => computeVizProps,
  config: () => config_default,
  default: () => Map_default,
  themes: () => themes2,
  useIconPlaceholder: () => useIconPlaceholder
});
module.exports = __toCommonJS(Map_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport2 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport3 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport4 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport5 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport6 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport7 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:chroma-js
var chroma_js_exports = {};
__export(chroma_js_exports, {
  default: () => chroma_js_default
});
var defaultImport8 = __toESM(require("chroma-js"));
__reExport(chroma_js_exports, require("chroma-js"));
var chroma_js_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:maplibre-gl
var maplibre_gl_exports = {};
__export(maplibre_gl_exports, {
  default: () => maplibre_gl_default
});
var defaultImport9 = __toESM(require("maplibre-gl"));
__reExport(maplibre_gl_exports, require("maplibre-gl"));
var maplibre_gl_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport10 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/react-ui/Button
var Button_exports = {};
__export(Button_exports, {
  default: () => Button_default
});
var defaultImport11 = __toESM(require("@splunk/react-ui/Button"));
__reExport(Button_exports, require("@splunk/react-ui/Button"));
var Button_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualization-context/MapContext
var MapContext_exports = {};
__export(MapContext_exports, {
  default: () => MapContext_default
});
var defaultImport12 = __toESM(require("@splunk/visualization-context/MapContext"));
__reExport(MapContext_exports, require("@splunk/visualization-context/MapContext"));
var MapContext_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport13 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport14 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:maplibre-gl/dist/maplibre-gl.css
var maplibre_gl_exports2 = {};
__export(maplibre_gl_exports2, {
  default: () => maplibre_gl_default2
});
var defaultImport15 = __toESM(require("maplibre-gl/dist/maplibre-gl.css"));
__reExport(maplibre_gl_exports2, require("maplibre-gl/dist/maplibre-gl.css"));
var maplibre_gl_default2 = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/Map/PureMap/PureMapContainer.tsx
var PureMapContainer = styled_components_default.div.attrs({ "data-test": "puremap-container" })`
    ${maplibre_gl_default2}
    overflow: hidden;
    position: relative;
    z-index: 0;
    background-color: ${(props) => props.backgroundColor};
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};

    // keep zoom control on top of cooperative gesture layer
    .maplibregl-cooperative-gesture-screen {
        z-index: 0;
    }

    // overwrite maplibregl zoom control styles
    .maplibregl-ctrl-top-left {
        display: ${(props) => props.showZoomControls ? "block" : "none"};
        position: absolute;
        top: 12px;
        left: 16px;
        .maplibregl-ctrl-group {
            width: 40px !important;
            height: 87px !important;
            border-radius: 4px;
            margin: 8px 0px;
            background-color: ${(props) => props.controlBackgroundColor};
            box-shadow: 0px 26px 103px rgba(0, 0, 0, 0.64), 0px 11px 18px rgba(0, 0, 0, 0.32),
                0px 3px 6px rgba(0, 0, 0, 0.3);
            & button {
                width: 40px;
                height: 43px;
                border-top: 0;
            }
            .maplibregl-ctrl-zoom-in .maplibregl-ctrl-icon {
                background-image: url('data:image/svg+xml;charset=UTF-8,<svg width="16" height="16" viewBox="0 0 16 16" xmlns="http://www.w3.org/2000/svg"><path d="M9 1C9 0.447715 8.55229 0 8 0C7.44772 0 7 0.447715 7 1V7H1C0.447715 7 0 7.44772 0 8C0 8.55229 0.447715 9 1 9H7V15C7 15.5523 7.44772 16 8 16C8.55229 16 9 15.5523 9 15V9H15C15.5523 9 16 8.55229 16 8C16 7.44772 15.5523 7 15 7H9V1Z" fill="${(props) => props.controlIconColorEncoded.color}" fill-opacity="${(props) => props.controlIconColorEncoded.opacity}" /></svg>');
            }

            .maplibregl-ctrl-zoom-out .maplibregl-ctrl-icon {
                background-image: url('data:image/svg+xml;charset=UTF-8,<svg width="14" height="3" viewBox="0 0 14 3" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M0 1.99707C0 1.44479 0.447715 0.99707 1 0.99707H13C13.5523 0.99707 14 1.44479 14 1.99707C14 2.54936 13.5523 2.99707 13 2.99707H1C0.447715 2.99707 0 2.54936 0 1.99707Z" fill="${(props) => props.controlIconColorEncoded.color}" fill-opacity="${(props) => props.controlIconColorEncoded.opacity}" /></svg>');
            }
        }
    }

    // overwrite maplibregl scale styles
    .maplibregl-ctrl-bottom-left {
        display: ${(props) => props.showScale ? "block" : "none"};
        position: absolute;
        z-index: 0;
        bottom: 16px;
        left: 12px;
        width: 86px;
        height: 29px;
        border-radius: 4px;
        margin: 0;
        background-color: ${(props) => props.controlBackgroundColor};
        box-shadow: 0px 26px 103px rgba(0, 0, 0, 0.13), 0px 11px 18px rgba(0, 0, 0, 0.06),
            0px 3px 6px rgba(0, 0, 0, 0.06);
        .maplibregl-ctrl-scale {
            background-color: ${(props) => props.controlBackgroundColor};
            color: ${(props) => props.controlForegroundColor};
            border: 2px solid ${(props) => props.controlForegroundColor};
            border-top: 0;
            border-left: 0;
            border-right: 0;
            padding: 0;
            margin: 6px 8px 8px 8px;
            line-height: 13px;
            letter-spacing: 0.02em;
            font-family: sans-serif;
            font-size: 10px;
        }
    }
`;
var PureMapContainer_default = PureMapContainer;

// esm-externals:d3-scale
var d3_scale_exports = {};
__export(d3_scale_exports, {
  default: () => d3_scale_default
});
var defaultImport16 = __toESM(require("d3-scale"));
__reExport(d3_scale_exports, require("d3-scale"));
var d3_scale_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/visualization-color-palettes
var visualization_color_palettes_exports = {};
__export(visualization_color_palettes_exports, {
  default: () => visualization_color_palettes_default
});
var defaultImport17 = __toESM(require("@splunk/visualization-color-palettes"));
__reExport(visualization_color_palettes_exports, require("@splunk/visualization-color-palettes"));
var visualization_color_palettes_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/visualization-encoding/utils/types
var types_exports = {};
__export(types_exports, {
  default: () => types_default
});
var defaultImport18 = __toESM(require("@splunk/visualization-encoding/utils/types"));
__reExport(types_exports, require("@splunk/visualization-encoding/utils/types"));
var types_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// src/Map/PureMap/MapUtils.ts
var MAX_LATITUDE = 90;
var MIN_LATITUDE = -90;
var MAX_LONGITUDE = 180;
var MIN_LONGITUDE = -180;
var DEFAULT_RESULT_LIMIT = 1e3;
var DEFAULT_CLUSTER_COLOR = "#909090";
var DEFAULT_SERIES_COLORS = visualization_color_palettes_exports.VIZ_CATEGORICAL;
var MAP_STYLE_VERSION_NUMBER = 8;
var MIN_BUBBLE_RADIUS = 7.11;
var MAX_BUBBLE_RADIUS = 45.26;
var LONGITUDE = "longitude";
var LATITUDE = "latitude";
var getTilePreset = ({
  defaultTileConfig = [],
  customTileConfig = []
}) => {
  var _a, _b;
  const tilePreset = {};
  let defaultTileLight = {};
  let defaultTileDark = {};
  const tileConfigs = [].concat(defaultTileConfig).concat(customTileConfig);
  (0, lodash_exports.forEach)(tileConfigs, (tileConfig) => {
    const key = tileConfig == null ? void 0 : tileConfig.key;
    const updatedConfig = __spreadProps(__spreadValues({ theme: "all" }, tileConfig), { version: MAP_STYLE_VERSION_NUMBER });
    tilePreset[key] = updatedConfig;
  });
  if (defaultTileConfig.length > 0) {
    defaultTileLight = (_a = defaultTileConfig.find((config2) => config2.theme === "light")) != null ? _a : defaultTileConfig.find((config2) => config2.theme === void 0);
    defaultTileDark = (_b = defaultTileConfig.find((config2) => config2.theme === "dark")) != null ? _b : defaultTileConfig.find((config2) => config2.theme === void 0);
  }
  return { tilePreset, defaultTileLight, defaultTileDark };
};
var getMapStyle = ({
  showBaseLayer,
  baseLayerTileServer = "",
  baseLayerTileServerType = "",
  tilePreset = {},
  colorScheme = "light",
  defaultTileLight = {},
  defaultTileDark = {}
}) => {
  if (!showBaseLayer) {
    return {
      version: MAP_STYLE_VERSION_NUMBER,
      sources: {
        "base-tiles": {
          type: "raster",
          tiles: [
            "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR42mNkYAAAAAYAAjCB0C8AAAAASUVORK5CYII="
          ],
          tileSize: 256
        }
      },
      layers: [
        {
          id: "base-layer",
          type: "raster",
          source: "base-tiles",
          minzoom: 0,
          maxzoom: 22
        }
      ]
    };
  }
  if (baseLayerTileServer && tilePreset[baseLayerTileServer] && (tilePreset[baseLayerTileServer].theme === colorScheme || tilePreset[baseLayerTileServer].theme === "all")) {
    return tilePreset[baseLayerTileServer];
  }
  if (baseLayerTileServer && baseLayerTileServerType) {
    let tiles = [];
    if (baseLayerTileServer.match(/^(https?):\/\/{(s|S)}\../)) {
      tiles = [
        baseLayerTileServer.replace(/{(s|S)}/, "a"),
        baseLayerTileServer.replace(/{(s|S)}/, "b"),
        baseLayerTileServer.replace(/{(s|S)}/, "c")
      ];
    } else {
      tiles = [baseLayerTileServer];
    }
    const mapStyle = {
      version: MAP_STYLE_VERSION_NUMBER,
      sources: {
        "base-tiles": {
          type: baseLayerTileServerType,
          tiles,
          tileSize: 256
        }
      },
      layers: [
        {
          id: "base-layer",
          type: "raster",
          source: "base-tiles",
          minzoom: 0,
          maxzoom: 24
          // https://maplibre.org/maplibre-gl-js-docs/api/map/
        }
      ]
    };
    return mapStyle;
  }
  return colorScheme === "light" ? defaultTileLight : defaultTileDark;
};
var getZoomConstraintsFromTileConfig = (tileConfig, baseLayerTileServer) => {
  const { sources, layers } = tileConfig;
  let matchedBaseLayerTileServer = false;
  const sourceKeys = Object.keys(sources);
  for (let i = 0; i < sourceKeys.length; i += 1) {
    const { minzoom, maxzoom } = sources[sourceKeys[i]];
    if (baseLayerTileServer && sources[sourceKeys[i]].tiles.indexOf(baseLayerTileServer) !== -1) {
      matchedBaseLayerTileServer = true;
    }
    if ((baseLayerTileServer && matchedBaseLayerTileServer || !baseLayerTileServer) && (0, lodash_exports.isNumber)(minzoom) && (0, lodash_exports.isNumber)(maxzoom)) {
      return {
        minZoom: minzoom,
        maxZoom: maxzoom
      };
    }
  }
  for (let i = 0; i < layers.length; i += 1) {
    const { minzoom, maxzoom } = layers[i];
    if ((baseLayerTileServer && matchedBaseLayerTileServer || !baseLayerTileServer) && (0, lodash_exports.isNumber)(minzoom) && (0, lodash_exports.isNumber)(maxzoom)) {
      return {
        minZoom: minzoom,
        maxZoom: maxzoom
      };
    }
  }
  return {
    minZoom: 0,
    maxZoom: 24
  };
};
var getZoomLevelFromGeobin = (geobinStr) => {
  var _a;
  if (!geobinStr) {
    return null;
  }
  const geobinPattern = /bin_id_zl_([0-9]{0,2})?_y_/g;
  const match = geobinPattern.exec(geobinStr);
  return (_a = (match == null ? void 0 : match.length) && parseInt(match[1], 10)) != null ? _a : null;
};
var getStaticColors = (colorCount, colorArray) => {
  if (colorCount < 0 || !colorCount) {
    return [DEFAULT_CLUSTER_COLOR];
  }
  if (!colorArray || !colorArray.length) {
    return [...Array(colorCount).keys()].map((i) => DEFAULT_SERIES_COLORS[i]);
  }
  return [...Array(colorCount).keys()].map(
    (i) => (0, colorUtils_exports.isColor)(colorArray[i % colorArray.length]) ? colorArray[i % colorArray.length] : DEFAULT_CLUSTER_COLOR
  );
};
var matchBubbleSize = (dataRange, data) => {
  const size2 = (0, d3_scale_exports.scalePow)().exponent(0.2).domain(dataRange).range([MIN_BUBBLE_RADIUS, MAX_BUBBLE_RADIUS])(
    data
  );
  if (size2 > MAX_BUBBLE_RADIUS) {
    return MAX_BUBBLE_RADIUS;
  }
  if (size2 < MIN_BUBBLE_RADIUS) {
    return MIN_BUBBLE_RADIUS;
  }
  return size2;
};
var transposeArray = (array2) => {
  if (!array2 || !array2.length || !array2[0] || !array2[0].length) {
    return [];
  }
  return array2[0].map((_7, i) => array2.map((row) => row[i]));
};
var sanitizeValues = (values) => {
  if (!values) {
    return 0;
  }
  if (!Array.isArray(values)) {
    return values > 0 ? values : 0;
  }
  return values.map((arr) => sanitizeValues(arr));
};
var sortByValuesField = (bubbleLayer) => {
  const { bubbleSizeFields, dataValuesField } = bubbleLayer;
  const index = bubbleSizeFields.indexOf(dataValuesField);
  if (index === -1) return bubbleLayer;
  bubbleLayer.bubbleSizeFields.unshift(bubbleLayer.bubbleSizeFields.splice(index, 1)[0]);
  bubbleLayer.bubbleSize.unshift(bubbleLayer.bubbleSize.splice(index, 1)[0]);
};
var bakeBubbleData = (layer) => {
  var _a;
  if (!layer || !((_a = layer.bubbleSize) == null ? void 0 : _a.length) || !layer.geobin || !layer.geobin.length || !layer.latitude || !layer.latitude.length || !layer.longitude || !layer.longitude.length) {
    return null;
  }
  const sanitizedBubbleSize = sanitizeValues(layer.bubbleSize);
  let transposedBubbleSize;
  let transposedSanitizedBubbleSize;
  let isPie = false;
  if (Array.isArray(layer.bubbleSize[0])) {
    transposedBubbleSize = transposeArray(layer.bubbleSize);
    transposedSanitizedBubbleSize = transposeArray(sanitizedBubbleSize);
    if (layer.bubbleSize.length > 1) {
      isPie = true;
      if (layer.dataValuesField && !!layer.dataColors) {
        sortByValuesField(layer);
      }
    }
  } else {
    transposedBubbleSize = layer.bubbleSize.map((n) => [n]);
    transposedSanitizedBubbleSize = sanitizedBubbleSize.map((n) => [n]);
  }
  if (!transposedBubbleSize || !transposedBubbleSize.length) {
    return null;
  }
  const data = layer.latitude.map((lat, i) => ({
    zoom: getZoomLevelFromGeobin(layer.geobin[i]),
    values: transposedBubbleSize[i],
    sanitizedValues: transposedSanitizedBubbleSize[i],
    coordinates: [layer.longitude[i], lat],
    metadata: layer.metadata ? layer.metadata[i] : {}
  })).filter((d) => Boolean(d.values));
  let min = (0, lodash_exports.sum)(transposedSanitizedBubbleSize[0]);
  let max = (0, lodash_exports.sum)(transposedSanitizedBubbleSize[1]);
  transposedSanitizedBubbleSize.forEach((row) => {
    const bubbleSize = (0, lodash_exports.sum)(row);
    max = bubbleSize > max ? bubbleSize : max;
    min = bubbleSize < min ? bubbleSize : min;
  });
  return {
    data,
    dataRange: [min, max],
    isPie,
    resultLimit: layer.resultLimit,
    bubbleSizeFields: layer.bubbleSizeFields
  };
};
var isValidLatLon = (latlon) => {
  if (!latlon || !Array.isArray(latlon) || latlon.length !== 2) {
    return false;
  }
  const [lat, lon] = latlon;
  if (!(0, types_exports.isNumber)(lat) || !(Number(lat) >= MIN_LATITUDE && Number(lat) <= MAX_LATITUDE)) {
    return false;
  }
  if (!(0, types_exports.isNumber)(lon) || !(Number(lon) >= MIN_LONGITUDE && Number(lon) <= MAX_LONGITUDE)) {
    return false;
  }
  return true;
};
var getLatOrLonCoordinates = (layer, field) => {
  const getClusterValues = (clusterLayer) => (0, lodash_exports.get)(clusterLayer, field, []).slice(
    0,
    clusterLayer.type === visualization_schemas_exports.LAYER_TYPE.Marker && clusterLayer.resultLimit ? clusterLayer.resultLimit : DEFAULT_RESULT_LIMIT
  );
  const getChoroplethValues = (choroplethLayer) => {
    const slicedGeomList = choroplethLayer.geom.slice(0, choroplethLayer.resultLimit);
    const flatCoordinates = slicedGeomList.flatMap((geomObject) => geomObject.coordinates.flat(2));
    return flatCoordinates.map((coord) => coord[field === LONGITUDE ? 0 : 1]);
  };
  return layer.type === visualization_schemas_exports.LAYER_TYPE.Choropleth ? getChoroplethValues(layer) : getClusterValues(layer);
};
var getGlobalLayerBoundaries = (layers) => {
  const isLayerValid = (field) => layers.every((layer) => layer[field] || layer.geom);
  const getDefaultMax = (field) => field === LONGITUDE ? MAX_LONGITUDE : MAX_LATITUDE;
  const getDefaultMin = (field) => field === LONGITUDE ? MIN_LONGITUDE : MIN_LATITUDE;
  if (!layers || !Array.isArray(layers) || !layers.length) {
    return null;
  }
  const getMin = (field) => {
    if (!isLayerValid(field)) {
      return getDefaultMin(field);
    }
    return layers.reduce((prevVal, layer) => {
      const coordinatesNumArr = getLatOrLonCoordinates(layer, field).map((x) => +x);
      return (0, lodash_exports.min)([prevVal, ...coordinatesNumArr]);
    }, getDefaultMax(field));
  };
  const getMax = (field) => {
    if (!isLayerValid(field)) {
      return getDefaultMax(field);
    }
    return layers.reduce((prevVal, layer) => {
      const coordinatesNumArr = getLatOrLonCoordinates(layer, field).map(Number);
      return (0, lodash_exports.max)([prevVal, ...coordinatesNumArr]);
    }, getDefaultMin(field));
  };
  return [
    [getMin(LONGITUDE), getMin(LATITUDE)],
    [getMax(LONGITUDE), getMax(LATITUDE)]
  ];
};
var getScaledOpacities = (colors, cfgOpacity) => {
  const opacities = colors == null ? void 0 : colors.map((color) => {
    var _a;
    return (color == null ? void 0 : color.length) === 9 ? (_a = chroma_js_default(color).alpha()) != null ? _a : 1 : 1;
  });
  return opacities == null ? void 0 : opacities.map((opacity) => opacity * cfgOpacity);
};
var compareBaseStyles = (curr, next) => {
  var _a, _b, _c, _d;
  const currBaseLayer = (_a = curr == null ? void 0 : curr.layers) == null ? void 0 : _a.find((layer) => (layer == null ? void 0 : layer.id) === "base-layer");
  const nextBaseLayer = (_b = next == null ? void 0 : next.layers) == null ? void 0 : _b.find((layer) => (layer == null ? void 0 : layer.id) === "base-layer");
  const currBaseSource = (0, lodash_exports.get)(curr == null ? void 0 : curr.sources, (_c = currBaseLayer == null ? void 0 : currBaseLayer.source) != null ? _c : "");
  const nextBaseSource = (0, lodash_exports.get)(next == null ? void 0 : next.sources, (_d = nextBaseLayer == null ? void 0 : nextBaseLayer.source) != null ? _d : "");
  if (!currBaseLayer || !nextBaseLayer || !currBaseSource || !nextBaseSource) {
    return false;
  }
  return (0, lodash_exports.isEqual)(currBaseLayer, nextBaseLayer) && (0, lodash_exports.isEqual)(currBaseSource, nextBaseSource);
};
var formatMetadata = (choroplethLayer, i) => {
  if (!choroplethLayer || !choroplethLayer.areaIds || !choroplethLayer.areaValues) return {};
  if (i >= choroplethLayer.areaIds.length) return {};
  const metadata = choroplethLayer.metadata ? choroplethLayer.metadata[i] : {};
  const name = choroplethLayer.areaIds[i];
  const value = choroplethLayer.areaValues[i];
  const base = { name, value: String(value) };
  return Object.keys(metadata).reduce((result, curr) => {
    const key = `row.${curr}.value`;
    const val = (0, lodash_exports.isObject)(metadata[curr]) ? JSON.stringify(metadata[curr]) : String(metadata[curr]);
    return __spreadProps(__spreadValues({}, result), { [key]: val });
  }, base);
};

// esm-externals:@splunk/visualizations-shared/iconUtils
var iconUtils_exports = {};
__export(iconUtils_exports, {
  default: () => iconUtils_default
});
var defaultImport19 = __toESM(require("@splunk/visualizations-shared/iconUtils"));
__reExport(iconUtils_exports, require("@splunk/visualizations-shared/iconUtils"));
var iconUtils_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/visualizations-shared/RemoteIcon
var RemoteIcon_exports = {};
__export(RemoteIcon_exports, {
  default: () => RemoteIcon_default
});
var defaultImport20 = __toESM(require("@splunk/visualizations-shared/RemoteIcon"));
__reExport(RemoteIcon_exports, require("@splunk/visualizations-shared/RemoteIcon"));
var RemoteIcon_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport21 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// esm-externals:@splunk/react-ui/Popover
var Popover_exports = {};
__export(Popover_exports, {
  default: () => Popover_default
});
var defaultImport22 = __toESM(require("@splunk/react-ui/Popover"));
__reExport(Popover_exports, require("@splunk/react-ui/Popover"));
var Popover_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport23 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// src/Map/PureMap/Tooltip.tsx
var StyledPopover = styled_components_default(Popover_default)`
    width: 250px;
    font-size: 12px;
`;
var StyledTable = styled_components_default.table`
    margin: 2px 6px 2px 6px;
    table-layout: fixed;
    width: calc(100% - 12px);
`;
var StyledTitleColumn = styled_components_default.td`
    opacity: 0.85;
`;
var StyledValueColumn = styled_components_default.td`
    text-align: right;
`;
var StyledColorBlock = styled_components_default.div`
    background-color: ${(props) => props.color};
    display: inline-block;
    margin-right: 4px;
    border-radius: 2px;
    width: 6px;
    height: 11px;
    transform: translateY(1px);
`;
var StyledFieldLabel = styled_components_default.span`
    display: inline-block;
    white-space: nowrap;
`;
var StyledIconWrapper = styled_components_default.span`
    margin-left: 4px;
    display: inline-block;
    vertical-align: middle;
`;
var StyledTooltipHeader = styled_components_default.thead`
    th {
        height: 16px;
        color: ${themes_exports.variables.contentColorActive};
        padding: 0;
    }

    span {
        display: block;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
        width: 100%;
    }
`;
var convertDegToDMS = (decimalDegree, type) => {
  const truncate = (n) => n > 0 ? Math.floor(n) : Math.ceil(n);
  const absoluteDegree = Math.abs(decimalDegree);
  let degrees = truncate(absoluteDegree);
  let minutes = truncate((absoluteDegree - degrees) * 60);
  let seconds = Math.round((absoluteDegree - degrees - minutes / 60) * 3600);
  if (seconds === 60) {
    minutes += 1;
    seconds = 0;
  }
  if (minutes === 60) {
    degrees += 1;
    minutes = 0;
  }
  let direction;
  if (type === "longitude") {
    direction = decimalDegree < 0 ? "W" : "E";
  } else if (type === "latitude") {
    direction = decimalDegree < 0 ? "S" : "N";
  }
  return `${degrees}\xB0 ${minutes}' ${seconds}" ${direction}`;
};
var Tooltip = ({
  open,
  anchor,
  latitude,
  longitude,
  areaId,
  areaValue,
  additionalFields = [],
  showCoordinates = true,
  tooltipHeader = null
}) => {
  const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
  const isTooltipIconFlagEnabled = Boolean(
    featureFlagContext && featureFlagContext.visualizations_enableTooltipIcon
  );
  return /* @__PURE__ */ react_exports.createElement(
    StyledPopover,
    {
      open,
      animation: false,
      anchor,
      "data-test": "map-marker-tooltip",
      defaultPlacement: "above"
    },
    /* @__PURE__ */ react_exports.createElement(StyledTable, null, tooltipHeader && /* @__PURE__ */ react_exports.createElement(StyledTooltipHeader, { "data-test": "tooltip-header" }, /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement("th", { colSpan: 2 }, /* @__PURE__ */ react_exports.createElement("span", { "data-test": "tooltip-header-value" }, tooltipHeader)))), /* @__PURE__ */ react_exports.createElement("tbody", null, areaId && areaValue && /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, { "data-test": "area-id" }, areaId), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "area-value" }, areaValue)), Boolean(showCoordinates && latitude) && /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, null, (0, i18n_exports._)("Latitude")), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "latitude" }, convertDegToDMS(latitude, "latitude"))), Boolean(showCoordinates && longitude) && /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, null, (0, i18n_exports._)("Longitude")), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "longitude" }, convertDegToDMS(longitude, "longitude"))), additionalFields.filter(({ value }) => value && String(value) !== "0").map(({ name, value, color, icon }, index) => /* @__PURE__ */ react_exports.createElement("tr", { key: String(index) }, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, { "data-test": "field-title" }, color ? /* @__PURE__ */ react_exports.createElement(StyledColorBlock, { "data-test": "field-color", color }) : null, /* @__PURE__ */ react_exports.createElement(StyledFieldLabel, null, name, isTooltipIconFlagEnabled && icon && ((0, iconUtils_exports.isRemoteIcon)(icon) || (0, iconUtils_exports.isDataURI)(icon)) ? /* @__PURE__ */ react_exports.createElement(StyledIconWrapper, { "data-test": "field-icon" }, /* @__PURE__ */ react_exports.createElement(RemoteIcon_default, { iconURL: icon, width: 16, height: 16 })) : null)), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "field-value" }, value)))))
  );
};
var Tooltip_default = Tooltip;

// src/Map/PureMap/MarkerWrapper.tsx
var MarkerWrapper = (_a) => {
  var _b = _a, {
    longitude,
    latitude,
    areaId,
    areaValue,
    additionalFields = [],
    tooltipHeader = null,
    map,
    isChoroplethTooltipOpen,
    children,
    showCoordinates = true
  } = _b, otherProps = __objRest(_b, [
    "longitude",
    "latitude",
    "areaId",
    "areaValue",
    "additionalFields",
    "tooltipHeader",
    "map",
    "isChoroplethTooltipOpen",
    "children",
    "showCoordinates"
  ]);
  const container = react_exports.useRef();
  const marker = react_exports.useRef();
  const [isTooltipOpen, setTooltipOpenStatus] = react_exports.useState(false);
  const isChoroplethTooltip = react_exports.useCallback(() => isChoroplethTooltipOpen !== void 0, [
    isChoroplethTooltipOpen
  ]);
  const openTooltip = react_exports.useCallback(() => setTooltipOpenStatus(true), []);
  const closeTooltip = react_exports.useCallback(() => setTooltipOpenStatus(false), []);
  const cleanupMarker = react_exports.useCallback(() => {
    if (marker.current) {
      marker.current.remove();
      marker.current = void 0;
    }
  }, []);
  react_exports.useEffect(() => {
    try {
      if (marker.current) {
        marker.current.setLngLat([longitude, latitude]);
      } else {
        marker.current = new maplibre_gl_exports.Marker({ element: container.current });
        marker.current.setLngLat([longitude, latitude]);
        marker.current.addTo(map.current);
      }
    } catch (error) {
      console.error(error);
      cleanupMarker();
    }
  }, [latitude, longitude, map]);
  react_exports.useEffect(() => cleanupMarker, []);
  const filteredAdditionalFields = additionalFields.filter(({ value }) => value && String(value) !== "0");
  const showTooltip = showCoordinates || filteredAdditionalFields.length || areaId && areaValue;
  return /* @__PURE__ */ react_exports.createElement("div", { style: { visibility: isChoroplethTooltip() ? "hidden" : "visible" } }, /* @__PURE__ */ react_exports.createElement(
    "div",
    __spreadValues({
      style: { visibility: isChoroplethTooltip() ? "hidden" : "visible" },
      ref: container,
      "data-test": "map-marker",
      onMouseOver: openTooltip,
      onMouseLeave: closeTooltip,
      onFocus: openTooltip,
      onBlur: closeTooltip
    }, otherProps),
    children
  ), /* @__PURE__ */ react_exports.createElement("div", null, showTooltip && /* @__PURE__ */ react_exports.createElement(
    Tooltip_default,
    {
      open: isChoroplethTooltip() ? isChoroplethTooltipOpen : isTooltipOpen,
      anchor: container.current,
      latitude: isChoroplethTooltip() ? null : latitude,
      longitude: isChoroplethTooltip() ? null : longitude,
      areaId,
      areaValue,
      additionalFields,
      showCoordinates,
      tooltipHeader
    }
  )));
};
var MarkerWrapper_default = MarkerWrapper;

// src/Map/PureMap/BubbleLayer.tsx
var GEO_BOUND_PREFIX = "_geo_bounds_";
var GEO_LAT_AND_LONG_FIELD = ["_geo_long_field", "_geo_lat_field"];
var ICON_DISPLAY_CUTOFF = 16;
var PieSegment = react_exports.memo(
  ({
    start,
    end,
    radius,
    color,
    themeColor,
    segmentMetadata,
    handleBubbleClick
  }) => {
    const { name, value } = segmentMetadata != null ? segmentMetadata : {};
    const handleSegmentClick = react_exports.useCallback(
      (e) => {
        handleBubbleClick(e, name, value);
      },
      [name, value, handleBubbleClick]
    );
    if (end - start === 1) {
      return /* @__PURE__ */ react_exports.createElement(
        "circle",
        {
          onClick: handleSegmentClick,
          cx: radius,
          cy: radius,
          r: radius,
          fill: color,
          fillOpacity: 0.5,
          strokeWidth: 1.5,
          stroke: color
        }
      );
    }
    const a0 = 2 * Math.PI * (start - 0.25);
    const a1 = 2 * Math.PI * (end - 0.25);
    const x0 = Math.cos(a0);
    const y0 = Math.sin(a0);
    const x1 = Math.cos(a1);
    const y1 = Math.sin(a1);
    const arc = end - start > 0.5 ? 1 : 0;
    return /* @__PURE__ */ react_exports.createElement(
      "path",
      {
        onClick: handleSegmentClick,
        d: `M ${radius} ${radius} L ${radius + radius * x0} ${radius + radius * y0} A ${radius} ${radius} 0 ${arc} 1 ${radius + radius * x1} ${radius + radius * y1} L ${radius} ${radius} A 0 0 0 ${arc} 0 ${radius} ${radius}`,
        fill: color,
        fillOpacity: 0.8,
        stroke: themeColor,
        strokeWidth: 2,
        strokeOpacity: 0.3
      }
    );
  }
);
PieSegment.displayName = "MapBubblePieSegment";
var StyledMarkerWrapper = styled_components_default(MarkerWrapper_default)`
    cursor: pointer;
`;
var Bubble = react_exports.memo(
  ({
    originalValues,
    valueRange,
    colors,
    themeColor,
    isPie,
    latitude,
    longitude,
    bubbleSize,
    additionalFields = [],
    tooltipHeader = null,
    map,
    handleMapClick,
    icon,
    showCoordinates
  }) => {
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const isBubbleMapIconFlagEnabled = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableBubbleMapIcon
    );
    const onBubbleClick = react_exports.useCallback(
      (e, name, value) => {
        handleMapClick(e, name, value);
        e.stopPropagation();
      },
      [handleMapClick]
    );
    const allZeros = originalValues.every((v) => v === 0);
    const values = originalValues.map((v) => v > 0 ? v : 0);
    const total = values.reduce((totalValue, v) => totalValue + v, 0);
    const radius = matchBubbleSize(valueRange, total);
    const bubble = react_exports.useMemo(() => {
      if (allZeros || !originalValues.length) return null;
      const offsets = [];
      let runningTotal = 0;
      values.forEach((count) => {
        offsets.push(runningTotal);
        runningTotal += count;
      });
      const width = radius * 2;
      return /* @__PURE__ */ react_exports.createElement("svg", { width, height: width, viewBox: `-3 -3 ${width + 6} ${width + 6}` }, isPie && /* @__PURE__ */ react_exports.createElement(
        "circle",
        {
          cx: radius,
          cy: radius,
          r: radius,
          fill: "none",
          strokeWidth: 2,
          stroke: themeColor,
          strokeOpacity: 0.3
        }
      ), values.map((v, i) => /* @__PURE__ */ react_exports.createElement(
        PieSegment,
        {
          key: String(i),
          start: offsets[i] / total,
          end: (offsets[i] + v) / total,
          radius,
          color: colors[i],
          themeColor,
          segmentMetadata: bubbleSize[i],
          handleBubbleClick: onBubbleClick
        }
      )));
    }, [
      bubbleSize,
      colors,
      isPie,
      onBubbleClick,
      originalValues,
      themeColor,
      allZeros,
      radius,
      total,
      values
    ]);
    if (!bubble) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      StyledMarkerWrapper,
      {
        longitude,
        latitude,
        additionalFields: [...bubbleSize, ...additionalFields],
        tooltipHeader,
        map,
        "data-test-type": "bubble",
        showCoordinates
      },
      bubble,
      isBubbleMapIconFlagEnabled && radius >= ICON_DISPLAY_CUTOFF && icon && ((0, iconUtils_exports.isRemoteIcon)(icon) || (0, iconUtils_exports.isDataURI)(icon)) && /* @__PURE__ */ react_exports.createElement(
        "div",
        {
          "data-test": "bubble-icon-wrapper",
          style: {
            position: "absolute",
            top: `${radius}px`,
            left: `${radius}px`,
            transform: "translate(-50%, -50%)",
            pointerEvents: "none"
          }
        },
        /* @__PURE__ */ react_exports.createElement(RemoteIcon_default, { iconURL: icon, width: radius * 0.8, height: radius * 0.8 })
      )
    );
  }
);
Bubble.displayName = "MapBubble";
var BubbleLayer = (props) => {
  const { bubbleLayer, themeColorScheme, map, zoom, onMapClick, showCoordinates } = props;
  bubbleLayer.seriesColors = bubbleLayer.seriesColors || DEFAULT_SERIES_COLORS;
  bubbleLayer.bubbleSize = bubbleLayer.bubbleSize || [];
  bubbleLayer.icon = bubbleLayer.icon || [];
  const bakedData = react_exports.useMemo(() => bakeBubbleData(bubbleLayer), [bubbleLayer]);
  const staticColors = react_exports.useMemo(
    () => getStaticColors(bubbleLayer.bubbleSize.length, bubbleLayer.seriesColors),
    [bubbleLayer.bubbleSize.length, bubbleLayer.seriesColors]
  );
  const { data = [], dataRange = [], resultLimit, bubbleSizeFields, isPie } = bakedData != null ? bakedData : {};
  const { additionalTooltipFields = [], tooltipHeaderFieldName = null } = bubbleLayer;
  const roundedZoom = Math.round(zoom);
  const themeColor = themeColorScheme === "light" ? "#ffffff" : "#1a1c20";
  const dynamicColors = bubbleLayer.dataColors;
  const dataToRender = react_exports.useMemo(
    () => data.reduce((acc, datum, i) => {
      if (datum.zoom === roundedZoom) {
        acc.push({ data: datum, idx: i });
      }
      return acc;
    }, []).slice(0, resultLimit || DEFAULT_RESULT_LIMIT).sort((a, b) => (0, lodash_exports.sum)(b.data.values) - (0, lodash_exports.sum)(a.data.values)),
    [data, resultLimit, roundedZoom]
  );
  const handleMapClick = react_exports.useCallback(
    (e, name, value, i) => {
      var _a, _b, _c;
      const metadata = (_c = (_b = (_a = dataToRender[i]) == null ? void 0 : _a.data) == null ? void 0 : _b.metadata) != null ? _c : {};
      const payload = Object.keys(metadata).reduce(
        (acc, curr) => {
          const key = `row.${curr}.value`;
          const val = String(metadata[curr]);
          return __spreadProps(__spreadValues({}, acc), { [key]: val });
        },
        { name, value: String(value) }
      );
      onMapClick({ e, payload });
    },
    [dataToRender, onMapClick]
  );
  return /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, dataToRender.map((datum, i) => {
    const colors = dynamicColors ? [
      dataToRender.map(
        (obj) => (0, colorUtils_exports.isColor)(dynamicColors[obj.idx]) ? dynamicColors[obj.idx] : DEFAULT_CLUSTER_COLOR
      )[i]
    ] : staticColors;
    const [longitude, latitude] = datum.data.coordinates;
    const bubbleSize = datum.data.values.map((value, index) => ({
      name: bubbleSizeFields[index],
      value,
      color: colors[index]
    }));
    const additionalFields = bubbleLayer.metadata ? additionalTooltipFields.map((field) => {
      var _a;
      return {
        name: field,
        value: datum.data.metadata[field],
        icon: (_a = bubbleLayer.tooltipFieldIcons) == null ? void 0 : _a[field]
      };
    }) : [];
    const tooltipHeaderField = bubbleLayer.metadata && datum.data.metadata[tooltipHeaderFieldName];
    return /* @__PURE__ */ react_exports.createElement(
      Bubble,
      {
        key: String(i),
        originalValues: datum.data.values,
        valueRange: dataRange,
        colors,
        themeColor,
        isPie,
        longitude,
        latitude,
        bubbleSize,
        additionalFields,
        tooltipHeader: tooltipHeaderField,
        map,
        handleMapClick: (e, name, value) => handleMapClick(e, name, value, i),
        icon: bubbleLayer.icon[datum.idx],
        showCoordinates
      }
    );
  }));
};
var BubbleLayer_default = BubbleLayer;

// src/Map/PureMap/MarkerLayer.tsx
var MarkerIcon = (_a) => {
  var _b = _a, { theme, color } = _b, otherProps = __objRest(_b, ["theme", "color"]);
  const strokeOpacity = theme === "light" ? 0.7 : 0.15;
  return /* @__PURE__ */ react_exports.createElement("svg", __spreadValues({ width: 22, height: 28, fill: "none" }, otherProps), /* @__PURE__ */ react_exports.createElement(
    "path",
    {
      d: "M11 .5C5.201.5.5 5.201.5 11c0 3.136 1.376 5.952 3.555 7.875 2.839 2.506 4.144 4.58 4.893 6.02.183.35.334.665.469.946l.014.03c.136.285.263.548.387.766.235.412.571.863 1.182.863.61 0 .947-.45 1.182-.863.124-.218.25-.48.387-.765l.014-.03c.135-.282.286-.597.469-.947.75-1.44 2.054-3.514 4.893-6.02A10.476 10.476 0 0 0 21.5 11C21.5 5.201 16.799.5 11 .5Z",
      fill: color
    }
  ), /* @__PURE__ */ react_exports.createElement(
    "path",
    {
      d: "M11 .5C5.201.5.5 5.201.5 11c0 3.136 1.376 5.952 3.555 7.875 2.839 2.506 4.144 4.58 4.893 6.02.183.35.334.665.469.946l.014.03c.136.285.263.548.387.766.235.412.571.863 1.182.863.61 0 .947-.45 1.182-.863.124-.218.25-.48.387-.765l.014-.03c.135-.282.286-.597.469-.947.75-1.44 2.054-3.514 4.893-6.02A10.476 10.476 0 0 0 21.5 11C21.5 5.201 16.799.5 11 .5Z",
      stroke: "#08090A"
    }
  ), /* @__PURE__ */ react_exports.createElement(
    "path",
    {
      d: "M11 .5C5.201.5.5 5.201.5 11c0 3.136 1.376 5.952 3.555 7.875 2.839 2.506 4.144 4.58 4.893 6.02.183.35.334.665.469.946l.014.03c.136.285.263.548.387.766.235.412.571.863 1.182.863.61 0 .947-.45 1.182-.863.124-.218.25-.48.387-.765l.014-.03c.135-.282.286-.597.469-.947.75-1.44 2.054-3.514 4.893-6.02A10.476 10.476 0 0 0 21.5 11C21.5 5.201 16.799.5 11 .5Z",
      stroke: color,
      strokeOpacity
    }
  ));
};
var Marker2 = react_exports.memo(
  ({
    latitude,
    longitude,
    color,
    themeColorScheme,
    map,
    additionalFields,
    handleLayerClick,
    showCoordinates,
    tooltipHeader
  }) => {
    const icon = react_exports.useMemo(
      () => /* @__PURE__ */ react_exports.createElement(MarkerIcon, { color, theme: themeColorScheme, onClick: handleLayerClick }),
      [color, handleLayerClick, themeColorScheme]
    );
    return /* @__PURE__ */ react_exports.createElement(
      StyledMarkerWrapper2,
      {
        latitude,
        longitude,
        map,
        additionalFields,
        "data-test-type": "marker",
        showCoordinates,
        tooltipHeader
      },
      icon
    );
  }
);
Marker2.displayName = "MapMarker";
var StyledMarkerWrapper2 = styled_components_default(MarkerWrapper_default)`
    width: 22px;
    height: 28px;
    cursor: pointer;
`;
var generateMarkerWrapperProps = (markerLayer, onMapClick = lodash_exports.noop, showCoordinates) => {
  var _a;
  const latArray = markerLayer.latitude;
  const lonArray = markerLayer.longitude;
  const isStaticColor = !markerLayer.dataColors;
  const limit = Math.min(
    latArray.length,
    lonArray.length,
    markerLayer.resultLimit ? markerLayer.resultLimit : DEFAULT_RESULT_LIMIT
  );
  const markerProps = [];
  for (let i = 0; i < limit; i += 1) {
    const staticColor = markerLayer.seriesColors && (0, colorUtils_exports.isColor)(markerLayer.seriesColors[0]) ? markerLayer.seriesColors[0] : DEFAULT_CLUSTER_COLOR;
    const dynamicColor = markerLayer.dataColors && (0, colorUtils_exports.isColor)(markerLayer.dataColors[i]) ? markerLayer.dataColors[i] : DEFAULT_CLUSTER_COLOR;
    const color = isStaticColor ? staticColor : dynamicColor;
    const tooltipHeader = markerLayer.tooltipHeaderField && markerLayer.tooltipHeaderField[i];
    const additionalFields = ((_a = markerLayer.metadata) == null ? void 0 : _a[i]) ? markerLayer.additionalTooltipFields.map((field) => ({
      name: field,
      value: markerLayer.metadata[i][field]
    })) : [];
    const handleLayerClick = (e) => {
      var _a2;
      const metadata = (_a2 = markerLayer == null ? void 0 : markerLayer.metadata[i]) != null ? _a2 : {};
      const payload = Object.keys(metadata).reduce((acc, curr) => {
        const key = `row.${curr}.value`;
        const value = String(metadata[curr]);
        return __spreadProps(__spreadValues({}, acc), { [key]: value });
      }, {});
      onMapClick({ e, payload });
    };
    markerProps.push({
      latitude: latArray[i],
      longitude: lonArray[i],
      color,
      additionalFields,
      tooltipHeader,
      handleLayerClick,
      showCoordinates
    });
  }
  return markerProps;
};
var MarkerLayer = (props) => {
  const { map, themeColorScheme, markerLayer, onMapClick, showCoordinates = true } = props;
  markerLayer.seriesColors = markerLayer.seriesColors || DEFAULT_SERIES_COLORS;
  const markerPropsList = react_exports.useMemo(
    () => generateMarkerWrapperProps(markerLayer, onMapClick, showCoordinates),
    [markerLayer, onMapClick, showCoordinates]
  );
  return /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, markerPropsList.map((markerProps, i) => /* @__PURE__ */ react_exports.createElement(
    Marker2,
    __spreadProps(__spreadValues({
      key: String(i),
      themeColorScheme,
      map
    }, markerProps), {
      showCoordinates
    })
  )));
};
var MarkerLayer_default = MarkerLayer;

// src/Map/PureMap/ClusterLayer.tsx
var ClusterLayer = ({
  clusterLayer,
  themeColorScheme,
  zoom,
  map,
  onMapClick,
  showCoordinates
}) => {
  var _a;
  if (((_a = map == null ? void 0 : map.current) == null ? void 0 : _a.isStyleLoaded) && [clusterLayer.longitude, clusterLayer.latitude].every(Array.isArray)) {
    if ((clusterLayer == null ? void 0 : clusterLayer.type) === visualization_schemas_exports.LAYER_TYPE.Marker && !("geobin" in clusterLayer)) {
      return /* @__PURE__ */ react_exports.createElement(
        MarkerLayer_default,
        {
          markerLayer: clusterLayer,
          themeColorScheme,
          map,
          onMapClick,
          showCoordinates
        }
      );
    }
    if ((clusterLayer == null ? void 0 : clusterLayer.type) === visualization_schemas_exports.LAYER_TYPE.Bubble && "geobin" in clusterLayer && "bubbleSize" in clusterLayer) {
      return /* @__PURE__ */ react_exports.createElement(
        BubbleLayer_default,
        {
          bubbleLayer: clusterLayer,
          themeColorScheme,
          map,
          zoom,
          onMapClick,
          showCoordinates
        }
      );
    }
  }
  return null;
};
var ClusterLayer_default = ClusterLayer;

// src/Map/PureMap/ChoroplethLayer.tsx
var getShapeId = (id) => `shape-${id}`;
var getSourceId = (id) => `source-${id}`;
var getStrokeId = (id) => `stroke-${id}`;
var compareGeom = (prev, next) => {
  if (prev !== null && next !== null) {
    return prev.type === next.type && (0, lodash_exports.isEqual)(prev.coordinates, next.coordinates);
  }
  return prev === null && next === null;
};
var compareChoropleth = (prevProps, nextProps) => {
  return compareGeom(prevProps.geomData, nextProps.geomData) && prevProps.id === nextProps.id && prevProps.map === nextProps.map && prevProps.areaId === nextProps.areaId && prevProps.areaValue === nextProps.areaValue && prevProps.color === nextProps.color && prevProps.opacity === nextProps.opacity && prevProps.strokeColor === nextProps.strokeColor && prevProps.isThemeChanged === nextProps.isThemeChanged && (0, lodash_exports.isEqual)(prevProps.additionalFields, nextProps.additionalFields) && prevProps.tooltipHeader === nextProps.tooltipHeader && prevProps.handleMapClick.toString() === nextProps.handleMapClick.toString();
};
var cleanupChoropleth = (shapeId, sourceId, strokeId, map) => {
  var _a, _b, _c;
  let currLayer;
  let currSource;
  let currStrokeLayer;
  try {
    currLayer = (_a = map == null ? void 0 : map.current) == null ? void 0 : _a.getLayer(shapeId);
    currStrokeLayer = (_b = map == null ? void 0 : map.current) == null ? void 0 : _b.getLayer(strokeId);
    currSource = (_c = map == null ? void 0 : map.current) == null ? void 0 : _c.getSource(sourceId);
  } catch (e) {
    return;
  }
  if (currLayer) {
    map.current.removeLayer(shapeId);
  }
  if (currStrokeLayer) {
    map.current.removeLayer(strokeId);
  }
  if (currSource) {
    map.current.removeSource(sourceId);
  }
};
var Choropleth = react_exports.memo(
  ({
    id,
    areaId,
    areaValue,
    geomData,
    map,
    color,
    opacity,
    strokeColor,
    isThemeChanged,
    additionalFields,
    tooltipHeader,
    handleMapClick
  }) => {
    const sourceId = getSourceId(id);
    const shapeId = getShapeId(id);
    const strokeId = getStrokeId(id);
    const formattedGeomData = {
      type: "Feature",
      geometry: geomData
    };
    const [isTooltipOpen, setTooltipOpenStatus] = react_exports.useState(false);
    const [mouseLat, setmouseLat] = react_exports.useState(0);
    const [mouseLng, setmouseLng] = react_exports.useState(0);
    const openTooltip = react_exports.useCallback(() => {
      setTooltipOpenStatus(true);
    }, []);
    const closeTooltip = react_exports.useCallback(() => {
      setTooltipOpenStatus(false);
    }, []);
    const updateChoropleth = react_exports.useCallback(() => {
      cleanupChoropleth(shapeId, sourceId, strokeId, map);
      map.current.addSource(sourceId, {
        type: "geojson",
        data: formattedGeomData
      });
      map.current.addLayer({
        id: shapeId,
        type: "fill",
        source: sourceId,
        layout: {},
        paint: {
          "fill-opacity": opacity,
          "fill-color": color
        }
      });
      if (strokeColor !== "transparent") {
        map.current.addLayer({
          id: strokeId,
          type: "line",
          source: sourceId,
          layout: {},
          paint: {
            "line-color": strokeColor,
            "line-width": 1
          }
        });
      }
      map.current.on("mousemove", shapeId, (e) => {
        const mouseLngLat = e.lngLat;
        setmouseLat(mouseLngLat.lat);
        setmouseLng(mouseLngLat.lng);
        openTooltip();
        map.current.getCanvas().style.cursor = "pointer";
      });
      map.current.on("mouseleave", shapeId, () => {
        closeTooltip();
        map.current.getCanvas().style.cursor = "";
      });
      map.current.on("click", shapeId, (e) => {
        handleMapClick(e);
      });
    }, [shapeId, sourceId, map, color, opacity, formattedGeomData]);
    react_exports.useEffect(() => {
      updateChoropleth();
    }, [map, geomData, color, opacity, id, strokeColor]);
    react_exports.useEffect(() => () => cleanupChoropleth(shapeId, sourceId, strokeId, map), []);
    if (isThemeChanged) {
      updateChoropleth();
    }
    return /* @__PURE__ */ react_exports.createElement(
      MarkerWrapper_default,
      {
        isChoroplethTooltipOpen: isTooltipOpen,
        additionalFields,
        tooltipHeader,
        latitude: mouseLat,
        longitude: mouseLng,
        map,
        areaId,
        areaValue
      },
      /* @__PURE__ */ react_exports.createElement("div", { "data-test": "choropleth-anchor", style: { padding: "24px", visibility: "hidden" } })
    );
  },
  compareChoropleth
);
Choropleth.displayName = "MapChoropleth";
var ChoroplethLayer = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  const { map, choroplethLayer, isThemeChanged, setIsThemeChanged, onMapClick } = props;
  const cfgOpacity = Math.min(Math.max(choroplethLayer == null ? void 0 : choroplethLayer.choroplethOpacity, 0), 1);
  const scaledOpacities = (_a = getScaledOpacities(choroplethLayer == null ? void 0 : choroplethLayer.dataColors, cfgOpacity)) != null ? _a : [];
  const colors = (_b = choroplethLayer == null ? void 0 : choroplethLayer.dataColors) == null ? void 0 : _b.map((color) => (color == null ? void 0 : color.length) > 7 ? color.slice(0, 7) : color);
  const limit = Math.min(
    (_c = choroplethLayer == null ? void 0 : choroplethLayer.areaIds) == null ? void 0 : _c.length,
    (_d = choroplethLayer == null ? void 0 : choroplethLayer.areaValues) == null ? void 0 : _d.length,
    (_f = (_e = choroplethLayer == null ? void 0 : choroplethLayer.geom) == null ? void 0 : _e.length) != null ? _f : 0,
    (choroplethLayer == null ? void 0 : choroplethLayer.resultLimit) ? choroplethLayer.resultLimit : DEFAULT_RESULT_LIMIT
  );
  const areaIdSliced = (_h = (_g = choroplethLayer == null ? void 0 : choroplethLayer.areaIds) == null ? void 0 : _g.slice(0, limit)) != null ? _h : [];
  const uniqueAreaIdSliced = (0, lodash_exports.uniq)(areaIdSliced).length !== areaIdSliced.length ? areaIdSliced.map((id, i) => `${id}${i}`) : areaIdSliced;
  const additionalFields = (choroplethLayer == null ? void 0 : choroplethLayer.metadata) ? choroplethLayer.metadata.map(
    (choroplethMetadata) => choroplethLayer.additionalTooltipFields.map((field) => ({
      name: field,
      value: choroplethMetadata[field]
    }))
  ) : [];
  const tooltipHeaderField = (choroplethLayer == null ? void 0 : choroplethLayer.tooltipHeaderField) || null;
  const handleMapClick = (e, i) => {
    const payload = formatMetadata(choroplethLayer, i);
    onMapClick({ e, payload });
  };
  if (!map || !choroplethLayer || !choroplethLayer.geom) {
    return /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null);
  }
  if (isThemeChanged) {
    setIsThemeChanged(false);
  }
  return /* @__PURE__ */ react_exports.createElement("div", null, uniqueAreaIdSliced.map((id, i) => {
    const areaId = areaIdSliced[i];
    const areaValue = choroplethLayer.areaValues[i];
    return /* @__PURE__ */ react_exports.createElement(
      Choropleth,
      {
        key: id,
        id,
        geomData: choroplethLayer.geom[i],
        map,
        color: colors[i],
        opacity: scaledOpacities[i],
        strokeColor: choroplethLayer.choroplethStrokeColor,
        isThemeChanged,
        areaId,
        areaValue,
        additionalFields: additionalFields[i],
        tooltipHeader: tooltipHeaderField && tooltipHeaderField[i],
        handleMapClick: (e) => handleMapClick(e, i)
      }
    );
  }));
};
var ChoroplethLayer_default = ChoroplethLayer;

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport24 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// esm-externals:@splunk/visualization-context/GeoRegistry
var GeoRegistry_exports = {};
__export(GeoRegistry_exports, {
  default: () => GeoRegistry_default
});
var defaultImport25 = __toESM(require("@splunk/visualization-context/GeoRegistry"));
__reExport(GeoRegistry_exports, require("@splunk/visualization-context/GeoRegistry"));
var GeoRegistry_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:@splunk/visualization-context/GeoJsonProvider
var GeoJsonProvider_exports = {};
__export(GeoJsonProvider_exports, {
  default: () => GeoJsonProvider_default
});
var defaultImport26 = __toESM(require("@splunk/visualization-context/GeoJsonProvider"));
__reExport(GeoJsonProvider_exports, require("@splunk/visualization-context/GeoJsonProvider"));
var GeoJsonProvider_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// src/Map/PureMap/LocalChoroplethLayer.tsx
var LocalChoroplethLayer = (props) => {
  var _a, _b;
  const { width, height, map, choroplethLayer, isThemeChanged, setIsThemeChanged, onMapClick } = props;
  const cfgOpacity = Math.min(Math.max(choroplethLayer == null ? void 0 : choroplethLayer.choroplethOpacity, 0), 1);
  const [geoJson, setGeoJson] = react_exports.useState({ features: [{ properties: { name: "" }, geometry: [] }] });
  const [validGeoJson, setValidGeoJson] = react_exports.useState(true);
  const [geoJsonError, setGeoJsonError] = react_exports.useState({ level: "info", message: "" });
  react_exports.useEffect(() => {
    let geoJsonData;
    const geoRegistry = GeoRegistry_default.create();
    geoRegistry.addDefaultProvider(new GeoJsonProvider_default());
    try {
      geoJsonData = geoRegistry.getByURL(choroplethLayer.source);
      setGeoJson(geoJsonData);
      setValidGeoJson(true);
    } catch (e) {
      setGeoJsonError(e);
      setValidGeoJson(false);
    }
  }, [choroplethLayer.source]);
  const updatedPropertyFormat = react_exports.useMemo(() => {
    let propertyFormat = "name";
    if (choroplethLayer.areaIds && validGeoJson) {
      const propertyFormats = Object.keys(geoJson.features[0].properties);
      for (let idx = 0; idx < geoJson.features.length; idx += 1) {
        const shapeProperty = geoJson.features[idx].properties;
        const formatCheck = propertyFormats.find(
          (key) => shapeProperty[key] === choroplethLayer.areaIds[0]
        );
        if (formatCheck !== void 0) {
          propertyFormat = formatCheck;
          break;
        }
      }
    }
    return propertyFormat;
  }, [choroplethLayer.areaIds, geoJson]);
  const colors = (_a = choroplethLayer == null ? void 0 : choroplethLayer.dataColors) == null ? void 0 : _a.map((color) => (color == null ? void 0 : color.length) > 7 ? color.slice(0, 7) : color);
  const scaledOpacities = (_b = getScaledOpacities(choroplethLayer == null ? void 0 : choroplethLayer.dataColors, cfgOpacity)) != null ? _b : [];
  const updatedAllChoroplethData = react_exports.useMemo(() => {
    const allChoroplethData = [];
    if (validGeoJson) {
      for (let idx = 0; idx < geoJson.features.length; idx += 1) {
        const el = geoJson.features[idx];
        const choroplethData = {
          color: choroplethLayer.choroplethEmptyAreaColor,
          areaValue: "No Data",
          opacity: cfgOpacity,
          name: "",
          idx: 0
        };
        choroplethData.name = el.properties[updatedPropertyFormat];
        if (choroplethLayer.areaIds) {
          const dataIdx = choroplethLayer.areaIds.indexOf(el.properties[updatedPropertyFormat]);
          if (dataIdx !== -1) {
            choroplethData.color = colors[dataIdx];
            choroplethData.areaValue = choroplethLayer.areaValues[dataIdx];
            choroplethData.opacity = scaledOpacities[dataIdx];
            choroplethData.idx = dataIdx;
          } else {
            choroplethData.idx = choroplethLayer.areaIds.length;
          }
        }
        allChoroplethData.push(choroplethData);
      }
    }
    return allChoroplethData;
  }, [choroplethLayer.areaIds, choroplethLayer.areaValues, colors, scaledOpacities]);
  const handleMapClick = (e, i) => {
    const payload = formatMetadata(choroplethLayer, i);
    onMapClick({ e, payload });
  };
  if (isThemeChanged) {
    setIsThemeChanged(false);
  }
  const additionalFields = (choroplethLayer == null ? void 0 : choroplethLayer.metadata) ? choroplethLayer.metadata.map(
    (choroplethMetadata) => {
      var _a2;
      return (_a2 = choroplethLayer.additionalTooltipFields) == null ? void 0 : _a2.map((field) => ({
        name: field,
        value: choroplethMetadata[field]
      }));
    }
  ) : [];
  return /* @__PURE__ */ react_exports.createElement("div", null, !validGeoJson && /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "choropleth-message",
      width,
      height,
      level: geoJsonError.level,
      message: geoJsonError.message
    }
  ), validGeoJson && updatedAllChoroplethData.map((el, i) => {
    return /* @__PURE__ */ react_exports.createElement(
      Choropleth,
      {
        key: el.name,
        id: el.name,
        map,
        color: el.color,
        opacity: el.opacity,
        strokeColor: choroplethLayer.choroplethStrokeColor,
        areaId: el.name,
        areaValue: el.areaValue,
        handleMapClick: (e) => handleMapClick(e, el.idx),
        isThemeChanged,
        geomData: geoJson.features[i].geometry,
        additionalFields: additionalFields[el.idx],
        tooltipHeader: choroplethLayer.tooltipHeaderField && choroplethLayer.tooltipHeaderField[el.idx]
      }
    );
  }));
};
var LocalChoroplethLayer_default = LocalChoroplethLayer;

// src/Map/PureMap/PureMap.tsx
var DEFAULT_CENTER = [0, 0];
var DEFAULT_CONTROL_BACKGROUND_COLOR = "#2b3033";
var DEFAULT_CONTROL_FOREGROUND_COLOR = "#B5B5B5";
var DEFAULT_SCALE_UNIT = "imperial";
var DEFAULT_SHOW_SCALE = true;
var DEFAULT_SHOW_ZOOM_CONTROLS = true;
var DEFAULT_SHOW_BASELAYER = true;
var DEFAULT_ZOOM = 0;
var formatColor = (color) => {
  const chromaColor = chroma_js_default(color);
  return {
    color: chroma_js_default(chromaColor.rgb()).hex().replace("#", "%23"),
    opacity: chromaColor.alpha()
  };
};
var StyledFitToDataButton = styled_components_default(Button_default).attrs({ "data-test": "fit-to-data-button" })`
    position: absolute;
    top: 115px;
    left: 16px;
    z-index: 3;
    width: 40px !important;
    height: 40px;
    border-radius: 4px;
    border: none;
    box-shadow: 0px 26px 103px rgba(0, 0, 0, 0.64), 0px 11px 18px rgba(0, 0, 0, 0.32),
        0px 3px 6px rgba(0, 0, 0, 0.3) !important;
    background-color: ${(props) => props.controlBackgroundColor} !important;
    background-repeat: no-repeat;
    background-position: center;
    background-image: url('data:image/svg+xml;charset=UTF-8,<svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg"><circle cx="12" cy="12" r="9" stroke="${(props) => props.controlIconColorEncoded.color}" stroke-width="2" stroke-linecap="round"/><path d="M12 3.5V6.5M12 20.5V17.5M3.5 12H6.5M20.5 12H17.5" stroke="${(props) => props.controlIconColorEncoded.color}" stroke-width="2" stroke-linecap="round"/></svg>');
`;
PureMapContainer_default.displayName = "PureMapContainer";
var PureMap = (props) => {
  const {
    width,
    height,
    backgroundColor,
    baseLayerTileServer,
    baseLayerTileServerType,
    center,
    controlBackgroundColor,
    controlForegroundColor,
    layers = [],
    scaleUnit,
    showScale,
    showZoomControls,
    showBaseLayer,
    themeColorScheme,
    zoom,
    onMapLoad,
    onMapClick,
    onOptionsChange,
    title,
    showCoordinates
  } = props;
  const { defaultTileConfig, customTileConfig } = (0, react_exports.useContext)(MapContext_default);
  const basemapContainer = (0, react_exports.useRef)(null);
  const map = (0, react_exports.useRef)(null);
  const scaleControl = (0, react_exports.useRef)(null);
  const zoomControl = (0, react_exports.useRef)(null);
  const fitToDataButtonClickedRef = (0, react_exports.useRef)(false);
  const { tilePreset, defaultTileLight, defaultTileDark } = (0, react_exports.useMemo)(
    () => getTilePreset({ defaultTileConfig, customTileConfig }),
    [defaultTileConfig, customTileConfig]
  );
  const [currentZoomLevel, _setCurrentZoomLevel] = react_exports.useState(zoom != null ? zoom : DEFAULT_ZOOM);
  const currentZoomLevelRef = (0, react_exports.useRef)(currentZoomLevel);
  const setCurrentZoomLevel = (newZoom) => {
    currentZoomLevelRef.current = newZoom;
    _setCurrentZoomLevel(newZoom);
  };
  const [isMapLoaded, setMapIsLoaded] = react_exports.useState(false);
  const [isThemeChanged, setIsThemeChanged] = react_exports.useState(false);
  const [mapMinZoom, _setMapMinZoom] = react_exports.useState(-1);
  const mapMinZoomRef = (0, react_exports.useRef)(mapMinZoom);
  const setMapMinZoom = (newMinZoom) => {
    mapMinZoomRef.current = newMinZoom;
    _setMapMinZoom(newMinZoom);
  };
  const lngLatCenter = (0, react_exports.useMemo)(() => {
    if (!isValidLatLon(center)) {
      return DEFAULT_CENTER;
    }
    return [center[1], center[0]];
  }, [center]);
  const zoomLevel = (0, react_exports.useMemo)(() => {
    if (zoom === void 0) {
      return DEFAULT_ZOOM;
    }
    return zoom;
  }, [zoom]);
  const setIsThemeChangedCallback = (isMyThemeChanged) => {
    setIsThemeChanged(isMyThemeChanged);
  };
  const onOptionsChangeProxy = (0, react_exports.useCallback)(
    (e) => {
      onOptionsChange(e);
    },
    [onOptionsChange]
  );
  const fitMapToContent = (0, react_exports.useCallback)(() => {
    const lngLatBounds = getGlobalLayerBoundaries([layers[0]]);
    map.current.fitBounds(
      lngLatBounds,
      {
        padding: MAX_BUBBLE_RADIUS + 5,
        animate: false
      },
      { triggeredFromFitBounds: true }
    );
  }, [layers]);
  const addZoomEndEventListener = (0, react_exports.useCallback)(() => {
    map.current.on("zoomend", (event) => {
      const mapZoomLevel = map.current.getZoom();
      if (mapZoomLevel < mapMinZoomRef.current) {
        setMapMinZoom(mapZoomLevel);
      }
      if (event == null ? void 0 : event.triggeredFromFitBounds) {
        return;
      }
      setCurrentZoomLevel(mapZoomLevel);
    });
  }, []);
  const initializeMap = (0, react_exports.useCallback)(
    (mapStyle) => {
      map.current = new maplibre_gl_exports.Map(__spreadValues({
        container: basemapContainer.current,
        preserveDrawingBuffer: true,
        style: mapStyle,
        center: lngLatCenter,
        zoom: zoomLevel,
        cooperativeGestures: {
          windowsHelpText: (0, i18n_exports._)("Use Ctrl + scroll to zoom map"),
          macHelpText: (0, i18n_exports._)("Use \u2318 + scroll to zoom map"),
          mobileHelpText: (0, i18n_exports._)("Use two fingers to move the map")
        }
      }, getZoomConstraintsFromTileConfig(mapStyle, baseLayerTileServer)));
      map.current.on("load", () => {
        if ((layers == null ? void 0 : layers.length) > 0 && center === void 0 && zoom === void 0) {
          setMapMinZoom(map.current.getZoom());
          map.current.on("zoomend", () => {
            addZoomEndEventListener();
          });
          fitMapToContent();
        } else {
          addZoomEndEventListener();
        }
        setMapIsLoaded(true);
        setTimeout(() => {
          if (onMapLoad && typeof onMapLoad.exec === "function") {
            onMapLoad.exec();
          }
        }, 500);
      });
      map.current.on("dragend", () => {
        const newCenter = map.current.getCenter();
        onOptionsChangeProxy({ center: [newCenter.lat, newCenter.lng], zoom: map.current.getZoom() });
      });
      map.current.on("resize", () => {
        const mapZoomLevel = map.current.getZoom();
        if (currentZoomLevelRef.current <= mapMinZoomRef.current && mapZoomLevel !== mapMinZoomRef.current) {
          setMapMinZoom(mapZoomLevel);
        }
      });
      zoomControl.current = new maplibre_gl_exports.NavigationControl({ showCompass: false });
      map.current.addControl(zoomControl.current, "top-left");
    },
    [lngLatCenter, zoomLevel, layers == null ? void 0 : layers.length]
  );
  const initializeScale = (0, react_exports.useCallback)(() => {
    scaleControl.current = new maplibre_gl_exports.ScaleControl({
      maxWidth: 70,
      unit: scaleUnit
    });
    map.current.addControl(scaleControl.current);
  }, [scaleUnit]);
  const updateScale = (0, react_exports.useCallback)(() => {
    var _a;
    if (showScale) {
      (_a = scaleControl == null ? void 0 : scaleControl.current) == null ? void 0 : _a.setUnit(scaleUnit);
    }
  }, [scaleUnit, showScale]);
  (0, react_exports.useEffect)(() => {
    if (map.current) {
      map.current.resize();
    }
  }, [width, height]);
  (0, react_exports.useEffect)(() => {
    if (map.current) {
      if (currentZoomLevel === mapMinZoomRef.current && (zoom === void 0 || zoom < mapMinZoomRef.current)) {
        return;
      }
      const newCenter = map.current.getCenter();
      onOptionsChangeProxy({
        // when zooming with mouse/track pad,
        // zooming centers at the cursor position, need to update center as well
        center: [newCenter.lat, newCenter.lng],
        zoom: currentZoomLevel
      });
    }
  }, [currentZoomLevel, onOptionsChangeProxy]);
  (0, react_exports.useEffect)(() => {
    if (Object.keys(tilePreset).length === 0 && (!baseLayerTileServer || !baseLayerTileServerType)) {
      console.warn(
        "Map Tile Server configuration is missing or invalid. Please provide a valid configuration"
      );
      return;
    }
    const mapStyle = getMapStyle({
      showBaseLayer,
      baseLayerTileServer,
      baseLayerTileServerType,
      tilePreset,
      colorScheme: themeColorScheme,
      defaultTileLight,
      defaultTileDark
    });
    mapStyle.version = MAP_STYLE_VERSION_NUMBER;
    if (map.current) {
      const curr = map.current.getStyle();
      const next = (0, lodash_exports.omit)(mapStyle, ["theme", "name", "key"]);
      if (!compareBaseStyles(curr, next)) {
        map.current.setStyle((0, lodash_exports.omit)(mapStyle, ["theme", "name", "key"]));
        setIsThemeChanged(true);
      }
      const { minZoom, maxZoom } = getZoomConstraintsFromTileConfig(mapStyle, baseLayerTileServer);
      map.current.setMinZoom(minZoom);
      map.current.setMaxZoom(maxZoom);
      updateScale();
    } else {
      initializeMap((0, lodash_exports.omit)(mapStyle, ["theme", "name", "key"]));
      initializeScale();
    }
  }, [
    showBaseLayer,
    tilePreset,
    initializeMap,
    initializeScale,
    updateScale,
    defaultTileLight,
    defaultTileDark,
    baseLayerTileServer,
    baseLayerTileServerType,
    themeColorScheme
  ]);
  (0, react_exports.useEffect)(() => {
    if (map.current) {
      if (fitToDataButtonClickedRef.current) {
        return;
      }
      map.current.flyTo({
        center: lngLatCenter,
        // Make sure we are not flying to a zoom value smaller than the mapMinZoom
        // If we do, the map will do a little shake.
        zoom: Math.max(zoomLevel, mapMinZoomRef.current)
      });
    }
  }, [lngLatCenter, zoomLevel]);
  (0, react_exports.useEffect)(
    () => () => {
      if (map.current) {
        map.current.remove();
      }
    },
    []
  );
  const [layer] = layers;
  (0, react_exports.useEffect)(() => {
    if (isMapLoaded && layer && zoom === void 0 && center === void 0) {
      fitMapToContent();
      fitToDataButtonClickedRef.current = false;
    }
  }, [
    layer == null ? void 0 : layer.resultLimit,
    layer == null ? void 0 : layer.latitude,
    layer == null ? void 0 : layer.longitude,
    layer == null ? void 0 : layer.areaIds,
    zoom,
    center
  ]);
  const showResetButton = (0, react_exports.useCallback)(() => {
    return center !== void 0 || zoom !== void 0;
  }, [center, zoom]);
  const handleResetClick = (0, react_exports.useCallback)(() => {
    fitToDataButtonClickedRef.current = true;
    onOptionsChangeProxy({ center: void 0, zoom: void 0 });
  }, [onOptionsChangeProxy]);
  return /* @__PURE__ */ react_exports.createElement(
    PureMapContainer_default,
    {
      "aria-label": title || (0, i18n_exports._)("Map"),
      className: "puremap",
      width,
      height,
      backgroundColor,
      controlBackgroundColor,
      controlForegroundColor,
      controlIconColorEncoded: formatColor(controlForegroundColor),
      ref: basemapContainer,
      showScale,
      showZoomControls
    },
    showResetButton() && /* @__PURE__ */ react_exports.createElement(
      StyledFitToDataButton,
      {
        onClick: handleResetClick,
        title: (0, i18n_exports._)("Fit to data"),
        controlBackgroundColor,
        controlForegroundColor,
        controlIconColorEncoded: formatColor(controlForegroundColor)
      }
    ),
    isMapLoaded && layer && (layer.type === visualization_schemas_exports.LAYER_TYPE.Bubble || layer.type === visualization_schemas_exports.LAYER_TYPE.Marker) && /* @__PURE__ */ react_exports.createElement(
      ClusterLayer_default,
      {
        clusterLayer: layer,
        themeColorScheme,
        map,
        zoom: currentZoomLevel,
        onMapClick,
        showCoordinates
      }
    ),
    isMapLoaded && layer && layer.type === visualization_schemas_exports.LAYER_TYPE.Choropleth && layer.source && /* @__PURE__ */ react_exports.createElement(
      LocalChoroplethLayer_default,
      {
        width,
        height,
        map,
        choroplethLayer: layer,
        isThemeChanged,
        setIsThemeChanged: setIsThemeChangedCallback,
        onMapClick
      }
    ),
    isMapLoaded && layer && layer.type === visualization_schemas_exports.LAYER_TYPE.Choropleth && !layer.source && /* @__PURE__ */ react_exports.createElement(
      ChoroplethLayer_default,
      {
        map,
        choroplethLayer: layer,
        isThemeChanged,
        setIsThemeChanged: setIsThemeChangedCallback,
        onMapClick
      }
    )
  );
};
var isLatLng = (props, propName, componentName) => {
  if (!props[propName]) {
    return null;
  }
  const latAbs = Math.abs(props[propName][0]);
  const lonAbs = Math.abs(props[propName][1]);
  const latlon = props[propName];
  if (latAbs > MAX_LATITUDE && lonAbs <= MAX_LATITUDE) {
    throw new Error(`${componentName} ${propName} may have reversed [lat, lon] ranges.`);
  }
  if (!isValidLatLon(latlon)) {
    throw new Error(`${componentName} ${propName} incorrect [lat, lon] ranges.`);
  }
  return null;
};
PureMap.propTypes = {
  // eslint-disable-next-line react/no-unused-prop-types
  mode: prop_types_exports.string,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  backgroundColor: prop_types_exports.string,
  baseLayerTileServer: prop_types_exports.string,
  baseLayerTileServerType: prop_types_exports.string,
  center: isLatLng,
  controlBackgroundColor: prop_types_exports.string,
  controlForegroundColor: prop_types_exports.string,
  layers: prop_types_exports.arrayOf(
    prop_types_exports.shape({
      type: prop_types_exports.string,
      latitude: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])),
      longitude: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])),
      label: prop_types_exports.string,
      showInLegend: prop_types_exports.bool,
      dataColors: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.arrayOf(prop_types_exports.string)]),
      seriesColors: prop_types_exports.arrayOf(prop_types_exports.string),
      additionalTooltipFields: prop_types_exports.arrayOf(prop_types_exports.string),
      tooltipHeaderField: prop_types_exports.arrayOf(prop_types_exports.string),
      resultLimit: prop_types_exports.number,
      source: prop_types_exports.string,
      choroplethEmptyAreaColor: prop_types_exports.string
    })
  ),
  scaleUnit: prop_types_exports.string,
  showScale: prop_types_exports.bool,
  themeColorScheme: prop_types_exports.string,
  zoom: prop_types_exports.number,
  onMapLoad: prop_types_exports.shape({
    exec: prop_types_exports.func
  }),
  onMapClick: prop_types_exports.func,
  onOptionsChange: prop_types_exports.func
};
PureMap.defaultProps = {
  mode: "view",
  width: 800,
  height: 500,
  backgroundColor: "#0b0c0e",
  controlBackgroundColor: DEFAULT_CONTROL_BACKGROUND_COLOR,
  controlForegroundColor: DEFAULT_CONTROL_FOREGROUND_COLOR,
  scaleUnit: DEFAULT_SCALE_UNIT,
  showScale: DEFAULT_SHOW_SCALE,
  showZoomControls: DEFAULT_SHOW_ZOOM_CONTROLS,
  showBaseLayer: DEFAULT_SHOW_BASELAYER,
  layers: [],
  themeColorScheme: "dark",
  onMapLoad: { exec: lodash_exports.noop },
  onMapClick: lodash_exports.noop,
  onOptionsChange: lodash_exports.noop
};
var PureMap_default = PureMap;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport27 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport28 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport29 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport30 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes3,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes3
    }
  }
];
var BackgroundColor_default = background;

// src/Map/config.ts
var defaultContext = {
  colorRangeConfig: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ],
  colorMatchConfig: [{ match: "", value: "#5C33FF" }]
};
var dataContract = {
  requiredDataSources: [],
  optionalDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization."
    }
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 800,
  initialHeight: 600
};
var themes = {
  defaultBackgroundColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.black(props),
      light: themes_exports.variables.backgroundColor(props)
    },
    prisma: themes_exports.variables.backgroundColorSidebar(props)
  })(props),
  controlBackgroundColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.gray22(props),
      light: themes_exports.variables.white(props)
    },
    prisma: themes_exports.variables.backgroundColorPopup(props)
  })(props),
  controlForegroundColor: (props) => (0, themes_exports.pick)({
    enterprise: themes_exports.variables.textColor(props),
    prisma: themes_exports.variables.contentColorDefault(props)
  })(props),
  defaultChoroplethEmptyAreaColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.gray22(props),
      light: themes_exports.variables.gray92(props)
    },
    prisma: {
      dark: themes_exports.variables.interactiveColorBackground(props),
      light: themes_exports.variables.neutral300(props)
    }
  })(props),
  defaultGradientMigrationConfig: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: ["#4D4A5D", themes_exports.variables.syntaxPurple(props)],
      light: ["#D2CFDC", themes_exports.variables.syntaxPurple(props)]
    },
    prisma: {
      dark: ["#484558", themes_exports.variables.syntaxPurple(props)],
      light: ["#D8D4E1", themes_exports.variables.syntaxPurple(props)]
    }
  })(props)
};
var isChoroplethLayer = (options) => {
  var _a, _b;
  return ((_b = (_a = options.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.type) === visualization_schemas_exports.LAYER_TYPE.Choropleth;
};
var isLocalChoroplethLayer = (options) => isChoroplethLayer(options) && (options.layers[0].source === "geo://default/us" || options.layers[0].source === "geo://default/world");
var EDITOR_LABEL_WIDTH = 140;
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data configurations"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Layer type"),
          option: "layers[0].type",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Bubble"), value: visualization_schemas_exports.LAYER_TYPE.Bubble },
              { label: (0, i18n_exports._)("Marker"), value: visualization_schemas_exports.LAYER_TYPE.Marker },
              { label: (0, i18n_exports._)("Choropleth"), value: visualization_schemas_exports.LAYER_TYPE.Choropleth }
            ]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Area IDs"),
          option: "layers[0].areaIds",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false,
            filterByTypes: ["string"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Area values"),
          option: "layers[0].areaValues",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false,
            filterByTypes: ["number"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Latitude"),
          option: "layers[0].latitude",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => !isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Longitude"),
          option: "layers[0].longitude",
          editor: "editor.columnSelector",
          showEditor: ({ options }) => !isChoroplethLayer(options),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Bubble size"),
          option: "layers[0].bubbleSize",
          editor: "editor.columnMultiSelector",
          showEditor: ({ options }) => !(options.layers && options.layers.length && (options.layers[0].type === "marker" || options.layers[0].type === "choropleth")),
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false,
            excludeByNames: ["latitude", "longitude", "geobin"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Additional tooltip fields"),
          option: "layers[0].additionalTooltipFields",
          editor: "editor.columnMultiSelectionByFieldNameEditor"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Tooltip header field"),
          option: "layers[0].tooltipHeaderField",
          editor: "editor.columnSelector",
          editorProps: {
            dataSourceKey: "primary",
            shouldShowInternalFields: false
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Result limit"),
          option: "layers[0].resultLimit",
          editor: "editor.number",
          showEditor: ({ options }) => !isLocalChoroplethLayer(options),
          editorProps: {
            themes,
            labelPosition: "top",
            min: 0
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Latitude (initial map location)"),
          option: "center[0]",
          editor: "editor.number",
          editorProps: {
            themes,
            labelPosition: "top",
            min: -90,
            max: 90
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Longitude (initial map location)"),
          option: "center[1]",
          editor: "editor.number",
          editorProps: {
            themes,
            labelPosition: "top",
            min: -180,
            max: 180
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Zoom (initial map location)"),
          option: "zoom",
          editor: "editor.number",
          editorProps: {
            themes,
            labelPosition: "top",
            min: 0
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Show Latitude and Longitude"),
          option: "showCoordinates",
          editor: "editor.checkbox",
          editorProps: {
            labelPosition: "right",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Show zoom controls"),
          option: "showZoomControls",
          editor: "editor.checkbox",
          editorProps: {
            labelPosition: "right",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Show scale"),
          option: "showScale",
          editor: "editor.toggle",
          editorProps: {
            labelPosition: "right",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Scale unit"),
          option: "scaleUnit",
          editor: "editor.radioBar",
          showEditor: ({ options }) => options.showScale !== false,
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Metric"), value: "metric" },
              { label: (0, i18n_exports._)("Imperial"), value: "imperial" }
            ]
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Data colors"),
          option: "layers[0].dataColors",
          context: "colorRangeConfig",
          editor: "editor.dynamicColorWithPrecedence",
          editorProps: {
            labelPosition: "top",
            flyoutTitle: (0, i18n_exports._)("Dynamic coloring: value"),
            formatters: [
              {
                label: (0, i18n_exports._)("Ranges"),
                value: "rangeValue",
                isDefault: true,
                defaults: {
                  dataValues: defaultContext.colorRangeConfig
                }
              },
              {
                label: (0, i18n_exports._)("Matches"),
                value: "matchValue",
                defaults: {
                  dataValues: defaultContext.colorMatchConfig
                }
              }
            ],
            dataSelectors: [
              {
                label: (0, i18n_exports._)("Data values"),
                value: "dataValues"
              }
            ],
            defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig
          },
          showEditor: ({ options }) => !isChoroplethLayer(options)
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Data values"),
          editor: "editor.columnSelector",
          option: "layers[0].dataValues",
          showEditor: ({ options }) => {
            var _a, _b;
            return !isChoroplethLayer(options) && ((_b = (_a = options.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.dataColors);
          },
          editorProps: {
            dataSourceKey: "primary",
            filterByTypes: ["number"]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Series colors"),
          option: "layers[0].seriesColors",
          editor: "editor.seriesColors",
          showEditor: ({ options }) => {
            var _a, _b;
            return !isChoroplethLayer(options) && !((_b = (_a = options.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.dataColors);
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Choropleth empty area"),
          option: "layers[0].choroplethEmptyAreaColor",
          editor: "editor.color",
          showEditor: ({ options }) => isLocalChoroplethLayer(options),
          editorProps: {
            themes
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Choropleth stroke"),
          option: "layers[0].choroplethStrokeColor",
          editor: "editor.color",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            themes
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Choropleth opacity (%)"),
          option: "layers[0].choroplethOpacity",
          editor: "editor.percent",
          showEditor: ({ options }) => isChoroplethLayer(options),
          editorProps: {
            themes,
            min: 0
          }
        }
      ],
      // TODO: add support for seriesColorsByField option
      // [
      //     {
      //         label: _('Series colors by field name'),
      //         option: 'seriesColorsByField',
      //         editor: 'editor.seriesColorsByField',
      //     },
      // ],
      BackgroundColor_default({ themes }),
      [
        {
          label: (0, i18n_exports._)("Show base layer"),
          option: "showBaseLayer",
          editor: "editor.toggle"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Base layer tile server"),
          option: "baseLayerTileServer",
          editor: "editor.text",
          showEditor: ({ options }) => options.showBaseLayer !== false
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Base layer tile server type"),
          option: "baseLayerTileServerType",
          editor: "editor.radioBar",
          showEditor: ({ options }) => options.showBaseLayer === false ? false : !(typeof options.baseLayerTileServer === "undefined" || options.baseLayerTileServer === ""),
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Vector"), value: "vector" },
              { label: (0, i18n_exports._)("Raster"), value: "raster" }
            ]
          }
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.map",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Map"),
  category: "Spatial" /* SPATIAL */,
  status: "preview",
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Map,
  placeholderIcon: placeholders_exports.Map,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.mapOptionsSchema,
  editorConfig,
  events: {
    "map.load": {
      description: "triggered when map is fully loaded",
      parentKeys: ["exec"]
    },
    "map.click": {
      description: "trigger when user clicks map layer"
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */],
  themes,
  requiredProps: []
};
var config_default = enhanceConfig(config);

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport31 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport32 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport33 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport34 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport35 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport36 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport37 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport37 ? defaultImport37.default : defaultImport37;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport38 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport38 ? defaultImport38.default : defaultImport38;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys, target) => keys.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport39 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport39 ? defaultImport39.default : defaultImport39;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder2 = shouldShowIconPlaceholder) => {
  const { config: config2 } = Visualization;
  const { themes: themes3 } = config2;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder2(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes3 == null ? void 0 : themes3.defaultBackgroundColor) == null ? void 0 : _a.call(themes3, props);
    const icon = (_b = config2.placeholderIcon) != null ? _b : config2.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config2.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport40 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport40 ? defaultImport40.default : defaultImport40;

// src/common/utils/dataUtils.ts
var convertToArrOfObjects = (columns, fields) => {
  if (!columns || !columns[0] || !columns[0].length) return [];
  const data = [];
  for (let i = 0; i < columns[0].length; i += 1) {
    const newObj = {};
    fields.forEach((field, index) => {
      const fieldName = typeof field === "string" ? field : field.name;
      if (columns[index][i] === "") {
        newObj[fieldName] = null;
      } else {
        newObj[fieldName] = columns[index][i];
      }
    });
    data.push(newObj);
  }
  return data;
};
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport41 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport41 ? defaultImport41.default : defaultImport41;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport42 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport42 ? defaultImport42.default : defaultImport42;

// src/common/utils/trellisUtils.ts
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval = () => {
    },
    disableEditModeCover,
    useIconPlaceholder: useIconPlaceholder2
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder2)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:@splunk/visualization-encoding/utils/dsl
var dsl_exports = {};
__export(dsl_exports, {
  default: () => dsl_default
});
var defaultImport43 = __toESM(require("@splunk/visualization-encoding/utils/dsl"));
__reExport(dsl_exports, require("@splunk/visualization-encoding/utils/dsl"));
var dsl_default = "default" in defaultImport43 ? defaultImport43.default : defaultImport43;

// src/common/utils/mapUtils.ts
var columnsNullToZeros = (config2, dataSources, options) => {
  var _a, _b;
  const { primary } = dataSources;
  const { columns, fields } = primary.data;
  let newColumns = columns;
  const mergedOptions = (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
    {},
    options,
    (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(config2.optionsSchema, "default")
  );
  if (((_b = (_a = mergedOptions.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.type) === "bubble") {
    const latitudeField = (0, dsl_exports.getFieldsFromDSL)(mergedOptions.layers[0].latitude, dataSources)[0] || "";
    const longitudeField = (0, dsl_exports.getFieldsFromDSL)(mergedOptions.layers[0].longitude, dataSources)[0] || "";
    const stringsFields = (0, dsl_exports.getFieldsFromDSL)("> primary | frameBySeriesTypes('string')", dataSources);
    const excludedFields = Array.from(
      /* @__PURE__ */ new Set([
        latitudeField,
        longitudeField,
        "geobin",
        "name",
        ...stringsFields,
        ...GEO_LAT_AND_LONG_FIELD
      ])
    );
    const indicesToEvaluate = new Set(
      fields.reduce((arr, e, i) => {
        const field = typeof e === "string" ? e : e.name.toString();
        if (!excludedFields.includes(field)) {
          arr.push(i);
        }
        return arr;
      }, [])
    );
    newColumns = columns.map((column, i) => {
      if (indicesToEvaluate.has(i)) {
        return column.map((value) => !value || !(0, types_exports.isNumber)(value) ? 0 : +value);
      }
      return column;
    });
  }
  const modifiedDatasources = __spreadProps(__spreadValues({}, dataSources), {
    primary: __spreadProps(__spreadValues({}, primary), {
      data: __spreadProps(__spreadValues({}, primary.data), {
        columns: newColumns
      })
    })
  });
  return modifiedDatasources;
};

// src/Map/Map.tsx
var formatLayer = (l, dataFields, dataSourceData, transformedData) => {
  const geobinIdx = dataFields.indexOf("geobin");
  const layer = l;
  if (geobinIdx > -1) {
    layer.geobin = dataSourceData.columns[geobinIdx];
  }
  const geomIdx = dataFields.indexOf("geom");
  if (geomIdx > -1) {
    layer.geom = dataSourceData.columns[geomIdx].map((geomItem) => {
      return typeof geomItem === "string" ? JSON.parse(geomItem) : geomItem;
    });
  }
  if (Object.prototype.hasOwnProperty.call(layer, "seriesColors")) {
    layer.seriesColors = Array.isArray(layer.seriesColors) ? (0, colorUtils_exports.sanitizeArrayOfColors)(layer.seriesColors) : void 0;
  }
  if (Object.prototype.hasOwnProperty.call(layer, "dataColors")) {
    layer.dataColors = Array.isArray(layer.dataColors) ? (0, colorUtils_exports.sanitizeArrayOfColors)(layer.dataColors) : void 0;
  }
  layer.metadata = transformedData;
};
var computeVizProps = (props) => {
  var _a, _b, _c;
  const { themeFunc, theme, layers, dataSources, onOptionsChange, title } = props;
  const themeColorVariables = ["controlBackgroundColor", "controlForegroundColor"];
  const themeColors = {};
  themeColorVariables.forEach((variable) => {
    themeColors[variable] = themeFunc(variable);
  });
  const themeColorScheme = (theme == null ? void 0 : theme.splunkThemeV1) ? theme == null ? void 0 : theme.splunkThemeV1.colorScheme : "dark";
  const dataSourceData = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) != null ? _b : {};
  const transformedData = convertToArrOfObjects(dataSourceData.columns, dataSourceData.fields);
  const dataFields = ((_c = dataSourceData.fields) != null ? _c : []).map(
    (field) => typeof field === "string" ? field : field.name
  );
  layers == null ? void 0 : layers.forEach((l) => formatLayer(l, dataFields, dataSourceData, transformedData));
  return __spreadProps(__spreadValues(__spreadProps(__spreadValues({}, themeColors), { themeColorScheme }), layers), { onOptionsChange, title });
};
var withTooltipFields = (Viz) => {
  const VizWithTooltipFields = (_a) => {
    var _b = _a, { dataSources, options } = _b, otherProps = __objRest(_b, ["dataSources", "options"]);
    var _a2, _b2, _c;
    if (!dataSources || !dataSources.primary || !dataSources.primary.data) {
      return /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, otherProps), { options }));
    }
    const mergedOptions = (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
      {},
      options,
      (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(config_default.optionsSchema, "default")
    );
    if ((_a2 = mergedOptions.layers) == null ? void 0 : _a2[0]) {
      if (((_c = (_b2 = mergedOptions.layers) == null ? void 0 : _b2[0]) == null ? void 0 : _c.type) === "bubble") {
        mergedOptions.layers[0].bubbleSizeFields = "> bubbleSize | getField()";
        mergedOptions.layers[0].dataValuesField = "> dataValues | getField()";
        mergedOptions.layers[0].tooltipHeaderFieldName = "> tooltipHeaderField | getField()";
      }
      const { fields } = dataSources.primary.data;
      if (Array.isArray(mergedOptions.layers[0].additionalTooltipFields) && Array.isArray(fields) && fields.length) {
        const { bubbleSizeFields = [] } = mergedOptions.layers[0];
        mergedOptions.layers[0].additionalTooltipFields = mergedOptions.layers[0].additionalTooltipFields.filter(
          (field) => (typeof fields[0] === "string" ? fields.includes(field) : fields.map((f) => f.name).includes(field)) && !bubbleSizeFields.includes(field)
        );
      }
    }
    return /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({ dataSources, options: mergedOptions }, otherProps));
  };
  VizWithTooltipFields.propTypes = Viz.propTypes;
  VizWithTooltipFields.defaultProps = Viz.defaultProps;
  VizWithTooltipFields.config = Viz.config;
  return VizWithTooltipFields;
};
var withoutInternalFields = (Viz) => {
  const VizWithoutInternalFields = (_a) => {
    var _b = _a, { dataSources } = _b, otherProps = __objRest(_b, ["dataSources"]);
    if (!dataSources || !dataSources.primary || !dataSources.primary.data) {
      return /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, otherProps));
    }
    const { primary } = dataSources;
    const { columns, fields } = primary.data;
    let newColumns = [];
    let newFields = [];
    if (fields && columns && fields.length === columns.length) {
      const indicesToRemove = new Set(
        fields.reduce((arr, e, i) => {
          const field = typeof e === "string" ? e : e.name.toString();
          if (field.startsWith("_") && !field.startsWith(GEO_BOUND_PREFIX) && !GEO_LAT_AND_LONG_FIELD.includes(field)) {
            arr.push(i);
          }
          return arr;
        }, [])
      );
      newFields = fields.filter((d, i) => !indicesToRemove.has(i));
      newColumns = columns.filter((d, i) => !indicesToRemove.has(i));
    }
    const modifiedDatasources = __spreadProps(__spreadValues({}, dataSources), {
      primary: __spreadProps(__spreadValues({}, primary), {
        data: __spreadProps(__spreadValues({}, primary.data), {
          columns: newColumns,
          fields: newFields
        })
      })
    });
    return /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({ dataSources: modifiedDatasources }, otherProps));
  };
  VizWithoutInternalFields.propTypes = Viz.propTypes;
  VizWithoutInternalFields.defaultProps = Viz.defaultProps;
  VizWithoutInternalFields.config = Viz.config;
  return VizWithoutInternalFields;
};
var withNullToZeros = (Viz) => {
  const VizWithColumnsNullToZeros = (_a) => {
    var _b = _a, { dataSources, options } = _b, otherProps = __objRest(_b, ["dataSources", "options"]);
    if (!dataSources || !dataSources.primary || !dataSources.primary.data) {
      return /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({ options }, otherProps));
    }
    const modifiedDatasources = columnsNullToZeros(config_default, dataSources, options);
    return /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({ dataSources: modifiedDatasources, options }, otherProps));
  };
  VizWithColumnsNullToZeros.propTypes = Viz.propTypes;
  VizWithColumnsNullToZeros.defaultProps = Viz.defaultProps;
  VizWithColumnsNullToZeros.config = Viz.config;
  return VizWithColumnsNullToZeros;
};
function useIconPlaceholder(dataSources, loading) {
  return loading;
}
var Map2 = withoutInternalFields(
  withTooltipFields(
    withNullToZeros(
      withDashboardViz_default({
        ReactViz: PureMap_default,
        vizConfig: config_default,
        computeVizProps,
        disableEditModeCover: true,
        useIconPlaceholder
      })
    )
  )
);
var { themes: themes2 } = config_default;
var Map_default = Map2;
//# sourceMappingURL=Map.js.map
