/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __pow = Math.pow;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Punchcard/index.ts
var Punchcard_exports = {};
__export(Punchcard_exports, {
  PurePunchcard: () => PurePunchcard,
  computeVizProps: () => computeVizProps,
  config: () => config2,
  default: () => Punchcard_default2,
  themes: () => themes2
});
module.exports = __toCommonJS(Punchcard_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-color-palettes
var visualization_color_palettes_exports = {};
__export(visualization_color_palettes_exports, {
  default: () => visualization_color_palettes_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-color-palettes"));
__reExport(visualization_color_palettes_exports, require("@splunk/visualization-color-palettes"));
var visualization_color_palettes_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport3 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport4 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport5 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport7 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport8 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport9 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config3) => {
      return __spreadProps(__spreadValues({}, config3), { open: config3.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes3,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes3
    }
  }
];
var BackgroundColor_default = background;

// src/Punchcard/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [
    // Note: SCP-14090 disable ui for optional datasources. We may need to add it back later
    // {
    //     name: 'annotation',
    //     description: 'DataSource that populate event annotations',
    // },
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {
  bubbleColorConfig: {
    colors: ["rgba(123,86,219,0.4)", "rgba(123,86,219,1)"]
  }
};
var themes = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Show bubble labels"),
          option: "bubbleLabelDisplay",
          editor: "editor.radioBar",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("All"), value: "all" },
              { label: (0, i18n_exports._)("Max"), value: "max" },
              { label: (0, i18n_exports._)("Off"), value: "off" }
            ]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Pulsate max value"),
          option: "showMaxValuePulsation",
          editor: "editor.toggle"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Bubble scale"),
          option: "bubbleSizeMethod",
          editor: "editor.radioBar",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Radius"), value: "radius" },
              { label: (0, i18n_exports._)("Area"), value: "area" }
            ]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Bubble row scale"),
          option: "bubbleRowScale",
          editor: "editor.radioBar",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Global"), value: "global" },
              { label: (0, i18n_exports._)("By Row"), value: "row" }
            ]
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Color mode"),
          option: "colorMode",
          editor: "editor.radioBar",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Dynamic"), value: "dynamic" },
              { label: (0, i18n_exports._)("Categorical"), value: "categorical" }
            ]
          }
        }
      ],
      [
        // This should be hidden in categorical color mode
        {
          label: (0, i18n_exports._)("Color by field"),
          editor: "editor.columnSelector",
          option: "bubbleColor",
          context: "bubbleColorConfig",
          showEditor: ({ options }) => options.colorMode === "dynamic" || options.colorMode === void 0,
          editorProps: {
            dataSourceKey: "primary",
            prepareValue: (definition) => {
              const {
                options: { bubbleColor }
              } = definition;
              return {
                context: {},
                options: {
                  bubbleColor: `${bubbleColor} | gradient(bubbleColorConfig)`
                }
              };
            }
          }
        }
      ],
      BackgroundColor_default({ themes }),
      [
        {
          label: (0, i18n_exports._)("Legend display"),
          option: "legendDisplay",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Right"), value: "right" },
              { label: (0, i18n_exports._)("Off"), value: "off" }
            ]
          },
          showEditor: ({ options }) => options.colorMode === "categorical"
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.punchcard",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Punchcard"),
  category: "Correlation" /* CORRELATION */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Punchcard,
  placeholderIcon: placeholders_exports.Punchcard,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.punchcardOptionsSchema,
  editorConfig,
  events: {
    "legend.click": {
      description: "Triggered when user clicks a chart legend"
    },
    "point.click": {
      description: "Triggered when user clicks a data point"
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "placeholder" /* PLACEHOLDER */, "events" /* EVENTS */],
  themes,
  requiredProps: ["x", "y", "size"]
};
var config_default = enhanceConfig(config);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport10 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport11 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport12 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport13 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport14 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport15 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport16 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport17 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport18 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport19 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport20 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport21 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport22 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport23 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport24 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport25 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport26 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys, target) => keys.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config: config3 } = Visualization;
  const { themes: themes3 } = config3;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes3 == null ? void 0 : themes3.defaultBackgroundColor) == null ? void 0 : _a.call(themes3, props);
    const icon = (_b = config3.placeholderIcon) != null ? _b : config3.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config3.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport27 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// src/common/utils/dataUtils.ts
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every2 = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every2) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every2) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every2) + 1;
    const rangeTo = Math.floor((i + 1) * every2) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport28 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport29 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// src/common/utils/trellisUtils.ts
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:@splunk/visualization-encoding/utils/types
var types_exports = {};
__export(types_exports, {
  default: () => types_default
});
var defaultImport30 = __toESM(require("@splunk/visualization-encoding/utils/types"));
__reExport(types_exports, require("@splunk/visualization-encoding/utils/types"));
var types_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// esm-externals:@splunk/ui-utils/keyboard
var keyboard_exports = {};
__export(keyboard_exports, {
  default: () => keyboard_default
});
var defaultImport31 = __toESM(require("@splunk/ui-utils/keyboard"));
__reExport(keyboard_exports, require("@splunk/ui-utils/keyboard"));
var keyboard_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// esm-externals:d3-scale
var d3_scale_exports = {};
__export(d3_scale_exports, {
  default: () => d3_scale_default
});
var defaultImport32 = __toESM(require("d3-scale"));
__reExport(d3_scale_exports, require("d3-scale"));
var d3_scale_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// src/Punchcard/PurePunchcard/src/utils/punchcardUtils.ts
var AXIS_ORIENTATION_TYPES = /* @__PURE__ */ ((AXIS_ORIENTATION_TYPES2) => {
  AXIS_ORIENTATION_TYPES2["VERTICAL"] = "vertical";
  AXIS_ORIENTATION_TYPES2["HORIZONTAL"] = "horizontal";
  return AXIS_ORIENTATION_TYPES2;
})(AXIS_ORIENTATION_TYPES || {});
var BUBBLE_ROW_SCALE_TYPES = /* @__PURE__ */ ((BUBBLE_ROW_SCALE_TYPES2) => {
  BUBBLE_ROW_SCALE_TYPES2["GLOBAL"] = "global";
  BUBBLE_ROW_SCALE_TYPES2["ROW"] = "row";
  return BUBBLE_ROW_SCALE_TYPES2;
})(BUBBLE_ROW_SCALE_TYPES || {});
var BUBBLE_SCALE_TYPES = /* @__PURE__ */ ((BUBBLE_SCALE_TYPES2) => {
  BUBBLE_SCALE_TYPES2["RADIUS"] = "radius";
  BUBBLE_SCALE_TYPES2["AREA"] = "area";
  return BUBBLE_SCALE_TYPES2;
})(BUBBLE_SCALE_TYPES || {});
var COLOR_MODE_TYPES = /* @__PURE__ */ ((COLOR_MODE_TYPES2) => {
  COLOR_MODE_TYPES2["SEQUENTIAL"] = "sequential";
  COLOR_MODE_TYPES2["CATEGORICAL"] = "categorical";
  return COLOR_MODE_TYPES2;
})(COLOR_MODE_TYPES || {});
var BUBBLE_LABELS_TYPES = /* @__PURE__ */ ((BUBBLE_LABELS_TYPES2) => {
  BUBBLE_LABELS_TYPES2["ALL"] = "all";
  BUBBLE_LABELS_TYPES2["MAX"] = "max";
  BUBBLE_LABELS_TYPES2["NONE"] = "none";
  return BUBBLE_LABELS_TYPES2;
})(BUBBLE_LABELS_TYPES || {});
var GRAYSCALE_FILTER_ID = `punchcard-grayscale-filter-id-${Math.floor(Math.random() * 1e3)}`;
var X_AXIS_HEIGHT = 15;
var Y_AXIS_WIDTH = 77;
var MARGIN = 10;
var LEGEND_WIDTH = 135;
var HORIZONTAL_SPACE_FOR_SINGLE_CHAR = 6;
var getColorCategoryMapping = ({ category, colorMode, seriesColors }) => {
  if (colorMode === "sequential" /* SEQUENTIAL */) {
    return null;
  }
  return (0, d3_scale_exports.scaleOrdinal)().domain(category).range(seriesColors).unknown(seriesColors[0]);
};
var getChartAreaDimensions = ({ containerWidth, containerHeight, displayLegend }) => {
  const yAxisStartX = MARGIN;
  const chartAreaStartX = yAxisStartX + Y_AXIS_WIDTH + MARGIN;
  let chartAreaEndX = containerWidth - MARGIN;
  let legendStartX = null;
  if (displayLegend) {
    legendStartX = containerWidth - LEGEND_WIDTH;
    chartAreaEndX = legendStartX - MARGIN;
  }
  const chartAreaStartY = MARGIN;
  const xAxisStartY = containerHeight - X_AXIS_HEIGHT - MARGIN;
  const chartAreaEndY = xAxisStartY - MARGIN;
  return {
    xAxisStartY,
    yAxisStartX,
    chartAreaStartX,
    chartAreaStartY,
    chartAreaEndX,
    chartAreaEndY,
    legendStartX
  };
};
var getScales = ({ values, start, end }) => {
  const scale = (0, d3_scale_exports.scaleBand)().domain(values).range([start, end]);
  const positionScale = (value) => scale(value) + scale.bandwidth() / 2;
  return {
    scale,
    positionScale
  };
};
var createValueScale = (values) => {
  const absValuesWithoutZero = [];
  values.forEach((value) => {
    if (value) {
      absValuesWithoutZero.push(Math.abs(value));
    }
  });
  return (0, d3_scale_exports.scaleLinear)().domain([Math.min(...absValuesWithoutZero), Math.max(...absValuesWithoutZero)]).range([0, 1]).clamp(true).unknown(0);
};
var getDataByRows = ({
  bubbleRowScale,
  bubbleScale,
  category,
  colorCategoryMapping,
  colorMode,
  bubbleColor,
  minBubbleColorIntensity,
  size: size2,
  x,
  y,
  isBubbleSizeDynamic,
  minBubbleSize,
  maxBubbleSize,
  minBand,
  maxBubbleRadius,
  minBubbleRadius
}) => {
  const dataByRows = {};
  const minRadius = isBubbleSizeDynamic ? minBand / 2 * minBubbleSize : minBubbleRadius;
  const maxRadius = isBubbleSizeDynamic ? minBand / 2 * maxBubbleSize : maxBubbleRadius;
  const minArea = Math.PI * __pow(minRadius, 2);
  const maxArea = Math.PI * __pow(maxRadius, 2);
  const isBubbleColorAnArray = Array.isArray(bubbleColor);
  const globalSizeScale = createValueScale(size2);
  const getRadiusValue = (value, sizeScale) => bubbleScale === "radius" /* RADIUS */ ? (maxRadius - minRadius) * sizeScale(Math.abs(value)) + minRadius : Math.sqrt(((maxArea - minArea) * sizeScale(Math.abs(value)) + minArea) / Math.PI);
  const getColorValue = (c) => colorMode === "categorical" /* CATEGORICAL */ ? colorCategoryMapping(c) : bubbleColor;
  const getOpacityValue = (value, sizeScale) => colorMode === "categorical" /* CATEGORICAL */ || isBubbleColorAnArray ? 1 : sizeScale(Math.abs(value)) * (1 - minBubbleColorIntensity) + minBubbleColorIntensity;
  y.forEach((yValue, index) => {
    const xValue = x[index];
    const sizeValue = size2[index];
    const categoryValue = category && category[index] ? category[index] : null;
    const bubbleColorValue = colorMode === "sequential" /* SEQUENTIAL */ && isBubbleColorAnArray ? bubbleColor[index] : getColorValue(categoryValue);
    if (xValue == null || yValue == null || sizeValue == null) {
      return;
    }
    if (!dataByRows[yValue]) {
      dataByRows[yValue] = {
        rowXValues: [],
        rowSizeValues: [],
        rowCategoryValues: [],
        rowColorValues: [],
        rowFillOpacityValues: [],
        rowSizeScale: globalSizeScale,
        rowRadiusValues: []
      };
    }
    dataByRows[yValue].rowXValues.push(xValue);
    dataByRows[yValue].rowSizeValues.push(sizeValue);
    dataByRows[yValue].rowCategoryValues.push(categoryValue);
    dataByRows[yValue].rowColorValues.push(bubbleColorValue);
    dataByRows[yValue].rowFillOpacityValues.push(
      getOpacityValue(size2[index], dataByRows[yValue].rowSizeScale)
    );
    dataByRows[yValue].rowRadiusValues.push(getRadiusValue(size2[index], dataByRows[yValue].rowSizeScale));
  });
  if (bubbleRowScale === "row" /* ROW */) {
    Object.entries(dataByRows).forEach(([row, rowData]) => {
      const rowSizeScale = createValueScale(rowData.rowSizeValues);
      dataByRows[row].rowSizeScale = rowSizeScale;
      rowData.rowSizeValues.forEach((rowSizeValue, index) => {
        dataByRows[row].rowFillOpacityValues[index] = getOpacityValue(
          rowData.rowSizeValues[index],
          rowSizeScale
        );
        dataByRows[row].rowRadiusValues[index] = getRadiusValue(
          rowData.rowSizeValues[index],
          rowSizeScale
        );
      });
    });
  }
  return dataByRows;
};
var isSomethingSelected = ({ selectedX, selectedY, selectedCategory }) => selectedX !== null || selectedY !== null || selectedCategory !== null;
var isBubbleSelected = ({
  selectedX,
  selectedY,
  selectedCategory,
  xValue,
  yValue,
  categoryValue
}) => {
  if (selectedX !== null && xValue !== selectedX) {
    return false;
  }
  if (selectedY !== null && yValue !== selectedY) {
    return false;
  }
  if (selectedCategory !== null && categoryValue !== selectedCategory) {
    return false;
  }
  return true;
};
var truncateAxisLabelText = ({
  label,
  widthInPX = Y_AXIS_WIDTH,
  axisLabelOverflowMode = "ellipsisEnd"
}) => {
  const availableLength = Math.floor(widthInPX / HORIZONTAL_SPACE_FOR_SINGLE_CHAR);
  if (label.length <= availableLength) {
    return label;
  }
  if (availableLength < "X...".length) {
    return "";
  }
  const endMarker = Math.max(0, availableLength - "...".length);
  if (axisLabelOverflowMode === "ellipsisStart") {
    return `...${label.slice(-endMarker)}`;
  }
  return `${label.slice(0, endMarker)}...`;
};
var getBubbleAccessibleName = ({ categoryValue, xValue, yValue, sizeValue }) => {
  if (sizeValue) {
    return categoryValue ? `Category: ${categoryValue}, X: ${xValue}, Y: ${yValue}, Size: ${sizeValue}` : `X: ${xValue}, Y: ${yValue}, Size: ${sizeValue}`;
  }
  return `There's no data for point: X: ${xValue}, Y: ${yValue}`;
};
var addNullValuesToRowData = ({ rowData, uniqX }) => {
  const newRowData = uniqX.flatMap((singleX) => {
    const indexesOfSingleXInRowData = rowData.rowXValues.map((element, index) => element === singleX ? index : -1).filter((index) => index !== -1);
    if (indexesOfSingleXInRowData.length === 0) {
      return {
        rowXValues: singleX,
        rowSizeValues: null,
        rowCategoryValues: null,
        rowColorValues: null,
        rowFillOpacityValues: null,
        rowRadiusValues: null
      };
    }
    return indexesOfSingleXInRowData.map((indexOfSingleXInRowData) => {
      return {
        rowXValues: singleX,
        rowSizeValues: rowData.rowSizeValues[indexOfSingleXInRowData],
        rowCategoryValues: rowData.rowCategoryValues[indexOfSingleXInRowData],
        rowColorValues: rowData.rowColorValues[indexOfSingleXInRowData],
        rowFillOpacityValues: rowData.rowFillOpacityValues[indexOfSingleXInRowData],
        rowRadiusValues: rowData.rowRadiusValues[indexOfSingleXInRowData]
      };
    });
  });
  return newRowData.reduce(
    (acc, obj) => {
      Object.keys(obj).forEach((key) => {
        acc[key].push(obj[key]);
      });
      return acc;
    },
    {
      rowXValues: [],
      rowSizeValues: [],
      rowCategoryValues: [],
      rowColorValues: [],
      rowFillOpacityValues: [],
      rowRadiusValues: [],
      rowSizeScale: rowData.rowSizeScale
    }
  );
};
var getElementToFocus = ({
  category,
  bubbleSizes,
  x,
  y,
  uniqX,
  uniqY,
  selectedX,
  selectedY,
  selectedCategory,
  key
}) => {
  const elementsByColumnsWithValues = x.map((el, i) => {
    var _a;
    return {
      x: el,
      y: y[i],
      category: (_a = category[i]) != null ? _a : null,
      size: bubbleSizes[i]
    };
  });
  const elementsByColumns = uniqX.flatMap(
    (uX) => uniqY.flatMap((uY) => {
      const indexesOfElement = elementsByColumnsWithValues.map((el, index) => el.x === uX && el.y === uY ? index : -1).filter((index) => index !== -1);
      if (indexesOfElement.length > 0) {
        return indexesOfElement.map((indexOfElement) => elementsByColumnsWithValues[indexOfElement]);
      }
      return {
        x: uX,
        y: uY,
        size: null,
        category: null
      };
    })
  );
  const elementsByRows = uniqY.flatMap((uniqYEl) => elementsByColumns.filter((el) => el.y === uniqYEl));
  const currentElIndexInColumns = elementsByColumns.findIndex(
    (el) => el.x === selectedX && el.y === selectedY && el.category === selectedCategory
  );
  const currentElIndexInRows = elementsByRows.findIndex(
    (el) => el.x === selectedX && el.y === selectedY && el.category === selectedCategory
  );
  let newEl;
  if (key === "down") {
    newEl = elementsByColumns[currentElIndexInColumns + 1];
  } else if (key === "up") {
    newEl = elementsByColumns[currentElIndexInColumns - 1];
  } else if (key === "right") {
    newEl = elementsByRows[currentElIndexInRows + 1];
  } else if (key === "left") {
    newEl = elementsByRows[currentElIndexInRows - 1];
  }
  return newEl;
};

// esm-externals:lodash/findIndex
var findIndex_exports = {};
__export(findIndex_exports, {
  default: () => findIndex_default
});
var defaultImport33 = __toESM(require("lodash/findIndex"));
__reExport(findIndex_exports, require("lodash/findIndex"));
var findIndex_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// esm-externals:lodash/find
var find_exports = {};
__export(find_exports, {
  default: () => find_default
});
var defaultImport34 = __toESM(require("lodash/find"));
__reExport(find_exports, require("lodash/find"));
var find_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// esm-externals:lodash/sortBy
var sortBy_exports = {};
__export(sortBy_exports, {
  default: () => sortBy_default
});
var defaultImport35 = __toESM(require("lodash/sortBy"));
__reExport(sortBy_exports, require("lodash/sortBy"));
var sortBy_default = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// esm-externals:lodash/flattenDeep
var flattenDeep_exports = {};
__export(flattenDeep_exports, {
  default: () => flattenDeep_default
});
var defaultImport36 = __toESM(require("lodash/flattenDeep"));
__reExport(flattenDeep_exports, require("lodash/flattenDeep"));
var flattenDeep_default = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// src/Punchcard/PurePunchcard/src/utils/sortUtils.js
var TIME_RANGES = {
  month: [
    { january: true, jan: true, "jan.": true },
    { february: true, feb: true, "feb.": true },
    { march: true, mar: true, "mar.": true },
    { april: true, apr: true, "apr.": true },
    { may: true },
    { june: true, jun: true, "jun.": true },
    { july: true, jul: true, "jul.": true },
    { august: true, aug: true, "aug.": true },
    { september: true, sep: true, sept: true, "sep.": true, "sept.": true },
    { october: true, oct: true, "oct.": true },
    { november: true, nov: true, "nov.": true },
    { december: true, dec: true, "dec.": true }
  ],
  wday: [
    { monday: true, mon: true, "mon.": true },
    { tuesday: true, tu: true, "tu.": true, tue: true, "tue.": true, tues: true, "tues.": true },
    { wednesday: true, wed: true, "wed.": true },
    { thursday: true, th: true, "th.": true, thur: true, "thur.": true, thurs: true, "thurs.": true },
    { friday: true, fri: true, "fri.": true },
    { saturday: true, sat: true, "sat.": true },
    { sunday: true, sun: true, "sun.": true }
  ]
};
var sortedByWeekday = (axis) => {
  const sortedAxis = [];
  const notWeekDay = find_default(axis, (value) => {
    const lowerValue = value.toLowerCase();
    const index = findIndex_default(TIME_RANGES.wday, lowerValue);
    if (index === -1) {
      return true;
    }
    if (sortedAxis[index]) {
      sortedAxis[index] = [sortedAxis[index], value];
    } else {
      sortedAxis[index] = value;
    }
    return false;
  });
  return notWeekDay ? [] : flattenDeep_default(sortedAxis.filter(Boolean));
};
var sortedByMonth = (axis) => {
  const sortedAxis = [];
  const notMonth = find_default(axis, (value) => {
    const lowerValue = value.toLowerCase();
    const index = findIndex_default(TIME_RANGES.month, lowerValue);
    if (index === -1) {
      return true;
    }
    if (sortedAxis[index]) {
      sortedAxis[index] = [sortedAxis[index], value];
    } else {
      sortedAxis[index] = value;
    }
    return false;
  });
  return notMonth ? [] : flattenDeep_default(sortedAxis.filter(Boolean));
};
var sortedByDTime = (axis) => {
  const acceptTimeFormat = [
    /^([0-1])?\d( )?(am|pm)$/i,
    // 1am, 1 am, 12am, 12 am
    /^([0-1])?\d:[0-5]\d( )?(am|pm)$/i,
    // 01:00 am, 01:00am, 1:00am
    /^([0-2])?\d:([0-5]\d:)?[0-5]\d$/,
    // 01:00:00, 1:00:00, 23:00
    /^([0-2])?\d:[0-5]\d:[0-5]\d( )?(am|pm)$/i
    // 01:00:00 am, 1:00:00am
  ];
  const sortArr = [];
  const notDate = find_default(axis, (value) => {
    if (!Number.isNaN(Number(value))) {
      return true;
    }
    let convertedDate = new Date(value);
    if (!Number.isNaN(Number(convertedDate))) {
      sortArr.push({ epoch: convertedDate, original: value });
      return false;
    }
    const acceptedTime = acceptTimeFormat.find((format) => format.test(value));
    if (acceptedTime) {
      const midday = /(am|pm)$/i;
      let reformatTime = value;
      const containsMidday = value.match(midday);
      if (containsMidday) {
        reformatTime = value.split(midday).slice(0, -1);
        reformatTime[0] = `${reformatTime[0].trim()}:00`;
        reformatTime = reformatTime.join(" ");
      }
      convertedDate = /* @__PURE__ */ new Date(`1970/01/01 ${reformatTime}`);
      sortArr.push({ epoch: convertedDate, original: value });
      return false;
    }
    return true;
  });
  if (notDate) {
    return [];
  }
  return sortBy_default(sortArr, (val) => val.epoch).map((val) => val.original);
};
var sortByDigitOrAlpha = (axis) => {
  const coercedIsFinite = (num) => Number.isFinite(Number(num));
  if ((0, lodash_exports.every)(axis, coercedIsFinite)) {
    return axis.sort((a, b) => Number(a) - Number(b));
  }
  return axis.sort();
};
var sortAxis = (axis) => {
  const sortedTimeAxis = sortedByDTime(axis);
  if (sortedTimeAxis.length) {
    return sortedTimeAxis;
  }
  const sortedWeekdays = sortedByWeekday(axis);
  if (sortedWeekdays.length) {
    return sortedWeekdays;
  }
  const sortedMonths = sortedByMonth(axis);
  if (sortedMonths.length) {
    return sortedMonths;
  }
  return sortByDigitOrAlpha(axis);
};

// src/Punchcard/PurePunchcard/src/PunchcardAxis.tsx
var AxisLabelText = styled_components_default.text`
    cursor: pointer;
    dominant-baseline: middle;
    fill: ${pick_default({
  /* was previously named textColor in themeReg */
  enterprise: variables_default.textColor,
  prisma: variables_default.contentColorDefault
})};
    font-size: 12px;
    text-anchor: ${(props) => props.orientation === "horizontal" /* HORIZONTAL */ ? "middle" : "start"};
    opacity: ${(props) => props.muted ? 0.15 : 1};
    transition: all 0.15s;
`;
var PunchcardAxis = (props) => {
  const {
    labels,
    handleMouseEnter,
    handleMouseLeave,
    orientation,
    scale,
    selected,
    startPositionX,
    startPositionY
  } = props;
  return /* @__PURE__ */ react_exports.createElement("g", { "data-test": `${orientation === "vertical" /* VERTICAL */ ? "y" : "x"}-axis` }, labels.map((label, index) => {
    const positionDelta = index * scale.bandwidth() + scale.bandwidth() / 2;
    const xPosition = orientation === "vertical" /* VERTICAL */ ? startPositionX : startPositionX + positionDelta;
    const yPosition = orientation === "vertical" /* VERTICAL */ ? startPositionY + positionDelta : startPositionY;
    const xAxisWidthScale = scale.copy().paddingInner(0.1).round(true);
    const truncatedLabel = orientation === "vertical" /* VERTICAL */ ? truncateAxisLabelText({ label: `${label}` }) : truncateAxisLabelText({
      label: `${label}`,
      widthInPX: xAxisWidthScale.bandwidth()
    });
    return /* @__PURE__ */ react_exports.createElement(
      AxisLabelText,
      {
        key: label,
        x: xPosition,
        y: yPosition,
        orientation,
        onMouseEnter: () => handleMouseEnter(label),
        onMouseLeave: handleMouseLeave,
        muted: selected && label !== selected
      },
      /* @__PURE__ */ react_exports.createElement("title", null, label),
      truncatedLabel
    );
  }));
};
var propTypes3 = {
  labels: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])).isRequired,
  handleMouseEnter: prop_types_exports.func,
  handleMouseLeave: prop_types_exports.func,
  orientation: prop_types_exports.oneOf(Object.values(AXIS_ORIENTATION_TYPES)),
  scale: prop_types_exports.func.isRequired,
  selected: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  startPositionX: prop_types_exports.number,
  startPositionY: prop_types_exports.number
};
var defaultProps = {
  // set as undefined as we are using defaultProps in conjunction with ts
  // where it requires all keys of interface to be present in defaultProps
  // eslint-disable-next-line react/default-props-match-prop-types
  labels: void 0,
  handleMouseEnter: () => {
  },
  handleMouseLeave: () => {
  },
  orientation: "vertical",
  // eslint-disable-next-line react/default-props-match-prop-types
  scale: void 0,
  selected: null,
  startPositionX: 0,
  startPositionY: 0
};
PunchcardAxis.propTypes = propTypes3;
PunchcardAxis.defaultProps = defaultProps;
var PunchcardAxis_default = PunchcardAxis;

// src/Punchcard/PurePunchcard/src/PunchcardBubble.tsx
var BubbleCircle = styled_components_default.circle`
    fill: ${(props) => props.outline ? pick_default({
  // bubbleTextColor
  enterprise: {
    light: variables_default.white,
    // equal to enterpriseDark.textColor
    dark: variables_default.contentColorInverted
    // enterprise.textColor
  },
  prisma: variables_default.contentColorActive
})(props) : props.color};
    fill-opacity: 1;
    opacity: ${(props) => props.hover ? 0 : props.fillOpacity};
    stroke: ${(props) => props.outline ? props.color : "none"};
`;
var pulsateAnimation = (r) => styled_components_exports.keyframes`
    41% {
        opacity: 0;
        r: ${r + 5};
    }
    100% {
        opacity: 0;
        r: ${r + 5};
    }
`;
var PulsateBubble = styled_components_default(BubbleCircle)`
    animation: ${(props) => pulsateAnimation(props.r)} 2.4s linear 0.4s infinite;
`;
var BubbleGroup = styled_components_default.g`
    cursor: pointer;
    opacity: ${(props) => props.muted ? 0.15 : 1};
    filter: ${(props) => props.muted ? `url(#${GRAYSCALE_FILTER_ID})` : ""};
    transition: opacity 0.15s;
`;
var BubbleLabelText = styled_components_default.text`
    dominant-baseline: middle;
    opacity: ${(props) => props.displayLabel ? 1 : 0};
    fill: ${(props) => props.hover || props.outline ? pick_default({
  // bubbleAltTextColor
  enterprise: variables_default.textColor,
  prisma: variables_default.contentColorActive
})(props) : pick_default({
  enterprise: {
    dark: variables_default.textColor,
    light: variables_default.white
  },
  prisma: variables_default.contentColorActive
})(props)};
    font-size: ${(props) => props.hover ? "12px" : "10px"};
    font-weight: ${(props) => props.hover ? 500 : "normal"};
    text-anchor: middle;
`;
var MIN_BUBBLE_SIZE_TO_DISPLAY_LABEL = 13;
var MAX_DISPLAYABLE_VALUE = 99499999999999;
var VALUE_OVERFLOW_TEXT = "99T+";
var PunchcardBubble = (props) => {
  const {
    showBubbleLabel,
    color,
    cx,
    cy,
    fillOpacity,
    handleMouseEnter,
    handleMouseLeave,
    hover,
    muted,
    pulsate,
    value,
    r,
    handlePointClick,
    accessibleLabel,
    tabindex
  } = props;
  const outline = value < 0;
  const showPulsateBubble = pulsate && !muted && !hover;
  const displayLabel = hover || showBubbleLabel && r >= MIN_BUBBLE_SIZE_TO_DISPLAY_LABEL;
  const hasData = !!value;
  let bubbleLabelValueText = value <= MAX_DISPLAYABLE_VALUE ? (0, numberUtils_exports.formatNumber)(value, 0, { useTrendUnits: true }) : VALUE_OVERFLOW_TEXT;
  if (hover) {
    bubbleLabelValueText = (0, numberUtils_exports.formatNumber)(value, 2);
  }
  return /* @__PURE__ */ react_exports.createElement(
    BubbleGroup,
    {
      "data-test": "bubble",
      muted,
      onMouseEnter: hasData ? handleMouseEnter : void 0,
      onMouseLeave: hasData ? handleMouseLeave : void 0,
      onClick: () => hasData && handlePointClick(value),
      onFocus: handleMouseEnter,
      onBlur: handleMouseLeave,
      tabIndex: tabindex
    },
    showPulsateBubble && /* @__PURE__ */ react_exports.createElement(PulsateBubble, { cx, cy, r, color, outline: true, hover: null }),
    /* @__PURE__ */ react_exports.createElement(
      BubbleCircle,
      {
        cx,
        cy,
        r,
        color,
        hover,
        fillOpacity,
        outline
      }
    ),
    /* @__PURE__ */ react_exports.createElement(
      BubbleLabelText,
      {
        x: cx,
        y: cy,
        hover,
        outline,
        displayLabel,
        "aria-label": accessibleLabel
      },
      hasData ? bubbleLabelValueText : (0, i18n_exports._)("Null")
    )
  );
};
var propTypes4 = {
  showBubbleLabel: prop_types_exports.bool,
  color: prop_types_exports.string,
  cx: prop_types_exports.number,
  cy: prop_types_exports.number,
  fillOpacity: prop_types_exports.number,
  handleMouseEnter: prop_types_exports.func,
  handleMouseLeave: prop_types_exports.func,
  hover: prop_types_exports.bool,
  muted: prop_types_exports.bool,
  pulsate: prop_types_exports.bool,
  value: prop_types_exports.number,
  r: prop_types_exports.number,
  handlePointClick: prop_types_exports.func,
  accessibleLabel: prop_types_exports.string,
  tabindex: prop_types_exports.number
};
var defaultProps2 = {
  showBubbleLabel: true,
  color: "#46D3BB",
  cx: 0,
  cy: 0,
  fillOpacity: 1,
  handleMouseEnter: () => {
  },
  handleMouseLeave: () => {
  },
  hover: false,
  muted: false,
  pulsate: false,
  r: 1,
  value: void 0,
  handlePointClick: () => {
  },
  accessibleLabel: "",
  tabindex: -1
};
PunchcardBubble.propTypes = propTypes4;
PunchcardBubble.defaultProps = defaultProps2;
var PunchcardBubble_default = PunchcardBubble;

// src/Punchcard/PurePunchcard/src/PunchcardRow.tsx
var PunchcardRow = (props) => {
  const {
    showBubbleLabels,
    category,
    colors,
    handleMouseEnter,
    handleMouseLeave,
    maxSizeValue,
    opacities,
    radiusValues,
    selectedCategory,
    selectedX,
    selectedY,
    showMaxValuePulsation,
    size: size2,
    x,
    xScale,
    yIndex,
    yPosition,
    yValue,
    handlePointClick
  } = props;
  return /* @__PURE__ */ react_exports.createElement("g", null, x.map((xValue, index) => {
    const sizeValue = size2[index];
    const categoryValue = category[index];
    const colorValue = colors[index];
    const cx = xScale(xValue);
    const r = radiusValues[index];
    const fillOpacity = opacities[index];
    const hover = isSomethingSelected({ selectedX, selectedY, selectedCategory }) && isBubbleSelected({
      selectedX,
      selectedY,
      selectedCategory,
      xValue,
      yValue,
      categoryValue
    });
    const muted = isSomethingSelected({ selectedX, selectedY, selectedCategory }) && !hover;
    const showBubbleLabel = showBubbleLabels === "all" /* ALL */ || showBubbleLabels === "max" /* MAX */ && maxSizeValue === sizeValue;
    const accessibleLabel = getBubbleAccessibleName({ categoryValue, xValue, yValue, sizeValue });
    return /* @__PURE__ */ react_exports.createElement(
      PunchcardBubble_default,
      {
        key: `${xValue}-${yValue}-${sizeValue}-${categoryValue}`,
        showBubbleLabel,
        color: colorValue,
        cx,
        cy: yPosition,
        fillOpacity,
        handleMouseEnter: () => {
          handleMouseEnter(xValue, yValue, categoryValue);
        },
        handleMouseLeave,
        hover,
        muted,
        pulsate: showMaxValuePulsation && sizeValue === maxSizeValue,
        value: sizeValue,
        r,
        handlePointClick,
        accessibleLabel,
        tabindex: hover || !muted && yIndex === 0 && index === 0 ? 0 : -1
      }
    );
  }));
};
var propTypes5 = {
  showBubbleLabels: prop_types_exports.oneOf(Object.values(BUBBLE_LABELS_TYPES)),
  category: prop_types_exports.arrayOf(prop_types_exports.string),
  colors: prop_types_exports.arrayOf(prop_types_exports.string),
  handleMouseEnter: prop_types_exports.func,
  handleMouseLeave: prop_types_exports.func,
  maxSizeValue: prop_types_exports.number,
  opacities: prop_types_exports.arrayOf(prop_types_exports.number),
  radiusValues: prop_types_exports.arrayOf(prop_types_exports.number),
  selectedCategory: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  selectedX: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  selectedY: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  showMaxValuePulsation: prop_types_exports.bool,
  size: prop_types_exports.arrayOf(prop_types_exports.number),
  x: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])).isRequired,
  xScale: prop_types_exports.func,
  yIndex: prop_types_exports.number,
  yPosition: prop_types_exports.number,
  yValue: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  handlePointClick: prop_types_exports.func
};
var defaultProps3 = {
  showBubbleLabels: null,
  category: null,
  colors: null,
  handleMouseEnter: () => {
  },
  handleMouseLeave: () => {
  },
  maxSizeValue: null,
  opacities: null,
  radiusValues: null,
  selectedCategory: null,
  selectedX: null,
  selectedY: null,
  showMaxValuePulsation: true,
  size: null,
  // eslint-disable-next-line react/default-props-match-prop-types
  x: null,
  xScale: null,
  yIndex: null,
  yPosition: null,
  yValue: null,
  handlePointClick: () => {
  }
};
PunchcardRow.propTypes = propTypes5;
PunchcardRow.defaultProps = defaultProps3;
var PunchcardRow_default = (0, styled_components_exports.withTheme)(PunchcardRow);

// src/Punchcard/PurePunchcard/src/PunchcardChartArea.tsx
var PunchcardChartArea = (props) => {
  const {
    showBubbleLabels,
    bubbleRowScale,
    bubbleScale,
    category,
    colorCategoryMapping,
    colorMode,
    bubbleColor,
    handleMouseEnter,
    handleMouseLeave,
    isBubbleSizeDynamic,
    minBubbleColorIntensity,
    minBand,
    minBubbleSize,
    maxBubbleSize,
    maxBubbleRadius,
    minBubbleRadius,
    showMaxValuePulsation,
    selectedCategory,
    selectedX,
    selectedY,
    size: size2,
    uniqX,
    x,
    xScale,
    y,
    yScale,
    handlePointClick
  } = props;
  const dataByRows = getDataByRows({
    bubbleRowScale,
    bubbleScale,
    category,
    colorCategoryMapping,
    colorMode,
    bubbleColor,
    minBubbleColorIntensity,
    size: size2,
    x,
    y,
    isBubbleSizeDynamic,
    minBand,
    minBubbleSize,
    maxBubbleSize,
    maxBubbleRadius,
    minBubbleRadius
  });
  return /* @__PURE__ */ react_exports.createElement("g", null, Object.entries(dataByRows).map(([row, rowData], index) => {
    const yPosition = yScale(row);
    const {
      rowXValues,
      rowSizeValues,
      rowCategoryValues,
      rowColorValues,
      rowFillOpacityValues,
      rowSizeScale,
      rowRadiusValues
    } = addNullValuesToRowData({ rowData, uniqX });
    return /* @__PURE__ */ react_exports.createElement(
      PunchcardRow_default,
      {
        key: row,
        showBubbleLabels,
        category: rowCategoryValues,
        colors: rowColorValues,
        handleMouseEnter,
        handleMouseLeave,
        maxSizeValue: Math.max(...size2),
        opacities: rowFillOpacityValues,
        radiusValues: rowRadiusValues,
        selectedCategory,
        selectedX,
        selectedY,
        showMaxValuePulsation,
        sizeScale: rowSizeScale,
        size: rowSizeValues,
        x: rowXValues,
        xScale,
        yIndex: index,
        yPosition,
        yValue: row,
        handlePointClick
      }
    );
  }));
};
var propTypes6 = {
  showBubbleLabels: prop_types_exports.oneOf(Object.values(BUBBLE_LABELS_TYPES)),
  bubbleRowScale: prop_types_exports.oneOf(Object.values(BUBBLE_ROW_SCALE_TYPES)),
  bubbleScale: prop_types_exports.oneOf(Object.values(BUBBLE_SCALE_TYPES)),
  category: prop_types_exports.arrayOf(prop_types_exports.string),
  colorCategoryMapping: prop_types_exports.func,
  colorMode: prop_types_exports.oneOf(Object.values(COLOR_MODE_TYPES)),
  bubbleColor: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.arrayOf(prop_types_exports.string)]),
  handleMouseEnter: prop_types_exports.func,
  handleMouseLeave: prop_types_exports.func,
  isBubbleSizeDynamic: prop_types_exports.bool,
  minBubbleColorIntensity: prop_types_exports.number,
  minBand: prop_types_exports.number,
  minBubbleSize: prop_types_exports.number,
  maxBubbleSize: prop_types_exports.number,
  maxBubbleRadius: prop_types_exports.number,
  minBubbleRadius: prop_types_exports.number,
  showMaxValuePulsation: prop_types_exports.bool,
  selectedCategory: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  selectedX: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  selectedY: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  size: prop_types_exports.arrayOf(prop_types_exports.number).isRequired,
  uniqX: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])).isRequired,
  x: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])).isRequired,
  xScale: prop_types_exports.func,
  y: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])).isRequired,
  yScale: prop_types_exports.func,
  handlePointClick: prop_types_exports.func
};
var defaultProps4 = {
  showBubbleLabels: "all" /* ALL */,
  bubbleRowScale: "row" /* ROW */,
  bubbleScale: "area" /* AREA */,
  category: null,
  colorCategoryMapping: null,
  colorMode: "categorical" /* CATEGORICAL */,
  bubbleColor: "#A870EF",
  handleMouseEnter: () => {
  },
  handleMouseLeave: () => {
  },
  isBubbleSizeDynamic: true,
  minBubbleColorIntensity: 0.25,
  minBand: 15,
  minBubbleSize: 0.01,
  maxBubbleSize: 1,
  maxBubbleRadius: 15,
  minBubbleRadius: 1,
  showMaxValuePulsation: true,
  selectedCategory: null,
  selectedX: null,
  selectedY: null,
  // eslint-disable-next-line react/default-props-match-prop-types
  size: null,
  // eslint-disable-next-line react/default-props-match-prop-types
  uniqX: null,
  // eslint-disable-next-line react/default-props-match-prop-types
  x: null,
  xScale: null,
  // eslint-disable-next-line react/default-props-match-prop-types
  y: null,
  yScale: null,
  handlePointClick: () => {
  }
};
PunchcardChartArea.propTypes = propTypes6;
PunchcardChartArea.defaultProps = defaultProps4;
var PunchcardChartArea_default = PunchcardChartArea;

// src/Punchcard/PurePunchcard/src/PunchcardLegend.tsx
var LEGEND_ITEM_VERTICAL_SPACER = 25;
var LEGEND_ITEM_HORIZONTAL_SPACER = 10;
var LEGEND_RECT_WIDTH = 5;
var LEGEND_RECT_HEIGHT = 10;
var LEGEND_OFFSET_TOP = 7;
var LEGEND_OFFSET_RIGHT = 16;
var LEGEND_OFFSET_BOTTOM = 16;
var LegendGroup = styled_components_default.g`
    cursor: pointer;
    opacity: ${(props) => props.muted ? 0.15 : 1};
    transition: opacity 0.15s;
`;
var LegendIcon = styled_components_default.rect`
    width: ${LEGEND_RECT_WIDTH}px;
    height: ${LEGEND_RECT_HEIGHT}px;
    rx: 1px;
    ry: 1px;
`;
var LegendText = styled_components_default.text`
    dominant-baseline: middle;
    fill: ${pick_default({
  /* was previously named textColor in themeReg */
  enterprise: variables_default.textColor,
  prisma: variables_default.contentColorDefault
})};
    font-size: 12px;
`;
var PunchcardLegend = (props) => {
  const {
    category,
    colorCategoryMapping,
    handleMouseEnter,
    handleMouseLeave,
    selected,
    startPositionX,
    startPositionY,
    containerWidth,
    containerHeight,
    handleLegendClick
  } = props;
  const legendWidth = containerWidth - LEGEND_OFFSET_RIGHT - startPositionX;
  const legendHeight = containerHeight - LEGEND_OFFSET_BOTTOM;
  return /* @__PURE__ */ react_exports.createElement(
    "svg",
    {
      x: startPositionX,
      y: startPositionY - LEGEND_OFFSET_TOP,
      width: legendWidth,
      height: legendHeight
    },
    /* @__PURE__ */ react_exports.createElement("g", null, category.map((c, index) => {
      const yValue = index * LEGEND_ITEM_VERTICAL_SPACER;
      return /* @__PURE__ */ react_exports.createElement(
        LegendGroup,
        {
          key: c,
          muted: selected && selected !== c,
          onMouseEnter: () => handleMouseEnter(c),
          onMouseLeave: handleMouseLeave,
          onClick: () => handleLegendClick(),
          "data-test": "legend-group"
        },
        /* @__PURE__ */ react_exports.createElement(LegendIcon, { x: 0, y: yValue, fill: colorCategoryMapping(c) }),
        /* @__PURE__ */ react_exports.createElement(
          LegendText,
          {
            x: LEGEND_ITEM_HORIZONTAL_SPACER,
            y: yValue + LEGEND_RECT_HEIGHT / 2 + 2
          },
          /* @__PURE__ */ react_exports.createElement("title", null, c),
          c
        )
      );
    }))
  );
};
var propTypes7 = {
  category: prop_types_exports.arrayOf(prop_types_exports.string),
  colorCategoryMapping: prop_types_exports.func.isRequired,
  handleMouseEnter: prop_types_exports.func,
  handleMouseLeave: prop_types_exports.func,
  selected: prop_types_exports.string,
  startPositionX: prop_types_exports.number,
  startPositionY: prop_types_exports.number,
  containerWidth: prop_types_exports.number,
  containerHeight: prop_types_exports.number,
  handleLegendClick: prop_types_exports.func
};
var defaultProps5 = {
  category: null,
  // eslint-disable-next-line react/default-props-match-prop-types
  colorCategoryMapping: null,
  handleMouseEnter: () => {
  },
  handleMouseLeave: () => {
  },
  selected: null,
  startPositionX: 0,
  startPositionY: 0,
  containerWidth: 100,
  containerHeight: 100,
  handleLegendClick: () => {
  }
};
PunchcardLegend.propTypes = propTypes7;
PunchcardLegend.defaultProps = defaultProps5;
var PunchcardLegend_default = PunchcardLegend;

// src/Punchcard/PurePunchcard/src/PunchcardGridLines.tsx
var GridLine = styled_components_default.line`
    stroke: ${pick_default({
  enterprise: {
    light: variables_default.gray96,
    dark: variables_default.gray25
  },
  prisma: variables_default.interactiveColorBackgroundDisabled
})};
    stroke-width: 1px;
`;
var PunchcardGridLines = (props) => {
  const { xStartPosition, xEndPosition, yStartPosition, yEndPosition, xDelta, yDelta } = props;
  const yGridLinesXPositions = (0, lodash_exports.range)(xStartPosition, xEndPosition + 1, xDelta);
  const xGridLinesYPositions = (0, lodash_exports.range)(yStartPosition, yEndPosition + 1, yDelta);
  return /* @__PURE__ */ react_exports.createElement("g", { "data-test": "data-test-gridlines" }, yGridLinesXPositions.map((xValue) => /* @__PURE__ */ react_exports.createElement(
    GridLine,
    {
      key: `${xValue}x${yStartPosition}`,
      x1: xValue,
      y1: yStartPosition,
      x2: xValue,
      y2: yEndPosition
    }
  )), xGridLinesYPositions.map((yValue) => /* @__PURE__ */ react_exports.createElement(
    GridLine,
    {
      key: `${xStartPosition}x${yValue}`,
      x1: xStartPosition,
      y1: yValue,
      x2: xEndPosition,
      y2: yValue
    }
  )));
};
var propTypes8 = {
  xStartPosition: prop_types_exports.number,
  xEndPosition: prop_types_exports.number,
  yStartPosition: prop_types_exports.number,
  yEndPosition: prop_types_exports.number,
  xDelta: prop_types_exports.number,
  yDelta: prop_types_exports.number
};
var defaultProps6 = {
  xStartPosition: void 0,
  xEndPosition: void 0,
  yStartPosition: void 0,
  yEndPosition: void 0,
  xDelta: 10,
  yDelta: 10
};
PunchcardGridLines.propTypes = propTypes8;
PunchcardGridLines.defaultProps = defaultProps6;
var PunchcardGridLines_default = PunchcardGridLines;

// src/Punchcard/PurePunchcard/Punchcard.tsx
var Container = styled_components_default.div`
    cursor: default;
    overflow: hidden;
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
    background-color: ${(props) => props.backgroundColor};
`;
var PunchcardWrapper = styled_components_default.div`
    display: flex;
    justify-content: center;
    flex-direction: row;
    width: 100%;
    height: 100%;
    background-color: ${(props) => props.backgroundColor};
`;
var PunchcardContainer = styled_components_default.div`
    overflow: hidden;
    position: relative;
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
`;
var PunchcardSVG = styled_components_default.svg`
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
`;
var Punchcard = (props) => {
  const [selectedX, setSelectedX] = react_exports.useState(null);
  const [selectedY, setSelectedY] = react_exports.useState(null);
  const [selectedCategory, setSelectedCategory] = react_exports.useState(null);
  const cachedHandleResize = react_exports.useCallback((w, h) => {
    setContainerWidth(w);
    setContainerHeight(h);
  }, []);
  const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
  const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
  const handleMouseLeave = () => {
    setSelectedX(null);
    setSelectedY(null);
    setSelectedCategory(null);
  };
  const handleLegendHover = (category2) => {
    setSelectedX(null);
    setSelectedY(null);
    setSelectedCategory(category2);
  };
  const handleXAxisHover = (xValue) => {
    setSelectedX(xValue);
    setSelectedY(null);
    setSelectedCategory(null);
  };
  const handleYAxisHover = (yValue) => {
    setSelectedX(null);
    setSelectedY(yValue);
    setSelectedCategory(null);
  };
  const handleBubbleHover = (xValue, yValue, category2) => {
    setSelectedX(xValue);
    setSelectedY(yValue);
    setSelectedCategory(category2);
  };
  const {
    backgroundColor,
    showBubbleLabels,
    bubbleRowScale,
    bubbleScale,
    category,
    categoryField,
    colorMode,
    seriesColors,
    bubbleColor,
    minBubbleColorIntensity,
    height,
    showMaxValuePulsation,
    isBubbleSizeDynamic,
    minBubbleSize,
    maxBubbleSize,
    maxBubbleRadius,
    minBubbleRadius,
    useDefaultSort,
    showLegend,
    size: size2,
    sizeField,
    width,
    x,
    y,
    xField,
    yField,
    onPointClick,
    onLegendClick
  } = props;
  const calculatedColorMode = category ? colorMode : "sequential" /* SEQUENTIAL */;
  const displayLegend = showLegend && calculatedColorMode === "categorical" /* CATEGORICAL */;
  const uniqX = useDefaultSort ? sortAxis((0, lodash_exports.uniq)(x.map((v) => `${v}`))) : (0, lodash_exports.uniq)(x);
  const uniqY = useDefaultSort ? sortAxis((0, lodash_exports.uniq)(y.map((v) => `${v}`))) : (0, lodash_exports.uniq)(y);
  const uniqCategory = (0, lodash_exports.uniq)(category);
  const bubbleSizes = size2.map((v) => (0, types_exports.isNumber)(v) ? Number(v) : null);
  const colorCategoryMapping = getColorCategoryMapping({
    category: uniqCategory,
    colorMode: calculatedColorMode,
    seriesColors
  });
  const handlePointClick = (sizeValue) => {
    const rowData = {
      [`row.${xField}.value`]: selectedX,
      [`row.${yField}.value`]: selectedY,
      [`row.${sizeField}.value`]: sizeValue
    };
    if (categoryField) rowData[`row.${categoryField}.value`] = selectedCategory;
    onPointClick({
      type: "point.click",
      payload: __spreadValues({
        value: selectedY,
        name: yField
      }, rowData)
    });
  };
  const handleLegendClick = () => {
    onLegendClick({
      type: "legend.click",
      payload: {
        name: yField
      }
    });
  };
  const chartRef = react_exports.useRef();
  const handleKeyDown = (e) => {
    var _a, _b;
    const key = (0, keyboard_exports.keycode)(e);
    const elementToFocus = getElementToFocus({
      category,
      bubbleSizes,
      x,
      y,
      uniqX,
      uniqY,
      selectedX,
      selectedY,
      selectedCategory,
      key
    });
    if (!elementToFocus) {
      return;
    }
    const ariaLabel = getBubbleAccessibleName({
      categoryValue: elementToFocus.category,
      xValue: elementToFocus.x,
      yValue: elementToFocus.y,
      sizeValue: elementToFocus.size
    });
    (_b = (_a = chartRef.current.querySelector(`[aria-label="${ariaLabel}"]`)) == null ? void 0 : _a.parentElement) == null ? void 0 : _b.focus();
  };
  const renderVisualization = () => {
    if (!containerWidth || !containerHeight) {
      return null;
    }
    const {
      xAxisStartY,
      yAxisStartX,
      chartAreaStartX,
      chartAreaStartY,
      chartAreaEndX,
      chartAreaEndY,
      legendStartX
    } = getChartAreaDimensions({
      containerWidth,
      containerHeight,
      displayLegend
    });
    const { scale: xScale, positionScale: xPositionScale } = getScales({
      values: uniqX,
      start: chartAreaStartX,
      end: chartAreaEndX
    });
    const { scale: yScale, positionScale: yPositionScale } = getScales({
      values: uniqY,
      start: chartAreaStartY,
      end: chartAreaEndY
    });
    const minBand = Math.min(xScale.bandwidth(), yScale.bandwidth());
    return /* @__PURE__ */ react_exports.createElement(PunchcardWrapper, { "data-test": "punchcard-wrapper", backgroundColor }, /* @__PURE__ */ react_exports.createElement(
      PunchcardContainer,
      {
        "data-test": "punchcard-container",
        width: containerWidth,
        height: containerHeight,
        ref: chartRef,
        onKeyDown: handleKeyDown
      },
      /* @__PURE__ */ react_exports.createElement(PunchcardSVG, { width: containerWidth, height: containerHeight }, /* @__PURE__ */ react_exports.createElement(
        PunchcardGridLines_default,
        {
          xStartPosition: xPositionScale(uniqX[0]),
          xEndPosition: xPositionScale(uniqX[uniqX.length - 1]),
          yStartPosition: yPositionScale(uniqY[0]),
          yEndPosition: yPositionScale(uniqY[uniqY.length - 1]),
          xDelta: xScale.bandwidth(),
          yDelta: yScale.bandwidth()
        }
      ), /* @__PURE__ */ react_exports.createElement(
        PunchcardAxis_default,
        {
          labels: uniqX,
          orientation: "horizontal" /* HORIZONTAL */,
          handleMouseEnter: handleXAxisHover,
          handleMouseLeave,
          startPositionX: chartAreaStartX,
          startPositionY: xAxisStartY,
          scale: xScale,
          selected: selectedX
        }
      ), /* @__PURE__ */ react_exports.createElement(
        PunchcardAxis_default,
        {
          labels: uniqY,
          orientation: "vertical" /* VERTICAL */,
          handleMouseEnter: handleYAxisHover,
          handleMouseLeave,
          startPositionX: yAxisStartX,
          startPositionY: chartAreaStartY,
          scale: yScale,
          selected: selectedY
        }
      ), displayLegend && /* @__PURE__ */ react_exports.createElement(
        PunchcardLegend_default,
        {
          category: uniqCategory,
          colorCategoryMapping,
          handleMouseEnter: handleLegendHover,
          handleMouseLeave,
          selected: selectedCategory,
          startPositionX: legendStartX,
          startPositionY: yPositionScale(uniqY[0]),
          containerWidth,
          containerHeight,
          handleLegendClick
        }
      ), /* @__PURE__ */ react_exports.createElement(
        PunchcardChartArea_default,
        {
          showBubbleLabels,
          bubbleRowScale,
          bubbleScale,
          category,
          colorCategoryMapping,
          colorMode: calculatedColorMode,
          bubbleColor,
          minBubbleColorIntensity,
          handleMouseEnter: handleBubbleHover,
          handleMouseLeave,
          isBubbleSizeDynamic,
          minBand,
          minBubbleSize,
          maxBubbleSize,
          minBubbleRadius,
          maxBubbleRadius,
          showMaxValuePulsation,
          selectedCategory,
          selectedX,
          selectedY,
          size: bubbleSizes,
          uniqX,
          x,
          xScale: xPositionScale,
          y,
          yScale: yPositionScale,
          handlePointClick
        }
      ), /* @__PURE__ */ react_exports.createElement("filter", { id: GRAYSCALE_FILTER_ID }, /* @__PURE__ */ react_exports.createElement(
        "feColorMatrix",
        {
          type: "matrix",
          values: "0.3333 0.3333 0.3333 0 0 0.3333 0.3333 0.3333 0 0 0.3333 0.3333 0.3333 0 0 0 0 0 1 0"
        }
      )))
    ));
  };
  return /* @__PURE__ */ react_exports.createElement(Container, { backgroundColor, height, width }, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), renderVisualization());
};
var propTypes9 = {
  backgroundColor: prop_types_exports.string,
  showBubbleLabels: prop_types_exports.oneOf(Object.values(BUBBLE_LABELS_TYPES)),
  bubbleRowScale: prop_types_exports.oneOf(Object.values(BUBBLE_ROW_SCALE_TYPES)),
  bubbleScale: prop_types_exports.oneOf(Object.values(BUBBLE_SCALE_TYPES)),
  category: prop_types_exports.arrayOf(prop_types_exports.string),
  categoryField: prop_types_exports.string,
  colorMode: prop_types_exports.oneOf(Object.values(COLOR_MODE_TYPES)),
  seriesColors: prop_types_exports.arrayOf(prop_types_exports.string),
  bubbleColor: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.arrayOf(prop_types_exports.string)]),
  minBubbleColorIntensity: prop_types_exports.number,
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  isBubbleSizeDynamic: prop_types_exports.bool,
  minBubbleSize: prop_types_exports.number,
  maxBubbleSize: prop_types_exports.number,
  maxBubbleRadius: prop_types_exports.number,
  minBubbleRadius: prop_types_exports.number,
  useDefaultSort: prop_types_exports.bool,
  showMaxValuePulsation: prop_types_exports.bool,
  showLegend: prop_types_exports.bool,
  sizeField: prop_types_exports.string,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // hotfix: isRequired check is removed here for x, y and size props
  // to remove console warnings on early return of this component and
  // implemented in config file using requiredProps
  x: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])),
  y: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])),
  size: prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number])),
  xField: prop_types_exports.string,
  yField: prop_types_exports.string,
  onPointClick: prop_types_exports.func,
  onLegendClick: prop_types_exports.func
};
var defaultProps7 = {
  backgroundColor: "transparent",
  showBubbleLabels: "all",
  bubbleRowScale: "global",
  bubbleScale: "area",
  category: null,
  categoryField: null,
  colorMode: "categorical",
  seriesColors: visualization_color_palettes_exports.CATEGORICAL,
  bubbleColor: "#7B56DB",
  minBubbleColorIntensity: 0.4,
  showMaxValuePulsation: true,
  height: 500,
  isBubbleSizeDynamic: true,
  minBubbleSize: 0.25,
  maxBubbleSize: 1,
  maxBubbleRadius: 15,
  minBubbleRadius: 1,
  useDefaultSort: false,
  showLegend: true,
  size: null,
  sizeField: null,
  width: "100%",
  x: null,
  y: null,
  xField: null,
  yField: null,
  onPointClick: lodash_exports.noop,
  onLegendClick: lodash_exports.noop
};
Punchcard.propTypes = propTypes9;
Punchcard.defaultProps = defaultProps7;
var Punchcard_default = Punchcard;

// src/common/chartingUtils.ts
var mapToValues = (optionValuesSCMapping) => (options) => {
  const convertedOptions = __spreadValues({}, options);
  Object.keys(optionValuesSCMapping).forEach((key) => {
    if ((0, lodash_exports.has)(options, key)) {
      const updatedValue = optionValuesSCMapping[key][options[key]];
      if (!(0, lodash_exports.isUndefined)(updatedValue)) {
        convertedOptions[key] = updatedValue;
      }
    }
  });
  return convertedOptions;
};

// src/Punchcard/punchcardUtils.ts
var punchcardOptionsMapping = {
  legendDisplay: "showLegend",
  bubbleLabelDisplay: "showBubbleLabels",
  showDefaultSort: "useDefaultSort",
  bubbleSizeMethod: "bubbleScale",
  showDynamicBubbleSize: "isBubbleSizeDynamic",
  bubbleRadiusMax: "maxBubbleRadius",
  bubbleRadiusMin: "minBubbleRadius",
  bubbleSizeMax: "maxBubbleSize",
  bubbleSizeMin: "minBubbleSize"
};
var punchcardOptionValuesMapping = {
  showLegend: {
    right: true,
    off: false
  },
  showBubbleLabels: {
    off: "none"
  },
  colorMode: {
    dynamic: "sequential"
  }
};
var mapToOldKey = (options) => (0, lodash_exports.mapKeys)(options, (val, key) => punchcardOptionsMapping[key] ? punchcardOptionsMapping[key] : key);
var convertToPunchcardProperties = (originalOptions) => (0, lodash_exports.chain)(mapToOldKey(originalOptions)).thru(mapToValues(punchcardOptionValuesMapping)).value();

// src/Punchcard/Punchcard.ts
var config2 = config_default;
var PurePunchcard = Punchcard_default;
var validOptions = Object.keys(config2.optionsSchema);
var computeVizProps = (_a) => {
  var _b = _a, {
    onPointClick,
    onLegendClick,
    x,
    y,
    category
  } = _b, otherOptions = __objRest(_b, [
    "onPointClick",
    "onLegendClick",
    "x",
    "y",
    "category"
  ]);
  const options = (0, lodash_exports.chain)(otherOptions).pick(validOptions).thru(convertToPunchcardProperties).value();
  if (options.seriesColors && typeof options.seriesColors === "string") {
    try {
      options.seriesColors = JSON.parse(options.seriesColors);
    } catch (e) {
      options.seriesColors = visualization_color_palettes_exports.VIZ_CATEGORICAL;
    }
  }
  return __spreadValues({
    onPointClick,
    onLegendClick,
    x,
    y,
    // PurePunchcard accepts category as string array
    category: category && category.map(String)
  }, options);
};
var viz = withDashboardViz_default({
  ReactViz: Punchcard_default,
  computeVizProps,
  vizConfig: config_default
});
var { themes: themes2 } = config_default;
var Punchcard_default2 = viz;
//# sourceMappingURL=Punchcard.js.map
