/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// src/SingleValue/index.ts
var SingleValue_exports = {};
__export(SingleValue_exports, {
  PureSingleValue: () => PureSingleValue,
  computeVizProps: () => computeVizProps,
  config: () => config2,
  default: () => SingleValue_default2,
  themes: () => themes2
});
module.exports = __toCommonJS(SingleValue_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport3 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:lodash/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport4 = __toESM(require("lodash/pick"));
__reExport(pick_exports, require("lodash/pick"));
var pick_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:lodash/isEmpty
var isEmpty_exports = {};
__export(isEmpty_exports, {
  default: () => isEmpty_default
});
var defaultImport5 = __toESM(require("lodash/isEmpty"));
__reExport(isEmpty_exports, require("lodash/isEmpty"));
var isEmpty_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport6 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/common/components/VizStyleWrapper.jsx
var VizStyleWrapper = styled_components_default.div.attrs(({ dataTestKey }) => ({
  "data-test": dataTestKey,
  "data-testid": dataTestKey
}))`
    display: flex;
    justify-content: center;
    flex-direction: column;
    width: 100%;
    height: 100%;
    background-color: ${(props) => props.backgroundColor};
`;
VizStyleWrapper.displayName = "VizStyleWrapper";
var VizStyleWrapper_default = VizStyleWrapper;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport8 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport9 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// src/common/hooks/useTrellisEnabled.ts
var useTrellisFeatureFlagOn = () => {
  const context = (0, react_exports.useContext)(FeatureFlagContext_default);
  return Boolean(context == null ? void 0 : context.visualizations_enableTrellis);
};
var useTrellisEnabled = (layoutType = visualization_schemas_exports.LAYOUT_TYPE.Off) => {
  const trellisFeatureEnabled = useTrellisFeatureFlagOn();
  return trellisFeatureEnabled && layoutType === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};

// src/common/components/TrellisTitle.tsx
var TRELLIS_TITLE_HEIGHT = 28;
var TrellisTitleText = styled_components_default.div`
    margin-left: 10px;
    margin-right: 10px;
    padding-top: 8px;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
`;
var TrellisTitleDiv = styled_components_default.div`
    height: ${TRELLIS_TITLE_HEIGHT}px;
    font-size: 14px;
    font-weight: 700;
    color: ${(props) => props.fontColor};
    background-color: ${(props) => props.backgroundColor};
    box-shadow: 0 1px ${(props) => props.backgroundColor}; // this is added to avoid a 1px gap between title and viz divs that showed up intermittently because of pixel rounding error in chrome.
`;
var TrellisTitle = (props) => {
  const titleText = String(props.trellisKey).toString();
  return /* @__PURE__ */ react_exports.createElement(
    TrellisTitleDiv,
    {
      fontColor: props.fontColor,
      backgroundColor: props.backgroundColor,
      "data-test": "trellis-title",
      title: titleText
    },
    /* @__PURE__ */ react_exports.createElement(TrellisTitleText, null, titleText)
  );
};

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport10 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport11 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/domUtils
var domUtils_exports = {};
__export(domUtils_exports, {
  default: () => domUtils_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/domUtils"));
__reExport(domUtils_exports, require("@splunk/visualizations-shared/domUtils"));
var domUtils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/visualizations-shared/propUtils
var propUtils_exports = {};
__export(propUtils_exports, {
  default: () => propUtils_default
});
var defaultImport13 = __toESM(require("@splunk/visualizations-shared/propUtils"));
__reExport(propUtils_exports, require("@splunk/visualizations-shared/propUtils"));
var propUtils_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport14 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// src/common/utils/singleValueUtils.js
var DEFAULT_FONT = 12;
var DEFAULT_FONT_FAMILY = '"Splunk Platform Sans", "Proxima Nova", "Helvetica Neue", Helvetica, Arial, sans-serif';
var getAligment = (align) => {
  const alignMap = {
    left: "start",
    center: "center",
    right: "end"
  };
  return alignMap[align] || "center";
};
var shouldShowTrend = (trendDisplay) => trendDisplay === "absolute" || trendDisplay === "percent";
var isLoadingOrNoColumns = (dataSources, loading) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noColumns = data === void 0;
  return loading || noColumns;
};
var getFormattedColor = (color, defaultColor) => (0, propUtils_exports.formatColor)(color) || (0, propUtils_exports.formatColor)(defaultColor);
var hasBackground = (backgroundColor) => !!backgroundColor && backgroundColor !== "transparent";
var isIdenticalColor = (colorA, colorB) => !!colorA && !!colorB && (0, propUtils_exports.formatColor)(colorA.toLowerCase()) === (0, propUtils_exports.formatColor)(colorB.toLowerCase());
var getDefaultColorWithBg = ({ backgroundColor, defaultFontColor, defaultBlockFontColor }) => isIdenticalColor(backgroundColor, defaultBlockFontColor) ? defaultFontColor : defaultBlockFontColor;
var getMajorColor = ({ majorColor, backgroundColor, defaultFontColor, defaultBlockFontColor }) => {
  if (hasBackground(backgroundColor) && !majorColor) {
    return getDefaultColorWithBg({
      backgroundColor,
      defaultFontColor,
      defaultBlockFontColor
    });
  }
  return getFormattedColor(majorColor, defaultFontColor);
};
var getTrendColor = ({
  trendColor,
  trendValue,
  majorValue,
  customizedBgColor,
  trendDisplay,
  defaultColors
}) => {
  if (trendColor) {
    return trendColor;
  }
  if (Number.isNaN(Number(trendValue))) {
    return void 0;
  }
  const { defaultFontColor, defaultBlockFontColor, defaultBackgroundColor } = defaultColors;
  if (hasBackground(customizedBgColor) && !isIdenticalColor(customizedBgColor, defaultBackgroundColor) && !isIdenticalColor(customizedBgColor, defaultBlockFontColor)) {
    return defaultBlockFontColor;
  }
  const isInvalidTrend = trendDisplay === "percent" && trendValue === parseFloat(majorValue);
  if (trendValue === 0 || isInvalidTrend) {
    return defaultFontColor;
  }
  return trendValue > 0 ? colorConstants_exports.DELTA_GREEN : colorConstants_exports.DELTA_RED;
};
var computeColors = (props, defaultColors) => {
  const backgroundColor = getFormattedColor(props.backgroundColor, defaultColors.defaultBackgroundColor);
  const backgroundEnabled = hasBackground(backgroundColor);
  const majorColor = getMajorColor({
    majorColor: props.majorColor,
    backgroundColor,
    defaultFontColor: defaultColors.defaultFontColor,
    defaultBlockFontColor: defaultColors.defaultBlockFontColor
  });
  const trendColor = getTrendColor({
    trendColor: props.trendColor,
    trendValue: props.trendValue,
    majorValue: props.majorValue,
    customizedBgColor: props.backgroundColor,
    trendDisplay: props.trendDisplay,
    defaultColors
  });
  const underLabelColor = majorColor;
  return {
    backgroundColor,
    backgroundEnabled,
    majorColor,
    trendColor,
    underLabelColor
  };
};
var computeText = ({
  value,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateValue
}) => {
  let text = (0, numberUtils_exports.isNumerial)(value) ? (0, numberUtils_exports.formatNumber)(value, numberPrecision, {
    useThousandSeparators: shouldUseThousandSeparators,
    // todo: need update formatNumber
    useTrendUnits: shouldAbbreviateValue
  }) : value;
  text = text || "";
  return text;
};
var getMajorText = ({
  majorValueDisplay,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateMajorValue
}) => computeText({
  value: majorValueDisplay === null ? "N/A" : majorValueDisplay,
  // if majorValueDisplay is null, use `N/A`.
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateValue: shouldAbbreviateMajorValue
});
var getTrendText = ({
  majorValue,
  trendValue,
  trendDisplay,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue
}) => {
  const compute = (value) => computeText({
    value,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateValue: shouldAbbreviateTrendValue
  });
  if (trendValue === "" || !(0, numberUtils_exports.isNumerial)(trendValue)) {
    return "";
  }
  const showPercent = trendDisplay === "percent";
  if (!showPercent) {
    return compute(trendValue);
  }
  const diff = Math.abs(trendValue - majorValue);
  let val = trendValue / diff * 100;
  if (trendValue === 0 && diff === 0) {
    val = 0;
  }
  if (!Number.isFinite(val)) {
    return "N/A";
  }
  const text = compute(val);
  return `${text}%`;
};
var computeFontSize = (text, { width, height }, fontFamily = DEFAULT_FONT_FAMILY, fontWeight = "normal") => {
  const widthInDefaultFont = (0, domUtils_exports.computeTextSize)(text, `${fontWeight} ${DEFAULT_FONT}px ${fontFamily}`);
  const fontSize = Math.min(
    width / widthInDefaultFont * DEFAULT_FONT,
    height / DEFAULT_FONT * DEFAULT_FONT
  );
  return parseInt(fontSize, 10);
};
var getMajorFontSize = ({ width, height, unit, majorText, spaceRatio = 1 }) => {
  const majorTextCalc = unit ? `${unit}${majorText}` : majorText;
  return computeFontSize(majorTextCalc, {
    width: width * spaceRatio,
    height
  });
};
var getTrendFontSize = ({ width, height, trendText, spaceRatio = 1 }) => {
  let trendFontSize = 12;
  if (spaceRatio > 0) {
    trendFontSize = computeFontSize(trendText, {
      width: width * spaceRatio,
      height
    });
    trendFontSize = parseInt(trendFontSize, 10) * spaceRatio;
  }
  return trendFontSize;
};
var getMajorAndTrend = ({
  width,
  height,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  trendDisplay,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue,
  shouldAbbreviateMajorValue
}) => {
  const majorTextSpaceRatio = (0, numberUtils_exports.isNumerial)(trendValue) && shouldShowTrend(trendDisplay) ? 0.6 : 1;
  const textContentWidth = width * 0.9;
  const textContentHeight = height * 0.9;
  const majorText = getMajorText({
    majorValueDisplay,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateMajorValue
  });
  const majorTextFontSize = majorFontSize || getMajorFontSize({
    width: textContentWidth,
    height: textContentHeight,
    unit,
    majorText,
    spaceRatio: majorTextSpaceRatio
  });
  const trendText = getTrendText({
    majorValue,
    trendValue,
    trendDisplay,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue
  });
  const trendTextFontSize = trendFontSize || getTrendFontSize({
    width: textContentWidth,
    height: textContentHeight,
    trendText,
    spaceRatio: 1 - majorTextSpaceRatio
  });
  return {
    majorText,
    majorTextFontSize,
    trendText,
    trendTextFontSize
  };
};
var updateVizInSmallSpace = ({
  width,
  height,
  toRemoveList,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  majorTextFontSize,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue
}) => {
  let removeIndex = 0;
  let newProps = {};
  let newMajorAndTrend = {};
  let newTextSize = majorTextFontSize;
  while (newTextSize < 12 && removeIndex < toRemoveList.length) {
    const toRemove = toRemoveList[removeIndex];
    newProps = __spreadValues(__spreadValues({}, newProps), {
      [toRemove.key]: toRemove.value
    });
    newMajorAndTrend = getMajorAndTrend(__spreadValues({
      majorValue,
      majorValueDisplay,
      trendValue,
      majorFontSize,
      trendFontSize,
      width,
      height,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue
    }, newProps));
    newTextSize = newMajorAndTrend.majorTextFontSize;
    removeIndex += 1;
  }
  if (newTextSize < 12) {
    const truncateValue = `${(majorValueDisplay || majorValue).toString().slice(0, 3)}...`;
    newMajorAndTrend = getMajorAndTrend(__spreadValues({
      majorValue,
      majorValueDisplay: truncateValue,
      trendValue,
      majorFontSize,
      trendFontSize,
      width,
      height,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue
    }, newProps));
  }
  return { newMajorAndTrend, updatedProps: newProps };
};
var computeSingleValueContent = ({
  contentWidth,
  contentHeight,
  containerWidth,
  containerHeight,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  trendDisplay,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue,
  shouldAbbreviateMajorValue,
  toRemoveList
}) => {
  let { majorText, trendText, majorTextFontSize, trendTextFontSize } = getMajorAndTrend({
    majorValue,
    majorValueDisplay: majorValueDisplay || majorValue,
    trendValue,
    majorFontSize,
    trendFontSize,
    trendDisplay,
    width: contentWidth,
    height: contentHeight,
    unit,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue,
    shouldAbbreviateMajorValue
  });
  const majorValueTitle = majorText;
  let smallVizProps = {};
  if (majorTextFontSize < 12) {
    const { newMajorAndTrend, updatedProps } = updateVizInSmallSpace({
      width: containerWidth,
      height: containerHeight,
      toRemoveList,
      majorValue,
      majorValueDisplay: majorValueDisplay || majorValue,
      trendValue,
      majorFontSize,
      trendFontSize,
      majorTextFontSize,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue
    });
    ({ majorText, trendText, majorTextFontSize, trendTextFontSize } = newMajorAndTrend);
    smallVizProps = updatedProps;
  }
  return {
    majorText,
    trendText,
    majorTextFontSize,
    trendTextFontSize,
    majorValueTitle,
    smallVizProps
  };
};
var getGraphColors = ({
  backgroundEnabled,
  backgroundColor,
  defaultColors,
  customColorFormatter
}) => {
  if (backgroundEnabled) {
    if (backgroundColor && typeof customColorFormatter === "function") {
      return customColorFormatter(backgroundColor);
    }
  }
  return defaultColors.none;
};
var adjustRGB = (rgb, delta) => {
  if (rgb === 255) {
    return rgb - delta;
  }
  if (rgb === 0) {
    return rgb + delta;
  }
  return rgb;
};
var changeColor = (color, ratio) => {
  const hex = color.replace(/(0x|#)/, "");
  const r = parseInt(hex.substr(0, 2), 16);
  const g = parseInt(hex.substr(2, 2), 16);
  const b = parseInt(hex.substr(4, 2), 16);
  let newR = Math.max(Math.min(Math.floor(r * ratio), 255), 0);
  let newG = Math.max(Math.min(Math.floor(g * ratio), 255), 0);
  let newB = Math.max(Math.min(Math.floor(b * ratio), 255), 0);
  if (newR === r && newG === g && newB === b) {
    if (newR === 0 && newG === 0 && newB === 0) {
      if (ratio > 1) {
        newR = adjustRGB(newR, 80);
        newG = adjustRGB(newG, 80);
        newB = adjustRGB(newB, 80);
      } else {
        newR = adjustRGB(newR, 40);
        newG = adjustRGB(newG, 40);
        newB = adjustRGB(newB, 40);
      }
    } else if (newR === 255 && newG === 255 && newB === 255) {
      if (ratio > 1) {
        newR = adjustRGB(newR, 20);
        newG = adjustRGB(newG, 20);
        newB = adjustRGB(newB, 20);
      } else {
        newR = adjustRGB(newR, 80);
        newG = adjustRGB(newG, 80);
        newB = adjustRGB(newB, 80);
      }
    } else {
      newR = adjustRGB(newR, 20);
      newG = adjustRGB(newG, 20);
      newB = adjustRGB(newB, 20);
    }
  }
  return `#${newR.toString(16).padStart(2, 0)}${newG.toString(16).padStart(2, 0)}${newB.toString(16).padStart(2, 0)}`;
};
var darken = (color) => changeColor(color, 0.5);
var handleValueClickCallback = (ev, majorValue, majorValueField, trendValue, onValueClick, trellisEnabled = false, trellisSplitBy = "", trellisKey = "") => onValueClick(__spreadProps(__spreadValues({}, ev), {
  payload: __spreadValues({
    trendValue,
    value: majorValue,
    name: majorValueField
  }, trellisEnabled && { "trellis.name": trellisSplitBy, "trellis.value": trellisKey })
}));
var getTrendColorWithPercent = (options) => {
  const shouldUsePercentTrendColor = options.trendColor === "> trendValue | rangeValue(trendColorEditorConfig)" && options.trendDisplay === "percent";
  return shouldUsePercentTrendColor ? { trendColor: "> trendValuePercent | rangeValue(trendColorEditorConfig)" } : {};
};

// esm-externals:@splunk/react-icons/enterprise/ArrowUp
var ArrowUp_exports = {};
__export(ArrowUp_exports, {
  default: () => ArrowUp_default
});
var defaultImport15 = __toESM(require("@splunk/react-icons/enterprise/ArrowUp"));
__reExport(ArrowUp_exports, require("@splunk/react-icons/enterprise/ArrowUp"));
var ArrowUp_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// esm-externals:@splunk/react-icons/enterprise/ArrowDown
var ArrowDown_exports = {};
__export(ArrowDown_exports, {
  default: () => ArrowDown_default
});
var defaultImport16 = __toESM(require("@splunk/react-icons/enterprise/ArrowDown"));
__reExport(ArrowDown_exports, require("@splunk/react-icons/enterprise/ArrowDown"));
var ArrowDown_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport17 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// src/SingleValueBasic/TrendValue.jsx
var Column = styled_components_default.div`
    display: flex;
    flex-direction: row;
    justify-content: ${(props) => props.justify || "flex-end"};
    height: ${(props) => props.size || 12}px;
    ${(props) => props.size ? `margin: 0 ${parseInt(props.size, 10) * 0.2 || 5}px;` : ""};
`;
var Text = styled_components_default.div`
    white-space: nowrap;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color || "#000"};
    font-family: ${DEFAULT_FONT_FAMILY};
    height: ${(props) => props.size || 12}px;
    line-height: ${(props) => props.size || 12}px;
    display: flex;
    align-self: baseline;
    ${(props) => props.size ? `margin-left: ${parseInt(props.size, 10) * 0.2 || 5}px;` : ""};
`;
var TrendValue = ({ fontSize, color, value, text }) => {
  let TrendIndicator = false;
  let ariaLabel = false;
  if (parseFloat(value, 10) > 0) {
    TrendIndicator = ArrowUp_default;
    ariaLabel = (0, i18n_exports._)("increase");
  } else if (parseFloat(value, 10) < 0) {
    TrendIndicator = ArrowDown_default;
    ariaLabel = (0, i18n_exports._)("decrease");
  }
  return /* @__PURE__ */ react_default.createElement(Column, { justify: "flex-end", size: fontSize }, /* @__PURE__ */ react_default.createElement(Text, { "data-test": "trendValueIndicator", size: fontSize, color }, TrendIndicator && /* @__PURE__ */ react_default.createElement(TrendIndicator, { "aria-label": ariaLabel })), /* @__PURE__ */ react_default.createElement(Text, { "data-test": "trendValue", size: fontSize, color }, `${text}`));
};
TrendValue.propTypes = {
  fontSize: prop_types_default.number,
  color: prop_types_default.string,
  value: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  text: prop_types_default.string
};
var TrendValue_default = TrendValue;

// esm-externals:cssesc
var cssesc_exports = {};
__export(cssesc_exports, {
  default: () => cssesc_default
});
var defaultImport18 = __toESM(require("cssesc"));
__reExport(cssesc_exports, require("cssesc"));
var cssesc_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// src/SingleValueBasic/MajorValue.jsx
var Row = styled_components_default.div`
    display: flex;
    flex-direction: row;
    align-items: flex-end;
    justify-content: left;
    height: ${(props) => props.size}px;
    line-height: ${(props) => props.size}px;
`;
var Text2 = styled_components_default.div`
    white-space: nowrap;
    height: 100%;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color};
    font-family: ${DEFAULT_FONT_FAMILY};
    font-weight: bold;
    &:hover {
        text-decoration: ${(props) => props.showUnderline ? "underline" : "inherit"};
        cursor: ${(props) => props.showUnderline ? "pointer" : "inherit"};
    }
    ${(props) => {
  if (!props.pseudoContent || !props.pseudoContentPosition) {
    return "";
  }
  return `&:${props.pseudoContentPosition} {
            // by default this pseudo element would inherit text-decoration from main element
            // and text-decoration could not be overwritten.
            // adding display: inline-block makes text decoration independent from main element.
            // => the unit will not be underlined if a user hovers over the main value
            display: inline-block;
            font-size: ${props.pseudoContentFontSize}px;
            position: relative;
            font-weight: normal;
            content: ${props.pseudoContent};
        }`;
}}
`;
var validUnitPositions = ["before", "after"];
var MajorValue = ({ color, fontSize, unitPosition, title, value, onValueClick, unit }) => {
  let sanitizedUnit;
  let sanitizedUnitPosition;
  if (typeof unit === "string") {
    sanitizedUnit = cssesc_default(unit, { wrap: true, quotes: "double" });
    if (typeof unitPosition === "string" && validUnitPositions.includes(unitPosition)) {
      sanitizedUnitPosition = unitPosition;
    } else {
      sanitizedUnitPosition = "after";
    }
  }
  const handleKeyDown = (e) => {
    if (e.keyCode !== 13) {
      return;
    }
    e.preventDefault();
    onValueClick(e);
  };
  return /* @__PURE__ */ react_default.createElement(Row, { size: fontSize }, /* @__PURE__ */ react_default.createElement(
    Text2,
    {
      "data-test": "majorValue",
      color,
      onClick: (e) => typeof onValueClick === "function" && onValueClick(e),
      showUnderline: !!onValueClick,
      size: fontSize,
      title,
      pseudoContent: sanitizedUnit,
      pseudoContentPosition: sanitizedUnitPosition,
      pseudoContentFontSize: fontSize * 0.6,
      tabIndex: "0",
      role: "button",
      onKeyDown: handleKeyDown
    },
    value
  ));
};
MajorValue.propTypes = {
  color: prop_types_default.string,
  fontSize: prop_types_default.number,
  unit: prop_types_default.string,
  unitPosition: prop_types_default.oneOf(validUnitPositions),
  value: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  title: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  onValueClick: prop_types_default.oneOfType([prop_types_default.bool, prop_types_default.func])
};
var MajorValue_default = MajorValue;

// src/SingleValueBasic/SingleValueBasic.jsx
var Column2 = styled_components_default.div`
    display: flex;
    flex-direction: column;
    align-self: center;
    justify-content: center;
`;
var Row2 = styled_components_default.div`
    display: flex;
    flex-direction: row;
    align-items: ${(props) => props.alignItems || "center"};
    justify-content: ${(props) => getAligment(props.align)};
`;
var Text3 = styled_components_default.div`
    font-weight: normal;
    white-space: nowrap;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color || "#000"};
    font-family: ${DEFAULT_FONT_FAMILY};
    height: ${(props) => props.size || 12}px;
    line-height: 1.2;
    margin: ${(props) => props.margin || "inherit"};
`;
var SingleValueBasic = (_a) => {
  var props = __objRest(_a, []);
  const {
    majorColor,
    majorTextFontSize,
    majorText,
    majorValueTitle,
    trendColor,
    trendTextFontSize,
    trendText,
    showTrendIndicator,
    unit,
    unitPosition,
    underLabel,
    underLabelFontSize,
    underLabelColor,
    onValueClick,
    align
  } = props;
  const trendIndicatorEnabled = trendText !== "" && showTrendIndicator;
  return /* @__PURE__ */ react_default.createElement(Column2, null, /* @__PURE__ */ react_default.createElement(
    Row2,
    {
      alignItems: "baseline",
      align,
      "data-test": `single-value-row-align-${getAligment(align)}`
    },
    /* @__PURE__ */ react_default.createElement(
      MajorValue_default,
      {
        color: majorColor,
        fontSize: majorTextFontSize,
        unit,
        unitPosition,
        value: majorText,
        title: majorValueTitle,
        onValueClick
      }
    ),
    trendIndicatorEnabled && // Passing the same value for value and text is a temporary hold until completion of https://jira.splunk.com/browse/SCP-21371
    /* @__PURE__ */ react_default.createElement(
      TrendValue_default,
      {
        fontSize: trendTextFontSize,
        color: trendColor,
        value: trendText,
        text: trendText
      }
    )
  ), underLabel && /* @__PURE__ */ react_default.createElement(
    Row2,
    {
      justify: "center",
      align,
      "data-test": `single-value-row-align-${getAligment(align)}`
    },
    /* @__PURE__ */ react_default.createElement(
      Text3,
      {
        "data-test": "underLabel",
        size: underLabelFontSize,
        color: underLabelColor,
        margin: "0 6px"
      },
      underLabel
    )
  ));
};
SingleValueBasic.propTypes = {
  majorText: prop_types_default.string,
  majorColor: prop_types_default.string,
  majorTextFontSize: prop_types_default.number,
  majorValueTitle: prop_types_default.string,
  trendText: prop_types_default.string,
  trendTextFontSize: prop_types_default.number,
  trendColor: prop_types_default.string,
  showTrendIndicator: prop_types_default.bool,
  unit: prop_types_default.string,
  unitPosition: prop_types_default.oneOf(["before", "after"]),
  underLabel: prop_types_default.string,
  underLabelFontSize: prop_types_default.number,
  underLabelColor: prop_types_default.string,
  onValueClick: prop_types_default.oneOfType([prop_types_default.bool, prop_types_default.func]),
  align: prop_types_default.string
};
var SingleValueBasic_default = SingleValueBasic;

// esm-externals:@splunk/react-ui/Popover
var Popover_exports = {};
__export(Popover_exports, {
  default: () => Popover_default
});
var defaultImport19 = __toESM(require("@splunk/react-ui/Popover"));
__reExport(Popover_exports, require("@splunk/react-ui/Popover"));
var Popover_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport20 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// src/SparkLine/SparkLine.jsx
var StyledSvg = styled_components_default.svg`
    /* For fixing IE11 shows overflow part line issue */
    overflow: hidden;
`;
var StyledTooltip = styled_components_default.div`
    padding: 3px 8px;
    font-size: 12px;
`;
var _SparkLine = class _SparkLine extends react_exports.Component {
  constructor(props, ...rest) {
    super(props, ...rest);
    __publicField(this, "handleCursorMount", (el) => {
      this.setState({
        anchor: el
      });
    });
    this.state = {
      anchor: null,
      currentPointX: null,
      open: false,
      rectArea: null,
      tooltip: null
    };
    this.titleId = (0, id_exports.createDOMID)();
  }
  getMax() {
    const { data, acceptNull, yMax } = this.props;
    const dataMax = () => acceptNull ? (0, lodash_exports.max)(this.fillNull(data)) : (0, lodash_exports.max)(data);
    return yMax !== void 0 ? yMax : dataMax();
  }
  getMin() {
    const { data, acceptNull, yMin } = this.props;
    const dataMin = () => acceptNull ? (0, lodash_exports.min)(this.fillNull(data)) : (0, lodash_exports.min)(data);
    return yMin !== void 0 ? yMin : dataMin();
  }
  /**
   * Gets unit value of x axis.
   * @param {Number} xMargin - margin of x axis.
   * @return {Number} unit value of x axis.
   * @private
   */
  getXUnit(xMargin) {
    const { data, width } = this.props;
    const xUnit = (width - xMargin * 2) / (data.length > 1 ? data.length - 1 : 1);
    return Math.max(0, xUnit);
  }
  /**
   * Gets unit value of y axis.
   * @param {String} yMargin - margin of y axis.
   * @return {Number} unit value of y axis.
   * @private
   */
  getYUnit(yMargin) {
    const { height } = this.props;
    const maxValue = this.getMax();
    const minValue = this.getMin();
    const yUnit = (height - yMargin * 2) / (maxValue - minValue || 2);
    return Math.max(0, yUnit);
  }
  /**
   * Get a list of arrays of points for drawing lines, based on acceptNull property
   * @method getSegmentSets
   * @param {Array} data
   * @param {Array} points
   * @returns {Array} List of datapoint sets used for drawing lines
   */
  getSegmentSets(data, points) {
    const { acceptNull } = this.props;
    const lines = [];
    let currentLine = [];
    data.forEach((p, idx) => {
      if (!acceptNull && (0, lodash_exports.isNull)(p)) {
        if (currentLine.length > 1) {
          lines.push(currentLine);
        }
        currentLine = [];
      } else {
        currentLine.push(points[idx]);
      }
    });
    if (currentLine.length > 1) {
      lines.push(currentLine);
    }
    return lines;
  }
  /**
   * Utility for fill null value with number 0.
   * @private
   */
  fillNull() {
    const { data } = this.props;
    return data.map((value) => value === null ? 0 : value);
  }
  /**
   * Converts data to points in svg
   * @param {Number} xMargin - margin of x axis.
   * @param {Number} yMargin - margin of x axis.
   * @return {Array} points coordination.
   * @private
   */
  dataToPoints(xMargin, yMargin) {
    const { data } = this.props;
    const xUnit = this.getXUnit(xMargin);
    const yUnit = this.getYUnit(yMargin);
    const maxValue = this.getMax();
    const minValue = this.getMin();
    return data.map((val, idx) => ({
      x: idx * xUnit + xMargin,
      y: maxValue === minValue ? yUnit + yMargin : (maxValue - val) * yUnit + yMargin
    })).map((p) => [p.x, p.y]);
  }
  /**
   * Renders rect area for helping figure out which is the nearest point so that
   * render related cursor and tooltip.
   * @param {Array} points - array of points coordination.
   * @param {Number} xMargin - margin of x axis.
   * @return {Array} array of svg rect objects
   * @private
   */
  renderRect(points, xMargin) {
    const { data, height } = this.props;
    const xUnit = this.getXUnit(xMargin);
    return points.map((p, i) => (
      /* eslint-disable react/no-array-index-key */
      /* @__PURE__ */ react_default.createElement(
        "rect",
        {
          key: `${i}_${p[0]}`,
          "data-test": `rect-${i}`,
          x: p[0] - xUnit / 2 <= 0 ? 0 : p[0] - xUnit / 2,
          y: 0,
          width: i === 0 && data.length !== 1 ? xUnit / 2 : xUnit,
          height,
          style: { fillOpacity: 0 },
          onMouseOver: (e) => {
            this.setState({
              open: data[i] !== null,
              rectArea: data[i] === null ? null : e.target,
              tooltip: data[i],
              currentPointX: p[0]
            });
          }
        }
      )
    ));
  }
  // Renders area chart
  renderArea(points) {
    const { data, fillColor, fillOpacity, height, isArea } = this.props;
    if (!isArea || points.length === 0) {
      return null;
    }
    let segments = this.getSegmentSets(data, points);
    segments = segments.map(
      (s) => s.concat([
        [s[s.length - 1][0], height],
        // down to bottom of graph
        [s[0][0], height],
        // over to below first data point
        s[0]
        // up to first data point to close the box
      ])
    );
    return /* @__PURE__ */ react_default.createElement("g", { "data-test": "area" }, segments.map((s) => /* @__PURE__ */ react_default.createElement(
      "polyline",
      {
        key: `area${s.join("")}`,
        points: s.join(" "),
        "data-test": "area-line",
        style: {
          fill: fillColor,
          fillOpacity,
          strokeWidth: "0"
        }
      }
    )));
  }
  renderCursor() {
    const {
      cursorStroke,
      cursorStrokeWidth,
      cursorStrokeLinecap,
      cursorStrokeDasharray,
      height
    } = this.props;
    return this.state.rectArea !== null && /* @__PURE__ */ react_default.createElement(
      "line",
      {
        "data-test": "cursor",
        ref: this.handleCursorMount,
        x1: this.state.currentPointX,
        y1: 0,
        x2: this.state.currentPointX,
        y2: height,
        style: {
          stroke: cursorStroke,
          strokeWidth: cursorStrokeWidth,
          strokeLinecap: cursorStrokeLinecap,
          strokeDasharray: cursorStrokeDasharray
        }
      }
    );
  }
  renderTooltip() {
    return this.state.anchor !== null && /* @__PURE__ */ react_default.createElement(
      Popover_default,
      {
        "data-test": "tooltip",
        open: this.state.open,
        anchor: this.state.anchor,
        "data-test-value": this.state.tooltip,
        appearance: "inverted",
        defaultPlacement: "above",
        animation: false
      },
      /* @__PURE__ */ react_default.createElement(StyledTooltip, null, this.state.anchor !== null ? this.state.tooltip : void 0)
    );
  }
  /**
   * Renders one or more svg circles to highlight values on the sparkline
   * @method renderEndDots
   * @param {Array[Array[Number]]} points // x,y coordinates of values
   * @param {Number} dotsToShow           // number of end dots to display
   * @param {Number} xMargin              // used when calculating the dot radius
   * @returns {Object} React representation of SVG group
   * @private
   */
  renderEndDots(points, dotsToShow, xMargin) {
    const { endDotFillColor, endDotRadius, endDotStroke, endDotStrokeWidth } = this.props;
    return /* @__PURE__ */ react_default.createElement("g", null, points.slice(-dotsToShow).map((point) => /* @__PURE__ */ react_default.createElement(
      "circle",
      {
        key: `end-dot${point[0]}${point[1]}`,
        "data-test": "end-dot",
        cx: point[0],
        cy: point[1],
        r: endDotRadius === 0 ? xMargin : endDotRadius,
        style: {
          fill: endDotFillColor,
          stroke: endDotStroke,
          strokeWidth: endDotStrokeWidth
        }
      }
    )));
  }
  /**
   * Renders the line(s) above the area graph
   * @method renderPolyline
   * @param {Array} points
   * @returns {Object} SVG Group of polylines
   */
  renderPolyline(points) {
    const { data, lineColor, lineLength, lineStrokeWidth } = this.props;
    const linePoints = (0, lodash_exports.isFinite)(lineLength) && lineLength > 0 ? lineLength : points.length;
    const lines = this.getSegmentSets(data.slice(-linePoints), points.slice(-linePoints));
    return /* @__PURE__ */ react_default.createElement("g", { "data-test": "sparkline" }, lines.map((lineData) => /* @__PURE__ */ react_default.createElement(
      "polyline",
      {
        key: `line${lineData.join("")}`,
        "data-test": "polyline",
        style: {
          fill: "none",
          stroke: lineColor,
          strokeWidth: lineStrokeWidth,
          strokeLinejoin: "round",
          strokeLinecap: "round"
        },
        points: lineData.join(" ")
      }
    )));
  }
  render() {
    const {
      data,
      elementRef,
      showTooltip,
      showEndDot,
      endDotRadius,
      endDotStrokeWidth,
      endDotCount,
      height,
      isArea,
      lineStrokeWidth,
      width,
      title
    } = this.props;
    if (data.length === 0) {
      return null;
    }
    const xMargin = endDotRadius + endDotStrokeWidth / 2;
    const yMargin = Math.max(lineStrokeWidth / 2, endDotRadius + endDotStrokeWidth / 2);
    const points = this.dataToPoints(xMargin, yMargin);
    const dotsToShow = Math.max(showEndDot && 1, (0, lodash_exports.isFinite)(endDotCount) && endDotCount > 0 && endDotCount);
    return /* @__PURE__ */ react_default.createElement(
      "div",
      __spreadValues({
        "data-test": "line",
        "data-test-type": isArea ? "area" : "line",
        onMouseOut: () => {
          this.setState({
            open: false,
            anchor: null,
            rectArea: null,
            currentPointX: null
          });
        },
        ref: elementRef
      }, (0, lodash_exports.omit)(this.props, (0, lodash_exports.keys)(_SparkLine.propTypes))),
      /* @__PURE__ */ react_default.createElement(
        StyledSvg,
        {
          height,
          width,
          role: "img",
          "aria-labelledby": this.titleId,
          "data-test": "sparkline-svg"
        },
        /* @__PURE__ */ react_default.createElement("title", { id: this.titleId, "data-test": "sparkline-title" }, title || (0, i18n_exports._)("Source count over time sparkline trend")),
        /* @__PURE__ */ react_default.createElement("g", null, this.renderCursor(), this.renderPolyline(points), this.renderArea(points), dotsToShow ? this.renderEndDots(points, dotsToShow, xMargin) : null, showTooltip ? this.renderRect(points, xMargin) : null, showTooltip ? this.renderTooltip() : null)
      )
    );
  }
};
__publicField(_SparkLine, "propTypes", {
  /**
   * If true, data can contain `null` as a value and is treated as `0`. If false, this throws error when data contains `null`.
   */
  acceptNull: prop_types_default.bool,
  /** Array of numbers. These data numbers are converted to points and show on sparkline. */
  data: (props) => {
    if (!(0, lodash_exports.isArray)(props.data)) {
      return new Error("Data provided to Sparkline must be an array.");
    }
    if (props.acceptNull && !props.data.every((value) => (0, lodash_exports.isNull)(value) || (0, lodash_exports.isFinite)(value))) {
      return new Error("Data provided to Sparkline must be finite numbers or null.");
    }
    if (!props.acceptNull && !props.data.every((value) => (0, lodash_exports.isFinite)(value))) {
      return new Error("Data provided to Sparkline must be finite numbers.");
    }
    return null;
  },
  /** A React ref which is set to the DOM element when the component mounts and `null` when it unmounts. */
  elementRef: prop_types_default.oneOfType([prop_types_default.func, prop_types_default.object]),
  /** Sets the number of end dots to display. When showEndDot is set to `true`, endDotCount is at least 1. If set to a positive value, this overrides showEndDot. */
  endDotCount: prop_types_default.number,
  /** Fills color to the end dot. */
  endDotFillColor: prop_types_default.string,
  /**
   * Sets end dot radius. End dot radius must be less than or equal to the margin. By default, its value equals the margin.
   */
  endDotRadius: prop_types_default.number,
  /** Sets end dot circle stroke color. */
  endDotStroke: prop_types_default.string,
  /** Sets end dot circle stroke width in pixels. */
  endDotStrokeWidth: prop_types_default.number,
  /** Fills color to area. */
  fillColor: prop_types_default.string,
  /** Fills opacity to area. Value must be in 0 ~ 1. */
  fillOpacity: prop_types_default.string,
  /** Sets cursor stroke color. */
  cursorStroke: prop_types_default.string,
  /** Sets cursor stroke width in pixels. */
  cursorStrokeWidth: prop_types_default.number,
  /** Sets cursor line cap style. */
  cursorStrokeLinecap: prop_types_default.oneOf(["butt", "round", "square"]),
  /** Sets cursor dash array style. */
  cursorStrokeDasharray: prop_types_default.string,
  /**
   * Container height. If this value is specified, sparkline calculates the size using this height. If height isn't specified,
   * sparkline figures out the container height by itself.
   */
  height: prop_types_default.number.isRequired,
  /** When set to `true`, sparkline shows as area. */
  isArea: prop_types_default.bool,
  /** The sparkline line color. */
  lineColor: prop_types_default.string,
  /** Allows user to draw only the last data points for the line. */
  lineLength: prop_types_default.number,
  /** The sparkline line stroke width in pixels. */
  lineStrokeWidth: prop_types_default.number,
  /** Enable to show end dot. */
  showEndDot: prop_types_default.bool,
  /** Enable to show tooltip. */
  showTooltip: prop_types_default.bool,
  /** Sets the data value range and maximum value shown on sparkline. */
  yMax: prop_types_default.number,
  /** Sets the data value range and minimum value shown on sparkline. */
  yMin: prop_types_default.number,
  /**
   * The width of the container.
   */
  width: prop_types_default.number.isRequired,
  /** Sets the a11y title text on sparkline. */
  title: prop_types_default.string
});
__publicField(_SparkLine, "defaultProps", {
  acceptNull: false,
  data: [],
  showTooltip: true,
  endDotCount: 0,
  showEndDot: false,
  endDotRadius: 0,
  endDotFillColor: "white",
  endDotStroke: "black",
  endDotStrokeWidth: 0,
  fillColor: "#65a637",
  fillOpacity: ".1",
  cursorStroke: "#5184AF",
  cursorStrokeWidth: 3,
  cursorStrokeLinecap: "square",
  cursorStrokeDasharray: "1, 5",
  isArea: false,
  lineColor: "#65a637",
  lineStrokeWidth: 1
});
var SparkLine = _SparkLine;
var SparkLine_default = SparkLine;

// src/SingleValue/PureSingleValue/SingleValueSparkline.jsx
var SingleValueSparkline = ({
  width,
  height,
  data,
  fill,
  fillOpacity = 0.2,
  stroke,
  showTooltip,
  isArea,
  lineLength = 0,
  endDotCount = 0,
  acceptNull = true
}) => /* @__PURE__ */ react_default.createElement(
  SparkLine_default,
  {
    lineColor: (0, propUtils_exports.formatColor)(stroke),
    fillColor: (0, propUtils_exports.formatColor)(fill),
    fillOpacity: fillOpacity.toString(10),
    data,
    height,
    width,
    showTooltip,
    isArea,
    lineStrokeWidth: 1.5,
    lineLength: isArea ? lineLength : void 0,
    endDotCount: isArea ? endDotCount : void 0,
    endDotRadius: Math.min(width, height) < 15 ? 1 : 3,
    endDotStroke: (0, propUtils_exports.formatColor)(stroke),
    endDotFillColor: (0, propUtils_exports.formatColor)(stroke),
    acceptNull,
    style: { flex: "0 0 auto", justifyContent: "center", display: "flex", alignItems: "flex-end" }
  }
);
SingleValueSparkline.propTypes = {
  acceptNull: prop_types_default.bool,
  data: prop_types_default.arrayOf(prop_types_default.number),
  endDotCount: prop_types_default.number,
  fill: prop_types_default.string,
  fillOpacity: prop_types_default.number,
  height: prop_types_default.number,
  isArea: prop_types_default.bool,
  lineLength: prop_types_default.number,
  showTooltip: prop_types_default.bool,
  stroke: prop_types_default.string,
  width: prop_types_default.number
};
var SingleValueSparkline_default = SingleValueSparkline;

// src/SingleValue/PureSingleValue/utils/displayUtils.js
var CONTENT_NEXT_TO_SPARKLINE_WIDTH_ALLOCATION_RATIO = 0.4;
var LINEHEIGHT_FACTOR = 1.2;
var CONTENT_SPARKLINE_SPACING = 16;
var VALID_SPARKLINE_POSITIONS = ["below", "before", "after", "off"];
var getUnderLabelHeight = ({ underLabel, underLabelFontSize }) => underLabel && underLabel.length ? underLabelFontSize * LINEHEIGHT_FACTOR : 0;
var getAvailableContentWidth = ({
  hasSparkline,
  isSparklinePositionBelow,
  containerWidth,
  overflowArea
}) => {
  const overflowTotalArea = 2 * overflowArea;
  if (hasSparkline && !isSparklinePositionBelow) {
    return CONTENT_NEXT_TO_SPARKLINE_WIDTH_ALLOCATION_RATIO * containerWidth - overflowTotalArea;
  }
  return containerWidth - overflowTotalArea;
};
var getAvailableContentHeight = ({
  height,
  hasSparkline,
  isSparklinePositionBelow,
  majorTextFontSize,
  underLabelHeight = 0
}) => {
  if (hasSparkline && !isSparklinePositionBelow) {
    return height;
  }
  return majorTextFontSize + CONTENT_SPARKLINE_SPACING + underLabelHeight;
};
var isValidPosition = (sparklinePosition) => VALID_SPARKLINE_POSITIONS.indexOf(sparklinePosition) > -1;
var parseSparklineValues = ({ sparklineValues }) => (
  // todo: need this function to maitain the behavior for dashboard-viz and react-viz.
  // can refactor it after we discard dashboard-viz and react-viz repo
  Array.isArray(sparklineValues) ? sparklineValues.map((v) => {
    const numV = (0, numberUtils_exports.parseNumber)(v);
    if (numV === 0) {
      return null;
    }
    return numV || v;
  }) : void 0
);
var shouldShowSparkline = ({ showSparkline, sparklineValues }) => showSparkline && Array.isArray(sparklineValues) && sparklineValues.length > 1 && sparklineValues.every((v) => v === null || !Number.isNaN((0, numberUtils_exports.parseNumber)(v))) && sparklineValues.filter((v) => v !== null).length > 0;
var getSparklineWidth = ({ width, isSparklinePositionBelow }) => {
  const spaceRatio = isSparklinePositionBelow ? 1 : 0.6;
  return width * spaceRatio;
};
var getSparklineHeight = ({ height, contentHeight, isSparklinePositionBelow }) => {
  const belowPositionHeight = height - contentHeight;
  const sanitizedBelowPositionHeight = belowPositionHeight < 0 ? 0 : belowPositionHeight;
  return isSparklinePositionBelow ? sanitizedBelowPositionHeight : height;
};
var getSparklineSegments = ({ hasSparkline, sparklineHighlightSegments }) => hasSparkline && typeof sparklineHighlightSegments === "number" && sparklineHighlightSegments > 0 ? sparklineHighlightSegments + 1 : 0;
var getEndDots = ({ hasSparkline, sparklineHighlightDots }) => !hasSparkline || typeof sparklineHighlightDots === "string" || sparklineHighlightDots < 0 ? 0 : sparklineHighlightDots;
var getSparklineColors = ({ backgroundEnabled, backgroundColor, sparklineSeverityColors }) => getGraphColors({
  backgroundEnabled,
  backgroundColor,
  defaultColors: sparklineSeverityColors,
  customColorFormatter: (color) => {
    if (color === colorConstants_exports.SPARKLINE_WHITE) {
      return sparklineSeverityColors.none;
    }
    return { background: darken(color), stroke: colorConstants_exports.SPARKLINE_WHITE };
  }
});
var getSparklines = ({
  width,
  height,
  contentHeight,
  hasSparkline,
  isSparklinePositionBelow,
  sparklineHighlightSegments,
  sparklineHighlightDots
}) => {
  const sparklineWidth = getSparklineWidth({
    width,
    isSparklinePositionBelow
  });
  const sparklineHeight = getSparklineHeight({
    height,
    contentHeight,
    isSparklinePositionBelow
  });
  const sparklineSegments = getSparklineSegments({ hasSparkline, sparklineHighlightSegments });
  const endDots = getEndDots({ hasSparkline, sparklineHighlightDots });
  return {
    sparklineWidth,
    sparklineHeight,
    sparklineSegments,
    endDots
  };
};

// src/SingleValue/PureSingleValue/SingleValueContent.jsx
var CONTENT_OVERFLOW_FADEOUT_AREA_PX = 16;
var Column3 = styled_components_default.div`
    display: flex;
    flex-direction: column;
    height: 100%;
    width: 100%;
    justify-content: center;
`;
var Row3 = styled_components_default.div`
    display: flex;
    flex-direction: row;
`;
var OverflowWrapper = styled_components_default.div.attrs(() => ({
  "data-test": "overflowWrapper"
}))`
    box-sizing: border-box;
    padding-left: 16px;
    padding-right: 16px;
    width: 100%;
    height: ${(props) => props.height}px;
    position: relative;
    display: flex;
    align-items: start;
    justify-content: ${(props) => getAligment(props.align)};
    &:after,
    &:before {
        position: absolute;
        height: 100%;
        width: ${CONTENT_OVERFLOW_FADEOUT_AREA_PX}px;
        content: '';
        top: 0;
    }
    &:after {
        right: 0;
        background: linear-gradient(
            90deg,
            ${(props) => props.overflowBackgroundColor}00,
            ${(props) => props.overflowBackgroundColor}
        );
    }
    &:before {
        left: 0;
        background: linear-gradient(
            -90deg,
            ${(props) => props.overflowBackgroundColor}00,
            ${(props) => props.overflowBackgroundColor}
        );
    }
`;
var SingleValueContent = (_a) => {
  var props = __objRest(_a, []);
  const {
    backgroundColor,
    contentHeight,
    majorColor,
    majorText,
    majorTextFontSize,
    majorValueTitle,
    trendColor,
    trendText,
    trendTextFontSize,
    showTrendIndicator,
    unit,
    unitPosition,
    underLabel,
    underLabelFontSize,
    underLabelColor,
    onValueClick,
    showSparkline,
    sparklinePosition,
    sparklineWidth,
    sparklineHeight,
    sparklineValues,
    sparklineAreaColor,
    sparklineStrokeColor,
    showSparklineTooltip,
    showSparklineAreaGraph,
    shouldSparklineAcceptNullData,
    sparklineSegments,
    endDots,
    align
  } = props;
  let sparkline = null;
  if (shouldShowSparkline({ showSparkline, sparklineValues })) {
    sparkline = /* @__PURE__ */ react_default.createElement(
      SingleValueSparkline_default,
      {
        width: sparklineWidth,
        height: sparklineHeight,
        data: sparklineValues,
        fill: sparklineAreaColor,
        stroke: sparklineStrokeColor,
        showTooltip: showSparklineTooltip,
        isArea: showSparklineAreaGraph,
        acceptNull: shouldSparklineAcceptNullData,
        lineLength: sparklineSegments,
        endDotCount: endDots
      }
    );
  }
  return /* @__PURE__ */ react_default.createElement(Column3, null, /* @__PURE__ */ react_default.createElement(Row3, null, sparklinePosition === "before" && sparkline, /* @__PURE__ */ react_default.createElement(
    OverflowWrapper,
    {
      overflowBackgroundColor: backgroundColor,
      height: contentHeight,
      align
    },
    /* @__PURE__ */ react_default.createElement(
      SingleValueBasic_default,
      {
        majorColor,
        majorText,
        majorTextFontSize,
        majorValueTitle,
        trendColor,
        trendText,
        trendTextFontSize,
        showTrendIndicator,
        unit,
        unitPosition,
        underLabel,
        underLabelFontSize,
        underLabelColor,
        onValueClick,
        align
      }
    )
  ), sparklinePosition === "after" && sparkline), sparklinePosition === "below" && sparkline);
};
SingleValueContent.propTypes = __spreadProps(__spreadValues({}, SingleValueBasic_default.propTypes), {
  contentHeight: prop_types_default.number,
  backgroundColor: prop_types_default.string,
  showSparkline: prop_types_default.bool,
  sparklinePosition: prop_types_default.oneOf(VALID_SPARKLINE_POSITIONS),
  sparklineWidth: prop_types_default.number,
  sparklineHeight: prop_types_default.number,
  sparklineValues: prop_types_default.arrayOf(prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number])),
  sparklineAreaColor: prop_types_default.string,
  sparklineStrokeColor: prop_types_default.string,
  showSparklineTooltip: prop_types_default.bool,
  showSparklineAreaGraph: prop_types_default.bool,
  shouldSparklineAcceptNullData: prop_types_default.bool,
  sparklineSegments: prop_types_default.number,
  endDots: prop_types_default.number
});
var SingleValueContent_default = SingleValueContent;

// src/SingleValue/PureSingleValue/SingleValue.jsx
var CONTENT_OVERFLOW_FADEOUT_AREA_PX2 = 16;
var DEFAULT_CONTENT_HEIGHT_ALLOCATION_RATIO = 0.8;
var DEFAULT_SPARKLINE_SEVERITY_COLORS = {
  none: {
    background: "#818d99",
    stroke: "#171d21"
  },
  low: {
    background: "#275126",
    stroke: "#FFFFFF"
  },
  guarded: {
    background: "#002b3e",
    stroke: "#FFFFFF"
  },
  elevated: {
    background: "#7d600f",
    stroke: "#FFFFFF"
  },
  high: {
    background: "#79401a",
    stroke: "#FFFFFF"
  },
  severe: {
    background: "#6f261d",
    stroke: "#FFFFFF"
  }
};
var Container = styled_components_default.div`
    overflow: hidden;
    ${(props) => (0, style_exports.toDimension)(pick_default(props, ["width", "height"]))};
`;
var SingleValue = (_a) => {
  var props = __objRest(_a, []);
  const {
    width,
    height = 250,
    hasEventHandlers,
    style,
    majorFontSize,
    majorValue,
    majorValueDisplay,
    majorValueField,
    trendValue,
    trendFontSize,
    unitPosition,
    underLabelFontSize,
    numberPrecision,
    // fixme todo probably belongs in a DSL formatter
    shouldUseThousandSeparators,
    // fixme todo probably belongs in a DSL formatter
    shouldAbbreviateTrendValue,
    // fixme todo probably belongs in a DSL formatter
    shouldAbbreviateMajorValue,
    // fixme todo probably belongs in a DSL formatter
    sparklineValues,
    sparklineHighlightSegments,
    // fixme this is not a pure viz if it has lots of rendering logic for a sub-viz.
    sparklineHighlightDots,
    showSparklineAreaGraph,
    showSparklineTooltip,
    shouldSparklineAcceptNullData,
    onValueClick,
    defaultFontColor,
    defaultBackgroundColor,
    defaultBlockFontColor,
    sparklineSeverityColors = DEFAULT_SPARKLINE_SEVERITY_COLORS,
    sparklineAreaColor,
    defaultThemeColors,
    splitByLayout,
    trellisKey = "",
    trellisSplitBy = "",
    align
  } = props;
  const defaultColors = {
    defaultFontColor,
    defaultBackgroundColor,
    defaultBlockFontColor,
    sparklineSeverityColors
  };
  const [containerWidth, setContainerWidth] = react_default.useState(Number(width));
  const [containerHeight, setContainerHeight] = react_default.useState(Number(height));
  const cachedHandleResize = react_default.useCallback((w, h) => {
    setContainerWidth(w);
    setContainerHeight(h);
  }, []);
  const trellisEnabled = useTrellisEnabled(splitByLayout);
  const handleValueClick = (0, react_exports.useCallback)(
    (ev) => handleValueClickCallback(
      ev,
      majorValue,
      majorValueField,
      trendValue,
      onValueClick,
      trellisEnabled,
      trellisSplitBy,
      trellisKey
    ),
    [onValueClick, majorValue, majorValueField, trendValue, trellisEnabled, trellisSplitBy, trellisKey]
  );
  const { backgroundEnabled, backgroundColor, majorColor, trendColor, underLabelColor } = computeColors(
    props,
    defaultColors
  );
  const sparklineStrokeColor = props.sparklineStrokeColor || getSparklineColors({
    backgroundEnabled,
    backgroundColor,
    sparklineSeverityColors
  }).stroke;
  const renderVisualization = () => {
    if (!containerWidth || !containerHeight) {
      return null;
    }
    let { sparklineDisplay = "below", trendDisplay = "absolute", unit, underLabel } = props;
    const parsedSparklineValues = parseSparklineValues({ sparklineValues });
    let hasSparkline = shouldShowSparkline({
      showSparkline: isValidPosition(sparklineDisplay) && sparklineDisplay !== "off",
      sparklineValues: parsedSparklineValues
    });
    if (hasSparkline) {
      if (!isValidPosition(sparklineDisplay)) {
        sparklineDisplay = "below";
      }
    }
    const isSparklinePositionBelow = hasSparkline && sparklineDisplay === "below";
    const contentWidth = getAvailableContentWidth({
      hasSparkline,
      isSparklinePositionBelow,
      containerWidth,
      overflowArea: CONTENT_OVERFLOW_FADEOUT_AREA_PX2
    });
    const toRemoveList = [
      { key: "sparklineDisplay", value: "off" },
      { key: "underLabel", value: "" },
      { key: "trendDisplay", value: "off" },
      { key: "unit", value: "" }
    ];
    const {
      majorText,
      trendText,
      majorTextFontSize,
      trendTextFontSize,
      majorValueTitle,
      smallVizProps
    } = computeSingleValueContent({
      majorValue,
      majorValueDisplay,
      trendValue,
      majorFontSize,
      trendFontSize,
      trendDisplay,
      contentWidth,
      contentHeight: containerHeight * DEFAULT_CONTENT_HEIGHT_ALLOCATION_RATIO,
      containerWidth,
      containerHeight,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue,
      shouldAbbreviateMajorValue,
      toRemoveList
    });
    if (!isEmpty_default(smallVizProps)) {
      ({ sparklineDisplay, trendDisplay, unit, underLabel } = smallVizProps);
      hasSparkline = shouldShowSparkline({
        showSparkline: isValidPosition(sparklineDisplay) && sparklineDisplay !== "off",
        sparklineValues: parsedSparklineValues
      });
    }
    const contentHeight = getAvailableContentHeight({
      height: containerHeight,
      hasSparkline,
      isSparklinePositionBelow,
      majorTextFontSize,
      underLabelHeight: getUnderLabelHeight({ underLabel, underLabelFontSize })
    });
    const { sparklineWidth, sparklineHeight, sparklineSegments, endDots } = getSparklines({
      width: containerWidth,
      height: containerHeight,
      contentHeight,
      hasSparkline,
      isSparklinePositionBelow,
      sparklineHighlightSegments,
      sparklineHighlightDots
    });
    return /* @__PURE__ */ react_default.createElement(VizStyleWrapper_default, { backgroundColor, style, dataTestKey: "SingleValueWrapper" }, /* @__PURE__ */ react_default.createElement(
      SingleValueContent_default,
      {
        "data-test": "SingleValueContent",
        backgroundColor,
        contentHeight,
        majorColor,
        majorText,
        majorTextFontSize,
        majorValueTitle,
        trendColor,
        trendText,
        trendTextFontSize,
        showTrendIndicator: shouldShowTrend(trendDisplay),
        unit,
        unitPosition,
        underLabel,
        underLabelFontSize,
        underLabelColor,
        onValueClick: hasEventHandlers && handleValueClick,
        showSparkline: hasSparkline,
        sparklinePosition: sparklineDisplay,
        sparklineWidth,
        sparklineHeight,
        sparklineValues: parsedSparklineValues,
        sparklineAreaColor,
        sparklineStrokeColor,
        showSparklineTooltip,
        showSparklineAreaGraph,
        shouldSparklineAcceptNullData,
        sparklineSegments,
        endDots,
        align
      }
    ));
  };
  if (trellisEnabled) {
    return /* @__PURE__ */ react_default.createElement(react_default.Fragment, null, /* @__PURE__ */ react_default.createElement(
      TrellisTitle,
      {
        fontColor: defaultThemeColors == null ? void 0 : defaultThemeColors.defaultFontColor,
        backgroundColor,
        trellisKey
      }
    ), /* @__PURE__ */ react_default.createElement(Container, { width, height: height - TRELLIS_TITLE_HEIGHT }, /* @__PURE__ */ react_default.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), renderVisualization()));
  }
  return /* @__PURE__ */ react_default.createElement(Container, { width, height }, /* @__PURE__ */ react_default.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), renderVisualization());
};
SingleValue.propTypes = {
  width: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  height: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  style: prop_types_default.object,
  sparklineValues: prop_types_default.arrayOf(prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number])),
  majorValue: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  majorValueDisplay: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  majorColor: prop_types_default.string,
  majorFontSize: prop_types_default.number,
  majorValueField: prop_types_default.string,
  trendValue: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  trendColor: prop_types_default.string,
  trendFontSize: prop_types_default.number,
  trendDisplay: prop_types_default.oneOf(["absolute", "percent", "off"]),
  shouldAbbreviateTrendValue: prop_types_default.bool,
  shouldAbbreviateMajorValue: prop_types_default.bool,
  backgroundColor: prop_types_default.string,
  unit: prop_types_default.string,
  unitPosition: prop_types_default.string,
  underLabel: prop_types_default.string,
  underLabelFontSize: prop_types_default.number,
  numberPrecision: prop_types_default.number,
  shouldUseThousandSeparators: prop_types_default.bool,
  showSparklineTooltip: prop_types_default.bool,
  showSparklineAreaGraph: prop_types_default.bool,
  sparklineDisplay: prop_types_default.oneOf(VALID_SPARKLINE_POSITIONS),
  sparklineAreaColor: prop_types_default.string,
  sparklineStrokeColor: prop_types_default.string,
  shouldSparklineAcceptNullData: prop_types_default.bool,
  sparklineHighlightSegments: prop_types_default.number,
  sparklineHighlightDots: prop_types_default.number,
  hasEventHandlers: prop_types_default.bool,
  onValueClick: prop_types_default.func,
  defaultFontColor: prop_types_default.string,
  defaultBackgroundColor: prop_types_default.string,
  defaultBlockFontColor: prop_types_default.string,
  sparklineSeverityColors: prop_types_default.object,
  defaultThemeColors: prop_types_default.object,
  splitByLayout: prop_types_default.string,
  trellisKey: prop_types_default.string,
  trellisSplitBy: prop_types_default.string,
  align: prop_types_default.string
};
SingleValue.defaultProps = {
  width: "100%",
  height: 250,
  majorValue: "N/A",
  majorValueField: "",
  trendDisplay: "absolute",
  shouldAbbreviateTrendValue: false,
  shouldAbbreviateMajorValue: false,
  unitPosition: "after",
  underLabelFontSize: 12,
  numberPrecision: 0,
  shouldUseThousandSeparators: true,
  showSparklineTooltip: false,
  showSparklineAreaGraph: false,
  sparklineDisplay: "below",
  shouldSparklineAcceptNullData: true,
  sparklineHighlightSegments: 0,
  sparklineHighlightDots: 0,
  hasEventHandlers: false,
  onValueClick: () => {
  },
  trellisKey: "",
  trellisSplitBy: "",
  align: "center"
};
var SingleValue_default = SingleValue;

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport21 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport22 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport23 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport24 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport25 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport26 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport27 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport28 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport29 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport30 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys2, target) => keys2.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport31 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config: config3 } = Visualization;
  const { themes: themes3 } = config3;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes3 == null ? void 0 : themes3.defaultBackgroundColor) == null ? void 0 : _a.call(themes3, props);
    const icon = (_b = config3.placeholderIcon) != null ? _b : config3.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config3.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// src/common/utils/dataUtils.ts
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport32 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport33 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// src/common/utils/trellisUtils.ts
var AGGREGATIONS = "aggregations";
var dataSourcesSplitByAggregationsUnknown = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let errorCode = null;
  if (fields && fields.length) {
    splitDataSources = {};
    for (let i = 0; i < fields.length; i += 1) {
      const fieldName = fields[i].name;
      if (!(fieldName == null ? void 0 : fieldName.startsWith("_"))) {
        splitDataSources[fieldName] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[fieldName].primary.data.fields = [fields[i]];
        splitDataSources[fieldName].primary.data.columns = [columns[i]];
      }
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var toFieldEntries = (fields) => {
  return fields.map((field) => {
    if (typeof field === "string") {
      return { name: field };
    }
    return field;
  });
};
var dataSourcesSplitByAggregationsTimechartAndChart = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = toFieldEntries((_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields);
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
  }
  if (splitByFields && splitByFields.length > 0) {
    splitDataSources = {};
    splitByFields.forEach((splitByField) => {
      splitDataSources[splitByField] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[splitByField].primary.data.fields = [fields[0]];
      splitDataSources[splitByField].primary.data.columns = [columns[0]];
      fields.forEach((field, idx) => {
        const fieldName = field == null ? void 0 : field.name;
        if (fieldName !== "_time" && !(fieldName == null ? void 0 : fieldName.startsWith("_")) && field.data_source === splitByField) {
          splitDataSources[splitByField].primary.data.fields.push(field);
          splitDataSources[splitByField].primary.data.columns.push(columns[idx]);
        }
      });
    });
  } else if ((!splitByFields || !splitByFields.length) && fields.length > 1) {
    splitDataSources = {};
    for (let i = 1; i < fields.length; i += 1) {
      const fieldName = fields[i].name;
      if (!(fieldName == null ? void 0 : fieldName.startsWith("_"))) {
        splitDataSources[fieldName] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[fieldName].primary.data.fields = [fields[0], fields[i]];
        splitDataSources[fieldName].primary.data.columns = [columns[0], columns[i]];
      }
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByAggregationsStats = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractDataSourceAggregationKeysStats)(fields);
  }
  if (splitByFields && splitByFields.length > 0) {
    splitDataSources = {};
    splitByFields.forEach((splitByField) => {
      splitDataSources[splitByField] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[splitByField].primary.data.fields = [fields[0]];
      splitDataSources[splitByField].primary.data.columns = [columns[0]];
      const idx = fields.findIndex((field) => field.name === splitByField);
      if (idx > 0) {
        splitDataSources[splitByField].primary.data.fields.push(fields[idx]);
        splitDataSources[splitByField].primary.data.columns.push(columns[idx]);
      }
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeTimechart = (dataSource, splitBy) => {
  var _a, _b, _c, _d, _e;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractSplitByFieldsChartFields)(fields);
  }
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    splitDataSources = {};
    const dataSourceKeys = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
    const valueKeys = [];
    for (let i = 1; i < fields.length; i += 1) {
      if (!((_e = fields[i].name) == null ? void 0 : _e.startsWith("_"))) {
        valueKeys.push(fields[i].splitby_value ? fields[i].splitby_value : fields[i].name);
      }
    }
    valueKeys.forEach((val) => {
      splitDataSources[val] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[val].primary.data.fields = [
        { name: fields[0].name },
        ...dataSourceKeys.map((k) => ({
          name: k
        }))
      ];
      splitDataSources[val].primary.data.columns = [[...columns[0]]];
      dataSourceKeys.forEach((dsKey) => {
        fields.forEach((field, idx) => {
          if (field.data_source === dsKey && (field.splitby_value === val || field.name === val)) {
            splitDataSources[val].primary.data.columns.push([...columns[idx]]);
          }
        });
      });
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeChart = (dataSource, splitBy) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractSplitByFieldsChartFields)(fields);
  }
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    splitDataSources = {};
    const splitByFieldIdx = splitByFields.findIndex((f) => f === splitBy);
    const otherSplitBy = splitByFields.filter((f) => f !== splitBy);
    const dataSourceKeys = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
    const nonDataSourceAggregations = [];
    if (!dataSourceKeys.length && fields[0].groupby_rank === "0" && fields.length && !fields[1].groupby_rank) {
      for (let i = 1; i < fields.length; i += 1) {
        nonDataSourceAggregations.push(fields[i].name);
      }
    }
    if (splitByFieldIdx === 0) {
      const valueKeys = (0, lodash_exports.cloneDeep)(columns[0]);
      valueKeys.forEach((val, idx) => {
        splitDataSources[val] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[val].primary.data.fields = [];
        if (otherSplitBy.length) {
          splitDataSources[val].primary.data.fields = [{ name: otherSplitBy[0] }];
        }
        if (dataSourceKeys.length) {
          const columnValues = [[]];
          splitDataSources[val].primary.data.fields = [
            ...splitDataSources[val].primary.data.fields,
            ...dataSourceKeys.map((k) => ({
              name: k
            }))
          ];
          dataSourceKeys.forEach(() => {
            columnValues.push([]);
          });
          for (let i = 1; i <= Math.ceil((fields.length - 1) / dataSourceKeys.length); i += 1) {
            columnValues[0].push(
              fields[i].splitby_value ? fields[i].splitby_value : fields[i].name
            );
            dataSourceKeys.forEach((dskey, dsIndx) => {
              const mul = (fields.length - 1) / dataSourceKeys.length;
              columnValues[dsIndx + 1].push(columns[i + dsIndx * mul][idx]);
            });
          }
          splitDataSources[val].primary.data.columns = columnValues;
        } else if (nonDataSourceAggregations.length) {
          const columnValues = [];
          fields.forEach((aggregationField, fieldIdx) => {
            if (fieldIdx > 0) {
              splitDataSources[val].primary.data.fields.push(aggregationField);
              columnValues.push([columns[fieldIdx][idx]]);
            }
          });
          splitDataSources[val].primary.data.columns = columnValues;
        }
      });
    } else {
      const valueKeys = [];
      for (let i = 1; i < fields.length; i += 1) {
        valueKeys.push(fields[i].splitby_value ? fields[i].splitby_value : fields[i].name);
      }
      valueKeys.forEach((val) => {
        splitDataSources[val] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[val].primary.data.fields = [
          { name: otherSplitBy[0] },
          ...dataSourceKeys.map((k) => ({
            name: k
          }))
        ];
        splitDataSources[val].primary.data.columns = [[...columns[0]]];
        dataSourceKeys.forEach((dsKey) => {
          fields.forEach((field, idx) => {
            if (field.data_source === dsKey && (field.splitby_value === val || field.name === val)) {
              splitDataSources[val].primary.data.columns.push([...columns[idx]]);
            }
          });
        });
      });
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeStatsorUnknown = (dataSource, splitBy, splitMode) => {
  var _a, _b, _c, _d, _e, _f;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = splitMode !== trellisUtils_exports.UNKNOWN ? (0, trellisUtils_exports.extractSplitByFieldsForStats)(fields) : (0, trellisUtils_exports.extractSplitByFieldsForUnknown)(fields);
  }
  const splitByIndex = fields == null ? void 0 : fields.findIndex(
    (field) => field === splitBy || field.name === splitBy
  );
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    const splitByColumn = (_f = (_e = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _e.data) == null ? void 0 : _f.columns[splitByIndex];
    splitDataSources = {};
    splitByColumn.forEach((val, idx) => {
      if (!splitDataSources[val]) {
        splitDataSources[val] = [idx];
      } else {
        splitDataSources[val].push(idx);
      }
    });
    const cloneFields = (0, lodash_exports.cloneDeep)(fields);
    cloneFields.splice(splitByIndex, 1);
    const valueKeys = Object.keys(splitDataSources);
    valueKeys.forEach((val) => {
      const valIndices = (0, lodash_exports.cloneDeep)(splitDataSources[val]);
      splitDataSources[val] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[val].primary.data.fields = cloneFields;
      splitDataSources[val].primary.data.columns = [];
      columns.forEach((col, idx) => {
        if (idx !== splitByIndex) {
          const newCol = valIndices.map((valIdx) => col[valIdx]);
          splitDataSources[val].primary.data.columns.push(newCol);
        }
      });
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var getTrellisDataSourcesBySplitMode = (splitMode, dataSources, trellisSplitBy) => {
  let result = null;
  try {
    if (splitMode === trellisUtils_exports.TIMECHART) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsTimechartAndChart(dataSources) : dataSourcesSplitByModeTimechart(dataSources, trellisSplitBy);
    } else if (splitMode === trellisUtils_exports.STATS) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsStats(dataSources) : dataSourcesSplitByModeStatsorUnknown(dataSources, trellisSplitBy, trellisUtils_exports.STATS);
    } else if (splitMode === trellisUtils_exports.CHART) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsTimechartAndChart(dataSources) : dataSourcesSplitByModeChart(dataSources, trellisSplitBy);
    } else if (splitMode === trellisUtils_exports.UNKNOWN) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsUnknown(dataSources) : dataSourcesSplitByModeStatsorUnknown(dataSources, trellisSplitBy, trellisUtils_exports.UNKNOWN);
    }
  } catch (ex) {
    console.error("getTrellisDataSourcesBySplitMode ", ex);
    result = { splitDataSources: null, errorCode: "UNKNOWN" };
  }
  return result;
};
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};
var calculateSharedMinMax = (splitData) => {
  let max2 = -Infinity;
  let min2 = Infinity;
  Object.keys(splitData).forEach((splitByKey) => {
    const datasources = splitData[splitByKey];
    Object.keys(datasources).forEach((datasourceName) => {
      const dataColumns = datasources[datasourceName].data.columns;
      dataColumns.forEach((column) => {
        column.forEach((point) => {
          const pointNumber = Number(point);
          if (pointNumber > max2) {
            max2 = pointNumber;
          }
          if (pointNumber < min2) {
            min2 = pointNumber;
          }
        });
      });
    });
  });
  return [min2, max2];
};
var determineMinMax = (splitData, trellisSharedScale, yAxisMin, yAxisMax, stackMode) => {
  if (!trellisSharedScale || stackMode === "stacked100" || yAxisMin !== "auto" && yAxisMax !== "auto")
    return [yAxisMin, yAxisMax];
  const [sharedMin, sharedMax] = calculateSharedMinMax(splitData);
  const shouldUseSharedMax = sharedMax !== -Infinity && yAxisMax === "auto";
  const shouldUseSharedMin = sharedMin !== Infinity && yAxisMin === "auto";
  return [shouldUseSharedMin ? sharedMin : yAxisMin, shouldUseSharedMax ? sharedMax : yAxisMax];
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval: computeVizPropsBeforeEval2 = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn2 = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn2 && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval2(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport34 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// esm-externals:@splunk/visualization-themes/variables
var variables_exports2 = {};
__export(variables_exports2, {
  default: () => variables_default2
});
var defaultImport35 = __toESM(require("@splunk/visualization-themes/variables"));
__reExport(variables_exports2, require("@splunk/visualization-themes/variables"));
var variables_default2 = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// esm-externals:@splunk/themes/pick
var pick_exports2 = {};
__export(pick_exports2, {
  default: () => pick_default2
});
var defaultImport36 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports2, require("@splunk/themes/pick"));
var pick_default2 = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport37 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport37 ? defaultImport37.default : defaultImport37;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport38 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport38 ? defaultImport38.default : defaultImport38;

// src/common/configContext/singleValueContext.ts
var defaultContext = {
  trendColorConfig: [
    {
      to: 0,
      value: "#9E2520"
    },
    {
      from: 0,
      value: "#1C6B2D"
    }
  ],
  majorColorConfig: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ],
  majorColorMatchConfig: [{ match: "", value: "#5C33FF" }],
  trendValueCopy: "> trendValue",
  divisor: "> majorValue | subtract(trendValueCopy) | divideBy(100)",
  trendValuePercent: "> trendValue | divideBy(divisor)"
};

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport39 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport39 ? defaultImport39.default : defaultImport39;

// src/common/editorConfig/DynamicMajorColorEditor.js
var getDynamicMajorColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Major value"),
  option: "majorColor",
  context: "majorColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.majorColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: major value"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          majorValue: defaultContext2.majorColorConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          majorValue: defaultContext2.majorColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Major value"),
        value: "majorValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/DynamicTrendColorEditor.js
var getDynamicTrendColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Trend value"),
  option: "trendColor",
  context: "trendColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.trendColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: trend value"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          trendValue: defaultContext2.trendColorConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Trend value"),
        value: "trendValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/DynamicBackgroundColorEditor.js
var getDynamicBackgroundColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Background color"),
  option: "backgroundColor",
  context: "backgroundColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.backgroundColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: background"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          majorValue: defaultContext2.majorColorConfig,
          trendValue: defaultContext2.trendColorConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          majorValue: defaultContext2.majorColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Major Value"),
        value: "majorValue"
      },
      {
        label: (0, i18n_exports._)("Trend"),
        value: "trendValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/StaticMajorAndTrendLayout.js
var StaticMajorAndTrendLayout = [
  [
    {
      label: (0, i18n_exports._)("Unit position"),
      // todo: we need a new editor combining unit and position
      option: "unitPosition",
      editor: "editor.select",
      editorProps: {
        values: [
          { label: (0, i18n_exports._)("Before"), value: "before" },
          { label: (0, i18n_exports._)("After"), value: "after" }
        ]
      },
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    },
    {
      label: (0, i18n_exports._)("Unit label"),
      option: "unit",
      editor: "editor.text",
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Precision"),
      option: "numberPrecision",
      editor: "editor.number",
      editorProps: {
        min: 0,
        max: 20
      },
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    }
  ]
];
var StaticMajorAndTrendLayout_default = StaticMajorAndTrendLayout;

// src/common/editorConfig/StaticMajorColorEditor.js
var StaticMajorColorEditor = {
  label: (0, i18n_exports._)("Major value"),
  option: "majorColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.majorColor)
};
var StaticMajorColorEditor_default = StaticMajorColorEditor;

// src/common/editorConfig/StaticTrendColorEditor.js
var StaticTrendColorEditor = {
  label: (0, i18n_exports._)("Trend value"),
  option: "trendColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.trendColor),
  isDisabled: ({ options }) => options.trendDisplay === "off"
};
var StaticTrendColorEditor_default = StaticTrendColorEditor;

// src/common/editorConfig/StaticBackgroundColorEditor.js
var StaticBackgroundColorEditor = {
  label: (0, i18n_exports._)("Background color"),
  option: "backgroundColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.backgroundColor)
};
var StaticBackgroundColorEditor_default = StaticBackgroundColorEditor;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config3) => {
      return __spreadProps(__spreadValues({}, config3), { open: config3.open || false });
    }
  );
  return enhancedConfig;
}
function hasCompatibleContexts(vizContext, presetContext) {
  const presetContextKeys = Object.keys(presetContext);
  return presetContextKeys.every(
    (contextKey) => presetContext[contextKey] === void 0 && vizContext[contextKey] === void 0 || presetContext[contextKey] !== void 0 && vizContext[contextKey] !== void 0
  );
}
function hasCompatibleOptions(vizOptions, presetOptions) {
  const presetOptionKeys = Object.keys(presetOptions);
  return presetOptionKeys.every(
    (optionKey) => (0, configUtils_exports.isDynamicOption)(presetOptions[optionKey]) === (0, configUtils_exports.isDynamicOption)(vizOptions[optionKey])
  );
}
function getInitialPreset(vizContext, vizOptions, presets2) {
  return presets2.find((preset) => {
    const presetContext = (0, lodash_exports.get)(preset, ["value", "context"], {});
    const presetOptions = (0, lodash_exports.get)(preset, ["value", "options"], {});
    const presetContextKeys = Object.keys(presetContext);
    const presetOptionKeys = Object.keys(presetOptions);
    if (presetContextKeys.length === 0 || presetOptionKeys.length === 0) return false;
    return hasCompatibleContexts(vizContext, presetContext) && hasCompatibleOptions(vizOptions, presetOptions);
  });
}

// src/common/editorConfig/TrellisEditors.ts
var isTrellisFeatureFlagOn = ({ featureFlags }) => {
  return Boolean(featureFlags == null ? void 0 : featureFlags.visualizations_enableTrellis);
};
var isTrellisEnabled = ({ options, featureFlags }) => {
  const { splitByLayout = visualization_schemas_exports.LAYOUT_TYPE.Off } = options;
  return isTrellisFeatureFlagOn({ featureFlags }) && splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};
var TrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Split by"),
      option: "trellisSplitBy",
      editor: "editor.trellisSplitBy",
      editorProps: {
        dataSourceKey: "primary"
      },
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Number of columns"),
      option: "trellisColumns",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      placeholder: (0, i18n_exports._)("Auto"),
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Min column width"),
      option: "trellisMinColumnWidth",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    },
    {
      label: (0, i18n_exports._)("Row height"),
      option: "trellisRowHeight",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Max number of components per page"),
      option: "trellisPageCount",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    }
  ]
];
var TimechartTrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn,
      // add help text for timecharts
      editorProps: {
        help: (0, i18n_exports._)(
          "Y2-axis and overlay field configurations are not supported when trellis is enabled."
        ),
        helpFormat: "under"
      }
    }
  ],
  ...TrellisEditorConfig.slice(1),
  [
    {
      label: (0, i18n_exports._)("Shared y-axis scale"),
      option: "trellisSharedScale",
      editor: "editor.checkbox",
      showEditor: isTrellisEnabled
    }
  ]
];
var TrellisBackgroundColorEditor = {
  label: (0, i18n_exports._)("Trellis background"),
  option: "trellisBackgroundColor",
  editor: "editor.color",
  showEditor: isTrellisEnabled
};

// src/SingleValue/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 250,
  initialHeight: 250
};
var basePresetContext = {
  majorColorEditorConfig: void 0,
  trendColorEditorConfig: void 0,
  backgroundColorEditorConfig: void 0
};
var basePresetOptions = {
  majorColor: void 0,
  trendColor: void 0,
  backgroundColor: void 0
};
var presets = [
  {
    // dummy context variables to allow for resetting of unused context states
    label: (0, i18n_exports._)("None"),
    name: "singleValue.none",
    value: {
      context: __spreadValues({}, basePresetContext),
      options: __spreadValues({}, basePresetOptions)
    }
  },
  {
    label: (0, i18n_exports._)("Major value"),
    name: "singleValue.majorValue",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        majorColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        majorColor: "> majorValue | rangeValue(majorColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Trend value"),
    name: "singleValue.trend",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        trendColorEditorConfig: defaultContext.trendColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        trendColor: "> trendValue | rangeValue(trendColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Major value and Trend value"),
    name: "singleValue.majorValueAndTrend",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        majorColorEditorConfig: defaultContext.majorColorConfig,
        trendColorEditorConfig: defaultContext.trendColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        majorColor: "> majorValue | rangeValue(majorColorEditorConfig)",
        trendColor: "> trendValue | rangeValue(trendColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Background"),
    name: "singleValue.background",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        backgroundColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        backgroundColor: "> majorValue | rangeValue(backgroundColorEditorConfig)"
      })
    }
  }
];
var themes = {
  defaultFontColor: (props) => pick_default2({
    enterprise: {
      dark: variables_default.textColor(props),
      light: variables_default.gray20(props)
    },
    prisma: variables_default.contentColorActive(props)
  })(props),
  defaultBlockFontColor: (props) => pick_default2({
    enterprise: variables_default.white(props),
    prisma: variables_default.contentColorActive(props)
  })(props),
  defaultBackgroundColor: (props) => pick_default2({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  defaultSparklineStrokeColor: (props) => pick_default2({
    enterprise: variables_default.textColor(props),
    prisma: variables_default.contentColorActive(props)
  })(props),
  // TODO(fkurniawan): update with SCP-36839
  sparklineSeverityColors: (props) => pick_default2({
    enterprise: {
      dark: JSON.stringify({
        none: {
          background: variables_exports2.enterpriseDark.gray60,
          // note: may need update later
          stroke: variables_exports2.enterpriseDark.white
        },
        low: {
          background: variables_exports2.enterpriseDark.successColorD50,
          stroke: variables_exports2.enterpriseDark.white
        },
        guarded: {
          background: variables_exports2.enterpriseDark.infoColorD50,
          stroke: variables_exports2.enterpriseDark.white
        },
        elevated: {
          background: variables_exports2.enterpriseDark.warningColorD50,
          stroke: variables_exports2.enterpriseDark.white
        },
        high: {
          background: variables_exports2.enterpriseDark.alertColorD50,
          stroke: variables_exports2.enterpriseDark.white
        },
        severe: {
          background: variables_exports2.enterpriseDark.errorColorD50,
          stroke: variables_exports2.enterpriseDark.white
        }
      }),
      light: JSON.stringify({
        none: {
          background: variables_exports2.enterprise.gray60,
          stroke: variables_exports2.enterprise.gray20
        },
        low: {
          background: variables_exports2.enterprise.successColorD50,
          stroke: variables_exports2.enterprise.white
        },
        guarded: {
          background: variables_exports2.enterprise.infoColorD50,
          stroke: variables_exports2.enterprise.white
        },
        elevated: {
          background: variables_exports2.enterprise.warningColorD50,
          stroke: variables_exports2.enterprise.white
        },
        high: {
          background: variables_exports2.enterprise.alertColorD50,
          stroke: variables_exports2.enterprise.white
        },
        severe: {
          background: variables_exports2.enterprise.errorColorD50,
          stroke: variables_exports2.enterprise.white
        }
      })
    },
    prisma: JSON.stringify({
      none: {
        background: variables_exports2.scp.gray52,
        stroke: variables_exports2.scp.white
      },
      low: {
        background: variables_exports2.scp.successColorD50,
        stroke: variables_exports2.scp.white
      },
      guarded: {
        background: variables_exports2.scp.infoColorD50,
        stroke: variables_exports2.scp.white
      },
      elevated: {
        background: variables_exports2.scp.warningColorD50,
        stroke: variables_exports2.scp.white
      },
      high: {
        background: variables_exports2.scp.alertColorD50,
        stroke: variables_exports2.scp.white
      },
      severe: {
        background: variables_exports2.scp.errorColorD50,
        stroke: variables_exports2.scp.white
      }
    })
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data configurations"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Value"),
          editor: "editor.columnSelector",
          option: "sparklineValues",
          context: "sparklineValuesContext",
          editorProps: {
            dataSourceKey: "primary",
            prepareValue: (definition) => {
              const {
                options: { sparklineValues }
              } = definition;
              return {
                context: {},
                options: {
                  majorValue: `> sparklineValues | lastPoint()`,
                  trendValue: `> sparklineValues | delta(-2)`,
                  sparklineValues
                }
              };
            }
          },
          isDisabled: ({ options }) => options.splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      ...StaticMajorAndTrendLayout_default,
      [
        {
          label: (0, i18n_exports._)("Trend display"),
          option: "trendDisplay",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Percent"), value: "percent" },
              { label: (0, i18n_exports._)("Absolute"), value: "absolute" },
              { label: (0, i18n_exports._)("Off"), value: "off" }
            ]
          },
          showEditor: ({ options }) => options.showValue || options.showValue === void 0
        },
        {
          label: (0, i18n_exports._)("Sparkline display"),
          option: "sparklineDisplay",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Off"), value: "off" },
              { label: (0, i18n_exports._)("Before"), value: "before" },
              { label: (0, i18n_exports._)("Below"), value: "below" },
              { label: (0, i18n_exports._)("After"), value: "after" }
            ]
          }
        }
      ],
      ...TrellisEditorConfig
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Dynamic elements"),
          key: "presetSelector",
          editor: "editor.presetSelector",
          editorProps: {
            presets,
            value: ({ context, options }) => {
              const initialPreset = getInitialPreset(context, options, presets);
              return initialPreset && initialPreset.label || null;
            }
          }
        }
      ],
      [
        __spreadProps(__spreadValues({}, StaticMajorColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicMajorColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        __spreadProps(__spreadValues({}, StaticTrendColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicTrendColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        __spreadProps(__spreadValues({}, StaticBackgroundColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [
        __spreadProps(__spreadValues({}, TrellisBackgroundColorEditor), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicBackgroundColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        {
          label: (0, i18n_exports._)("Major value size (px)"),
          option: "majorFontSize",
          editor: "editor.number",
          editorProps: {
            min: 1
          },
          placeholder: (0, i18n_exports._)("Auto"),
          showEditor: ({ options }) => options.showValue || options.showValue === void 0
        },
        {
          label: (0, i18n_exports._)("Trend value size (px)"),
          option: "trendFontSize",
          editor: "editor.number",
          editorProps: {
            min: 1
          },
          placeholder: (0, i18n_exports._)("Auto"),
          showEditor: ({ options }) => options.showValue || options.showValue === void 0,
          isDisabled: ({ options }) => options.trendDisplay === "off"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Major value abbreviation"),
          option: "shouldAbbreviateMajorValue",
          editor: "editor.checkbox"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Trend value abbreviation"),
          option: "shouldAbbreviateTrendValue",
          editor: "editor.checkbox"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Alignment"),
          editor: "editor.radioBar",
          option: "align",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Left"), value: "left" },
              { label: (0, i18n_exports._)("Center"), value: "center" },
              { label: (0, i18n_exports._)("Right"), value: "right" }
            ]
          },
          showEditor: ({ options }) => options.showValue || options.showValue === void 0
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.singlevalue",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Single value"),
  category: "Single Value" /* SINGLE_VALUE */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.SingleValue,
  placeholderIcon: placeholders_exports.SingleValue,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.singleValueOptionsSchema,
  editorConfig,
  events: {
    "value.click": {
      description: "trigger when user clicks major value",
      payloadKeys: ["majorValue", "trendValue"]
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */, "trellis" /* TRELLIS */],
  themes,
  requiredProps: ["majorValue"]
};
var config_default = enhanceConfig(config);

// esm-externals:@splunk/react-ui/Paginator
var Paginator_exports = {};
__export(Paginator_exports, {
  default: () => Paginator_default
});
var defaultImport40 = __toESM(require("@splunk/react-ui/Paginator"));
__reExport(Paginator_exports, require("@splunk/react-ui/Paginator"));
var Paginator_default = "default" in defaultImport40 ? defaultImport40.default : defaultImport40;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport41 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport41 ? defaultImport41.default : defaultImport41;

// esm-externals:@splunk/themes/useSplunkTheme
var useSplunkTheme_exports = {};
__export(useSplunkTheme_exports, {
  default: () => useSplunkTheme_default
});
var defaultImport42 = __toESM(require("@splunk/themes/useSplunkTheme"));
__reExport(useSplunkTheme_exports, require("@splunk/themes/useSplunkTheme"));
var useSplunkTheme_default = "default" in defaultImport42 ? defaultImport42.default : defaultImport42;

// src/common/hocs/withTrellis.tsx
var TrellisContainer = styled_components_default.div`
    overflow: hidden;
    display: flex;
    flex-direction: column;
    background-color: ${(props) => props.backgroundColor};
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
    > [data-test='paginator'] {
        align-self: flex-end;
        margin-bottom: 10px;
    }
`;
var TrellisContainerGrid = styled_components_default.div`
    display: grid;
    height: ${(props) => {
  return `${props.height}px`;
}};
    gap: 10px 10px;
    grid-template-columns: ${(props) => {
  return props.colCount ? `repeat(${props.colCount}, minmax(${props.colMinWidth}px, 1fr))` : `repeat(auto-fit, minmax(${props.colMinWidth}px, 1fr))`;
}};
    overflow: auto;
    justify-items: stretch;
    grid-auto-rows: ${(props) => `${props.rowHeight}px`};
    .child {
        height: ${(props) => `${props.rowHeight}px`};
    }
`;
var showErrorMessage = (errorCode, width, height) => {
  if (errorCode === "INVALID_SPLIT_BY_FIELD") {
    return /* @__PURE__ */ react_exports.createElement(
      Message_default,
      {
        width,
        height,
        message: (0, i18n_exports._)("Select a valid trellis split by field"),
        level: "info"
      }
    );
  }
  if (errorCode === "UNKNOWN_DATA_SPLIT_MODE") {
    return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, message: (0, i18n_exports._)("Unknown data split mode"), level: "info" });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, message: (0, i18n_exports._)("Error render in trellis"), level: "info" });
};
var withTrellis = (Viz) => {
  const VizWithTrellis = (opts) => {
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(opts.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(opts.height));
    const _a = opts, { options = {}, height, width } = _a, otherProps = __objRest(_a, ["options", "height", "width"]);
    const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(Viz.config.optionsSchema, "default");
    const mergedOptions = (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)({}, options, defaultOptions);
    const {
      trellisColumns,
      trellisPageCount,
      trellisMinColumnWidth,
      trellisRowHeight,
      splitByLayout,
      trellisSplitBy,
      trellisSharedScale,
      stackMode,
      yAxisMin,
      yAxisMax
    } = mergedOptions;
    const colCount = trellisColumns > 0 ? trellisColumns : defaultOptions.trellisColumns;
    const pageCount = +trellisPageCount > 0 ? +trellisPageCount : defaultOptions.trellisPageCount;
    const colMinWidth = trellisMinColumnWidth > 0 ? trellisMinColumnWidth : defaultOptions.trellisMinColumnWidth;
    const rowHeight = trellisRowHeight > 0 ? trellisRowHeight : defaultOptions.trellisRowHeight;
    const [pageNum, setPageNum] = (0, react_exports.useState)(1);
    const [pagedData, setPagedData] = (0, react_exports.useState)(null);
    let splitByKeys = [];
    let totalPages = 0;
    let showPaginator = false;
    const { dataSources } = otherProps;
    const theme = {
      splunkThemeV1: useSplunkTheme_default()
    };
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = (0, themes_exports.getSettingsFromThemedProps)({ theme });
    const trellisBackgroundColor = (0, react_exports.useMemo)(() => {
      const themeFunc = (themeVar) => {
        var _a2, _b;
        return (_b = (_a2 = Viz.config.themes)[themeVar]) == null ? void 0 : _b.call(_a2, {
          trellisBackgroundColor: mergedOptions.trellisBackgroundColor,
          theme
        });
      };
      const evaluated = Options_exports.Options.evaluate(
        {
          context: Viz.config.context,
          options: { trellisBackgroundColor: mergedOptions.trellisBackgroundColor }
        },
        {},
        themeFunc
      );
      return evaluated.trellisBackgroundColor;
    }, [
      mergedOptions.trellisBackgroundColor,
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity
    ]);
    const columns = (0, lodash_exports.get)(dataSources, "primary.data.columns", void 0);
    const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields", void 0);
    const noColumns = columns === void 0;
    const noFields = fields === void 0;
    const updateDataDisplay = (currPage) => {
      if (!showPaginator) {
        setPagedData(splitByKeys);
        setPageNum(1);
      } else {
        const startIdx = pageCount * (currPage - 1);
        const paged = splitByKeys.slice(startIdx, startIdx + pageCount);
        setPagedData(paged);
      }
    };
    (0, react_exports.useEffect)(() => {
      setPageNum(1);
      updateDataDisplay(1);
    }, [pageCount, trellisSplitBy]);
    (0, react_exports.useEffect)(() => {
      updateDataDisplay(pageNum);
    }, [columns, fields, trellisSplitBy, pageNum, splitByLayout]);
    const handlePageChange = (0, react_exports.useCallback)(
      (event, { page }) => {
        setPageNum(page);
      },
      [pageNum, pagedData]
    );
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const isTrellisFeatureFlagOn2 = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    if (!isTrellisFeatureFlagOn2 || !splitByLayout || splitByLayout !== visualization_schemas_exports.LAYOUT_TYPE.Trellis) {
      return /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, opts));
    }
    if (splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis) {
      if (noColumns || noFields) {
        return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, message: (0, i18n_exports._)("Loading"), level: "info" });
      }
      let currTrellisSplitBy = trellisSplitBy;
      if (!trellisSplitBy || trellisSplitBy.length === 0) {
        const splitByPossibleFields = (0, trellisUtils_exports.getAllPossibleSplitByFields)(fields);
        currTrellisSplitBy = splitByPossibleFields.fields && splitByPossibleFields.fields.length ? splitByPossibleFields.fields[0] : AGGREGATIONS;
      }
      const splitMode = (0, trellisUtils_exports.getTrellisDataSplitterMode)(fields);
      const dataSplitResult = getTrellisDataSourcesBySplitMode(
        splitMode,
        dataSources,
        currTrellisSplitBy
      );
      const modifiedDataSourceBySplitBy = dataSplitResult == null ? void 0 : dataSplitResult.splitDataSources;
      const dataSplitErrorCode = dataSplitResult == null ? void 0 : dataSplitResult.errorCode;
      if (!modifiedDataSourceBySplitBy || Object.keys(modifiedDataSourceBySplitBy).length === 0 || dataSplitErrorCode) {
        return showErrorMessage(dataSplitErrorCode, width, height);
      }
      const splitByKeysModified = modifiedDataSourceBySplitBy ? Object.keys(modifiedDataSourceBySplitBy) : [];
      if (splitByKeysModified) {
        showPaginator = splitByKeysModified.length > pageCount;
        splitByKeys = splitByKeysModified;
        totalPages = splitByKeysModified ? Math.ceil(splitByKeysModified.length / pageCount) : 0;
      }
      const [calculatedMin, calculatedMax] = determineMinMax(
        modifiedDataSourceBySplitBy,
        trellisSharedScale,
        yAxisMin,
        yAxisMax,
        stackMode
      );
      return /* @__PURE__ */ react_exports.createElement(TrellisContainer, { height, width, backgroundColor: trellisBackgroundColor }, /* @__PURE__ */ react_exports.createElement(
        TrellisContainerGrid,
        {
          height,
          colCount,
          colMinWidth,
          rowHeight
        },
        pagedData == null ? void 0 : pagedData.map((splitByKey, idx) => /* @__PURE__ */ react_exports.createElement(
          "div",
          {
            className: "child",
            "data-test": "trellis-child",
            key: `div-child-${idx.toString()}`
          },
          /* @__PURE__ */ react_exports.createElement(
            SizeAwareWrapper_default,
            {
              width,
              height,
              onResize: cachedHandleResize
            }
          ),
          /* @__PURE__ */ react_exports.createElement(
            Viz,
            __spreadProps(__spreadValues({}, otherProps), {
              trellisKey: splitByKey,
              trellisSplitBy: currTrellisSplitBy,
              dataSources: modifiedDataSourceBySplitBy[splitByKey],
              options: __spreadProps(__spreadValues({}, options), {
                yAxisMin: calculatedMin,
                yAxisMax: calculatedMax
              }),
              key: `viz-${idx.toString()}`,
              height: containerHeight,
              width: containerWidth
            })
          )
        ))
      ), showPaginator && totalPages >= pageNum && /* @__PURE__ */ react_exports.createElement(
        Paginator_default,
        {
          onChange: handlePageChange,
          current: pageNum,
          alwaysShowLastPageLink: true,
          totalPages
        }
      ));
    }
    return null;
  };
  VizWithTrellis.propTypes = Viz.proptypes;
  VizWithTrellis.defaultProps = Viz.defaultProps;
  VizWithTrellis.config = Viz.config;
  return VizWithTrellis;
};
var withTrellis_default = withTrellis;

// src/SingleValue/SingleValue.ts
var config2 = config_default;
var PureSingleValue = SingleValue_default;
var computeVizProps = (_a) => {
  var _b = _a, { themeFunc } = _b, props = __objRest(_b, ["themeFunc"]);
  const defaultThemeColorVariables = [
    "defaultFontColor",
    "defaultBackgroundColor",
    "defaultBlockFontColor",
    "defaultSparklineStrokeColor",
    "sparklineSeverityColors"
  ];
  const defaultThemeColors = {};
  defaultThemeColorVariables.forEach((variable) => {
    defaultThemeColors[variable] = themeFunc(variable);
  });
  if (typeof defaultThemeColors.sparklineSeverityColors === "string") {
    try {
      defaultThemeColors.sparklineSeverityColors = JSON.parse(
        defaultThemeColors.sparklineSeverityColors
      );
    } catch (e) {
    }
  }
  return __spreadValues({ defaultThemeColors }, props);
};
var computeVizPropsBeforeEval = (options) => {
  const trendColor = getTrendColorWithPercent(options);
  return __spreadValues({}, trendColor);
};
var viz = withTrellis_default(
  withDashboardViz_default({
    ReactViz: SingleValue_default,
    vizConfig: config_default,
    computeVizProps,
    computeVizPropsBeforeEval,
    useIconPlaceholder: (dataSources, loading) => isLoadingOrNoColumns(dataSources, loading)
  })
);
var { themes: themes2 } = config_default;
var SingleValue_default2 = viz;
//# sourceMappingURL=SingleValue.js.map
