/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __pow = Math.pow;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/SingleValueRadial/index.ts
var SingleValueRadial_exports = {};
__export(SingleValueRadial_exports, {
  PureSingleValueRadial: () => PureSingleValueRadial,
  PureSingleValueRadialThemes: () => PureSingleValueRadialThemes,
  computeVizProps: () => computeVizProps,
  config: () => config2,
  default: () => SingleValueRadial_default2,
  themes: () => themes2
});
module.exports = __toCommonJS(SingleValueRadial_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport3 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport4 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport5 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:lodash/pick
var pick_exports2 = {};
__export(pick_exports2, {
  default: () => pick_default2
});
var defaultImport6 = __toESM(require("lodash/pick"));
__reExport(pick_exports2, require("lodash/pick"));
var pick_default2 = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:lodash/isEmpty
var isEmpty_exports = {};
__export(isEmpty_exports, {
  default: () => isEmpty_default
});
var defaultImport7 = __toESM(require("lodash/isEmpty"));
__reExport(isEmpty_exports, require("lodash/isEmpty"));
var isEmpty_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport8 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport9 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// src/common/components/VizStyleWrapper.jsx
var VizStyleWrapper = styled_components_default.div.attrs(({ dataTestKey }) => ({
  "data-test": dataTestKey,
  "data-testid": dataTestKey
}))`
    display: flex;
    justify-content: center;
    flex-direction: column;
    width: 100%;
    height: 100%;
    background-color: ${(props) => props.backgroundColor};
`;
VizStyleWrapper.displayName = "VizStyleWrapper";
var VizStyleWrapper_default = VizStyleWrapper;

// src/common/components/TrellisTitle.tsx
var TRELLIS_TITLE_HEIGHT = 28;
var TrellisTitleText = styled_components_default.div`
    margin-left: 10px;
    margin-right: 10px;
    padding-top: 8px;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
`;
var TrellisTitleDiv = styled_components_default.div`
    height: ${TRELLIS_TITLE_HEIGHT}px;
    font-size: 14px;
    font-weight: 700;
    color: ${(props) => props.fontColor};
    background-color: ${(props) => props.backgroundColor};
    box-shadow: 0 1px ${(props) => props.backgroundColor}; // this is added to avoid a 1px gap between title and viz divs that showed up intermittently because of pixel rounding error in chrome.
`;
var TrellisTitle = (props) => {
  const titleText = String(props.trellisKey).toString();
  return /* @__PURE__ */ react_exports.createElement(
    TrellisTitleDiv,
    {
      fontColor: props.fontColor,
      backgroundColor: props.backgroundColor,
      "data-test": "trellis-title",
      title: titleText
    },
    /* @__PURE__ */ react_exports.createElement(TrellisTitleText, null, titleText)
  );
};

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport10 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport11 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/domUtils
var domUtils_exports = {};
__export(domUtils_exports, {
  default: () => domUtils_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/domUtils"));
__reExport(domUtils_exports, require("@splunk/visualizations-shared/domUtils"));
var domUtils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/visualizations-shared/propUtils
var propUtils_exports = {};
__export(propUtils_exports, {
  default: () => propUtils_default
});
var defaultImport13 = __toESM(require("@splunk/visualizations-shared/propUtils"));
__reExport(propUtils_exports, require("@splunk/visualizations-shared/propUtils"));
var propUtils_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport14 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// src/common/utils/singleValueUtils.js
var DEFAULT_FONT = 12;
var DEFAULT_FONT_FAMILY = '"Splunk Platform Sans", "Proxima Nova", "Helvetica Neue", Helvetica, Arial, sans-serif';
var SVR_PADDING = { top: 12, bottom: 12, left: 16, right: 16 };
var getAligment = (align) => {
  const alignMap = {
    left: "start",
    center: "center",
    right: "end"
  };
  return alignMap[align] || "center";
};
var shouldShowTrend = (trendDisplay) => trendDisplay === "absolute" || trendDisplay === "percent";
var getFormattedColor = (color, defaultColor) => (0, propUtils_exports.formatColor)(color) || (0, propUtils_exports.formatColor)(defaultColor);
var hasBackground = (backgroundColor) => !!backgroundColor && backgroundColor !== "transparent";
var isIdenticalColor = (colorA, colorB) => !!colorA && !!colorB && (0, propUtils_exports.formatColor)(colorA.toLowerCase()) === (0, propUtils_exports.formatColor)(colorB.toLowerCase());
var getDefaultColorWithBg = ({ backgroundColor, defaultFontColor, defaultBlockFontColor }) => isIdenticalColor(backgroundColor, defaultBlockFontColor) ? defaultFontColor : defaultBlockFontColor;
var getMajorColor = ({ majorColor, backgroundColor, defaultFontColor, defaultBlockFontColor }) => {
  if (hasBackground(backgroundColor) && !majorColor) {
    return getDefaultColorWithBg({
      backgroundColor,
      defaultFontColor,
      defaultBlockFontColor
    });
  }
  return getFormattedColor(majorColor, defaultFontColor);
};
var getTrendColor = ({
  trendColor,
  trendValue,
  majorValue,
  customizedBgColor,
  trendDisplay,
  defaultColors
}) => {
  if (trendColor) {
    return trendColor;
  }
  if (Number.isNaN(Number(trendValue))) {
    return void 0;
  }
  const { defaultFontColor, defaultBlockFontColor, defaultBackgroundColor } = defaultColors;
  if (hasBackground(customizedBgColor) && !isIdenticalColor(customizedBgColor, defaultBackgroundColor) && !isIdenticalColor(customizedBgColor, defaultBlockFontColor)) {
    return defaultBlockFontColor;
  }
  const isInvalidTrend = trendDisplay === "percent" && trendValue === parseFloat(majorValue);
  if (trendValue === 0 || isInvalidTrend) {
    return defaultFontColor;
  }
  return trendValue > 0 ? colorConstants_exports.DELTA_GREEN : colorConstants_exports.DELTA_RED;
};
var computeColors = (props, defaultColors) => {
  const backgroundColor = getFormattedColor(props.backgroundColor, defaultColors.defaultBackgroundColor);
  const backgroundEnabled = hasBackground(backgroundColor);
  const majorColor = getMajorColor({
    majorColor: props.majorColor,
    backgroundColor,
    defaultFontColor: defaultColors.defaultFontColor,
    defaultBlockFontColor: defaultColors.defaultBlockFontColor
  });
  const trendColor = getTrendColor({
    trendColor: props.trendColor,
    trendValue: props.trendValue,
    majorValue: props.majorValue,
    customizedBgColor: props.backgroundColor,
    trendDisplay: props.trendDisplay,
    defaultColors
  });
  const underLabelColor = majorColor;
  return {
    backgroundColor,
    backgroundEnabled,
    majorColor,
    trendColor,
    underLabelColor
  };
};
var computeText = ({
  value,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateValue
}) => {
  let text = (0, numberUtils_exports.isNumerial)(value) ? (0, numberUtils_exports.formatNumber)(value, numberPrecision, {
    useThousandSeparators: shouldUseThousandSeparators,
    // todo: need update formatNumber
    useTrendUnits: shouldAbbreviateValue
  }) : value;
  text = text || "";
  return text;
};
var getMajorText = ({
  majorValueDisplay,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateMajorValue
}) => computeText({
  value: majorValueDisplay === null ? "N/A" : majorValueDisplay,
  // if majorValueDisplay is null, use `N/A`.
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateValue: shouldAbbreviateMajorValue
});
var getTrendText = ({
  majorValue,
  trendValue,
  trendDisplay,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue
}) => {
  const compute = (value) => computeText({
    value,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateValue: shouldAbbreviateTrendValue
  });
  if (trendValue === "" || !(0, numberUtils_exports.isNumerial)(trendValue)) {
    return "";
  }
  const showPercent = trendDisplay === "percent";
  if (!showPercent) {
    return compute(trendValue);
  }
  const diff = Math.abs(trendValue - majorValue);
  let val = trendValue / diff * 100;
  if (trendValue === 0 && diff === 0) {
    val = 0;
  }
  if (!Number.isFinite(val)) {
    return "N/A";
  }
  const text = compute(val);
  return `${text}%`;
};
var computeFontSize = (text, { width, height }, fontFamily = DEFAULT_FONT_FAMILY, fontWeight = "normal") => {
  const widthInDefaultFont = (0, domUtils_exports.computeTextSize)(text, `${fontWeight} ${DEFAULT_FONT}px ${fontFamily}`);
  const fontSize = Math.min(
    width / widthInDefaultFont * DEFAULT_FONT,
    height / DEFAULT_FONT * DEFAULT_FONT
  );
  return parseInt(fontSize, 10);
};
var getMajorFontSize = ({ width, height, unit, majorText, spaceRatio = 1 }) => {
  const majorTextCalc = unit ? `${unit}${majorText}` : majorText;
  return computeFontSize(majorTextCalc, {
    width: width * spaceRatio,
    height
  });
};
var getTrendFontSize = ({ width, height, trendText, spaceRatio = 1 }) => {
  let trendFontSize = 12;
  if (spaceRatio > 0) {
    trendFontSize = computeFontSize(trendText, {
      width: width * spaceRatio,
      height
    });
    trendFontSize = parseInt(trendFontSize, 10) * spaceRatio;
  }
  return trendFontSize;
};
var getMajorAndTrend = ({
  width,
  height,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  trendDisplay,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue,
  shouldAbbreviateMajorValue
}) => {
  const majorTextSpaceRatio = (0, numberUtils_exports.isNumerial)(trendValue) && shouldShowTrend(trendDisplay) ? 0.6 : 1;
  const textContentWidth = width * 0.9;
  const textContentHeight = height * 0.9;
  const majorText = getMajorText({
    majorValueDisplay,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateMajorValue
  });
  const majorTextFontSize = majorFontSize || getMajorFontSize({
    width: textContentWidth,
    height: textContentHeight,
    unit,
    majorText,
    spaceRatio: majorTextSpaceRatio
  });
  const trendText = getTrendText({
    majorValue,
    trendValue,
    trendDisplay,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue
  });
  const trendTextFontSize = trendFontSize || getTrendFontSize({
    width: textContentWidth,
    height: textContentHeight,
    trendText,
    spaceRatio: 1 - majorTextSpaceRatio
  });
  return {
    majorText,
    majorTextFontSize,
    trendText,
    trendTextFontSize
  };
};
var minimallyTruncateStringToWidth = ({
  text,
  fontSize = DEFAULT_FONT,
  fontFamily = DEFAULT_FONT_FAMILY,
  fontWeight = "normal",
  containerWidth
}) => {
  let textWidth = (0, domUtils_exports.computeTextSize)(text, `${fontWeight} ${fontSize}px ${fontFamily}`);
  let modifiedText = text;
  const ellipsesLength = (0, domUtils_exports.computeTextSize)("...", `${fontWeight} ${fontSize}px ${fontFamily}`);
  if (containerWidth - ellipsesLength > 0 && textWidth > containerWidth) {
    while (textWidth + ellipsesLength > containerWidth && modifiedText.length > 1) {
      modifiedText = modifiedText.substring(0, modifiedText.length - 1);
      textWidth = (0, domUtils_exports.computeTextSize)(modifiedText, `normal ${fontSize}px ${fontFamily}`);
    }
    modifiedText = `${modifiedText}...`;
  }
  return modifiedText;
};
var computeSingleValueRadialContent = ({
  contentWidth,
  contentHeight,
  containerWidth,
  containerHeight,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  trendDisplay,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue,
  shouldAbbreviateMajorValue,
  smallViz
}) => {
  let { majorText, trendText, majorTextFontSize, trendTextFontSize } = getMajorAndTrend({
    majorValue,
    majorValueDisplay: majorValueDisplay || majorValue,
    trendValue,
    majorFontSize,
    trendFontSize,
    trendDisplay,
    width: contentWidth,
    height: contentHeight,
    unit,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue,
    shouldAbbreviateMajorValue
  });
  const majorValueTitle = majorText;
  let smallVizProps = {};
  if (smallViz) {
    const truncateValue = minimallyTruncateStringToWidth({
      text: majorValueDisplay || majorValue,
      fontWeight: "bold",
      fontSize: 12,
      containerWidth
    });
    ({ majorText, trendText, majorTextFontSize, trendTextFontSize } = getMajorAndTrend({
      majorValueDisplay: truncateValue,
      majorValue,
      trendValue,
      majorFontSize,
      trendFontSize,
      width: containerWidth,
      height: containerHeight,
      unit,
      trendDisplay,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue,
      shouldAbbreviateMajorValue
    }));
    smallVizProps = {
      trendDisplay,
      unit
    };
  }
  return {
    majorText,
    trendText,
    majorTextFontSize,
    trendTextFontSize,
    majorValueTitle,
    smallVizProps
  };
};
var getGraphColors = ({
  backgroundEnabled,
  backgroundColor,
  defaultColors,
  customColorFormatter
}) => {
  if (backgroundEnabled) {
    if (backgroundColor && typeof customColorFormatter === "function") {
      return customColorFormatter(backgroundColor);
    }
  }
  return defaultColors.none;
};
var adjustRGB = (rgb, delta) => {
  if (rgb === 255) {
    return rgb - delta;
  }
  if (rgb === 0) {
    return rgb + delta;
  }
  return rgb;
};
var changeColor = (color, ratio) => {
  const hex = color.replace(/(0x|#)/, "");
  const r = parseInt(hex.substr(0, 2), 16);
  const g = parseInt(hex.substr(2, 2), 16);
  const b = parseInt(hex.substr(4, 2), 16);
  let newR = Math.max(Math.min(Math.floor(r * ratio), 255), 0);
  let newG = Math.max(Math.min(Math.floor(g * ratio), 255), 0);
  let newB = Math.max(Math.min(Math.floor(b * ratio), 255), 0);
  if (newR === r && newG === g && newB === b) {
    if (newR === 0 && newG === 0 && newB === 0) {
      if (ratio > 1) {
        newR = adjustRGB(newR, 80);
        newG = adjustRGB(newG, 80);
        newB = adjustRGB(newB, 80);
      } else {
        newR = adjustRGB(newR, 40);
        newG = adjustRGB(newG, 40);
        newB = adjustRGB(newB, 40);
      }
    } else if (newR === 255 && newG === 255 && newB === 255) {
      if (ratio > 1) {
        newR = adjustRGB(newR, 20);
        newG = adjustRGB(newG, 20);
        newB = adjustRGB(newB, 20);
      } else {
        newR = adjustRGB(newR, 80);
        newG = adjustRGB(newG, 80);
        newB = adjustRGB(newB, 80);
      }
    } else {
      newR = adjustRGB(newR, 20);
      newG = adjustRGB(newG, 20);
      newB = adjustRGB(newB, 20);
    }
  }
  return `#${newR.toString(16).padStart(2, 0)}${newG.toString(16).padStart(2, 0)}${newB.toString(16).padStart(2, 0)}`;
};
var lighten = (color) => changeColor(color, 1.3);
var darken = (color) => changeColor(color, 0.5);
var handleValueClickCallback = (ev, majorValue, majorValueField, trendValue, onValueClick, trellisEnabled = false, trellisSplitBy = "", trellisKey = "") => onValueClick(__spreadProps(__spreadValues({}, ev), {
  payload: __spreadValues({
    trendValue,
    value: majorValue,
    name: majorValueField
  }, trellisEnabled && { "trellis.name": trellisSplitBy, "trellis.value": trellisKey })
}));
var getTrendColorWithPercent = (options) => {
  const shouldUsePercentTrendColor = options.trendColor === "> trendValue | rangeValue(trendColorEditorConfig)" && options.trendDisplay === "percent";
  return shouldUsePercentTrendColor ? { trendColor: "> trendValuePercent | rangeValue(trendColorEditorConfig)" } : {};
};

// esm-externals:@splunk/react-icons/enterprise/ArrowUp
var ArrowUp_exports = {};
__export(ArrowUp_exports, {
  default: () => ArrowUp_default
});
var defaultImport15 = __toESM(require("@splunk/react-icons/enterprise/ArrowUp"));
__reExport(ArrowUp_exports, require("@splunk/react-icons/enterprise/ArrowUp"));
var ArrowUp_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// esm-externals:@splunk/react-icons/enterprise/ArrowDown
var ArrowDown_exports = {};
__export(ArrowDown_exports, {
  default: () => ArrowDown_default
});
var defaultImport16 = __toESM(require("@splunk/react-icons/enterprise/ArrowDown"));
__reExport(ArrowDown_exports, require("@splunk/react-icons/enterprise/ArrowDown"));
var ArrowDown_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport17 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// src/SingleValueBasic/TrendValue.jsx
var Column = styled_components_default.div`
    display: flex;
    flex-direction: row;
    justify-content: ${(props) => props.justify || "flex-end"};
    height: ${(props) => props.size || 12}px;
    ${(props) => props.size ? `margin: 0 ${parseInt(props.size, 10) * 0.2 || 5}px;` : ""};
`;
var Text = styled_components_default.div`
    white-space: nowrap;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color || "#000"};
    font-family: ${DEFAULT_FONT_FAMILY};
    height: ${(props) => props.size || 12}px;
    line-height: ${(props) => props.size || 12}px;
    display: flex;
    align-self: baseline;
    ${(props) => props.size ? `margin-left: ${parseInt(props.size, 10) * 0.2 || 5}px;` : ""};
`;
var TrendValue = ({ fontSize, color, value, text }) => {
  let TrendIndicator = false;
  let ariaLabel = false;
  if (parseFloat(value, 10) > 0) {
    TrendIndicator = ArrowUp_default;
    ariaLabel = (0, i18n_exports._)("increase");
  } else if (parseFloat(value, 10) < 0) {
    TrendIndicator = ArrowDown_default;
    ariaLabel = (0, i18n_exports._)("decrease");
  }
  return /* @__PURE__ */ react_default.createElement(Column, { justify: "flex-end", size: fontSize }, /* @__PURE__ */ react_default.createElement(Text, { "data-test": "trendValueIndicator", size: fontSize, color }, TrendIndicator && /* @__PURE__ */ react_default.createElement(TrendIndicator, { "aria-label": ariaLabel })), /* @__PURE__ */ react_default.createElement(Text, { "data-test": "trendValue", size: fontSize, color }, `${text}`));
};
TrendValue.propTypes = {
  fontSize: prop_types_default.number,
  color: prop_types_default.string,
  value: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  text: prop_types_default.string
};
var TrendValue_default = TrendValue;

// esm-externals:cssesc
var cssesc_exports = {};
__export(cssesc_exports, {
  default: () => cssesc_default
});
var defaultImport18 = __toESM(require("cssesc"));
__reExport(cssesc_exports, require("cssesc"));
var cssesc_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// src/SingleValueBasic/MajorValue.jsx
var Row = styled_components_default.div`
    display: flex;
    flex-direction: row;
    align-items: flex-end;
    justify-content: left;
    height: ${(props) => props.size}px;
    line-height: ${(props) => props.size}px;
`;
var Text2 = styled_components_default.div`
    white-space: nowrap;
    height: 100%;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color};
    font-family: ${DEFAULT_FONT_FAMILY};
    font-weight: bold;
    &:hover {
        text-decoration: ${(props) => props.showUnderline ? "underline" : "inherit"};
        cursor: ${(props) => props.showUnderline ? "pointer" : "inherit"};
    }
    ${(props) => {
  if (!props.pseudoContent || !props.pseudoContentPosition) {
    return "";
  }
  return `&:${props.pseudoContentPosition} {
            // by default this pseudo element would inherit text-decoration from main element
            // and text-decoration could not be overwritten.
            // adding display: inline-block makes text decoration independent from main element.
            // => the unit will not be underlined if a user hovers over the main value
            display: inline-block;
            font-size: ${props.pseudoContentFontSize}px;
            position: relative;
            font-weight: normal;
            content: ${props.pseudoContent};
        }`;
}}
`;
var validUnitPositions = ["before", "after"];
var MajorValue = ({ color, fontSize, unitPosition, title, value, onValueClick, unit }) => {
  let sanitizedUnit;
  let sanitizedUnitPosition;
  if (typeof unit === "string") {
    sanitizedUnit = cssesc_default(unit, { wrap: true, quotes: "double" });
    if (typeof unitPosition === "string" && validUnitPositions.includes(unitPosition)) {
      sanitizedUnitPosition = unitPosition;
    } else {
      sanitizedUnitPosition = "after";
    }
  }
  const handleKeyDown = (e) => {
    if (e.keyCode !== 13) {
      return;
    }
    e.preventDefault();
    onValueClick(e);
  };
  return /* @__PURE__ */ react_default.createElement(Row, { size: fontSize }, /* @__PURE__ */ react_default.createElement(
    Text2,
    {
      "data-test": "majorValue",
      color,
      onClick: (e) => typeof onValueClick === "function" && onValueClick(e),
      showUnderline: !!onValueClick,
      size: fontSize,
      title,
      pseudoContent: sanitizedUnit,
      pseudoContentPosition: sanitizedUnitPosition,
      pseudoContentFontSize: fontSize * 0.6,
      tabIndex: "0",
      role: "button",
      onKeyDown: handleKeyDown
    },
    value
  ));
};
MajorValue.propTypes = {
  color: prop_types_default.string,
  fontSize: prop_types_default.number,
  unit: prop_types_default.string,
  unitPosition: prop_types_default.oneOf(validUnitPositions),
  value: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  title: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  onValueClick: prop_types_default.oneOfType([prop_types_default.bool, prop_types_default.func])
};
var MajorValue_default = MajorValue;

// src/SingleValueBasic/SingleValueBasic.jsx
var Column2 = styled_components_default.div`
    display: flex;
    flex-direction: column;
    align-self: center;
    justify-content: center;
`;
var Row2 = styled_components_default.div`
    display: flex;
    flex-direction: row;
    align-items: ${(props) => props.alignItems || "center"};
    justify-content: ${(props) => getAligment(props.align)};
`;
var Text3 = styled_components_default.div`
    font-weight: normal;
    white-space: nowrap;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color || "#000"};
    font-family: ${DEFAULT_FONT_FAMILY};
    height: ${(props) => props.size || 12}px;
    line-height: 1.2;
    margin: ${(props) => props.margin || "inherit"};
`;
var SingleValueBasic = (_a) => {
  var props = __objRest(_a, []);
  const {
    majorColor,
    majorTextFontSize,
    majorText,
    majorValueTitle,
    trendColor,
    trendTextFontSize,
    trendText,
    showTrendIndicator,
    unit,
    unitPosition,
    underLabel,
    underLabelFontSize,
    underLabelColor,
    onValueClick,
    align
  } = props;
  const trendIndicatorEnabled = trendText !== "" && showTrendIndicator;
  return /* @__PURE__ */ react_default.createElement(Column2, null, /* @__PURE__ */ react_default.createElement(
    Row2,
    {
      alignItems: "baseline",
      align,
      "data-test": `single-value-row-align-${getAligment(align)}`
    },
    /* @__PURE__ */ react_default.createElement(
      MajorValue_default,
      {
        color: majorColor,
        fontSize: majorTextFontSize,
        unit,
        unitPosition,
        value: majorText,
        title: majorValueTitle,
        onValueClick
      }
    ),
    trendIndicatorEnabled && // Passing the same value for value and text is a temporary hold until completion of https://jira.splunk.com/browse/SCP-21371
    /* @__PURE__ */ react_default.createElement(
      TrendValue_default,
      {
        fontSize: trendTextFontSize,
        color: trendColor,
        value: trendText,
        text: trendText
      }
    )
  ), underLabel && /* @__PURE__ */ react_default.createElement(
    Row2,
    {
      justify: "center",
      align,
      "data-test": `single-value-row-align-${getAligment(align)}`
    },
    /* @__PURE__ */ react_default.createElement(
      Text3,
      {
        "data-test": "underLabel",
        size: underLabelFontSize,
        color: underLabelColor,
        margin: "0 6px"
      },
      underLabel
    )
  ));
};
SingleValueBasic.propTypes = {
  majorText: prop_types_default.string,
  majorColor: prop_types_default.string,
  majorTextFontSize: prop_types_default.number,
  majorValueTitle: prop_types_default.string,
  trendText: prop_types_default.string,
  trendTextFontSize: prop_types_default.number,
  trendColor: prop_types_default.string,
  showTrendIndicator: prop_types_default.bool,
  unit: prop_types_default.string,
  unitPosition: prop_types_default.oneOf(["before", "after"]),
  underLabel: prop_types_default.string,
  underLabelFontSize: prop_types_default.number,
  underLabelColor: prop_types_default.string,
  onValueClick: prop_types_default.oneOfType([prop_types_default.bool, prop_types_default.func]),
  align: prop_types_default.string
};
var SingleValueBasic_default = SingleValueBasic;

// src/SingleValueRadial/PureSingleValueRadial/RadialGraph.jsx
var RadialGraph = ({
  progress,
  strokeWidth,
  backgroundColor = colorConstants_exports.RADIAL_BACKGROUND_COLOR,
  progressColor = colorConstants_exports.RADIAL_STROKE_COLOR,
  width = 200,
  height = 200
}) => {
  const semicircleRadius = height - strokeWidth / 2;
  const circumference = semicircleRadius * 2 * Math.PI;
  const bgCircleOffset = 0.5 * circumference;
  const progress50 = progress / 100 * 50;
  const progressWidth = progress50 / 100 * circumference;
  const strokeDashoffset = circumference * 0.5;
  return /* @__PURE__ */ react_default.createElement("svg", { height, width, "data-test": "radial-visualization" }, /* @__PURE__ */ react_default.createElement("g", null, /* @__PURE__ */ react_default.createElement(
    "circle",
    {
      "data-test": "background-radial",
      stroke: backgroundColor,
      fill: "transparent",
      strokeWidth,
      strokeDasharray: `${bgCircleOffset} ${circumference - bgCircleOffset}`,
      style: { strokeDashoffset },
      r: semicircleRadius,
      cx: width / 2,
      cy: semicircleRadius + strokeWidth / 2
    }
  ), /* @__PURE__ */ react_default.createElement(
    "circle",
    {
      "data-test": "progress-radial",
      "data-test-value": progress,
      stroke: progressColor,
      fill: "transparent",
      strokeWidth,
      strokeDasharray: `${progressWidth} ${circumference - progressWidth}`,
      style: { strokeDashoffset },
      r: semicircleRadius,
      cx: width / 2,
      cy: semicircleRadius + strokeWidth / 2
    }
  )));
};
RadialGraph.propTypes = {
  progress: prop_types_default.number,
  strokeWidth: prop_types_default.number,
  backgroundColor: prop_types_default.string,
  progressColor: prop_types_default.string,
  width: prop_types_default.number,
  height: prop_types_default.number
};
RadialGraph.defaultProps = {
  progress: 0,
  strokeWidth: 12
};
var RadialGraph_default = RadialGraph;

// src/SingleValueRadial/PureSingleValueRadial/utils/displayUtils.js
var DEFAULT_RADIAL_STROKE_WIDTH = 16;
var SMALL_RADIAL_STROKE_WIDTH = 6;
var getRadialColors = ({ backgroundEnabled, backgroundColor }) => getGraphColors({
  backgroundEnabled,
  backgroundColor,
  defaultColors: colorConstants_exports.RADIAL_SEVERITY_COLORS,
  customColorFormatter: (color) => ({ background: lighten(color), stroke: darken(color) })
});
var getRadialGraphDimensions = ({ width, height }) => {
  const radius = Math.min(width, height * 2) / 2;
  return {
    width: width - SVR_PADDING.left - SVR_PADDING.right,
    height: radius - SVR_PADDING.top - SVR_PADDING.bottom
  };
};
var getRadialHelperDimensions = ({ height, strokeWidth = DEFAULT_RADIAL_STROKE_WIDTH }) => {
  const semicircleRadius = height - strokeWidth / 2;
  const innerArcRadius = semicircleRadius * 0.9;
  const halfContentWidth = innerArcRadius * 0.7;
  const contentHeight = Math.floor(Math.sqrt(__pow(innerArcRadius, 2) - __pow(halfContentWidth, 2)));
  return {
    contentWidth: halfContentWidth * 2,
    contentHeight,
    helperArcRadius: innerArcRadius,
    semicircleRadius
  };
};
var getRadialStrokeWidth = (graphHeight) => graphHeight >= 90 ? DEFAULT_RADIAL_STROKE_WIDTH : SMALL_RADIAL_STROKE_WIDTH;
var getRadialProgress = (progressValue, minValue, maxValue) => typeof progressValue === "number" && minValue < maxValue && progressValue > 0 ? progressValue / (maxValue - minValue) * 100 : 0;

// src/SingleValueRadial/PureSingleValueRadial/utils/gaugeUtils.ts
var getGaugeRange = (formattedGaugeRanges, majorValue) => {
  if (typeof majorValue !== "number") {
    return -1;
  }
  const numRanges = formattedGaugeRanges.length;
  return formattedGaugeRanges.findIndex(
    (r, i) => i === numRanges - 1 && r.from <= majorValue || r.from <= majorValue && majorValue < r.to
  );
};
var validateGaugeRanges = (gaugeRanges) => {
  if (!gaugeRanges || !Array.isArray(gaugeRanges) || gaugeRanges.length < 2) {
    return false;
  }
  for (let i = 0; i < gaugeRanges.length; i += 1) {
    const range2 = gaugeRanges[i];
    if (!range2 || typeof range2 !== "object") {
      return false;
    }
    if (i === 0 && (Object.keys(range2).includes("from") || !Object.keys(range2).includes("to") || typeof range2.to !== "number")) {
      return false;
    }
    if (i === gaugeRanges.length - 1 && (Object.keys(range2).includes("to") || !Object.keys(range2).includes("from") || typeof range2.from !== "number")) {
      return false;
    }
    if (i > 0 && i < gaugeRanges.length - 1 && (!Object.keys(range2).includes("from") || !Object.keys(range2).includes("to") || typeof range2.from !== "number" || typeof range2.to !== "number" || range2.from !== gaugeRanges[i - 1].to || range2.from >= range2.to)) {
      return false;
    }
    if (!Object.keys(range2).includes("value") || typeof range2.value !== "string") {
      return false;
    }
  }
  return true;
};
var getProgressWidth = (value, minValue, maxValue, circumference) => {
  const progress = getRadialProgress(value, minValue, maxValue);
  const progress50 = progress / 100 * 50;
  const progressWidth = progress50 / 100 * circumference;
  return progressWidth;
};
var computeTextWidth = (text, font) => {
  const canvas = document.createElement("canvas");
  const context = canvas.getContext("2d");
  context.font = font;
  const measure = context.measureText(text);
  return measure.width;
};
var getVerticalLabelOffset = (theta, textHeight, maxOffset) => {
  if (theta > 90) {
    return (-(maxOffset / 90) * (180 - theta) + maxOffset) * textHeight;
  }
  return (-(maxOffset / 90) * theta + maxOffset) * textHeight;
};
var getLabelFontSize = (height, showRadialGraph) => {
  const strokeWidth = getGaugeStrokeWidth(height);
  const { semicircleRadius, helperArcRadius } = getRadialHelperDimensions({
    height,
    strokeWidth
  });
  const fillVacantSpace = semicircleRadius < 50 || !showRadialGraph;
  return fillVacantSpace ? 0 : Math.min(helperArcRadius * 0.08, 16);
};
var getGaugeStrokeWidth = (height) => {
  return height >= 225 ? 30 : 16;
};
var getSortedGaugeRanges = (gaugeRanges) => {
  gaugeRanges.sort((a, b) => {
    if (a.to == null) return 1;
    if (b.to == null) return -1;
    return +a.to - +b.to;
  });
  return gaugeRanges;
};
var getFormattedGaugeRanges = (gaugeRanges, minValue, maxValue) => {
  const formattedGaugeRanges = [];
  gaugeRanges.forEach((range2, index) => {
    if (index === 0 && minValue < range2.to) {
      const newRange = { from: minValue, to: range2.to, value: range2.value };
      if (maxValue < range2.to) {
        newRange.to = maxValue;
      }
      formattedGaugeRanges.push(newRange);
    }
    if (index === gaugeRanges.length - 1 && maxValue > range2.from) {
      const newRange = { from: range2.from, to: maxValue, value: range2.value };
      if (minValue > range2.from) {
        newRange.from = minValue;
      }
      formattedGaugeRanges.push(newRange);
    }
    if (Object.keys(range2).includes("from") && Object.keys(range2).includes("to")) {
      const newRange = __spreadValues({}, range2);
      if (minValue > range2.from && minValue < range2.to) {
        newRange.from = minValue;
      }
      if (maxValue > range2.from && maxValue < range2.to) {
        newRange.to = maxValue;
      }
      if (minValue < range2.to && maxValue > range2.from) {
        formattedGaugeRanges.push(newRange);
      }
    }
  });
  return formattedGaugeRanges;
};

// src/SingleValueRadial/PureSingleValueRadial/GaugeGraph.tsx
var GaugeGraph = ({
  width = 200,
  height = 200,
  strokeWidth = getGaugeStrokeWidth(height),
  radialBackgroundColor = colorConstants_exports.RADIAL_BACKGROUND_COLOR,
  fontColor,
  formattedGaugeRanges,
  majorValue: propMajorValue,
  maxValue,
  minValue,
  showRadialGraph
}) => {
  function toRadians(degrees) {
    return degrees * Math.PI / 180;
  }
  function toDegrees(radians) {
    return radians * 180 / Math.PI;
  }
  const labelFontSize = getLabelFontSize(height, showRadialGraph);
  const labelFontSizeString = `${String(labelFontSize)}px Splunk Platform Sans`;
  const maxOffset = 0.35;
  const labelSpace = labelFontSize / 2;
  const triangleBase = height >= 113 ? 8 : 4;
  const padding = labelFontSize > 0 ? labelSpace * 2 + labelFontSize * 2 : triangleBase;
  const semicircleRadius = height - strokeWidth / 2 - padding;
  const circumference = semicircleRadius * 2 * Math.PI;
  const bgCircleOffset = circumference * 0.5;
  const strokeDashoffset = circumference * 0.5;
  const semicircleEdgeRadius = semicircleRadius + strokeWidth / 2;
  const innerStrokeWidth = strokeWidth / 4;
  const innerSemicircleRadius = height - strokeWidth - padding - innerStrokeWidth / 2 - 1;
  const innerCircumference = innerSemicircleRadius * 2 * Math.PI;
  const cx = width / 2;
  const cyOffset = labelFontSize > 0 ? labelSpace * 2 + labelFontSize : triangleBase / 2;
  const cy = semicircleRadius + strokeWidth / 2 + cyOffset;
  let majorValue;
  if (typeof propMajorValue === "string") {
    majorValue = parseInt(propMajorValue, 10);
  } else {
    majorValue = propMajorValue;
  }
  const range2 = getGaugeRange(formattedGaugeRanges, majorValue);
  const circles = [];
  const labels = [];
  let showMarker = false;
  const radius = semicircleRadius;
  const x = strokeWidth / 2 + innerStrokeWidth + 2;
  const markerVal = Math.max(Math.min(maxValue, majorValue), minValue);
  const theta = toRadians(180 - getRadialProgress(markerVal - minValue, minValue, maxValue) / 100 * 180);
  const p1x = cx + (radius - x) * Math.cos(theta);
  const p1y = cy - (radius - x) * Math.sin(theta);
  const centerX = (radius - x - triangleBase / Math.sqrt(3)) * Math.cos(theta);
  const centerY = (radius - x - triangleBase / Math.sqrt(3)) * Math.sin(theta);
  const rotation1 = 2 * Math.PI / 3;
  const rotation2 = -2 * Math.PI / 3;
  const xVal = (radius - x) * Math.cos(theta);
  const yVal = (radius - x) * Math.sin(theta);
  const p2x = centerX + (xVal - centerX) * Math.cos(rotation1) - (yVal - centerY) * Math.sin(rotation1);
  const p2y = centerY + (xVal - centerX) * Math.sin(rotation1) + (yVal - centerY) * Math.cos(rotation1);
  const p3x = centerX + (xVal - centerX) * Math.cos(rotation2) - (yVal - centerY) * Math.sin(rotation2);
  const p3y = centerY + (xVal - centerX) * Math.sin(rotation2) + (yVal - centerY) * Math.cos(rotation2);
  const d = `M ${p1x} ${p1y} L ${cx + p2x} ${cy - p2y} L ${cx + p3x} ${cy - p3y} Z`;
  formattedGaugeRanges.forEach((r, i) => {
    if (range2 >= i && typeof majorValue === "number") {
      const startVal = Math.min(r.from, majorValue);
      const endVal = Math.min(r.to, majorValue);
      const progressWidth2 = getProgressWidth(endVal - startVal, minValue, maxValue, circumference);
      const offsetDistance2 = getProgressWidth(maxValue - startVal, minValue, maxValue, circumference);
      circles.push(
        /* @__PURE__ */ react_exports.createElement(
          "circle",
          {
            "data-test": "progress-radial",
            stroke: r.value,
            fill: "transparent",
            strokeWidth,
            strokeDasharray: `${progressWidth2} ${circumference - progressWidth2}`,
            style: { strokeDashoffset: offsetDistance2 },
            r: semicircleRadius,
            cx,
            cy,
            key: `progress${r.from}`
          }
        )
      );
    }
    if (range2 <= i && (typeof majorValue !== "number" || majorValue < r.to) && i < formattedGaugeRanges.length - 1) {
      const breakpointWidth = 1;
      const breakpointOpacity = 0.15;
      const offsetDistance2 = getProgressWidth(maxValue - r.to, minValue, maxValue, circumference);
      circles.push(
        /* @__PURE__ */ react_exports.createElement(
          "circle",
          {
            "data-test": "breakpoint-radial",
            stroke: fontColor,
            opacity: breakpointOpacity,
            fill: "transparent",
            strokeWidth,
            strokeDasharray: `${breakpointWidth} ${circumference - breakpointWidth}`,
            style: { strokeDashoffset: offsetDistance2 },
            r: semicircleRadius,
            cx,
            cy,
            key: `breakpoint${r.from}`
          }
        )
      );
    }
    if (i < formattedGaugeRanges.length - 1) {
      const toTheta = toRadians(
        180 - getRadialProgress(r.to - minValue, minValue, maxValue) / 100 * 180
      );
      let labelX = cx + (semicircleEdgeRadius + labelSpace) * Math.cos(toTheta);
      let labelY = cy - (semicircleEdgeRadius + labelSpace) * Math.sin(toTheta);
      const labelWidth = computeTextWidth(String(r.to), labelFontSizeString);
      const vertOffset = getVerticalLabelOffset(toDegrees(toTheta), labelFontSize, maxOffset);
      labelY += vertOffset;
      if (r.to < (maxValue + minValue) / 2) {
        labelX -= labelWidth + vertOffset / 3;
      } else if (r.to === (maxValue + minValue) / 2) {
        labelX -= labelWidth / 2;
      }
      labels.push(
        /* @__PURE__ */ react_exports.createElement(
          "text",
          {
            "data-test": "label",
            fill: fontColor,
            x: labelX,
            y: labelY,
            fontSize: labelFontSize,
            key: `label${r.from}`
          },
          r.to
        )
      );
    }
    const progressWidth = getProgressWidth(r.to - r.from, minValue, maxValue, innerCircumference);
    const offsetDistance = getProgressWidth(maxValue - r.from, minValue, maxValue, innerCircumference);
    circles.push(
      /* @__PURE__ */ react_exports.createElement(
        "circle",
        {
          "data-test": "inner-radial",
          stroke: r.value,
          fill: "transparent",
          strokeWidth: innerStrokeWidth,
          strokeDasharray: `${progressWidth} ${innerCircumference - progressWidth}`,
          style: { strokeDashoffset: offsetDistance },
          r: innerSemicircleRadius,
          cx,
          cy,
          key: `inner${r.from}`
        }
      )
    );
  });
  labels.push(
    /* @__PURE__ */ react_exports.createElement(
      "text",
      {
        "data-test": "min-label",
        fill: fontColor,
        x: cx - semicircleEdgeRadius,
        y: cy + labelFontSize,
        fontSize: labelFontSize,
        key: "min-label"
      },
      minValue
    )
  );
  const maxLabelWidth = computeTextWidth(String(maxValue), labelFontSizeString);
  labels.push(
    /* @__PURE__ */ react_exports.createElement(
      "text",
      {
        "data-test": "max-label",
        fill: fontColor,
        x: cx + semicircleEdgeRadius - maxLabelWidth,
        y: cy + labelFontSize,
        fontSize: labelFontSize,
        key: "max-label"
      },
      maxValue
    )
  );
  showMarker = typeof majorValue === "number" && formattedGaugeRanges.length >= 1;
  if (showMarker && majorValue > formattedGaugeRanges[0].from && majorValue <= formattedGaugeRanges[formattedGaugeRanges.length - 1].to) {
    const progressWidth = getProgressWidth(maxValue - majorValue, minValue, maxValue, circumference);
    const indicatorWidth = 1;
    circles.push(
      /* @__PURE__ */ react_exports.createElement(
        "circle",
        {
          "data-test": "indicator-radial",
          stroke: fontColor || "#FFFFFF",
          fill: "transparent",
          strokeWidth,
          strokeDasharray: `${indicatorWidth} ${circumference - indicatorWidth}`,
          style: { strokeDashoffset: progressWidth },
          r: semicircleRadius,
          cx,
          cy,
          key: "indicator"
        }
      )
    );
  }
  return /* @__PURE__ */ react_exports.createElement("svg", { height, width, "data-test": "radial-gauge-visualization" }, /* @__PURE__ */ react_exports.createElement("g", null, /* @__PURE__ */ react_exports.createElement(
    "circle",
    {
      "data-test": "background-radial",
      stroke: radialBackgroundColor,
      fill: "transparent",
      strokeWidth,
      strokeDasharray: `${bgCircleOffset} ${circumference - bgCircleOffset}`,
      style: { strokeDashoffset },
      r: semicircleRadius,
      cx,
      cy
    }
  ), circles, labels, showMarker && /* @__PURE__ */ react_exports.createElement("path", { fill: fontColor, d, opacity: "100", "data-z-index": "4", "data-test": "marker" })));
};
GaugeGraph.propTypes = {
  width: prop_types_exports.number,
  height: prop_types_exports.number,
  strokeWidth: prop_types_exports.number,
  radialBackgroundColor: prop_types_exports.string,
  formattedGaugeRanges: prop_types_exports.array,
  majorValue: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  maxValue: prop_types_exports.number,
  minValue: prop_types_exports.number,
  showRadialGraph: prop_types_exports.bool
};
GaugeGraph.defaultProps = {
  strokeWidth: 12,
  formattedGaugeRanges: [],
  majorValue: "N/A"
};
var GaugeGraph_default = GaugeGraph;

// src/SingleValueRadial/PureSingleValueRadial/RadialLayout.jsx
var TextContainer = styled_components_default.div`
    position: ${(props) => props.smallViz ? "relative" : "absolute"};
    left: 0;
    bottom: 0;

    width: 100%;
    display: flex;
    align-items: ${(props) => props.align || "center"};
    justify-content: center;
    flex-direction: column;

    // To ensure the major text is flush with the bottom of the text container when radial is shown.
    [data-test='majorValue'] {
        ${(props) => !props.smallViz && { lineHeight: "normal" }}

        ::before {
            font-size: inherit;
            vertical-align: unset;
            top: unset;
        }

        ::after {
            font-size: inherit;
            vertical-align: unset;
            top: unset;
        }
    }

    // To ensure the trend text is flush with the bottom of the text container, and prevents weird spacing behavior at very small trend text sizes
    [data-test='trendValueIndicator'] {
        align-items: flex-end;
        ${(props) => props.smallViz && { marginLeft: "1px" }}
    }

    // Prevents weird spacing behavior at very small sizes.
    [data-test='trendValue'] {
        ${(props) => props.smallViz && { marginLeft: "1px" }}
    }

    div[class^='TrendValue__Column'] {
        ${(props) => props.smallViz && { margin: "0 1px" }}
    }
`;
var GraphContainer = styled_components_default.div`
    position: relative;
    margin: 0 auto;
    width: ${(props) => props.width}px;
    height: ${(props) => props.height}px;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
`;
var SingleValueContainer = styled_components_default.div`
    display: flex;
    flex: 0 0 0;
    align-items: flex-end;
    margin-bottom: -${(props) => props.singleValueBottomOffset}px; //negative margin to counteract padding under Proxima Nova
`;
var UnderLabelContainer = styled_components_default.div`
    display: flex;
    flex: 0 0 ${(props) => props.underLabelHeight}px; // Changes depending on height of underLabel.
    align-items: flex-end;
`;
var UnderLabelText = styled_components_default.span`
    color: ${(props) => props.color};
    -webkit-text-stroke: 0.5px ${(props) => props.strokeColor};
    font-size: 12px;

    // Prevent overflow of text beyond inner arc radius.
    max-width: ${(props) => props.maxWidth}px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
`;
var RadialContent = (_a) => {
  var props = __objRest(_a, []);
  const {
    majorColor,
    majorValue,
    majorText,
    majorTextFontSize,
    majorValueTitle,
    minValue,
    maxValue,
    trendColor,
    trendText,
    trendTextFontSize,
    showTrendIndicator,
    unit,
    unitPosition,
    underLabelColor,
    underLabel,
    onValueClick,
    showRadialGraph,
    progress,
    radialBackgroundColor,
    radialStrokeColor,
    radialStrokeWidth,
    graphWidth,
    graphHeight,
    isGaugeValid,
    formattedGaugeRanges,
    defaultFontColor
  } = props;
  const { semicircleRadius, helperArcRadius } = getRadialHelperDimensions({
    height: graphHeight,
    strokeWidth: radialStrokeWidth
  });
  const fillVacantSpace = semicircleRadius < 50 || !showRadialGraph;
  const underLabelHeight = fillVacantSpace ? 0 : Math.max(helperArcRadius * 0.2, 20);
  const underLabelWidth = helperArcRadius * 2;
  const singleValueBottomOffset = majorTextFontSize * 0.2;
  let radialGraph = null;
  if (showRadialGraph) {
    radialGraph = isGaugeValid ? /* @__PURE__ */ react_default.createElement(
      GaugeGraph_default,
      {
        width: graphWidth,
        height: graphHeight,
        strokeWidth: radialStrokeWidth,
        radialBackgroundColor,
        fontColor: defaultFontColor,
        formattedGaugeRanges,
        majorValue,
        minValue,
        maxValue,
        showRadialGraph
      }
    ) : /* @__PURE__ */ react_default.createElement(
      RadialGraph_default,
      {
        progress,
        backgroundColor: radialBackgroundColor,
        progressColor: radialStrokeColor,
        strokeWidth: radialStrokeWidth,
        width: graphWidth,
        height: graphHeight
      }
    );
  }
  const singleValueComponent = /* @__PURE__ */ react_default.createElement(SingleValueContainer, { singleValueBottomOffset }, /* @__PURE__ */ react_default.createElement(
    SingleValueBasic_default,
    {
      majorColor,
      majorText,
      majorTextFontSize,
      majorValueTitle,
      trendColor,
      trendText,
      trendTextFontSize,
      showTrendIndicator,
      unit,
      unitPosition,
      onValueClick
    }
  ));
  const underLabelComponent = /* @__PURE__ */ react_default.createElement(UnderLabelContainer, { underLabelHeight }, !fillVacantSpace && underLabel && /* @__PURE__ */ react_default.createElement(
    UnderLabelText,
    {
      "data-test": "underLabel",
      maxWidth: underLabelWidth * 0.9,
      color: underLabelColor,
      title: underLabel
    },
    underLabel
  ));
  return /* @__PURE__ */ react_default.createElement(GraphContainer, { width: graphWidth, height: graphHeight, "data-test": "graph-container" }, radialGraph, /* @__PURE__ */ react_default.createElement(TextContainer, { smallViz: !showRadialGraph, height: graphHeight }, singleValueComponent, underLabelComponent));
};
RadialContent.propTypes = __spreadProps(__spreadValues({}, SingleValueBasic_default.propTypes), {
  trendPosition: prop_types_default.string,
  showRadialGraph: prop_types_default.bool,
  progress: prop_types_default.number,
  radialBackgroundColor: prop_types_default.string,
  radialStrokeColor: prop_types_default.string,
  radialStrokeWidth: prop_types_default.number,
  graphWidth: prop_types_default.number,
  graphHeight: prop_types_default.number,
  gaugeComponent: prop_types_default.element,
  backgroundColor: prop_types_default.string
});
var RadialLayout_default = RadialContent;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport19 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport20 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// src/common/hooks/useTrellisEnabled.ts
var useTrellisFeatureFlagOn = () => {
  const context = (0, react_exports.useContext)(FeatureFlagContext_default);
  return Boolean(context == null ? void 0 : context.visualizations_enableTrellis);
};
var useTrellisEnabled = (layoutType = visualization_schemas_exports.LAYOUT_TYPE.Off) => {
  const trellisFeatureEnabled = useTrellisFeatureFlagOn();
  return trellisFeatureEnabled && layoutType === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};

// src/SingleValueRadial/PureSingleValueRadial/SingleValueRadial.jsx
var Container = styled_components_default.div`
    overflow: hidden;
    ${(props) => (0, style_exports.toDimension)(pick_default2(props, ["width", "height"]))};
`;
var SingleValueRadial = (_a) => {
  var props = __objRest(_a, []);
  const {
    width,
    height = 250,
    style,
    isGaugeOn,
    gaugeRanges,
    majorFontSize,
    majorValue,
    majorValueDisplay,
    majorValueField,
    minValue,
    maxValue,
    trendValue,
    trendFontSize,
    unitPosition,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue,
    shouldAbbreviateMajorValue,
    onValueClick,
    splitByLayout,
    trellisKey = "",
    trellisSplitBy = ""
  } = props;
  const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
  const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
  const cachedHandleResize = react_exports.useCallback((w, h) => {
    setContainerWidth(w);
    setContainerHeight(h);
  }, []);
  const defaultColors = {
    defaultFontColor: pick_default({
      enterprise: {
        dark: variables_default.textColor(props),
        light: variables_default.gray20(props)
      },
      prisma: variables_default.contentColorActive(props)
    })(props),
    defaultBlockFontColor: pick_default({
      enterprise: variables_default.white(props),
      prisma: variables_default.contentColorActive(props)
    })(props)
  };
  const { backgroundEnabled, backgroundColor, majorColor, trendColor, underLabelColor } = computeColors(
    props,
    defaultColors
  );
  const radialColors = getRadialColors({ backgroundEnabled, backgroundColor });
  const radialBackgroundColor = props.radialBackgroundColor || radialColors.background;
  const radialStrokeColor = props.radialStrokeColor || radialColors.stroke;
  const trellisEnabled = useTrellisEnabled(splitByLayout);
  const handleValueClick = (0, react_exports.useCallback)(
    (ev) => handleValueClickCallback(
      ev,
      majorValue,
      majorValueField,
      trendValue,
      onValueClick,
      trellisEnabled,
      trellisSplitBy,
      trellisKey
    ),
    [onValueClick, majorValue, majorValueField, trendValue, trellisEnabled, trellisSplitBy, trellisKey]
  );
  const sortedGaugeRanges = gaugeRanges && getSortedGaugeRanges(gaugeRanges);
  const isGaugeValid = isGaugeOn && gaugeRanges && validateGaugeRanges(sortedGaugeRanges);
  const formattedGaugeRanges = isGaugeValid && getFormattedGaugeRanges(sortedGaugeRanges, minValue, maxValue);
  const renderVisualization = () => {
    if (!containerWidth || !containerHeight) {
      return null;
    }
    const { underLabel } = props;
    let { trendDisplay, unit } = props;
    let { width: graphWidth, height: graphHeight } = getRadialGraphDimensions({
      width: containerWidth,
      height: containerHeight
    });
    const radialStrokeWidth = getRadialStrokeWidth(graphHeight);
    const semicircleRadius = graphHeight - radialStrokeWidth / 2;
    const showRadialGraph = semicircleRadius >= 20;
    const offSet = isGaugeValid ? getLabelFontSize(graphHeight, showRadialGraph) * 3 : 0;
    let { contentWidth, contentHeight } = getRadialHelperDimensions({
      height: graphHeight - radialStrokeWidth / 2 - offSet,
      strokeWidth: radialStrokeWidth
    });
    if (!showRadialGraph) {
      graphWidth = containerWidth;
      contentWidth = containerWidth;
      graphHeight = containerHeight;
      contentHeight = containerHeight;
    }
    const {
      majorText,
      trendText,
      majorTextFontSize,
      trendTextFontSize,
      majorValueTitle,
      smallVizProps
    } = computeSingleValueRadialContent({
      majorValue,
      majorValueDisplay,
      trendValue,
      majorFontSize,
      trendFontSize,
      trendDisplay,
      contentWidth,
      contentHeight,
      // buffer for height of div
      containerWidth: containerWidth * 0.9,
      containerHeight: containerHeight * 0.9,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue,
      shouldAbbreviateMajorValue,
      smallViz: !showRadialGraph
    });
    if (!isEmpty_default(smallVizProps)) {
      ({ trendDisplay, unit } = smallVizProps);
    }
    const progress = getRadialProgress(majorValue - minValue, minValue, maxValue);
    return /* @__PURE__ */ react_exports.createElement(
      VizStyleWrapper_default,
      {
        backgroundColor,
        style,
        dataTestKey: "SingleValueRadialWrapper"
      },
      /* @__PURE__ */ react_exports.createElement(
        RadialLayout_default,
        {
          "data-test": "RadialLayout",
          majorColor,
          majorValue,
          majorText,
          majorTextFontSize,
          majorValueTitle,
          minValue,
          maxValue,
          trendColor,
          trendText,
          trendTextFontSize,
          showTrendIndicator: shouldShowTrend(trendDisplay),
          unit,
          unitPosition,
          underLabelColor,
          underLabel,
          onValueClick: handleValueClick,
          showRadialGraph,
          progress,
          radialBackgroundColor,
          radialStrokeColor,
          radialStrokeWidth,
          graphWidth,
          graphHeight,
          isGaugeValid,
          formattedGaugeRanges,
          defaultFontColor: defaultColors.defaultFontColor
        }
      )
    );
  };
  if (trellisEnabled) {
    return /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, /* @__PURE__ */ react_exports.createElement(
      TrellisTitle,
      {
        fontColor: defaultColors.defaultFontColor,
        backgroundColor,
        trellisKey
      }
    ), /* @__PURE__ */ react_exports.createElement(Container, { width, height: height - TRELLIS_TITLE_HEIGHT }, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), renderVisualization()));
  }
  return /* @__PURE__ */ react_exports.createElement(Container, { width, height }, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), renderVisualization());
};
SingleValueRadial.propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  style: prop_types_exports.object,
  majorValue: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  majorValueDisplay: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  majorValueField: prop_types_exports.string,
  majorColor: prop_types_exports.string,
  majorFontSize: prop_types_exports.number,
  minValue: prop_types_exports.number,
  maxValue: prop_types_exports.number,
  trendValue: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  trendColor: prop_types_exports.string,
  trendFontSize: prop_types_exports.number,
  trendDisplay: prop_types_exports.string,
  trendIndicatorPosition: prop_types_exports.oneOf(["standard", "below", "outside"]),
  shouldAbbreviateTrendValue: prop_types_exports.bool,
  shouldAbbreviateMajorValue: prop_types_exports.bool,
  backgroundColor: prop_types_exports.string,
  unit: prop_types_exports.string,
  unitPosition: prop_types_exports.string,
  underLabel: prop_types_exports.string,
  numberPrecision: prop_types_exports.number,
  shouldUseThousandSeparators: prop_types_exports.bool,
  radialBackgroundColor: prop_types_exports.string,
  radialStrokeColor: prop_types_exports.string,
  onValueClick: prop_types_exports.func,
  splitByLayout: prop_types_exports.string,
  trellisKey: prop_types_exports.string,
  trellisSplitBy: prop_types_exports.string,
  isGaugeOn: prop_types_exports.bool,
  gaugeComponent: prop_types_exports.element,
  gaugeRanges: prop_types_exports.array
};
SingleValueRadial.defaultProps = {
  width: "100%",
  height: 250,
  majorValue: "N/A",
  majorValueField: "",
  minValue: 0,
  maxValue: 100,
  trendDisplay: "absolute",
  trendIndicatorPosition: "standard",
  shouldAbbreviateTrendValue: false,
  shouldAbbreviateMajorValue: false,
  unitPosition: "after",
  numberPrecision: 0,
  shouldUseThousandSeparators: true,
  onValueClick: () => {
  },
  trellisKey: "",
  trellisSplitBy: ""
};
var SingleValueRadial_default = (0, styled_components_exports.withTheme)(SingleValueRadial);

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport21 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport22 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport23 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport24 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport25 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport26 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport27 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport28 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport29 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport30 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport31 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys, target) => keys.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config: config3 } = Visualization;
  const { themes: themes3 } = config3;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes3 == null ? void 0 : themes3.defaultBackgroundColor) == null ? void 0 : _a.call(themes3, props);
    const icon = (_b = config3.placeholderIcon) != null ? _b : config3.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config3.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// src/common/utils/dataUtils.ts
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport32 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport33 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// src/common/utils/trellisUtils.ts
var AGGREGATIONS = "aggregations";
var dataSourcesSplitByAggregationsUnknown = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let errorCode = null;
  if (fields && fields.length) {
    splitDataSources = {};
    for (let i = 0; i < fields.length; i += 1) {
      const fieldName = fields[i].name;
      if (!(fieldName == null ? void 0 : fieldName.startsWith("_"))) {
        splitDataSources[fieldName] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[fieldName].primary.data.fields = [fields[i]];
        splitDataSources[fieldName].primary.data.columns = [columns[i]];
      }
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var toFieldEntries = (fields) => {
  return fields.map((field) => {
    if (typeof field === "string") {
      return { name: field };
    }
    return field;
  });
};
var dataSourcesSplitByAggregationsTimechartAndChart = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = toFieldEntries((_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields);
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
  }
  if (splitByFields && splitByFields.length > 0) {
    splitDataSources = {};
    splitByFields.forEach((splitByField) => {
      splitDataSources[splitByField] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[splitByField].primary.data.fields = [fields[0]];
      splitDataSources[splitByField].primary.data.columns = [columns[0]];
      fields.forEach((field, idx) => {
        const fieldName = field == null ? void 0 : field.name;
        if (fieldName !== "_time" && !(fieldName == null ? void 0 : fieldName.startsWith("_")) && field.data_source === splitByField) {
          splitDataSources[splitByField].primary.data.fields.push(field);
          splitDataSources[splitByField].primary.data.columns.push(columns[idx]);
        }
      });
    });
  } else if ((!splitByFields || !splitByFields.length) && fields.length > 1) {
    splitDataSources = {};
    for (let i = 1; i < fields.length; i += 1) {
      const fieldName = fields[i].name;
      if (!(fieldName == null ? void 0 : fieldName.startsWith("_"))) {
        splitDataSources[fieldName] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[fieldName].primary.data.fields = [fields[0], fields[i]];
        splitDataSources[fieldName].primary.data.columns = [columns[0], columns[i]];
      }
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByAggregationsStats = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractDataSourceAggregationKeysStats)(fields);
  }
  if (splitByFields && splitByFields.length > 0) {
    splitDataSources = {};
    splitByFields.forEach((splitByField) => {
      splitDataSources[splitByField] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[splitByField].primary.data.fields = [fields[0]];
      splitDataSources[splitByField].primary.data.columns = [columns[0]];
      const idx = fields.findIndex((field) => field.name === splitByField);
      if (idx > 0) {
        splitDataSources[splitByField].primary.data.fields.push(fields[idx]);
        splitDataSources[splitByField].primary.data.columns.push(columns[idx]);
      }
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeTimechart = (dataSource, splitBy) => {
  var _a, _b, _c, _d, _e;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractSplitByFieldsChartFields)(fields);
  }
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    splitDataSources = {};
    const dataSourceKeys = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
    const valueKeys = [];
    for (let i = 1; i < fields.length; i += 1) {
      if (!((_e = fields[i].name) == null ? void 0 : _e.startsWith("_"))) {
        valueKeys.push(fields[i].splitby_value ? fields[i].splitby_value : fields[i].name);
      }
    }
    valueKeys.forEach((val) => {
      splitDataSources[val] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[val].primary.data.fields = [
        { name: fields[0].name },
        ...dataSourceKeys.map((k) => ({
          name: k
        }))
      ];
      splitDataSources[val].primary.data.columns = [[...columns[0]]];
      dataSourceKeys.forEach((dsKey) => {
        fields.forEach((field, idx) => {
          if (field.data_source === dsKey && (field.splitby_value === val || field.name === val)) {
            splitDataSources[val].primary.data.columns.push([...columns[idx]]);
          }
        });
      });
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeChart = (dataSource, splitBy) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractSplitByFieldsChartFields)(fields);
  }
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    splitDataSources = {};
    const splitByFieldIdx = splitByFields.findIndex((f) => f === splitBy);
    const otherSplitBy = splitByFields.filter((f) => f !== splitBy);
    const dataSourceKeys = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
    const nonDataSourceAggregations = [];
    if (!dataSourceKeys.length && fields[0].groupby_rank === "0" && fields.length && !fields[1].groupby_rank) {
      for (let i = 1; i < fields.length; i += 1) {
        nonDataSourceAggregations.push(fields[i].name);
      }
    }
    if (splitByFieldIdx === 0) {
      const valueKeys = (0, lodash_exports.cloneDeep)(columns[0]);
      valueKeys.forEach((val, idx) => {
        splitDataSources[val] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[val].primary.data.fields = [];
        if (otherSplitBy.length) {
          splitDataSources[val].primary.data.fields = [{ name: otherSplitBy[0] }];
        }
        if (dataSourceKeys.length) {
          const columnValues = [[]];
          splitDataSources[val].primary.data.fields = [
            ...splitDataSources[val].primary.data.fields,
            ...dataSourceKeys.map((k) => ({
              name: k
            }))
          ];
          dataSourceKeys.forEach(() => {
            columnValues.push([]);
          });
          for (let i = 1; i <= Math.ceil((fields.length - 1) / dataSourceKeys.length); i += 1) {
            columnValues[0].push(
              fields[i].splitby_value ? fields[i].splitby_value : fields[i].name
            );
            dataSourceKeys.forEach((dskey, dsIndx) => {
              const mul = (fields.length - 1) / dataSourceKeys.length;
              columnValues[dsIndx + 1].push(columns[i + dsIndx * mul][idx]);
            });
          }
          splitDataSources[val].primary.data.columns = columnValues;
        } else if (nonDataSourceAggregations.length) {
          const columnValues = [];
          fields.forEach((aggregationField, fieldIdx) => {
            if (fieldIdx > 0) {
              splitDataSources[val].primary.data.fields.push(aggregationField);
              columnValues.push([columns[fieldIdx][idx]]);
            }
          });
          splitDataSources[val].primary.data.columns = columnValues;
        }
      });
    } else {
      const valueKeys = [];
      for (let i = 1; i < fields.length; i += 1) {
        valueKeys.push(fields[i].splitby_value ? fields[i].splitby_value : fields[i].name);
      }
      valueKeys.forEach((val) => {
        splitDataSources[val] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[val].primary.data.fields = [
          { name: otherSplitBy[0] },
          ...dataSourceKeys.map((k) => ({
            name: k
          }))
        ];
        splitDataSources[val].primary.data.columns = [[...columns[0]]];
        dataSourceKeys.forEach((dsKey) => {
          fields.forEach((field, idx) => {
            if (field.data_source === dsKey && (field.splitby_value === val || field.name === val)) {
              splitDataSources[val].primary.data.columns.push([...columns[idx]]);
            }
          });
        });
      });
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeStatsorUnknown = (dataSource, splitBy, splitMode) => {
  var _a, _b, _c, _d, _e, _f;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = splitMode !== trellisUtils_exports.UNKNOWN ? (0, trellisUtils_exports.extractSplitByFieldsForStats)(fields) : (0, trellisUtils_exports.extractSplitByFieldsForUnknown)(fields);
  }
  const splitByIndex = fields == null ? void 0 : fields.findIndex(
    (field) => field === splitBy || field.name === splitBy
  );
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    const splitByColumn = (_f = (_e = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _e.data) == null ? void 0 : _f.columns[splitByIndex];
    splitDataSources = {};
    splitByColumn.forEach((val, idx) => {
      if (!splitDataSources[val]) {
        splitDataSources[val] = [idx];
      } else {
        splitDataSources[val].push(idx);
      }
    });
    const cloneFields = (0, lodash_exports.cloneDeep)(fields);
    cloneFields.splice(splitByIndex, 1);
    const valueKeys = Object.keys(splitDataSources);
    valueKeys.forEach((val) => {
      const valIndices = (0, lodash_exports.cloneDeep)(splitDataSources[val]);
      splitDataSources[val] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[val].primary.data.fields = cloneFields;
      splitDataSources[val].primary.data.columns = [];
      columns.forEach((col, idx) => {
        if (idx !== splitByIndex) {
          const newCol = valIndices.map((valIdx) => col[valIdx]);
          splitDataSources[val].primary.data.columns.push(newCol);
        }
      });
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var getTrellisDataSourcesBySplitMode = (splitMode, dataSources, trellisSplitBy) => {
  let result = null;
  try {
    if (splitMode === trellisUtils_exports.TIMECHART) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsTimechartAndChart(dataSources) : dataSourcesSplitByModeTimechart(dataSources, trellisSplitBy);
    } else if (splitMode === trellisUtils_exports.STATS) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsStats(dataSources) : dataSourcesSplitByModeStatsorUnknown(dataSources, trellisSplitBy, trellisUtils_exports.STATS);
    } else if (splitMode === trellisUtils_exports.CHART) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsTimechartAndChart(dataSources) : dataSourcesSplitByModeChart(dataSources, trellisSplitBy);
    } else if (splitMode === trellisUtils_exports.UNKNOWN) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsUnknown(dataSources) : dataSourcesSplitByModeStatsorUnknown(dataSources, trellisSplitBy, trellisUtils_exports.UNKNOWN);
    }
  } catch (ex) {
    console.error("getTrellisDataSourcesBySplitMode ", ex);
    result = { splitDataSources: null, errorCode: "UNKNOWN" };
  }
  return result;
};
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};
var calculateSharedMinMax = (splitData) => {
  let max = -Infinity;
  let min = Infinity;
  Object.keys(splitData).forEach((splitByKey) => {
    const datasources = splitData[splitByKey];
    Object.keys(datasources).forEach((datasourceName) => {
      const dataColumns = datasources[datasourceName].data.columns;
      dataColumns.forEach((column) => {
        column.forEach((point) => {
          const pointNumber = Number(point);
          if (pointNumber > max) {
            max = pointNumber;
          }
          if (pointNumber < min) {
            min = pointNumber;
          }
        });
      });
    });
  });
  return [min, max];
};
var determineMinMax = (splitData, trellisSharedScale, yAxisMin, yAxisMax, stackMode) => {
  if (!trellisSharedScale || stackMode === "stacked100" || yAxisMin !== "auto" && yAxisMax !== "auto")
    return [yAxisMin, yAxisMax];
  const [sharedMin, sharedMax] = calculateSharedMinMax(splitData);
  const shouldUseSharedMax = sharedMax !== -Infinity && yAxisMax === "auto";
  const shouldUseSharedMin = sharedMin !== Infinity && yAxisMin === "auto";
  return [shouldUseSharedMin ? sharedMin : yAxisMin, shouldUseSharedMax ? sharedMax : yAxisMax];
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval: computeVizPropsBeforeEval2 = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn2 = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn2 && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval2(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport34 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport35 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport36 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport37 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport37 ? defaultImport37.default : defaultImport37;

// src/common/editorConfig/StaticMajorAndTrendLayout.js
var StaticMajorAndTrendLayout = [
  [
    {
      label: (0, i18n_exports._)("Unit position"),
      // todo: we need a new editor combining unit and position
      option: "unitPosition",
      editor: "editor.select",
      editorProps: {
        values: [
          { label: (0, i18n_exports._)("Before"), value: "before" },
          { label: (0, i18n_exports._)("After"), value: "after" }
        ]
      },
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    },
    {
      label: (0, i18n_exports._)("Unit label"),
      option: "unit",
      editor: "editor.text",
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Precision"),
      option: "numberPrecision",
      editor: "editor.number",
      editorProps: {
        min: 0,
        max: 20
      },
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    }
  ]
];
var StaticMajorAndTrendLayout_default = StaticMajorAndTrendLayout;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config3) => {
      return __spreadProps(__spreadValues({}, config3), { open: config3.open || false });
    }
  );
  return enhancedConfig;
}
function hasCompatibleContexts(vizContext, presetContext) {
  const presetContextKeys = Object.keys(presetContext);
  return presetContextKeys.every(
    (contextKey) => presetContext[contextKey] === void 0 && vizContext[contextKey] === void 0 || presetContext[contextKey] !== void 0 && vizContext[contextKey] !== void 0
  );
}
function hasCompatibleOptions(vizOptions, presetOptions) {
  const presetOptionKeys = Object.keys(presetOptions);
  return presetOptionKeys.every(
    (optionKey) => (0, configUtils_exports.isDynamicOption)(presetOptions[optionKey]) === (0, configUtils_exports.isDynamicOption)(vizOptions[optionKey])
  );
}
function getInitialPreset(vizContext, vizOptions, presets2) {
  return presets2.find((preset) => {
    const presetContext = (0, lodash_exports.get)(preset, ["value", "context"], {});
    const presetOptions = (0, lodash_exports.get)(preset, ["value", "options"], {});
    const presetContextKeys = Object.keys(presetContext);
    const presetOptionKeys = Object.keys(presetOptions);
    if (presetContextKeys.length === 0 || presetOptionKeys.length === 0) return false;
    return hasCompatibleContexts(vizContext, presetContext) && hasCompatibleOptions(vizOptions, presetOptions);
  });
}

// src/common/editorConfig/DynamicMajorColorAndGaugeEditor.js
var getDynamicMajorColorAndGaugeEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Major value and gauge"),
  option: "majorColor",
  context: "majorColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.majorColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: major value"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          majorValue: defaultContext2.majorColorConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Major value"),
        value: "majorValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/DynamicTrendColorEditor.js
var getDynamicTrendColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Trend value"),
  option: "trendColor",
  context: "trendColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.trendColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: trend value"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          trendValue: defaultContext2.trendColorConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Trend value"),
        value: "trendValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/DynamicBackgroundColorEditor.js
var getDynamicBackgroundColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Background color"),
  option: "backgroundColor",
  context: "backgroundColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.backgroundColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: background"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          majorValue: defaultContext2.majorColorConfig,
          trendValue: defaultContext2.trendColorConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          majorValue: defaultContext2.majorColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Major Value"),
        value: "majorValue"
      },
      {
        label: (0, i18n_exports._)("Trend"),
        value: "trendValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/StaticMajorColorEditor.js
var StaticMajorColorEditor = {
  label: (0, i18n_exports._)("Major value"),
  option: "majorColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.majorColor)
};
var StaticMajorColorEditor_default = StaticMajorColorEditor;

// src/common/editorConfig/StaticTrendColorEditor.js
var StaticTrendColorEditor = {
  label: (0, i18n_exports._)("Trend value"),
  option: "trendColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.trendColor),
  isDisabled: ({ options }) => options.trendDisplay === "off"
};
var StaticTrendColorEditor_default = StaticTrendColorEditor;

// src/common/editorConfig/StaticBackgroundColorEditor.js
var StaticBackgroundColorEditor = {
  label: (0, i18n_exports._)("Background color"),
  option: "backgroundColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.backgroundColor)
};
var StaticBackgroundColorEditor_default = StaticBackgroundColorEditor;

// src/common/editorConfig/RadialBackgroundColor.ts
var radialBackground = ({ label, themes: themes3, labelPosition }) => [
  {
    label: (0, i18n_exports._)(label || "Radial background"),
    option: "radialBackgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes3
    }
  }
];
var RadialBackgroundColor_default = radialBackground;

// src/common/editorConfig/TrellisEditors.ts
var isTrellisFeatureFlagOn = ({ featureFlags }) => {
  return Boolean(featureFlags == null ? void 0 : featureFlags.visualizations_enableTrellis);
};
var isTrellisEnabled = ({ options, featureFlags }) => {
  const { splitByLayout = visualization_schemas_exports.LAYOUT_TYPE.Off } = options;
  return isTrellisFeatureFlagOn({ featureFlags }) && splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};
var TrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Split by"),
      option: "trellisSplitBy",
      editor: "editor.trellisSplitBy",
      editorProps: {
        dataSourceKey: "primary"
      },
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Number of columns"),
      option: "trellisColumns",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      placeholder: (0, i18n_exports._)("Auto"),
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Min column width"),
      option: "trellisMinColumnWidth",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    },
    {
      label: (0, i18n_exports._)("Row height"),
      option: "trellisRowHeight",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Max number of components per page"),
      option: "trellisPageCount",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    }
  ]
];
var TimechartTrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn,
      // add help text for timecharts
      editorProps: {
        help: (0, i18n_exports._)(
          "Y2-axis and overlay field configurations are not supported when trellis is enabled."
        ),
        helpFormat: "under"
      }
    }
  ],
  ...TrellisEditorConfig.slice(1),
  [
    {
      label: (0, i18n_exports._)("Shared y-axis scale"),
      option: "trellisSharedScale",
      editor: "editor.checkbox",
      showEditor: isTrellisEnabled
    }
  ]
];
var TrellisBackgroundColorEditor = {
  label: (0, i18n_exports._)("Trellis background"),
  option: "trellisBackgroundColor",
  editor: "editor.color",
  showEditor: isTrellisEnabled
};

// src/SingleValueRadial/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 250,
  initialHeight: 250
};
var defaultContext = {
  majorColorConfig: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ],
  majorColorMatchConfig: [{ match: "", value: "#5C33FF" }],
  trendColorConfig: [
    {
      to: 0,
      value: "#9E2520"
    },
    {
      from: 0,
      value: "#1C6B2D"
    }
  ],
  trendValueCopy: "> trendValue",
  divisor: "> majorValue | subtract(trendValueCopy) | divideBy(100)",
  trendValuePercent: "> trendValue | divideBy(divisor)"
};
var basePresetContext = {
  majorColorEditorConfig: void 0,
  trendColorEditorConfig: void 0,
  backgroundColorEditorConfig: void 0
};
var basePresetOptions = {
  majorColor: void 0,
  trendColor: void 0,
  backgroundColor: void 0
};
var presets = [
  {
    // dummy context variables to allow for resetting of unused context states
    label: (0, i18n_exports._)("None"),
    name: "singleValueRadial.none",
    value: {
      context: __spreadValues({}, basePresetContext),
      options: __spreadValues({}, basePresetOptions)
    }
  },
  {
    label: (0, i18n_exports._)("Major value and gauge"),
    name: "singleValueRadial.majorValue",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        majorColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        majorColor: "> majorValue | rangeValue(majorColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Major value, trend value, and gauge"),
    name: "singleValueRadial.majorValueAndTrend",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        majorColorEditorConfig: defaultContext.majorColorConfig,
        trendColorEditorConfig: defaultContext.trendColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        majorColor: "> majorValue | rangeValue(majorColorEditorConfig)",
        trendColor: "> trendValue | rangeValue(trendColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Trend value"),
    name: "singleValueRadial.trend",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        trendColorEditorConfig: defaultContext.trendColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        trendColor: "> trendValue | rangeValue(trendColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Background"),
    name: "singleValueRadial.background",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        backgroundColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        backgroundColor: "> majorValue | rangeValue(backgroundColorEditorConfig)"
      })
    }
  }
];
var themes = {
  defaultFontColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.white(props),
      light: variables_default.black(props)
    },
    prisma: variables_default.contentColorActive(props)
  })(props),
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.white(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  defaultRadialBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: "rgba(255, 255, 255, 0.15)",
      light: "rgba(0, 0, 0, 0.1)"
    },
    prisma: variables_default.interactiveColorBackgroundDisabled(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data configurations"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Value"),
          editor: "editor.columnSelector",
          option: "majorValue",
          context: "valuesContext",
          editorProps: {
            dataSourceKey: "primary",
            prepareValue: (definition) => {
              const {
                options: { majorValue: baseSPL }
              } = definition;
              return {
                context: {},
                options: {
                  majorValue: `${baseSPL} | lastPoint()`,
                  trendValue: `${baseSPL} | delta(-2)`
                }
              };
            }
          },
          isDisabled: ({ options }) => options.splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      ...StaticMajorAndTrendLayout_default,
      [
        {
          label: (0, i18n_exports._)("Trend display"),
          option: "trendDisplay",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Percent"), value: "percent" },
              { label: (0, i18n_exports._)("Absolute"), value: "absolute" },
              { label: (0, i18n_exports._)("Off"), value: "off" }
            ]
          },
          showEditor: ({ options }) => options.showValue || options.showValue === void 0
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Min"),
          option: "minValue",
          editor: "editor.number"
        },
        {
          label: (0, i18n_exports._)("Max"),
          option: "maxValue",
          editor: "editor.number"
        }
      ],
      ...TrellisEditorConfig
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Dynamic elements"),
          key: "presetSelector",
          editor: "editor.presetSelector",
          editorProps: {
            presets,
            value: ({ context, options }) => {
              const initialPreset = getInitialPreset(context, options, presets);
              return initialPreset && initialPreset.label || null;
            }
          }
        }
      ],
      [
        __spreadProps(__spreadValues({}, StaticMajorColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicMajorColorAndGaugeEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        __spreadProps(__spreadValues({}, StaticTrendColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicTrendColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        {
          label: (0, i18n_exports._)("Major value abbreviation"),
          option: "shouldAbbreviateMajorValue",
          editor: "editor.checkbox"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Trend value abbreviation"),
          option: "shouldAbbreviateTrendValue",
          editor: "editor.checkbox"
        }
      ],
      RadialBackgroundColor_default({ themes }),
      [
        __spreadProps(__spreadValues({}, StaticBackgroundColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [
        __spreadProps(__spreadValues({}, TrellisBackgroundColorEditor), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicBackgroundColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        {
          label: (0, i18n_exports._)("Show gauge ranges"),
          option: "isGaugeOn",
          editor: "editor.toggle",
          showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.majorColor)
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.singlevalueradial",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Single value radial"),
  category: "Single Value" /* SINGLE_VALUE */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.SingleValueRadial,
  placeholderIcon: placeholders_exports.SingleValueRadial,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.singleValueRadialOptionsSchema,
  editorConfig,
  events: {
    "value.click": {
      description: "trigger when user clicks major value",
      payloadKeys: ["majorValue", "trendValue"]
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */, "trellis" /* TRELLIS */],
  themes
};
var config_default = enhanceConfig(config);

// esm-externals:@splunk/react-ui/Paginator
var Paginator_exports = {};
__export(Paginator_exports, {
  default: () => Paginator_default
});
var defaultImport38 = __toESM(require("@splunk/react-ui/Paginator"));
__reExport(Paginator_exports, require("@splunk/react-ui/Paginator"));
var Paginator_default = "default" in defaultImport38 ? defaultImport38.default : defaultImport38;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport39 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport39 ? defaultImport39.default : defaultImport39;

// esm-externals:@splunk/themes/useSplunkTheme
var useSplunkTheme_exports = {};
__export(useSplunkTheme_exports, {
  default: () => useSplunkTheme_default
});
var defaultImport40 = __toESM(require("@splunk/themes/useSplunkTheme"));
__reExport(useSplunkTheme_exports, require("@splunk/themes/useSplunkTheme"));
var useSplunkTheme_default = "default" in defaultImport40 ? defaultImport40.default : defaultImport40;

// src/common/hocs/withTrellis.tsx
var TrellisContainer = styled_components_default.div`
    overflow: hidden;
    display: flex;
    flex-direction: column;
    background-color: ${(props) => props.backgroundColor};
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
    > [data-test='paginator'] {
        align-self: flex-end;
        margin-bottom: 10px;
    }
`;
var TrellisContainerGrid = styled_components_default.div`
    display: grid;
    height: ${(props) => {
  return `${props.height}px`;
}};
    gap: 10px 10px;
    grid-template-columns: ${(props) => {
  return props.colCount ? `repeat(${props.colCount}, minmax(${props.colMinWidth}px, 1fr))` : `repeat(auto-fit, minmax(${props.colMinWidth}px, 1fr))`;
}};
    overflow: auto;
    justify-items: stretch;
    grid-auto-rows: ${(props) => `${props.rowHeight}px`};
    .child {
        height: ${(props) => `${props.rowHeight}px`};
    }
`;
var showErrorMessage = (errorCode, width, height) => {
  if (errorCode === "INVALID_SPLIT_BY_FIELD") {
    return /* @__PURE__ */ react_exports.createElement(
      Message_default,
      {
        width,
        height,
        message: (0, i18n_exports._)("Select a valid trellis split by field"),
        level: "info"
      }
    );
  }
  if (errorCode === "UNKNOWN_DATA_SPLIT_MODE") {
    return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, message: (0, i18n_exports._)("Unknown data split mode"), level: "info" });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, message: (0, i18n_exports._)("Error render in trellis"), level: "info" });
};
var withTrellis = (Viz) => {
  const VizWithTrellis = (opts) => {
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(opts.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(opts.height));
    const _a = opts, { options = {}, height, width } = _a, otherProps = __objRest(_a, ["options", "height", "width"]);
    const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(Viz.config.optionsSchema, "default");
    const mergedOptions = (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)({}, options, defaultOptions);
    const {
      trellisColumns,
      trellisPageCount,
      trellisMinColumnWidth,
      trellisRowHeight,
      splitByLayout,
      trellisSplitBy,
      trellisSharedScale,
      stackMode,
      yAxisMin,
      yAxisMax
    } = mergedOptions;
    const colCount = trellisColumns > 0 ? trellisColumns : defaultOptions.trellisColumns;
    const pageCount = +trellisPageCount > 0 ? +trellisPageCount : defaultOptions.trellisPageCount;
    const colMinWidth = trellisMinColumnWidth > 0 ? trellisMinColumnWidth : defaultOptions.trellisMinColumnWidth;
    const rowHeight = trellisRowHeight > 0 ? trellisRowHeight : defaultOptions.trellisRowHeight;
    const [pageNum, setPageNum] = (0, react_exports.useState)(1);
    const [pagedData, setPagedData] = (0, react_exports.useState)(null);
    let splitByKeys = [];
    let totalPages = 0;
    let showPaginator = false;
    const { dataSources } = otherProps;
    const theme = {
      splunkThemeV1: useSplunkTheme_default()
    };
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = (0, themes_exports.getSettingsFromThemedProps)({ theme });
    const trellisBackgroundColor = (0, react_exports.useMemo)(() => {
      const themeFunc = (themeVar) => {
        var _a2, _b;
        return (_b = (_a2 = Viz.config.themes)[themeVar]) == null ? void 0 : _b.call(_a2, {
          trellisBackgroundColor: mergedOptions.trellisBackgroundColor,
          theme
        });
      };
      const evaluated = Options_exports.Options.evaluate(
        {
          context: Viz.config.context,
          options: { trellisBackgroundColor: mergedOptions.trellisBackgroundColor }
        },
        {},
        themeFunc
      );
      return evaluated.trellisBackgroundColor;
    }, [
      mergedOptions.trellisBackgroundColor,
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity
    ]);
    const columns = (0, lodash_exports.get)(dataSources, "primary.data.columns", void 0);
    const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields", void 0);
    const noColumns = columns === void 0;
    const noFields = fields === void 0;
    const updateDataDisplay = (currPage) => {
      if (!showPaginator) {
        setPagedData(splitByKeys);
        setPageNum(1);
      } else {
        const startIdx = pageCount * (currPage - 1);
        const paged = splitByKeys.slice(startIdx, startIdx + pageCount);
        setPagedData(paged);
      }
    };
    (0, react_exports.useEffect)(() => {
      setPageNum(1);
      updateDataDisplay(1);
    }, [pageCount, trellisSplitBy]);
    (0, react_exports.useEffect)(() => {
      updateDataDisplay(pageNum);
    }, [columns, fields, trellisSplitBy, pageNum, splitByLayout]);
    const handlePageChange = (0, react_exports.useCallback)(
      (event, { page }) => {
        setPageNum(page);
      },
      [pageNum, pagedData]
    );
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const isTrellisFeatureFlagOn2 = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    if (!isTrellisFeatureFlagOn2 || !splitByLayout || splitByLayout !== visualization_schemas_exports.LAYOUT_TYPE.Trellis) {
      return /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, opts));
    }
    if (splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis) {
      if (noColumns || noFields) {
        return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, message: (0, i18n_exports._)("Loading"), level: "info" });
      }
      let currTrellisSplitBy = trellisSplitBy;
      if (!trellisSplitBy || trellisSplitBy.length === 0) {
        const splitByPossibleFields = (0, trellisUtils_exports.getAllPossibleSplitByFields)(fields);
        currTrellisSplitBy = splitByPossibleFields.fields && splitByPossibleFields.fields.length ? splitByPossibleFields.fields[0] : AGGREGATIONS;
      }
      const splitMode = (0, trellisUtils_exports.getTrellisDataSplitterMode)(fields);
      const dataSplitResult = getTrellisDataSourcesBySplitMode(
        splitMode,
        dataSources,
        currTrellisSplitBy
      );
      const modifiedDataSourceBySplitBy = dataSplitResult == null ? void 0 : dataSplitResult.splitDataSources;
      const dataSplitErrorCode = dataSplitResult == null ? void 0 : dataSplitResult.errorCode;
      if (!modifiedDataSourceBySplitBy || Object.keys(modifiedDataSourceBySplitBy).length === 0 || dataSplitErrorCode) {
        return showErrorMessage(dataSplitErrorCode, width, height);
      }
      const splitByKeysModified = modifiedDataSourceBySplitBy ? Object.keys(modifiedDataSourceBySplitBy) : [];
      if (splitByKeysModified) {
        showPaginator = splitByKeysModified.length > pageCount;
        splitByKeys = splitByKeysModified;
        totalPages = splitByKeysModified ? Math.ceil(splitByKeysModified.length / pageCount) : 0;
      }
      const [calculatedMin, calculatedMax] = determineMinMax(
        modifiedDataSourceBySplitBy,
        trellisSharedScale,
        yAxisMin,
        yAxisMax,
        stackMode
      );
      return /* @__PURE__ */ react_exports.createElement(TrellisContainer, { height, width, backgroundColor: trellisBackgroundColor }, /* @__PURE__ */ react_exports.createElement(
        TrellisContainerGrid,
        {
          height,
          colCount,
          colMinWidth,
          rowHeight
        },
        pagedData == null ? void 0 : pagedData.map((splitByKey, idx) => /* @__PURE__ */ react_exports.createElement(
          "div",
          {
            className: "child",
            "data-test": "trellis-child",
            key: `div-child-${idx.toString()}`
          },
          /* @__PURE__ */ react_exports.createElement(
            SizeAwareWrapper_default,
            {
              width,
              height,
              onResize: cachedHandleResize
            }
          ),
          /* @__PURE__ */ react_exports.createElement(
            Viz,
            __spreadProps(__spreadValues({}, otherProps), {
              trellisKey: splitByKey,
              trellisSplitBy: currTrellisSplitBy,
              dataSources: modifiedDataSourceBySplitBy[splitByKey],
              options: __spreadProps(__spreadValues({}, options), {
                yAxisMin: calculatedMin,
                yAxisMax: calculatedMax
              }),
              key: `viz-${idx.toString()}`,
              height: containerHeight,
              width: containerWidth
            })
          )
        ))
      ), showPaginator && totalPages >= pageNum && /* @__PURE__ */ react_exports.createElement(
        Paginator_default,
        {
          onChange: handlePageChange,
          current: pageNum,
          alwaysShowLastPageLink: true,
          totalPages
        }
      ));
    }
    return null;
  };
  VizWithTrellis.propTypes = Viz.proptypes;
  VizWithTrellis.defaultProps = Viz.defaultProps;
  VizWithTrellis.config = Viz.config;
  return VizWithTrellis;
};
var withTrellis_default = withTrellis;

// src/SingleValueRadial/SingleValueRadial.tsx
var config2 = config_default;
var PureSingleValueRadial = SingleValueRadial_default;
var PureSingleValueRadialThemes = {};
var computeVizProps = (_a) => {
  var _b = _a, { trellisKey } = _b, props = __objRest(_b, ["trellisKey"]);
  return __spreadValues({ trellisKey }, props);
};
var computeVizPropsBeforeEval = (options) => {
  const trendColor = getTrendColorWithPercent(options);
  return __spreadValues({}, trendColor);
};
var viz = withTrellis_default(
  withDashboardViz_default({
    ReactViz: SingleValueRadial_default,
    vizConfig: config_default,
    computeVizProps,
    computeVizPropsBeforeEval
  })
);
var { themes: themes2 } = config_default;
var SingleValueRadial_default2 = viz;
//# sourceMappingURL=SingleValueRadial.js.map
