/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Table/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport2 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport4 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport5 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport7 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport8 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/react-icons/TextAlignCenter
var TextAlignCenter_exports = {};
__export(TextAlignCenter_exports, {
  default: () => TextAlignCenter_default
});
var defaultImport9 = __toESM(require("@splunk/react-icons/TextAlignCenter"));
__reExport(TextAlignCenter_exports, require("@splunk/react-icons/TextAlignCenter"));
var TextAlignCenter_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/react-icons/TextAlignLeft
var TextAlignLeft_exports = {};
__export(TextAlignLeft_exports, {
  default: () => TextAlignLeft_default
});
var defaultImport10 = __toESM(require("@splunk/react-icons/TextAlignLeft"));
__reExport(TextAlignLeft_exports, require("@splunk/react-icons/TextAlignLeft"));
var TextAlignLeft_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/react-icons/TextAlignRight
var TextAlignRight_exports = {};
__export(TextAlignRight_exports, {
  default: () => TextAlignRight_default
});
var defaultImport11 = __toESM(require("@splunk/react-icons/TextAlignRight"));
__reExport(TextAlignRight_exports, require("@splunk/react-icons/TextAlignRight"));
var TextAlignRight_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}
function generatePrecisionValues(numPrecisionValues) {
  return (0, lodash_exports.range)(0, numPrecisionValues + 1).map(
    (i) => ({
      label: `${i} (0${i > 0 ? "." : ""}${"0".repeat(i)})`,
      // e.g. 0.000 for numPrecisionValues = 3
      value: i
    })
  );
}

// src/Table/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [],
  initialRequestParams: {
    primary: (options = {}) => ({
      offset: 0,
      count: options.count ? options.count : 10,
      requestTotalCount: true
    })
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {
  tableAlignByType: [
    { match: "string", value: "left" },
    { match: "number", value: "right" },
    { match: "time", value: "left" },
    { match: "color", value: "left" },
    { match: "array", value: "left" },
    { match: "sparkline", value: "center" },
    { match: "unknown", value: "left" },
    { match: "null", value: "left" }
  ],
  tableCellTypeByType: [
    { match: "string", value: "TextCell" },
    { match: "number", value: "TextCell" },
    { match: "time", value: "TextCell" },
    { match: "color", value: "TextCell" },
    { match: "array", value: "ArrayCell" },
    { match: "sparkline", value: "SparklineCell" },
    { match: "unknown", value: "TextCell" },
    { match: "null", value: "TextCell" }
  ],
  // NOTE: These contexts are used by the table background color editor.
  // Please be careful removing/renaming/altering them.
  // There are unit tests and visual test that will capture breakages.
  tableRowColorMaxContrast: {
    colors: ["> themes.textColor", "> themes.inverseTextColor"],
    default: "> themes.textColor"
  },
  tableRowBackgroundColorEvenConfig: {
    channel: "hsv.v",
    value: "*0.96"
  },
  tableHeaderBackgroundColorConfig: {
    channel: "hsv.v",
    value: "*0.9"
  },
  tableRowBackgroundColorsByTheme: ["> themes.rowBackgroundColorOdd"],
  tableAltRowBackgroundColorsByTheme: ["> themes.rowBackgroundColorOdd", "> themes.rowBackgroundColorEven"],
  tableRowBackgroundColorsByBackgroundColor: ["> backgroundColor"],
  tableAltRowBackgroundColorsByBackgroundColor: [
    "> backgroundColor",
    "> backgroundColor | setColorChannel(tableRowBackgroundColorEvenConfig)"
  ]
};
var headerAlignConfigTable = {
  label: (0, i18n_exports._)("Header alignment"),
  editor: "editor.radioBar",
  option: "tableFormat.headerAlign",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
};
var headerAlignConfigColumn = __spreadProps(__spreadValues({}, headerAlignConfigTable), {
  option: "headerAlign",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Auto"), value: "auto" },
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
});
var textOverflowConfigColumn = {
  label: (0, i18n_exports._)("Text wrapping"),
  editor: "editor.radioBar",
  option: "textOverflow",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Standard"), value: "break-word" },
      { label: (0, i18n_exports._)("Anywhere"), value: "anywhere" },
      { label: (0, i18n_exports._)("Trim"), value: "ellipsis" }
    ]
  }
};
var textAlignConfigTable = {
  label: (0, i18n_exports._)("Cells alignment"),
  editor: "editor.radioBar",
  option: "tableFormat.align",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Auto"), value: "> table | type() | matchValue(tableAlignByType)" },
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
};
var textAlignConfigColumn = __spreadProps(__spreadValues({}, textAlignConfigTable), {
  option: "align",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Auto"), value: "auto" },
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
});
var unitPositionConfig = {
  label: (0, i18n_exports._)("Units position"),
  editor: "editor.select",
  option: "unitPosition",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Before"), value: "before" },
      { label: (0, i18n_exports._)("After"), value: "after" }
    ]
  }
};
var unitLabelConfig = {
  label: (0, i18n_exports._)("Unit label"),
  option: "unit",
  editor: "editor.text"
};
var timeFormattingConfig = {
  label: (0, i18n_exports._)("Date & Time formatting"),
  option: "format",
  editor: "editor.text",
  editorProps: {
    tooltip: (0, i18n_exports._)("For example: DD-MM-YYYY")
  }
};
var sequentialColorConfig = [
  { to: 20, value: "#D41F1F" },
  { from: 20, to: 40, value: "#D94E17" },
  { from: 40, to: 60, value: "#CBA700" },
  { from: 60, to: 80, value: "#669922" },
  { from: 80, value: "#118832" }
];
var matchColorConfig = [{ match: "", value: "#5C33FF" }];
var themes = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  defaultHeaderBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.gray20(props),
      light: variables_default.gray92(props)
    },
    prisma: variables_default.backgroundColor(props)
  })(props),
  rowBackgroundColorEven: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.gray96(props)
    },
    prisma: variables_default.backgroundColorPage(props)
  })(props),
  rowBackgroundColorOdd: (props) => pick_default({
    enterprise: {
      dark: "#0D1012",
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  textColor: (props) => pick_default({
    enterprise: variables_default.textColor(props),
    prisma: variables_default.contentColorDefault(props)
  })(props),
  inverseTextColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.contentColorInverted(props),
      // equal to textColor in enterprise
      light: variables_default.white(props)
      // equal to textColor in enterpriseDark
    },
    prisma: variables_default.contentColorInverted(props)
  })(props)
};
var backgroundColorPaletteSet = /* @__PURE__ */ new Set([
  ...colorConstants_exports.COLOR_EDITOR_PALETTE,
  ...(0, lodash_exports.map)(themes, (t) => (0, lodash_exports.get)(t, "defaultBackgroundColor"))
]);
var EDITOR_LABEL_WIDTH = 100;
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Rows displayed"),
          option: "count",
          editor: "editor.number",
          editorProps: {
            min: 0,
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Row numbers"),
          option: "showRowNumbers",
          editor: "editor.checkbox",
          editorProps: {
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Internal fields"),
          option: "showInternalFields",
          editor: "editor.checkbox",
          editorProps: {
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Header row"),
          option: "headerVisibility",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Inline"), value: "inline" },
              { label: (0, i18n_exports._)("Fixed"), value: "fixed" },
              { label: (0, i18n_exports._)("Hidden"), value: "none" }
            ],
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          key: "backgroundColor",
          editor: "editor.tableBackgroundColor",
          editorProps: {
            themes,
            labelPosition: "top",
            labelWidth: EDITOR_LABEL_WIDTH,
            palette: [...backgroundColorPaletteSet]
          }
        }
      ],
      [
        {
          option: "font",
          label: (0, i18n_exports._)("Font"),
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Proportional (Default)"), value: "proportional" },
              { label: (0, i18n_exports._)("Monospace"), value: "monospace" }
            ],
            labelPosition: "top",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          option: "fontSize",
          label: (0, i18n_exports._)("Font size"),
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Extra Small (font 10px, row 24px)"), value: "extraSmall" },
              { label: (0, i18n_exports._)("Small (font 12px, row 24px)"), value: "small" },
              { label: (0, i18n_exports._)("Default (font 14px, row 32px)"), value: "default" },
              { label: (0, i18n_exports._)("Large (font 16px, row 36px)"), value: "large" }
            ],
            labelPosition: "top",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        __spreadValues({}, headerAlignConfigTable)
      ],
      [
        __spreadValues({}, textAlignConfigTable)
      ],
      [
        {
          label: (0, i18n_exports._)("Column-specific formatting"),
          editor: "editor.tableColumnFormatter",
          editorProps: {
            // popover: {sections: [textFormatConfig, formatByTypeConfig, columnColoringConfig]}
            // Table column coloring does not adhere to same DSL structure as other dynamically colored options
            // we use the FormatterEditor directly and not the DynamicColorEditor's provided DSL builders
            columnColoringConfig: {
              coloringTypes: [
                {
                  label: (0, i18n_exports._)("Text"),
                  value: "rowColors"
                },
                {
                  label: (0, i18n_exports._)("Background"),
                  value: "rowBackgroundColors"
                }
              ],
              formatters: [
                {
                  label: (0, i18n_exports._)("Ranges"),
                  value: "rangeValue",
                  defaults: {
                    rowBackgroundColors: sequentialColorConfig,
                    rowColors: sequentialColorConfig
                  }
                },
                {
                  label: (0, i18n_exports._)("Matches"),
                  value: "matchValue",
                  defaults: {
                    rowBackgroundColors: matchColorConfig,
                    rowColors: matchColorConfig
                  }
                }
              ],
              themes
            },
            defaultOptionsByType: {
              number: {
                thousandSeparated: false,
                unitPosition: "after"
              },
              string: {
                unitPosition: "after"
              },
              text: {
                align: "auto",
                headerAlign: "auto",
                textOverflow: "break-word"
              }
            },
            textFormatConfig: [
              [
                __spreadValues({}, headerAlignConfigColumn)
              ],
              [
                __spreadValues({}, textAlignConfigColumn)
              ],
              [
                __spreadValues({}, textOverflowConfigColumn)
              ]
            ],
            flyoutConfig: {
              number: [
                [
                  __spreadValues({}, unitPositionConfig),
                  __spreadValues({}, unitLabelConfig)
                ],
                [
                  {
                    label: (0, i18n_exports._)("Precision"),
                    option: "precision",
                    editor: "editor.select",
                    editorProps: {
                      values: generatePrecisionValues(20)
                    }
                  },
                  {
                    label: (0, i18n_exports._)("Thousand separators"),
                    option: "thousandSeparated",
                    editor: "editor.radioBar",
                    editorProps: {
                      values: [
                        { label: (0, i18n_exports._)("Off"), value: false },
                        { label: (0, i18n_exports._)("On"), value: true }
                      ]
                    }
                  }
                ]
              ],
              // TODO(fkurniawan): fill in with proper editor components
              sparkline: [],
              string: [
                [
                  __spreadValues({}, unitPositionConfig),
                  __spreadValues({}, unitLabelConfig)
                ]
              ],
              time: [
                [
                  __spreadValues({}, timeFormattingConfig)
                ]
              ]
            },
            value: ({ context, options }) => {
              return {
                context,
                columnFormat: options.columnFormat,
                tableFormat: options.tableFormat
              };
            }
          },
          key: "TableColumnFormatterEditor"
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.table",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Table"),
  category: "Table" /* TABLE */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Table,
  placeholderIcon: placeholders_exports.Table,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.tableOptionsSchema,
  editorConfig,
  events: {
    "cell.click": {
      description: "triggered when user clicks a table cell"
    }
  },
  supports: [
    "dynamic-options" /* DYNAMIC_OPTIONS */,
    "events" /* EVENTS */,
    "page-and-sort" /* PAGE_AND_SORT */,
    "placeholder" /* PLACEHOLDER */
  ],
  themes
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=Table.config.js.map
