/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// src/Table/index.ts
var Table_exports2 = {};
__export(Table_exports2, {
  PureTable: () => PureTable_default,
  computeVizProps: () => computeVizProps,
  config: () => config_default,
  default: () => Table_default2,
  themes: () => themes2
});
module.exports = __toCommonJS(Table_exports2);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport2 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport3 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport4 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport5 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport7 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport8 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport9 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/react-icons/TextAlignCenter
var TextAlignCenter_exports = {};
__export(TextAlignCenter_exports, {
  default: () => TextAlignCenter_default
});
var defaultImport10 = __toESM(require("@splunk/react-icons/TextAlignCenter"));
__reExport(TextAlignCenter_exports, require("@splunk/react-icons/TextAlignCenter"));
var TextAlignCenter_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/react-icons/TextAlignLeft
var TextAlignLeft_exports = {};
__export(TextAlignLeft_exports, {
  default: () => TextAlignLeft_default
});
var defaultImport11 = __toESM(require("@splunk/react-icons/TextAlignLeft"));
__reExport(TextAlignLeft_exports, require("@splunk/react-icons/TextAlignLeft"));
var TextAlignLeft_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/react-icons/TextAlignRight
var TextAlignRight_exports = {};
__export(TextAlignRight_exports, {
  default: () => TextAlignRight_default
});
var defaultImport12 = __toESM(require("@splunk/react-icons/TextAlignRight"));
__reExport(TextAlignRight_exports, require("@splunk/react-icons/TextAlignRight"));
var TextAlignRight_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport13 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}
function generatePrecisionValues(numPrecisionValues) {
  return (0, lodash_exports.range)(0, numPrecisionValues + 1).map(
    (i) => ({
      label: `${i} (0${i > 0 ? "." : ""}${"0".repeat(i)})`,
      // e.g. 0.000 for numPrecisionValues = 3
      value: i
    })
  );
}

// src/Table/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [],
  initialRequestParams: {
    primary: (options = {}) => ({
      offset: 0,
      count: options.count ? options.count : 10,
      requestTotalCount: true
    })
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {
  tableAlignByType: [
    { match: "string", value: "left" },
    { match: "number", value: "right" },
    { match: "time", value: "left" },
    { match: "color", value: "left" },
    { match: "array", value: "left" },
    { match: "sparkline", value: "center" },
    { match: "unknown", value: "left" },
    { match: "null", value: "left" }
  ],
  tableCellTypeByType: [
    { match: "string", value: "TextCell" },
    { match: "number", value: "TextCell" },
    { match: "time", value: "TextCell" },
    { match: "color", value: "TextCell" },
    { match: "array", value: "ArrayCell" },
    { match: "sparkline", value: "SparklineCell" },
    { match: "unknown", value: "TextCell" },
    { match: "null", value: "TextCell" }
  ],
  // NOTE: These contexts are used by the table background color editor.
  // Please be careful removing/renaming/altering them.
  // There are unit tests and visual test that will capture breakages.
  tableRowColorMaxContrast: {
    colors: ["> themes.textColor", "> themes.inverseTextColor"],
    default: "> themes.textColor"
  },
  tableRowBackgroundColorEvenConfig: {
    channel: "hsv.v",
    value: "*0.96"
  },
  tableHeaderBackgroundColorConfig: {
    channel: "hsv.v",
    value: "*0.9"
  },
  tableRowBackgroundColorsByTheme: ["> themes.rowBackgroundColorOdd"],
  tableAltRowBackgroundColorsByTheme: ["> themes.rowBackgroundColorOdd", "> themes.rowBackgroundColorEven"],
  tableRowBackgroundColorsByBackgroundColor: ["> backgroundColor"],
  tableAltRowBackgroundColorsByBackgroundColor: [
    "> backgroundColor",
    "> backgroundColor | setColorChannel(tableRowBackgroundColorEvenConfig)"
  ]
};
var headerAlignConfigTable = {
  label: (0, i18n_exports._)("Header alignment"),
  editor: "editor.radioBar",
  option: "tableFormat.headerAlign",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
};
var headerAlignConfigColumn = __spreadProps(__spreadValues({}, headerAlignConfigTable), {
  option: "headerAlign",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Auto"), value: "auto" },
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
});
var textOverflowConfigColumn = {
  label: (0, i18n_exports._)("Text wrapping"),
  editor: "editor.radioBar",
  option: "textOverflow",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Standard"), value: "break-word" },
      { label: (0, i18n_exports._)("Anywhere"), value: "anywhere" },
      { label: (0, i18n_exports._)("Trim"), value: "ellipsis" }
    ]
  }
};
var textAlignConfigTable = {
  label: (0, i18n_exports._)("Cells alignment"),
  editor: "editor.radioBar",
  option: "tableFormat.align",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Auto"), value: "> table | type() | matchValue(tableAlignByType)" },
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
};
var textAlignConfigColumn = __spreadProps(__spreadValues({}, textAlignConfigTable), {
  option: "align",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Auto"), value: "auto" },
      { label: (0, i18n_exports._)("Left"), value: "left", icon: TextAlignLeft_default },
      { label: (0, i18n_exports._)("Center"), value: "center", icon: TextAlignCenter_default },
      { label: (0, i18n_exports._)("Right"), value: "right", icon: TextAlignRight_default }
    ]
  }
});
var unitPositionConfig = {
  label: (0, i18n_exports._)("Units position"),
  editor: "editor.select",
  option: "unitPosition",
  editorProps: {
    values: [
      { label: (0, i18n_exports._)("Before"), value: "before" },
      { label: (0, i18n_exports._)("After"), value: "after" }
    ]
  }
};
var unitLabelConfig = {
  label: (0, i18n_exports._)("Unit label"),
  option: "unit",
  editor: "editor.text"
};
var timeFormattingConfig = {
  label: (0, i18n_exports._)("Date & Time formatting"),
  option: "format",
  editor: "editor.text",
  editorProps: {
    tooltip: (0, i18n_exports._)("For example: DD-MM-YYYY")
  }
};
var sequentialColorConfig = [
  { to: 20, value: "#D41F1F" },
  { from: 20, to: 40, value: "#D94E17" },
  { from: 40, to: 60, value: "#CBA700" },
  { from: 60, to: 80, value: "#669922" },
  { from: 80, value: "#118832" }
];
var matchColorConfig = [{ match: "", value: "#5C33FF" }];
var themes = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  defaultHeaderBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.gray20(props),
      light: variables_default.gray92(props)
    },
    prisma: variables_default.backgroundColor(props)
  })(props),
  rowBackgroundColorEven: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.gray96(props)
    },
    prisma: variables_default.backgroundColorPage(props)
  })(props),
  rowBackgroundColorOdd: (props) => pick_default({
    enterprise: {
      dark: "#0D1012",
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  textColor: (props) => pick_default({
    enterprise: variables_default.textColor(props),
    prisma: variables_default.contentColorDefault(props)
  })(props),
  inverseTextColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.contentColorInverted(props),
      // equal to textColor in enterprise
      light: variables_default.white(props)
      // equal to textColor in enterpriseDark
    },
    prisma: variables_default.contentColorInverted(props)
  })(props)
};
var backgroundColorPaletteSet = /* @__PURE__ */ new Set([
  ...colorConstants_exports.COLOR_EDITOR_PALETTE,
  ...(0, lodash_exports.map)(themes, (t) => (0, lodash_exports.get)(t, "defaultBackgroundColor"))
]);
var EDITOR_LABEL_WIDTH = 100;
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Rows displayed"),
          option: "count",
          editor: "editor.number",
          editorProps: {
            min: 0,
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Row numbers"),
          option: "showRowNumbers",
          editor: "editor.checkbox",
          editorProps: {
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Internal fields"),
          option: "showInternalFields",
          editor: "editor.checkbox",
          editorProps: {
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Header row"),
          option: "headerVisibility",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Inline"), value: "inline" },
              { label: (0, i18n_exports._)("Fixed"), value: "fixed" },
              { label: (0, i18n_exports._)("Hidden"), value: "none" }
            ],
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          key: "backgroundColor",
          editor: "editor.tableBackgroundColor",
          editorProps: {
            themes,
            labelPosition: "top",
            labelWidth: EDITOR_LABEL_WIDTH,
            palette: [...backgroundColorPaletteSet]
          }
        }
      ],
      [
        {
          option: "font",
          label: (0, i18n_exports._)("Font"),
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Proportional (Default)"), value: "proportional" },
              { label: (0, i18n_exports._)("Monospace"), value: "monospace" }
            ],
            labelPosition: "top",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        {
          option: "fontSize",
          label: (0, i18n_exports._)("Font size"),
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Extra Small (font 10px, row 24px)"), value: "extraSmall" },
              { label: (0, i18n_exports._)("Small (font 12px, row 24px)"), value: "small" },
              { label: (0, i18n_exports._)("Default (font 14px, row 32px)"), value: "default" },
              { label: (0, i18n_exports._)("Large (font 16px, row 36px)"), value: "large" }
            ],
            labelPosition: "top",
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ],
      [
        __spreadValues({}, headerAlignConfigTable)
      ],
      [
        __spreadValues({}, textAlignConfigTable)
      ],
      [
        {
          label: (0, i18n_exports._)("Column-specific formatting"),
          editor: "editor.tableColumnFormatter",
          editorProps: {
            // popover: {sections: [textFormatConfig, formatByTypeConfig, columnColoringConfig]}
            // Table column coloring does not adhere to same DSL structure as other dynamically colored options
            // we use the FormatterEditor directly and not the DynamicColorEditor's provided DSL builders
            columnColoringConfig: {
              coloringTypes: [
                {
                  label: (0, i18n_exports._)("Text"),
                  value: "rowColors"
                },
                {
                  label: (0, i18n_exports._)("Background"),
                  value: "rowBackgroundColors"
                }
              ],
              formatters: [
                {
                  label: (0, i18n_exports._)("Ranges"),
                  value: "rangeValue",
                  defaults: {
                    rowBackgroundColors: sequentialColorConfig,
                    rowColors: sequentialColorConfig
                  }
                },
                {
                  label: (0, i18n_exports._)("Matches"),
                  value: "matchValue",
                  defaults: {
                    rowBackgroundColors: matchColorConfig,
                    rowColors: matchColorConfig
                  }
                }
              ],
              themes
            },
            defaultOptionsByType: {
              number: {
                thousandSeparated: false,
                unitPosition: "after"
              },
              string: {
                unitPosition: "after"
              },
              text: {
                align: "auto",
                headerAlign: "auto",
                textOverflow: "break-word"
              }
            },
            textFormatConfig: [
              [
                __spreadValues({}, headerAlignConfigColumn)
              ],
              [
                __spreadValues({}, textAlignConfigColumn)
              ],
              [
                __spreadValues({}, textOverflowConfigColumn)
              ]
            ],
            flyoutConfig: {
              number: [
                [
                  __spreadValues({}, unitPositionConfig),
                  __spreadValues({}, unitLabelConfig)
                ],
                [
                  {
                    label: (0, i18n_exports._)("Precision"),
                    option: "precision",
                    editor: "editor.select",
                    editorProps: {
                      values: generatePrecisionValues(20)
                    }
                  },
                  {
                    label: (0, i18n_exports._)("Thousand separators"),
                    option: "thousandSeparated",
                    editor: "editor.radioBar",
                    editorProps: {
                      values: [
                        { label: (0, i18n_exports._)("Off"), value: false },
                        { label: (0, i18n_exports._)("On"), value: true }
                      ]
                    }
                  }
                ]
              ],
              // TODO(fkurniawan): fill in with proper editor components
              sparkline: [],
              string: [
                [
                  __spreadValues({}, unitPositionConfig),
                  __spreadValues({}, unitLabelConfig)
                ]
              ],
              time: [
                [
                  __spreadValues({}, timeFormattingConfig)
                ]
              ]
            },
            value: ({ context, options }) => {
              return {
                context,
                columnFormat: options.columnFormat,
                tableFormat: options.tableFormat
              };
            }
          },
          key: "TableColumnFormatterEditor"
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.table",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Table"),
  category: "Table" /* TABLE */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Table,
  placeholderIcon: placeholders_exports.Table,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.tableOptionsSchema,
  editorConfig,
  events: {
    "cell.click": {
      description: "triggered when user clicks a table cell"
    }
  },
  supports: [
    "dynamic-options" /* DYNAMIC_OPTIONS */,
    "events" /* EVENTS */,
    "page-and-sort" /* PAGE_AND_SORT */,
    "placeholder" /* PLACEHOLDER */
  ],
  themes
};
var config_default = enhanceConfig(config);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport14 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport15 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport16 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport17 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport18 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport19 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport20 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport21 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport22 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport23 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport24 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport25 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport26 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport27 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport28 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport29 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys2, target) => keys2.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config: config2 } = Visualization;
  const { themes: themes3 } = config2;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes3 == null ? void 0 : themes3.defaultBackgroundColor) == null ? void 0 : _a.call(themes3, props);
    const icon = (_b = config2.placeholderIcon) != null ? _b : config2.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config2.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport30 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// src/common/utils/dataUtils.ts
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport31 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport32 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// src/common/utils/trellisUtils.ts
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:lodash/debounce
var debounce_exports = {};
__export(debounce_exports, {
  default: () => debounce_default
});
var defaultImport33 = __toESM(require("lodash/debounce"));
__reExport(debounce_exports, require("lodash/debounce"));
var debounce_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// esm-externals:@splunk/react-ui/Table
var Table_exports = {};
__export(Table_exports, {
  default: () => Table_default
});
var defaultImport34 = __toESM(require("@splunk/react-ui/Table"));
__reExport(Table_exports, require("@splunk/react-ui/Table"));
var Table_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// esm-externals:@splunk/react-ui/Paginator
var Paginator_exports = {};
__export(Paginator_exports, {
  default: () => Paginator_default
});
var defaultImport35 = __toESM(require("@splunk/react-ui/Paginator"));
__reExport(Paginator_exports, require("@splunk/react-ui/Paginator"));
var Paginator_default = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// esm-externals:@splunk/react-ui/Message
var Message_exports2 = {};
__export(Message_exports2, {
  default: () => Message_default2
});
var defaultImport36 = __toESM(require("@splunk/react-ui/Message"));
__reExport(Message_exports2, require("@splunk/react-ui/Message"));
var Message_default2 = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// src/Table/hooks.tsx
var isArray = (v) => Array.isArray(v);
var textOverflowStyles = {
  anywhere: {
    wordBreak: "break-all"
  },
  "break-word": {
    wordBreak: "break-word",
    wordWrap: "break-word",
    overflowWrap: "break-word"
  },
  ellipsis: {
    whiteSpace: "nowrap",
    overflow: "hidden",
    textOverflow: "ellipsis"
  }
};
var empty = {};
var getOverflowStyles = ({ textOverflow }) => {
  return textOverflowStyles[textOverflow] || empty;
};
var generateKey = (value = "", i) => `${i}-${value}`;
var getTextOverflowType = (columnFormat, columnId, currentColumn) => getAttributeFromColumnFormat("textOverflow", columnFormat, columnId, currentColumn);
var generateHeader = (value, columnId, i, columnFormat, tableFormat, showInternalFields) => {
  const ret = {
    key: generateKey(value, i),
    value,
    align: "left",
    columnId,
    sortKey: value,
    showCell: true
  };
  if (!showInternalFields && value.charAt(0) === "_" && value !== "_time") {
    ret.showCell = false;
  }
  const headerAlign = getColumnFormatHeaderAlign(columnFormat, columnId, value) || getTableFormatHeaderAlign(tableFormat) || "left";
  const textOverflowType = getTextOverflowType(columnFormat, columnId, value);
  const textOverflowStyle = getOverflowStyles({
    textOverflow: textOverflowType
  });
  ret.align = headerAlign;
  ret.truncate = true;
  ret.textOverflowType = textOverflowType;
  ret.style = textOverflowStyle;
  return ret;
};
var getColumnFormatAlign = (columnFormat, currentColumn, currentRow) => {
  let align;
  const alignOption = getAttributeFromColumnFormat(
    "align",
    columnFormat,
    currentColumn.columnId,
    currentColumn.value
  );
  if (isArray(alignOption) && (0, lodash_exports.includes)(visualization_schemas_exports.validAlignments, alignOption[currentRow])) {
    align = alignOption[currentRow];
  } else if (typeof alignOption === "string" && alignOption === "auto") {
    align = void 0;
  } else if (typeof alignOption === "string" && (0, lodash_exports.includes)(visualization_schemas_exports.validAlignments, alignOption)) {
    align = alignOption;
  } else if (typeof alignOption !== "undefined") {
    console.warn(
      `columnFormat.${currentColumn.columnId}.align should be a string or an array containing (${visualization_schemas_exports.validAlignments.join(
        " | "
      )}). ${JSON.stringify(alignOption)} provided`
    );
  }
  return align;
};
var getColumnFormatCellType = (columnFormat, currentColumn, currentRow) => {
  let cellType;
  const cellTypes = getAttributeFromColumnFormat(
    "cellTypes",
    columnFormat,
    currentColumn.columnId,
    currentColumn.value
  );
  if (isArray(cellTypes) && (0, lodash_exports.includes)(visualization_schemas_exports.validCellRenderers, cellTypes[currentRow])) {
    cellType = cellTypes[currentRow];
  } else if (typeof cellTypes !== "undefined") {
    console.warn(
      `columnFormat.${currentColumn.value}.cellType should be an array containing (${visualization_schemas_exports.validCellRenderers.join(" | ")}). ${JSON.stringify(
        cellTypes
      )} provided`
    );
  }
  return cellType;
};
var getColumnFormatSparklineType = (columnFormat, currentColumn, currentRow) => {
  let sparklineType;
  const types = getAttributeFromColumnFormat(
    "sparklineTypes",
    columnFormat,
    currentColumn.columnId,
    currentColumn.value
  );
  if (isArray(types) && (0, lodash_exports.includes)(visualization_schemas_exports.validSparklineTypes, types[currentRow])) {
    sparklineType = types[currentRow];
  } else if (typeof types !== "undefined") {
    console.warn(
      `columnFormat.${currentColumn.value}.sparklineTypes should be one of (${visualization_schemas_exports.validSparklineTypes.join(
        " | "
      )}). ${JSON.stringify(types)} provided`
    );
  }
  return sparklineType;
};
var getColumnFormatData = (columnFormat, currentColumn, currentRow) => {
  let datum;
  const data = getAttributeFromColumnFormat(
    "data",
    columnFormat,
    currentColumn.columnId,
    currentColumn.value
  );
  if (isArray(data)) {
    datum = data[currentRow];
  } else if (typeof data !== "undefined") {
    console.warn(
      `columnFormat.${currentColumn.value}.data should be an array containing formatted data. ${typeof data} provided`
    );
  }
  return datum;
};
var getColumnFormatColor = (columnFormat, currentColumn, currentRow, field) => {
  let color;
  const colors = getAttributeFromColumnFormat(
    field,
    columnFormat,
    currentColumn.columnId,
    currentColumn.value
  );
  if (isArray(colors) && (0, colorUtils_exports.isColor)(colors[currentRow])) {
    color = colors[currentRow];
  } else if (typeof colors !== "undefined") {
    console.warn(
      `columnFormat.${currentColumn.columnId}.${field} should be an array containing valid colors. ${JSON.stringify(colors)} provided`
    );
  }
  return color;
};
var getColumnFormatRowColor = (columnFormat, currentColumn, currentRow) => {
  return getColumnFormatColor(columnFormat, currentColumn, currentRow, "rowColors");
};
var getColumnFormatRowBgColor = (columnFormat, currentColumn, currentRow) => {
  return getColumnFormatColor(columnFormat, currentColumn, currentRow, "rowBackgroundColors");
};
var getColumnFormatSparklineColor = (columnFormat, currentColumn, currentRow) => {
  return getColumnFormatColor(columnFormat, currentColumn, currentRow, "sparklineColors");
};
var getColumnFormatSparklineAreaColor = (columnFormat, currentColumn, currentRow) => {
  return getColumnFormatColor(columnFormat, currentColumn, currentRow, "sparklineAreaColors");
};
var getColumnFormatHeaderAlign = (columnFormat, columnId, columnValue) => {
  let headerAlign;
  const alignOption = getAttributeFromColumnFormat("headerAlign", columnFormat, columnId, columnValue);
  if (typeof alignOption === "string" && alignOption === "auto") {
    return void 0;
  }
  if (typeof alignOption === "string" && (0, lodash_exports.includes)(visualization_schemas_exports.validAlignments, alignOption)) {
    headerAlign = alignOption;
  } else if (typeof alignOption !== "undefined") {
    console.warn(
      `columnFormat.${columnId}.headerAlign should be a string containing (${visualization_schemas_exports.validAlignments.join(
        " | "
      )}). ${JSON.stringify(alignOption)} provided`
    );
  }
  return headerAlign;
};
var getTableFormatAlign = (tableFormat, currentColumn, currentRow) => {
  const alignOption = (0, lodash_exports.get)(tableFormat, "align");
  let align;
  if (isArray(alignOption) && isArray(alignOption[currentColumn]) && (0, lodash_exports.includes)(visualization_schemas_exports.validAlignments, alignOption[currentColumn][currentRow])) {
    align = alignOption[currentColumn][currentRow];
  } else if (typeof alignOption === "string" && (0, lodash_exports.includes)(visualization_schemas_exports.validAlignments, alignOption)) {
    align = alignOption;
  } else if (typeof alignOption !== "undefined") {
    console.warn(
      `tableFormat.align should be a string or a 2 dimensional array containing (${visualization_schemas_exports.validAlignments.join(
        " | "
      )}). ${JSON.stringify(alignOption)} provided`
    );
  }
  return align;
};
var getTableFormatCellType = (tableFormat, currentColumn, currentRow) => {
  const cellTypes = (0, lodash_exports.get)(tableFormat, "cellTypes");
  let cellType;
  if (isArray(cellTypes) && isArray(cellTypes[currentColumn]) && (0, lodash_exports.includes)(visualization_schemas_exports.validCellRenderers, cellTypes[currentColumn][currentRow])) {
    cellType = cellTypes[currentColumn][currentRow];
  } else if (typeof cellTypes !== "undefined") {
    console.warn(
      `tableFormat.cellType should be a 2 dimensional array containing (${visualization_schemas_exports.validCellRenderers.join(
        " | "
      )}). ${JSON.stringify(cellTypes)} provided`
    );
  }
  return cellType;
};
var getTableFormatSparklineType = (tableFormat, currentColumn, currentRow) => {
  const types = (0, lodash_exports.get)(tableFormat, "sparklineTypes");
  let sparklineType;
  if (isArray(types) && isArray(types[currentColumn]) && (0, lodash_exports.includes)(visualization_schemas_exports.validSparklineTypes, types[currentColumn][currentRow])) {
    sparklineType = types[currentColumn][currentRow];
  } else if (typeof types !== "undefined") {
    console.warn(
      `tableFormat.sparklineTypes should be a 2 dimensional array containing one of (${visualization_schemas_exports.validSparklineTypes.join(
        " | "
      )}). ${JSON.stringify(types)} provided`
    );
  }
  return sparklineType;
};
var getTableFormatColor = (tableFormat, currentColumn, currentRow, field) => {
  const colors = (0, lodash_exports.get)(tableFormat, field);
  let color;
  if (isArray(colors) && isArray(colors[currentColumn]) && (0, colorUtils_exports.isColor)(colors[currentColumn][currentRow])) {
    color = colors[currentColumn][currentRow];
  } else if (isArray(colors) && (0, colorUtils_exports.isColor)(colors[currentRow])) {
    color = colors[currentRow];
  } else if (typeof colors !== "undefined" && isArray(colors) && isArray(colors[currentColumn]) && colors[currentColumn][currentRow] !== void 0) {
    console.warn(
      `tableFormat.${field} needs to be an array of colors, provided ${JSON.stringify(
        colors
      )}. Current value at [${currentColumn}][${currentRow}] is ${JSON.stringify(colors[currentRow])}`
    );
  }
  return color;
};
var getTableFormatRowColor = (tableFormat, currentCol, currentRow) => {
  return getTableFormatColor(tableFormat, currentCol, currentRow, "rowColors");
};
var getTableFormatRowBgColor = (tableFormat, currentCol, currentRow) => {
  return getTableFormatColor(tableFormat, currentCol, currentRow, "rowBackgroundColors");
};
var getTableFormatSparklineColor = (tableFormat, currentCol, currentRow) => {
  return getTableFormatColor(tableFormat, currentCol, currentRow, "sparklineColors");
};
var getTableFormatSparklineAreaColor = (tableFormat, currentCol, currentRow) => {
  return getTableFormatColor(tableFormat, currentCol, currentRow, "sparklineAreaColors");
};
var getTableFormatData = (tableFormat, currentCol, currentRow) => {
  const data = (0, lodash_exports.get)(tableFormat, "data");
  let datum;
  if (isArray(data) && isArray(data[currentCol])) {
    datum = data[currentCol][currentRow];
  } else if (typeof data !== "undefined") {
    console.warn(
      `tableFormat.data should be a 2 dimensional array containing formatted data to be displayed. ${typeof data} provided`
    );
  }
  return datum;
};
var getTableFormatHeaderAlign = (tableFormat) => {
  const alignOption = (0, lodash_exports.get)(tableFormat, "headerAlign");
  let headerAlign;
  if (typeof alignOption === "string" && visualization_schemas_exports.validAlignments.includes(alignOption)) {
    headerAlign = alignOption;
  } else if (typeof alignOption !== "undefined") {
    console.warn(
      `tableFormat.headerAlign should be a string containing (${visualization_schemas_exports.validAlignments.join(
        " | "
      )}). ${JSON.stringify(alignOption)} provided`
    );
  }
  return headerAlign;
};
var getAttributeFromColumnFormat = (attribute, columnFormat, columnId, columnValue) => (0, lodash_exports.get)(columnFormat, [columnId, attribute]) || (0, lodash_exports.get)(columnFormat, [columnValue, attribute]);
var validValueSelector = (v1, v2, v3, defaultValue) => {
  const validTypes = ["string", "number"];
  if (validTypes.includes(typeof v1) || isArray(v1)) {
    return v1;
  }
  if (validTypes.includes(typeof v2) || isArray(v2)) {
    return v2;
  }
  if (validTypes.includes(typeof v3) || isArray(v3)) {
    return v3;
  }
  return defaultValue;
};
var useTable = (tableArgs = {}) => {
  let { table = [], headers = [], columnIds = [] } = tableArgs;
  const {
    headerVisibility = "inline",
    showRowNumbers = false,
    showInternalFields = true,
    tableFormat = {},
    columnFormat = {},
    paginationOffset = 0,
    count = 0
  } = tableArgs;
  const longestColumnLength = Math.max(...table.map((column) => column.length));
  if (showRowNumbers) {
    const correctedPaginationOffset = Math.max(0, (paginationOffset - 1) * count);
    headers = ["#", ...headers];
    columnIds = ["#", ...columnIds];
    table = [
      Array.from({ length: longestColumnLength }, (v, i) => correctedPaginationOffset + i + 1),
      ...table
    ];
    if (isArray(tableFormat.align)) {
      tableFormat.align = [
        new Array(longestColumnLength).fill("left"),
        ...tableFormat.align
      ];
    }
    if (isArray(tableFormat.cellTypes)) {
      tableFormat.cellTypes = [
        new Array(longestColumnLength).fill("TextCell"),
        ...tableFormat.cellTypes
      ];
    }
    if (isArray(tableFormat.data)) {
      tableFormat.data = [
        Array.from({ length: longestColumnLength }, (v, i) => `${i + 1}`),
        ...tableFormat.data
      ];
    }
    if (isArray(tableFormat.rowBackgroundColors)) {
      if (tableFormat.rowBackgroundColors.length > 0 && isArray(tableFormat.rowBackgroundColors[0])) {
        tableFormat.rowBackgroundColors = [
          new Array(longestColumnLength),
          ...tableFormat.rowBackgroundColors
        ];
      }
    }
    if (isArray(tableFormat.rowColors)) {
      if (tableFormat.rowColors.length > 0 && isArray(tableFormat.rowColors[0])) {
        tableFormat.rowColors = [
          new Array(longestColumnLength),
          ...tableFormat.rowColors
        ];
      }
    }
    if (isArray(tableFormat.sparklineColors)) {
      tableFormat.sparklineColors = [new Array(longestColumnLength), ...tableFormat.sparklineColors];
    }
    if (isArray(tableFormat.sparklineAreaColors)) {
      tableFormat.sparklineAreaColors = [
        new Array(longestColumnLength),
        ...tableFormat.sparklineAreaColors
      ];
    }
    if (isArray(tableFormat.sparklineTypes)) {
      tableFormat.sparklineTypes = [
        new Array(longestColumnLength).fill("area"),
        ...tableFormat.sparklineTypes
      ];
    }
  }
  const tableHeader = {
    visibility: visualization_schemas_exports.validHeaderVisibilities.indexOf(headerVisibility) >= 0 ? headerVisibility : "inline",
    cells: table.map(
      (f, i) => {
        if (i < headers.length) {
          return generateHeader(
            headers[i],
            columnIds[i],
            i,
            columnFormat,
            tableFormat,
            showInternalFields
          );
        }
        return generateHeader("", "", i, columnFormat, tableFormat, showInternalFields);
      }
    ),
    style: {
      backgroundColor: (0, lodash_exports.has)(tableFormat, "headerBackgroundColor") && (0, colorUtils_exports.isColor)(tableFormat.headerBackgroundColor) && tableFormat.headerBackgroundColor || void 0,
      color: (0, lodash_exports.has)(tableFormat, "headerColor") && (0, colorUtils_exports.isColor)(tableFormat.headerColor) && tableFormat.headerColor || void 0
    }
  };
  const tableBody = {
    rows: []
  };
  for (let currentRow = 0; currentRow < longestColumnLength; currentRow += 1) {
    const row = {
      key: `row-${currentRow}`,
      index: currentRow,
      cells: []
    };
    table.forEach((column, i) => {
      const currentHeader = tableHeader.cells[i];
      const value = validValueSelector(
        getColumnFormatData(columnFormat, currentHeader, currentRow),
        getTableFormatData(tableFormat, i, currentRow),
        column[currentRow],
        ""
      );
      const rawValue = column[currentRow];
      const rowBackgroundColor = getColumnFormatRowBgColor(columnFormat, currentHeader, currentRow) || getTableFormatRowBgColor(tableFormat, i, currentRow) || void 0;
      const rowColor = getColumnFormatRowColor(columnFormat, currentHeader, currentRow) || getTableFormatRowColor(tableFormat, i, currentRow) || void 0;
      const align = getColumnFormatAlign(columnFormat, currentHeader, currentRow) || getTableFormatAlign(tableFormat, i, currentRow) || "left";
      const cellType = getColumnFormatCellType(columnFormat, currentHeader, currentRow) || getTableFormatCellType(tableFormat, i, currentRow) || "TextCell";
      const sparklineColor = getColumnFormatSparklineColor(columnFormat, currentHeader, currentRow) || getTableFormatSparklineColor(tableFormat, i, currentRow) || void 0;
      const sparklineAreaColor = getColumnFormatSparklineAreaColor(columnFormat, currentHeader, currentRow) || getTableFormatSparklineAreaColor(tableFormat, i, currentRow) || void 0;
      const sparklineType = getColumnFormatSparklineType(columnFormat, currentHeader, currentRow) || getTableFormatSparklineType(tableFormat, i, currentRow) || "area";
      const key = generateKey(value, `${currentRow}-${i}`);
      let additionalStyles = {};
      const textOverflowType = getTextOverflowType(columnFormat, columnIds[i], currentHeader.value);
      const textOverflowStyle = getOverflowStyles({
        textOverflow: textOverflowType
      });
      additionalStyles = __spreadValues(__spreadValues({}, additionalStyles), textOverflowStyle);
      let showCell = true;
      if (!showInternalFields && currentHeader.value.charAt(0) === "_" && currentHeader.value !== "_time") {
        showCell = false;
      }
      row.cells.push({
        key,
        value,
        rawValue,
        align,
        cellType,
        rowIndex: currentRow,
        columnIndex: i,
        sparklineColor,
        sparklineAreaColor,
        sparklineType,
        header: currentHeader.value,
        style: __spreadValues({
          backgroundColor: rowBackgroundColor,
          color: rowColor
        }, additionalStyles),
        showCell
      });
    });
    tableBody.rows.push(row);
  }
  return {
    tableHeader,
    tableBody
  };
};

// src/Table/cells/SwitchTableCell.tsx
var SwitchTableCell = ({ type, children }) => children.filter((child) => child.type.displayName === type);

// src/Table/cells/TextCell.tsx
var noop3 = () => void 0;
var TextCell = ({ cell, useMouseOverEffect }) => {
  const cellStyle = react_exports.useMemo(() => __spreadValues({}, cell.style), [cell.style]);
  return /* @__PURE__ */ react_exports.createElement(
    Table_default.Cell,
    {
      style: cellStyle,
      align: cell.align,
      "data-test-cell-type": "TextCell",
      "data-test-align-value": cell.align,
      "data-row-index": cell.rowIndex,
      "data-col-index": cell.columnIndex,
      onClick: useMouseOverEffect ? noop3 : void 0
    },
    cell.value.toString()
  );
};
TextCell.displayName = "TextCell";

// src/Table/cells/ArrayCell.tsx
var noop4 = () => void 0;
var ArrayCell = ({ cell, useMouseOverEffect }) => {
  const value = react_exports.useMemo(() => Array.isArray(cell.value) ? cell.value : [cell.value], [cell.value]);
  const cellStyle = react_exports.useMemo(() => __spreadValues({}, cell.style), [cell.style]);
  return /* @__PURE__ */ react_exports.createElement(
    Table_default.Cell,
    {
      style: cellStyle,
      align: cell.align,
      "data-test-align-value": cell.align,
      "data-test-cell-type": "ArrayCell",
      onClick: useMouseOverEffect ? noop4 : void 0
    },
    value.map(
      (v, i) => /* @__PURE__ */ react_exports.createElement(
        "div",
        {
          key: v.toString(),
          "data-row-index": cell.rowIndex,
          "data-col-index": cell.columnIndex,
          "data-array-index": i
        },
        v.toString()
      )
    )
  );
};
ArrayCell.displayName = "ArrayCell";

// esm-externals:@splunk/react-ui/Popover
var Popover_exports = {};
__export(Popover_exports, {
  default: () => Popover_default
});
var defaultImport37 = __toESM(require("@splunk/react-ui/Popover"));
__reExport(Popover_exports, require("@splunk/react-ui/Popover"));
var Popover_default = "default" in defaultImport37 ? defaultImport37.default : defaultImport37;

// src/SparkLine/SparkLine.jsx
var StyledSvg = styled_components_default.svg`
    /* For fixing IE11 shows overflow part line issue */
    overflow: hidden;
`;
var StyledTooltip = styled_components_default.div`
    padding: 3px 8px;
    font-size: 12px;
`;
var _SparkLine = class _SparkLine extends react_exports.Component {
  constructor(props, ...rest) {
    super(props, ...rest);
    __publicField(this, "handleCursorMount", (el) => {
      this.setState({
        anchor: el
      });
    });
    this.state = {
      anchor: null,
      currentPointX: null,
      open: false,
      rectArea: null,
      tooltip: null
    };
    this.titleId = (0, id_exports.createDOMID)();
  }
  getMax() {
    const { data, acceptNull, yMax } = this.props;
    const dataMax = () => acceptNull ? (0, lodash_exports.max)(this.fillNull(data)) : (0, lodash_exports.max)(data);
    return yMax !== void 0 ? yMax : dataMax();
  }
  getMin() {
    const { data, acceptNull, yMin } = this.props;
    const dataMin = () => acceptNull ? (0, lodash_exports.min)(this.fillNull(data)) : (0, lodash_exports.min)(data);
    return yMin !== void 0 ? yMin : dataMin();
  }
  /**
   * Gets unit value of x axis.
   * @param {Number} xMargin - margin of x axis.
   * @return {Number} unit value of x axis.
   * @private
   */
  getXUnit(xMargin) {
    const { data, width } = this.props;
    const xUnit = (width - xMargin * 2) / (data.length > 1 ? data.length - 1 : 1);
    return Math.max(0, xUnit);
  }
  /**
   * Gets unit value of y axis.
   * @param {String} yMargin - margin of y axis.
   * @return {Number} unit value of y axis.
   * @private
   */
  getYUnit(yMargin) {
    const { height } = this.props;
    const maxValue = this.getMax();
    const minValue = this.getMin();
    const yUnit = (height - yMargin * 2) / (maxValue - minValue || 2);
    return Math.max(0, yUnit);
  }
  /**
   * Get a list of arrays of points for drawing lines, based on acceptNull property
   * @method getSegmentSets
   * @param {Array} data
   * @param {Array} points
   * @returns {Array} List of datapoint sets used for drawing lines
   */
  getSegmentSets(data, points) {
    const { acceptNull } = this.props;
    const lines = [];
    let currentLine = [];
    data.forEach((p, idx) => {
      if (!acceptNull && (0, lodash_exports.isNull)(p)) {
        if (currentLine.length > 1) {
          lines.push(currentLine);
        }
        currentLine = [];
      } else {
        currentLine.push(points[idx]);
      }
    });
    if (currentLine.length > 1) {
      lines.push(currentLine);
    }
    return lines;
  }
  /**
   * Utility for fill null value with number 0.
   * @private
   */
  fillNull() {
    const { data } = this.props;
    return data.map((value) => value === null ? 0 : value);
  }
  /**
   * Converts data to points in svg
   * @param {Number} xMargin - margin of x axis.
   * @param {Number} yMargin - margin of x axis.
   * @return {Array} points coordination.
   * @private
   */
  dataToPoints(xMargin, yMargin) {
    const { data } = this.props;
    const xUnit = this.getXUnit(xMargin);
    const yUnit = this.getYUnit(yMargin);
    const maxValue = this.getMax();
    const minValue = this.getMin();
    return data.map((val, idx) => ({
      x: idx * xUnit + xMargin,
      y: maxValue === minValue ? yUnit + yMargin : (maxValue - val) * yUnit + yMargin
    })).map((p) => [p.x, p.y]);
  }
  /**
   * Renders rect area for helping figure out which is the nearest point so that
   * render related cursor and tooltip.
   * @param {Array} points - array of points coordination.
   * @param {Number} xMargin - margin of x axis.
   * @return {Array} array of svg rect objects
   * @private
   */
  renderRect(points, xMargin) {
    const { data, height } = this.props;
    const xUnit = this.getXUnit(xMargin);
    return points.map((p, i) => (
      /* eslint-disable react/no-array-index-key */
      /* @__PURE__ */ react_default.createElement(
        "rect",
        {
          key: `${i}_${p[0]}`,
          "data-test": `rect-${i}`,
          x: p[0] - xUnit / 2 <= 0 ? 0 : p[0] - xUnit / 2,
          y: 0,
          width: i === 0 && data.length !== 1 ? xUnit / 2 : xUnit,
          height,
          style: { fillOpacity: 0 },
          onMouseOver: (e) => {
            this.setState({
              open: data[i] !== null,
              rectArea: data[i] === null ? null : e.target,
              tooltip: data[i],
              currentPointX: p[0]
            });
          }
        }
      )
    ));
  }
  // Renders area chart
  renderArea(points) {
    const { data, fillColor, fillOpacity, height, isArea } = this.props;
    if (!isArea || points.length === 0) {
      return null;
    }
    let segments = this.getSegmentSets(data, points);
    segments = segments.map(
      (s) => s.concat([
        [s[s.length - 1][0], height],
        // down to bottom of graph
        [s[0][0], height],
        // over to below first data point
        s[0]
        // up to first data point to close the box
      ])
    );
    return /* @__PURE__ */ react_default.createElement("g", { "data-test": "area" }, segments.map((s) => /* @__PURE__ */ react_default.createElement(
      "polyline",
      {
        key: `area${s.join("")}`,
        points: s.join(" "),
        "data-test": "area-line",
        style: {
          fill: fillColor,
          fillOpacity,
          strokeWidth: "0"
        }
      }
    )));
  }
  renderCursor() {
    const {
      cursorStroke,
      cursorStrokeWidth,
      cursorStrokeLinecap,
      cursorStrokeDasharray,
      height
    } = this.props;
    return this.state.rectArea !== null && /* @__PURE__ */ react_default.createElement(
      "line",
      {
        "data-test": "cursor",
        ref: this.handleCursorMount,
        x1: this.state.currentPointX,
        y1: 0,
        x2: this.state.currentPointX,
        y2: height,
        style: {
          stroke: cursorStroke,
          strokeWidth: cursorStrokeWidth,
          strokeLinecap: cursorStrokeLinecap,
          strokeDasharray: cursorStrokeDasharray
        }
      }
    );
  }
  renderTooltip() {
    return this.state.anchor !== null && /* @__PURE__ */ react_default.createElement(
      Popover_default,
      {
        "data-test": "tooltip",
        open: this.state.open,
        anchor: this.state.anchor,
        "data-test-value": this.state.tooltip,
        appearance: "inverted",
        defaultPlacement: "above",
        animation: false
      },
      /* @__PURE__ */ react_default.createElement(StyledTooltip, null, this.state.anchor !== null ? this.state.tooltip : void 0)
    );
  }
  /**
   * Renders one or more svg circles to highlight values on the sparkline
   * @method renderEndDots
   * @param {Array[Array[Number]]} points // x,y coordinates of values
   * @param {Number} dotsToShow           // number of end dots to display
   * @param {Number} xMargin              // used when calculating the dot radius
   * @returns {Object} React representation of SVG group
   * @private
   */
  renderEndDots(points, dotsToShow, xMargin) {
    const { endDotFillColor, endDotRadius, endDotStroke, endDotStrokeWidth } = this.props;
    return /* @__PURE__ */ react_default.createElement("g", null, points.slice(-dotsToShow).map((point) => /* @__PURE__ */ react_default.createElement(
      "circle",
      {
        key: `end-dot${point[0]}${point[1]}`,
        "data-test": "end-dot",
        cx: point[0],
        cy: point[1],
        r: endDotRadius === 0 ? xMargin : endDotRadius,
        style: {
          fill: endDotFillColor,
          stroke: endDotStroke,
          strokeWidth: endDotStrokeWidth
        }
      }
    )));
  }
  /**
   * Renders the line(s) above the area graph
   * @method renderPolyline
   * @param {Array} points
   * @returns {Object} SVG Group of polylines
   */
  renderPolyline(points) {
    const { data, lineColor, lineLength, lineStrokeWidth } = this.props;
    const linePoints = (0, lodash_exports.isFinite)(lineLength) && lineLength > 0 ? lineLength : points.length;
    const lines = this.getSegmentSets(data.slice(-linePoints), points.slice(-linePoints));
    return /* @__PURE__ */ react_default.createElement("g", { "data-test": "sparkline" }, lines.map((lineData) => /* @__PURE__ */ react_default.createElement(
      "polyline",
      {
        key: `line${lineData.join("")}`,
        "data-test": "polyline",
        style: {
          fill: "none",
          stroke: lineColor,
          strokeWidth: lineStrokeWidth,
          strokeLinejoin: "round",
          strokeLinecap: "round"
        },
        points: lineData.join(" ")
      }
    )));
  }
  render() {
    const {
      data,
      elementRef,
      showTooltip,
      showEndDot,
      endDotRadius,
      endDotStrokeWidth,
      endDotCount,
      height,
      isArea,
      lineStrokeWidth,
      width,
      title
    } = this.props;
    if (data.length === 0) {
      return null;
    }
    const xMargin = endDotRadius + endDotStrokeWidth / 2;
    const yMargin = Math.max(lineStrokeWidth / 2, endDotRadius + endDotStrokeWidth / 2);
    const points = this.dataToPoints(xMargin, yMargin);
    const dotsToShow = Math.max(showEndDot && 1, (0, lodash_exports.isFinite)(endDotCount) && endDotCount > 0 && endDotCount);
    return /* @__PURE__ */ react_default.createElement(
      "div",
      __spreadValues({
        "data-test": "line",
        "data-test-type": isArea ? "area" : "line",
        onMouseOut: () => {
          this.setState({
            open: false,
            anchor: null,
            rectArea: null,
            currentPointX: null
          });
        },
        ref: elementRef
      }, (0, lodash_exports.omit)(this.props, (0, lodash_exports.keys)(_SparkLine.propTypes))),
      /* @__PURE__ */ react_default.createElement(
        StyledSvg,
        {
          height,
          width,
          role: "img",
          "aria-labelledby": this.titleId,
          "data-test": "sparkline-svg"
        },
        /* @__PURE__ */ react_default.createElement("title", { id: this.titleId, "data-test": "sparkline-title" }, title || (0, i18n_exports._)("Source count over time sparkline trend")),
        /* @__PURE__ */ react_default.createElement("g", null, this.renderCursor(), this.renderPolyline(points), this.renderArea(points), dotsToShow ? this.renderEndDots(points, dotsToShow, xMargin) : null, showTooltip ? this.renderRect(points, xMargin) : null, showTooltip ? this.renderTooltip() : null)
      )
    );
  }
};
__publicField(_SparkLine, "propTypes", {
  /**
   * If true, data can contain `null` as a value and is treated as `0`. If false, this throws error when data contains `null`.
   */
  acceptNull: prop_types_default.bool,
  /** Array of numbers. These data numbers are converted to points and show on sparkline. */
  data: (props) => {
    if (!(0, lodash_exports.isArray)(props.data)) {
      return new Error("Data provided to Sparkline must be an array.");
    }
    if (props.acceptNull && !props.data.every((value) => (0, lodash_exports.isNull)(value) || (0, lodash_exports.isFinite)(value))) {
      return new Error("Data provided to Sparkline must be finite numbers or null.");
    }
    if (!props.acceptNull && !props.data.every((value) => (0, lodash_exports.isFinite)(value))) {
      return new Error("Data provided to Sparkline must be finite numbers.");
    }
    return null;
  },
  /** A React ref which is set to the DOM element when the component mounts and `null` when it unmounts. */
  elementRef: prop_types_default.oneOfType([prop_types_default.func, prop_types_default.object]),
  /** Sets the number of end dots to display. When showEndDot is set to `true`, endDotCount is at least 1. If set to a positive value, this overrides showEndDot. */
  endDotCount: prop_types_default.number,
  /** Fills color to the end dot. */
  endDotFillColor: prop_types_default.string,
  /**
   * Sets end dot radius. End dot radius must be less than or equal to the margin. By default, its value equals the margin.
   */
  endDotRadius: prop_types_default.number,
  /** Sets end dot circle stroke color. */
  endDotStroke: prop_types_default.string,
  /** Sets end dot circle stroke width in pixels. */
  endDotStrokeWidth: prop_types_default.number,
  /** Fills color to area. */
  fillColor: prop_types_default.string,
  /** Fills opacity to area. Value must be in 0 ~ 1. */
  fillOpacity: prop_types_default.string,
  /** Sets cursor stroke color. */
  cursorStroke: prop_types_default.string,
  /** Sets cursor stroke width in pixels. */
  cursorStrokeWidth: prop_types_default.number,
  /** Sets cursor line cap style. */
  cursorStrokeLinecap: prop_types_default.oneOf(["butt", "round", "square"]),
  /** Sets cursor dash array style. */
  cursorStrokeDasharray: prop_types_default.string,
  /**
   * Container height. If this value is specified, sparkline calculates the size using this height. If height isn't specified,
   * sparkline figures out the container height by itself.
   */
  height: prop_types_default.number.isRequired,
  /** When set to `true`, sparkline shows as area. */
  isArea: prop_types_default.bool,
  /** The sparkline line color. */
  lineColor: prop_types_default.string,
  /** Allows user to draw only the last data points for the line. */
  lineLength: prop_types_default.number,
  /** The sparkline line stroke width in pixels. */
  lineStrokeWidth: prop_types_default.number,
  /** Enable to show end dot. */
  showEndDot: prop_types_default.bool,
  /** Enable to show tooltip. */
  showTooltip: prop_types_default.bool,
  /** Sets the data value range and maximum value shown on sparkline. */
  yMax: prop_types_default.number,
  /** Sets the data value range and minimum value shown on sparkline. */
  yMin: prop_types_default.number,
  /**
   * The width of the container.
   */
  width: prop_types_default.number.isRequired,
  /** Sets the a11y title text on sparkline. */
  title: prop_types_default.string
});
__publicField(_SparkLine, "defaultProps", {
  acceptNull: false,
  data: [],
  showTooltip: true,
  endDotCount: 0,
  showEndDot: false,
  endDotRadius: 0,
  endDotFillColor: "white",
  endDotStroke: "black",
  endDotStrokeWidth: 0,
  fillColor: "#65a637",
  fillOpacity: ".1",
  cursorStroke: "#5184AF",
  cursorStrokeWidth: 3,
  cursorStrokeLinecap: "square",
  cursorStrokeDasharray: "1, 5",
  isArea: false,
  lineColor: "#65a637",
  lineStrokeWidth: 1
});
var SparkLine = _SparkLine;
var SparkLine_default = SparkLine;

// src/Table/cells/SparklineCell.tsx
var paddingLeftRight = 5;
var paddingTopBottom = 3;
var parseSparklineData = (data) => (Array.isArray(data) ? data : [data]).map((d) => Number(d.toString())).map((d) => isNaN(d) ? null : d);
var noop5 = () => void 0;
var svgStyle = { height: 0 };
var dummySVG = /* @__PURE__ */ react_exports.createElement("svg", { style: svgStyle });
var SparklineCell = ({
  cell,
  useMouseOverEffect,
  width
}) => {
  const [cellEl, setEl] = react_exports.useState();
  const [height, setHeight] = react_exports.useState();
  let data = react_exports.useMemo(() => parseSparklineData(cell.value), [cell.value]);
  if (cell.value[0] === "##__SPARKLINE__##") {
    data = data.slice(1);
  }
  react_exports.useLayoutEffect(() => {
    setHeight(cellEl == null ? void 0 : cellEl.offsetHeight);
  }, [cellEl]);
  const cellStyle = react_exports.useMemo(
    () => __spreadProps(__spreadValues({}, cell.style), {
      padding: 0,
      margin: 0,
      width,
      height: `${height}px`
    }),
    [cell.style, width, height]
  );
  const lineStyle = react_exports.useMemo(
    () => ({
      paddingLeft: `${paddingLeftRight}px`,
      paddingTop: `${paddingTopBottom}px`,
      width: width === "auto" ? `${(cellEl == null ? void 0 : cellEl.offsetWidth) - paddingLeftRight * 2}px` : `${width}px`,
      height: `${height - paddingTopBottom * 2}px`
    }),
    [height, width, cellEl]
  );
  return /* @__PURE__ */ react_exports.createElement(
    Table_default.Cell,
    {
      style: cellStyle,
      align: cell.align,
      elementRef: setEl,
      "data-test-align-value": cell.align,
      "data-test-cell-type": "SparklineCell",
      "data-row-index": cell.rowIndex,
      "data-col-index": cell.columnIndex,
      onClick: useMouseOverEffect ? noop5 : void 0
    },
    height ? /* @__PURE__ */ react_exports.createElement(
      SparkLine_default,
      {
        style: lineStyle,
        data,
        width: (cellEl == null ? void 0 : cellEl.offsetWidth) - paddingLeftRight * 2,
        height: height - paddingTopBottom * 2,
        isArea: cell.sparklineType === "area",
        acceptNull: true,
        lineColor: cell.sparklineColor,
        fillColor: cell.sparklineAreaColor
      }
    ) : dummySVG
  );
};
SparklineCell.displayName = "SparklineCell";

// src/Table/PureTable.tsx
var MINIMUM_COLUMN_SIZE = 30;
var INITIAL_UNSET_COLUMN_WIDTH = 90;
var NonVisibleTableHead = styled_components_default(Table_default.Head)`
    pointer-events: none;
    & [data-test='head-cell'] > div {
        height: 0;
        padding: 0;
        margin: 0;
    }
`;
var FixedTableHead = styled_components_default(Table_default.Head)`
    position: sticky;
    top: 0;
`;
var TableHeadCell = styled_components_default(Table_default.HeadCell)`
    button > span {
        word-break: inherit;
        word-wrap: inherit;
        white-space: ${({ textOverflowType }) => textOverflowType === "ellipsis" ? "nowrap" : "inherit"};
        display: inline;
    }
`;
var VizTableContainer = styled_components_default.div`
    box-sizing: border-box;
    padding: ${pick_default({
  enterprise: variables_default.spacingHalf,
  prisma: variables_default.spacingSmall
})};
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor};
    display: flex;
    flex-flow: column nowrap;
    overflow: hidden;

    td,
    * > td:hover {
        color: ${({ isCellClickable }) => isCellClickable ? variables_default.linkColor : variables_default.textColor};
    }
`;
VizTableContainer.displayName = "VizTableContainer";
var PAGINATOR_CONTAINER_HEIGHT = 38;
var PAGINATOR_SPACING = 5;
var SUITableContainer = styled_components_default.div`
    & * {
        font-family: ${(props) => props.font};
        font-size: ${(props) => props.fontSize};
        line-height: ${(props) => props.lineHeight};
    }
    box-sizing: border-box;
    flex-grow: 1;
    overflow: hidden;
    ${({ width, height, isPaging, theme }) => {
  const padding = pick_default({
    enterprise: variables_default.spacingHalf({ theme }),
    prisma: variables_default.spacingSmall({ theme })
  })({ theme });
  const paddingOffset = parseInt(padding, 10) * 2;
  return (0, style_exports.toDimension)({
    width: width - paddingOffset,
    height: isPaging ? height - PAGINATOR_CONTAINER_HEIGHT - PAGINATOR_SPACING - paddingOffset : height - paddingOffset
  });
}};

    ${({ isPaging }) => isPaging && `
        margin-bottom: ${PAGINATOR_SPACING}px;
    `};

    /* TODO: Replace unsupported hacky style overrides */
    ${({ headerStyle }) => headerStyle && headerStyle.backgroundColor && styled_components_exports.css`
            & [data-test='head-cell'] {
                background-color: ${headerStyle.backgroundColor};
            }
        `}

    ${({ headerStyle }) => headerStyle && headerStyle.color && styled_components_exports.css`
            & [data-test='head-cell'] > button > span {
                color: ${headerStyle.color};
            }
        `}

        /* To accomodate custom logic that diverges from default resizableFillLayout behavior - allows the columns to shrink beneath Table width when columns are fixed */
        [data-test="main-table"] {
        ${({ isFullyFixed }) => isFullyFixed && styled_components_exports.css`
                width: fit-content;
                min-width: unset;
            `}
        td {
            white-space: pre-wrap; // css override to render text with newline/ line-breaks and tabs/ spaces properly
        }
    }
`;
SUITableContainer.displayName = "SUITableContainer";
var PaginatorContainer = styled_components_default.div`
    position: relative;
    text-align: right;
    height: ${PAGINATOR_CONTAINER_HEIGHT}px;
`;
PaginatorContainer.displayName = "PaginatorContainer";
var withEmptyTableMessage = (Viz) => {
  const Wrapper = (props) => {
    const {
      headers,
      columnIds,
      table,
      headerVisibility,
      showRowNumbers,
      showInternalFields,
      tableFormat,
      columnFormat,
      paginatorParams,
      count
    } = props;
    const { tableHeader, tableBody } = useTable({
      headers,
      columnIds,
      table,
      headerVisibility,
      showRowNumbers,
      showInternalFields,
      tableFormat: __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({}, tableFormat), (tableFormat == null ? void 0 : tableFormat.headerAlign) && { headerAlign: (0, lodash_exports.cloneDeep)(tableFormat.headerAlign) }), (tableFormat == null ? void 0 : tableFormat.align) && { align: (0, lodash_exports.cloneDeep)(tableFormat.align) }), (tableFormat == null ? void 0 : tableFormat.cellTypes) && { cellTypes: (0, lodash_exports.cloneDeep)(tableFormat.cellTypes) }), (tableFormat == null ? void 0 : tableFormat.data) && { data: (0, lodash_exports.cloneDeep)(tableFormat.data) }),
      columnFormat,
      paginationOffset: paginatorParams == null ? void 0 : paginatorParams.current,
      count
    });
    if (tableBody.rows.length === 0) {
      return /* @__PURE__ */ react_exports.createElement(Message_default2, { type: "warning" }, (0, i18n_exports._)("No data!"));
    }
    return /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { tableHeader, tableBody }));
  };
  Wrapper.displayName = "PureTableWrapper";
  return Wrapper;
};
var useTableHead = (visibility) => {
  if (visibility === "none") {
    return NonVisibleTableHead;
  }
  if (visibility === "fixed") {
    return FixedTableHead;
  }
  return Table_default.Head;
};
var HeadCell = (_a) => {
  var _b = _a, { value } = _b, props = __objRest(_b, ["value"]);
  const cellRef = react_exports.useRef(null);
  return /* @__PURE__ */ react_exports.createElement(TableHeadCell, __spreadValues({ elementRef: cellRef }, props), value);
};
var fontMap = {
  proportional: "Splunk Platform Sans",
  monospace: "Splunk Platform Mono"
};
var fontSizeMap = {
  extraSmall: "10px",
  small: "12px",
  default: "14px",
  large: "16px"
};
var rowHeightMap = {
  extraSmall: "12px",
  small: "12px",
  default: "20px",
  large: "24px"
};
var tableInnerStyle = { height: "100%" };
var PureTable = (props) => {
  const _a = props, {
    count,
    width,
    height,
    backgroundColor,
    tableHeader,
    tableBody,
    showRowNumbers,
    sortParams: { currentSortKey, currentSortDir, onSort },
    paginatorParams: _b
  } = _a, _c = _b, { isPaging, onChange: paginatorOnChange } = _c, paginatorProps = __objRest(_c, ["isPaging", "onChange"]), {
    onCellClick,
    onColumnFormatChange,
    columnFormat,
    mode,
    headerVisibility,
    font,
    fontSize
  } = _a;
  const [columns, setColumns] = react_exports.useState(columnFormat);
  const containerRef = react_exports.useRef(null);
  const containerRefInner = react_exports.useRef(null);
  const [isResizing, setResizing] = react_exports.useState(false);
  const firstRenderCount = react_exports.useRef(count);
  react_exports.useEffect(() => {
    if (firstRenderCount.current !== count) {
      firstRenderCount.current = count;
      paginatorOnChange(null, { count });
    }
  }, [count, paginatorProps]);
  const stringifiedColumnFormat = JSON.stringify(columnFormat);
  const columnFormatRef = react_exports.useRef(stringifiedColumnFormat);
  const modeRef = react_exports.useRef(mode);
  react_exports.useEffect(() => {
    if (modeRef.current !== mode || columnFormatRef.current !== stringifiedColumnFormat) {
      columnFormatRef.current = stringifiedColumnFormat;
      modeRef.current = mode;
      setColumns(columnFormat);
    }
  }, [mode, stringifiedColumnFormat]);
  const TableHead = useTableHead(headerVisibility);
  const debouncedDrilldown = react_exports.useMemo(
    () => debounce_default((e, payload) => {
      if (window.getSelection().toString() === "" || (e == null ? void 0 : e.ctrlKey) || (e == null ? void 0 : e.metaKey)) {
        if (typeof onCellClick === "function") {
          onCellClick({ e, payload });
        }
      }
    }, 200),
    [onCellClick]
  );
  const drilldownHandler = react_exports.useCallback(
    (e) => {
      const element = e.target;
      const row = element.getAttribute("data-row-index");
      const col = element.getAttribute("data-col-index");
      const arrayIndex = element.getAttribute("data-array-index") || -1;
      if (row && col) {
        const cellRefIndex = +col;
        let cellIndex = cellRefIndex;
        const rowIndex = +row;
        const fieldValue = tableHeader.cells[cellRefIndex].value;
        const cellValue = tableBody.rows[rowIndex].cells[cellRefIndex].value;
        const cellRawValue = tableBody.rows[rowIndex].cells[cellRefIndex].value;
        const value = arrayIndex === -1 ? cellValue : cellRawValue[+arrayIndex];
        if (showRowNumbers === true) {
          if (cellIndex === 0) {
            return;
          }
          cellIndex -= 1;
        }
        const payload = {
          cellIndex,
          rowIndex,
          fieldValue,
          cellValue,
          cellRawValue,
          value,
          name: fieldValue
        };
        tableBody.rows[rowIndex].cells.forEach((c, index) => {
          const rowToken = `row.${tableHeader.cells[index].value}.value`;
          payload[rowToken] = c.value;
        });
        debouncedDrilldown(e.nativeEvent, payload);
      }
    },
    [tableHeader.cells, tableBody.rows, showRowNumbers, debouncedDrilldown]
  );
  const tableCellClickHandler = react_exports.useCallback(
    (e) => {
      setResizing(false);
      return onCellClick ? drilldownHandler(e) : lodash_exports.noop;
    },
    [onCellClick, drilldownHandler]
  );
  const debouncedOnColumnFormatChange = react_exports.useMemo(
    () => debounce_default((newFormat) => {
      onColumnFormatChange(newFormat);
    }, 300),
    [onColumnFormatChange]
  );
  const handleEventHeadCellMouseDown = react_exports.useCallback((e) => {
    if (e.target.tagName.toLowerCase() === "hr") {
      e.stopPropagation();
    }
  }, []);
  const handleEventHeadCellMouseUp = react_exports.useCallback(() => {
    setResizing(false);
  }, [setResizing]);
  const handleKeyDown = (e) => {
    if (e.keyCode !== 13) {
      return;
    }
    drilldownHandler(e);
  };
  const handleKeyUp = react_exports.useCallback(
    (e) => {
      if (["ArrowLeft", "ArrowRight"].includes(e.key)) {
        setResizing(false);
      }
    },
    [setResizing]
  );
  const handleResizeColumn = (_event, payload) => {
    setResizing(true);
    const updatedCF = columns;
    const field = payload.columnId;
    updatedCF[field] = __spreadProps(__spreadValues({}, updatedCF[field]), {
      width: Math.max(payload.width, MINIMUM_COLUMN_SIZE)
    });
    setColumns(__spreadValues({}, updatedCF));
    if (mode === "edit") {
      debouncedOnColumnFormatChange(updatedCF);
    }
    setResizing(false);
  };
  const fontMapped = fontMap[font] || fontMap.proportional;
  const fontSizeMapped = fontSizeMap[fontSize] || fontSizeMap.default;
  const rowHeightMapped = rowHeightMap[fontSize] || rowHeightMap.default;
  const tableOuterStyle = react_exports.useMemo(
    () => ({ height: "100%", cursor: onCellClick ? "pointer" : "unset" }),
    [onCellClick]
  );
  const visibleHeaderCells = tableHeader.cells.filter((c) => c.showCell);
  const numberOfFixedHeaders = visibleHeaderCells.filter(({ value }) => {
    var _a2, _b2;
    return ((_a2 = columns[value]) == null ? void 0 : _a2.width) && ((_b2 = columns[value]) == null ? void 0 : _b2.width) !== "auto";
  }).length;
  const isFullyFixed = visibleHeaderCells.length === numberOfFixedHeaders;
  const isHeaderHidden = headerVisibility === "none";
  return /* @__PURE__ */ react_exports.createElement(
    VizTableContainer,
    {
      isCellClickable: Boolean(onCellClick),
      backgroundColor,
      ref: containerRef,
      "data-test": "table-container"
    },
    /* @__PURE__ */ react_exports.createElement(
      SUITableContainer,
      {
        ref: containerRefInner,
        width,
        height,
        isPaging,
        headerStyle: tableHeader.style,
        font: fontMapped,
        fontSize: fontSizeMapped,
        lineHeight: rowHeightMapped,
        isFullyFixed
      },
      /* @__PURE__ */ react_exports.createElement(
        Table_default,
        {
          resizableFillLayout: true,
          headType: isHeaderHidden ? void 0 : "inline",
          innerStyle: tableInnerStyle,
          outerStyle: tableOuterStyle,
          onClick: tableCellClickHandler,
          onKeyDown: onCellClick ? handleKeyDown : lodash_exports.noop,
          onKeyUp: handleKeyUp,
          onRequestResizeColumn: handleResizeColumn
        },
        /* @__PURE__ */ react_exports.createElement(TableHead, null, visibleHeaderCells.map(
          (_d) => {
            var _e = _d, {
              key,
              value,
              sortKey,
              style,
              align,
              textOverflowType
            } = _e, rest = __objRest(_e, [
              "key",
              "value",
              "sortKey",
              "style",
              "align",
              "textOverflowType"
            ]);
            var _a2, _b2;
            return /* @__PURE__ */ react_exports.createElement(
              HeadCell,
              __spreadProps(__spreadValues({}, __spreadValues({ sortKey }, rest)), {
                align,
                "data-test-align-value": align,
                "data-test-text-overflow-value": textOverflowType,
                key,
                columnId: value,
                sortDir: sortKey === currentSortKey ? currentSortDir : "none",
                width: (_b2 = (_a2 = columns[value]) == null ? void 0 : _a2.width) != null ? _b2 : INITIAL_UNSET_COLUMN_WIDTH,
                onMouseDown: handleEventHeadCellMouseDown,
                onMouseUp: handleEventHeadCellMouseUp,
                value,
                onSort: isResizing || showRowNumbers && value === "#" || isHeaderHidden ? null : onSort,
                resizable: !isHeaderHidden,
                style: showRowNumbers && value === "#" ? __spreadProps(__spreadValues({}, style), { cursor: "auto" }) : style,
                headerVisibility
              })
            );
          }
        )),
        /* @__PURE__ */ react_exports.createElement(Table_default.Body, null, tableBody.rows.map(
          (row) => /* @__PURE__ */ react_exports.createElement(Table_default.Row, { key: row.key }, row.cells.filter((c) => c.showCell).map(
            (cell) => {
              var _a2, _b2;
              return /* @__PURE__ */ react_exports.createElement(SwitchTableCell, { key: cell.key, type: cell.cellType }, /* @__PURE__ */ react_exports.createElement(
                TextCell,
                {
                  cell,
                  useMouseOverEffect: !!onCellClick
                }
              ), /* @__PURE__ */ react_exports.createElement(
                SparklineCell,
                {
                  cell,
                  useMouseOverEffect: !!onCellClick,
                  width: (_b2 = (_a2 = columns[cell.header]) == null ? void 0 : _a2.width) != null ? _b2 : "auto"
                }
              ), /* @__PURE__ */ react_exports.createElement(
                ArrayCell,
                {
                  cell,
                  useMouseOverEffect: !!onCellClick
                }
              ));
            }
          ))
        ))
      )
    ),
    isPaging ? /* @__PURE__ */ react_exports.createElement(PaginatorContainer, null, /* @__PURE__ */ react_exports.createElement(Paginator_default, __spreadValues({ onChange: paginatorOnChange }, paginatorProps))) : null
  );
};
var cellDataType = prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number, prop_types_exports.arrayOf(prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]))]);
PureTable.propTypes = {
  backgroundColor: prop_types_exports.string,
  count: prop_types_exports.number,
  columnFormat: prop_types_exports.objectOf(
    prop_types_exports.shape({
      align: prop_types_exports.oneOfType([prop_types_exports.arrayOf(prop_types_exports.oneOf(visualization_schemas_exports.validColumnAlignments)), prop_types_exports.oneOf(visualization_schemas_exports.validColumnAlignments)]),
      cellTypes: prop_types_exports.arrayOf(prop_types_exports.oneOf(visualization_schemas_exports.validCellRenderers)),
      data: prop_types_exports.arrayOf(cellDataType),
      headerAlign: prop_types_exports.oneOf(visualization_schemas_exports.validColumnAlignments),
      rowBackgroundColors: prop_types_exports.arrayOf(prop_types_exports.string),
      rowColors: prop_types_exports.arrayOf(prop_types_exports.string),
      sparklineAreaColors: prop_types_exports.arrayOf(prop_types_exports.string),
      sparklineColors: prop_types_exports.arrayOf(prop_types_exports.string),
      sparklineTypes: prop_types_exports.arrayOf(prop_types_exports.oneOf(visualization_schemas_exports.validSparklineTypes))
    })
  ),
  headers: prop_types_exports.arrayOf(prop_types_exports.string),
  headerVisibility: prop_types_exports.oneOf(visualization_schemas_exports.validHeaderVisibilities),
  height: prop_types_exports.oneOfType([prop_types_exports.number]),
  mode: prop_types_exports.string,
  onCellClick: prop_types_exports.func,
  paginatorParams: PaginatorParamsPropTypes,
  showRowNumbers: prop_types_exports.bool,
  sortParams: SortParamsPropTypes,
  table: prop_types_exports.arrayOf(prop_types_exports.arrayOf(cellDataType)),
  tableFormat: prop_types_exports.shape({
    align: prop_types_exports.oneOfType([prop_types_exports.arrayOf(prop_types_exports.arrayOf(prop_types_exports.oneOf(visualization_schemas_exports.validAlignments))), prop_types_exports.oneOf(visualization_schemas_exports.validAlignments)]),
    cellTypes: prop_types_exports.arrayOf(prop_types_exports.arrayOf(prop_types_exports.oneOf(visualization_schemas_exports.validCellRenderers))),
    data: prop_types_exports.arrayOf(prop_types_exports.arrayOf(cellDataType)),
    headerAlign: prop_types_exports.oneOf(visualization_schemas_exports.validAlignments),
    headerBackgroundColor: prop_types_exports.string,
    headerColor: prop_types_exports.string,
    rowBackgroundColors: prop_types_exports.oneOfType([prop_types_exports.arrayOf(prop_types_exports.string), prop_types_exports.arrayOf(prop_types_exports.arrayOf(prop_types_exports.string))]),
    rowColors: prop_types_exports.oneOfType([prop_types_exports.arrayOf(prop_types_exports.string), prop_types_exports.arrayOf(prop_types_exports.arrayOf(prop_types_exports.string))]),
    sparklineAreaColors: prop_types_exports.arrayOf(prop_types_exports.arrayOf(prop_types_exports.string)),
    sparklineColors: prop_types_exports.arrayOf(prop_types_exports.arrayOf(prop_types_exports.string)),
    sparklineTypes: prop_types_exports.arrayOf(prop_types_exports.arrayOf(prop_types_exports.oneOf(visualization_schemas_exports.validSparklineTypes)))
  }),
  theme: prop_types_exports.any,
  width: prop_types_exports.oneOfType([prop_types_exports.number]),
  onColumnFormatChange: prop_types_exports.func,
  font: prop_types_exports.string,
  fontSize: prop_types_exports.string
};
PureTable.defaultProps = {
  columnFormat: {},
  headers: [],
  headerVisibility: "inline",
  height: 300,
  mode: "view",
  onCellClick: null,
  paginatorParams: {
    isPaging: false,
    onChange: lodash_exports.noop
  },
  showRowNumbers: false,
  sortParams: {
    onSort: lodash_exports.noop
  },
  table: [],
  tableFormat: {},
  theme: {},
  width: 300,
  onColumnFormatChange: lodash_exports.noop,
  font: fontMap.proportional,
  fontSize: fontSizeMap.default
};
PureTable.displayName = "VizTable";
var PureTable_default = withEmptyTableMessage(FixedSizeContainer_default(PureTable));

// src/Table/Table.tsx
var computeVizProps = (_a) => {
  var props = __objRest(_a, []);
  var _a2, _b, _c, _d;
  const vizProps = __spreadValues({}, props);
  if (vizProps.columnFormat) {
    const columns = vizProps.columnFormat;
    const themeRowBackgroundColorOdd = vizProps.themeFunc("rowBackgroundColorOdd");
    const themeRowBackgroundColorEven = vizProps.themeFunc("rowBackgroundColorEven");
    const themeTextColor = vizProps.themeFunc("textColor");
    Object.entries(columns).forEach(([columnKey, columnProperties]) => {
      let rowBackgroundColors;
      let rowColors;
      if (columnProperties.rowBackgroundColors) {
        rowBackgroundColors = (0, colorUtils_exports.sanitizeArrayOfColors)(columnProperties.rowBackgroundColors).map(
          (color, i) => (
            // using (i + 1) % 2 because 'odd' refers to row number, so index 0 -> row 1 -> odd colored
            color || ((i + 1) % 2 === 0 ? themeRowBackgroundColorEven : themeRowBackgroundColorOdd)
          )
        );
      }
      if (columnProperties.rowColors) {
        rowColors = (0, colorUtils_exports.sanitizeArrayOfColors)(columnProperties.rowColors).map(
          (color) => color || themeTextColor
        );
      }
      vizProps.columnFormat[columnKey] = __spreadValues(__spreadValues(__spreadValues({}, vizProps.columnFormat[columnKey]), columnProperties.rowBackgroundColors && { rowBackgroundColors }), columnProperties.rowColors && { rowColors });
    });
    vizProps.columnIds = (_d = (_c = (_b = (_a2 = vizProps.dataSources) == null ? void 0 : _a2.primary) == null ? void 0 : _b.data) == null ? void 0 : _c.fields.map((field) => {
      var _a3;
      return (_a3 = field.name) != null ? _a3 : field;
    })) != null ? _d : [];
    if (vizProps.columnIds.length === 0) {
      vizProps.columnIds = vizProps.headers;
    }
  }
  if (vizProps.onOptionsChange) {
    const handleColumnFormatChange = (updatedColumnFormat) => {
      var _a3;
      const cloneOfExistingColumnFormat = __spreadValues({}, ((_a3 = vizProps == null ? void 0 : vizProps.options) == null ? void 0 : _a3.columnFormat) || {});
      const keys2 = Object.keys(updatedColumnFormat);
      const values = Object.values(updatedColumnFormat);
      keys2.forEach((key, index) => {
        if (!cloneOfExistingColumnFormat[key]) {
          cloneOfExistingColumnFormat[key] = {};
        }
        const newWidth = (0, lodash_exports.get)(values[index], "width");
        cloneOfExistingColumnFormat[key] = __spreadProps(__spreadValues({}, cloneOfExistingColumnFormat[key]), {
          width: newWidth
        });
      });
      vizProps.onOptionsChange({
        columnFormat: cloneOfExistingColumnFormat
      });
    };
    vizProps.onColumnFormatChange = handleColumnFormatChange;
  }
  return vizProps;
};
var Table = withDashboardViz_default({
  ReactViz: PureTable_default,
  vizConfig: config_default,
  disableEditModeCover: true,
  computeVizProps
});
var { themes: themes2 } = config_default;
var Table_default2 = Table;
//# sourceMappingURL=Table.js.map
