/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/Charting.tsx
var Charting_exports = {};
__export(Charting_exports, {
  NO_INPLACE_PROPS: () => NO_INPLACE_PROPS,
  appendTrellisToPayload: () => appendTrellisToPayload,
  canUpdateInPlace: () => canUpdateInPlace,
  changedOptions: () => changedOptions,
  default: () => Charting_default,
  updateRowPayload: () => updateRowPayload
});
module.exports = __toCommonJS(Charting_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport2 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-color-palettes
var visualization_color_palettes_exports = {};
__export(visualization_color_palettes_exports, {
  default: () => visualization_color_palettes_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-color-palettes"));
__reExport(visualization_color_palettes_exports, require("@splunk/visualization-color-palettes"));
var visualization_color_palettes_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport4 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport5 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:react-event-listener
var react_event_listener_exports = {};
__export(react_event_listener_exports, {
  default: () => react_event_listener_default
});
var defaultImport6 = __toESM(require("react-event-listener"));
__reExport(react_event_listener_exports, require("react-event-listener"));
var react_event_listener_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualizations-shared/i18n
var i18n_exports2 = {};
__export(i18n_exports2, {
  default: () => i18n_default2
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/i18n"));
__reExport(i18n_exports2, require("@splunk/visualizations-shared/i18n"));
var i18n_default2 = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/charting-bundle
var charting_bundle_exports = {};
__export(charting_bundle_exports, {
  default: () => charting_bundle_default
});
var defaultImport8 = __toESM(require("@splunk/charting-bundle"));
__reExport(charting_bundle_exports, require("@splunk/charting-bundle"));
var charting_bundle_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport9 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport10 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport11 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/themes/useSplunkTheme
var useSplunkTheme_exports = {};
__export(useSplunkTheme_exports, {
  default: () => useSplunkTheme_default
});
var defaultImport13 = __toESM(require("@splunk/themes/useSplunkTheme"));
__reExport(useSplunkTheme_exports, require("@splunk/themes/useSplunkTheme"));
var useSplunkTheme_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/visualizations-shared/themeUtils
var themeUtils_exports = {};
__export(themeUtils_exports, {
  default: () => themeUtils_default
});
var defaultImport14 = __toESM(require("@splunk/visualizations-shared/themeUtils"));
__reExport(themeUtils_exports, require("@splunk/visualizations-shared/themeUtils"));
var themeUtils_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport15 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/common/ChartingApi.ts
var ChartingApiFunctional = class {
  // eslint-disable-next-line no-useless-constructor
  constructor(chartRef) {
    this.chartRef = chartRef;
  }
  /**
   * Allows users to programmatically highlight a point on the chart
   *
   * @memberof ChartingApiFunctional
   */
  highlight({ xValue, seriesName } = { xValue: "", seriesName: "" }) {
    this.getChart().highlight(xValue, seriesName);
  }
  /**
   * Allows users to programmatically unhighlight all points on the chart
   *
   * @memberof ChartingApiFunctional
   */
  unHighlight() {
    this.getChart().unHighlight();
  }
  // returns chart object
  getChart() {
    var _a;
    return (_a = this.chartRef) == null ? void 0 : _a.current;
  }
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useEventCallback.tsx
var useEventCallback = (fn) => {
  const ref = (0, react_exports.useRef)(fn);
  (0, react_exports.useLayoutEffect)(() => {
    ref.current = fn;
  });
  return (0, react_exports.useCallback)((...args) => ref.current(...args), []);
};
var useEventCallback_default = useEventCallback;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport16 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// src/common/utils/dataUtils.ts
var calculateThresholdOnRangeSelect = ({
  firstIndex,
  lastIndex,
  dataSources,
  width
}) => {
  var _a, _b, _c;
  const window2 = lastIndex - firstIndex + 1;
  const ratio = Math.round(Number(((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns[0]) == null ? void 0 : _c.length) / window2) * 10) / 10;
  return Math.round(ratio * Number(width));
};
var calculateDownsamplingThreshold = ({
  enableSearchZoom,
  dataSources,
  selectChartEvent,
  width,
  xField
}) => {
  var _a, _b, _c;
  if (enableSearchZoom || !selectChartEvent) {
    return Number(width);
  }
  const primaryDataSource = dataSources == null ? void 0 : dataSources.primary;
  if (!primaryDataSource) {
    return null;
  }
  const { startXIndex, endXIndex, currentTarget } = selectChartEvent;
  try {
    const xFieldIndex = (_a = primaryDataSource == null ? void 0 : primaryDataSource.data) == null ? void 0 : _a.fields.findIndex((field) => {
      const name = typeof field === "string" ? field : field.name;
      return name === xField;
    });
    const downsampledXFieldIndex = (_b = currentTarget.dataSet) == null ? void 0 : _b.fields.findIndex((field) => field === xField);
    if (xFieldIndex === -1 || downsampledXFieldIndex === -1) {
      return null;
    }
    const fullSeries = (_c = primaryDataSource == null ? void 0 : primaryDataSource.data) == null ? void 0 : _c.columns[xFieldIndex];
    const downsampledSeries = currentTarget.dataSet.seriesList[downsampledXFieldIndex];
    const firstIndex = fullSeries.findIndex((x) => {
      return downsampledSeries[startXIndex] === x;
    });
    const lastIndex = fullSeries.findIndex((x) => {
      return downsampledSeries[endXIndex] === x;
    });
    if (firstIndex >= 0 && lastIndex >= 0 && firstIndex <= lastIndex) {
      return calculateThresholdOnRangeSelect({
        firstIndex,
        lastIndex,
        dataSources,
        width
      });
    }
  } catch (e) {
    console.error("Error occurred while setting downsample threshold on range select event", e);
  }
  return null;
};

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport17 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// src/common/hooks/useTrellisEnabled.ts
var useTrellisFeatureFlagOn = () => {
  const context = (0, react_exports.useContext)(FeatureFlagContext_default);
  return Boolean(context == null ? void 0 : context.visualizations_enableTrellis);
};
var useTrellisEnabled = (layoutType = visualization_schemas_exports.LAYOUT_TYPE.Off) => {
  const trellisFeatureEnabled = useTrellisFeatureFlagOn();
  return trellisFeatureEnabled && layoutType === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};

// src/common/components/TrellisTitle.tsx
var TRELLIS_TITLE_HEIGHT = 28;
var TrellisTitleText = styled_components_default.div`
    margin-left: 10px;
    margin-right: 10px;
    padding-top: 8px;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
`;
var TrellisTitleDiv = styled_components_default.div`
    height: ${TRELLIS_TITLE_HEIGHT}px;
    font-size: 14px;
    font-weight: 700;
    color: ${(props) => props.fontColor};
    background-color: ${(props) => props.backgroundColor};
    box-shadow: 0 1px ${(props) => props.backgroundColor}; // this is added to avoid a 1px gap between title and viz divs that showed up intermittently because of pixel rounding error in chrome.
`;
var TrellisTitle = (props) => {
  const titleText = String(props.trellisKey).toString();
  return /* @__PURE__ */ react_exports.createElement(
    TrellisTitleDiv,
    {
      fontColor: props.fontColor,
      backgroundColor: props.backgroundColor,
      "data-test": "trellis-title",
      title: titleText
    },
    /* @__PURE__ */ react_exports.createElement(TrellisTitleText, null, titleText)
  );
};

// src/common/Charting.tsx
var NO_INPLACE_PROPS = [
  "chart",
  "chart.orientation",
  "layout.splitSeries",
  "chart.style",
  "legend.placement"
];
var appendTrellisToPayload = (props, payload) => {
  if (props.trellisSplitBy) {
    payload["trellis.name"] = props.trellisSplitBy;
  }
  if (props.trellisKey) {
    payload["trellis.value"] = props.trellisKey;
  }
  return payload;
};
var changedOptions = (curOptions, nextOptions) => Object.keys(curOptions).filter((key) => !(key in nextOptions)).concat(
  Object.keys(nextOptions).filter(
    (key) => !(key in curOptions) || curOptions[key] !== nextOptions[key]
  )
);
var canUpdateInPlace = (curOptions, nextOptions) => {
  if (!curOptions || !nextOptions) {
    return false;
  }
  return !NO_INPLACE_PROPS.some((p) => curOptions[p] !== nextOptions[p]) && !changedOptions(curOptions, nextOptions).some((p) => p.toLowerCase().endsWith("color"));
};
var updateRowPayload = (chartEventRowContext, payload) => {
  Object.keys(chartEventRowContext || {}).forEach((key) => {
    payload[`${key}.value`] = chartEventRowContext[key];
  });
  return payload;
};
var ChartingContainer = styled_components_default.div.attrs((props) => ({
  "data-test": "charting-container",
  width: props.width,
  height: props.height
}))`
    & .highcharts-a11y-proxy-container {
        pointer-events: none;
    }
    overflow: hidden;
    position: relative;
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
`;
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  options: prop_types_exports.object,
  chartData: prop_types_exports.object,
  onEventTrigger: prop_types_exports.func,
  onClick: prop_types_exports.func,
  onSelect: prop_types_exports.func,
  onPointMouseOver: prop_types_exports.func,
  onPointMouseOut: prop_types_exports.func,
  style: prop_types_exports.object,
  colorPalette: prop_types_exports.array,
  visualizationApiRef: prop_types_exports.func,
  themeKey: prop_types_exports.string,
  originalDataSources: prop_types_exports.object,
  onDownsamplingThresholdChange: prop_types_exports.func,
  xField: prop_types_exports.string,
  y2Fields: prop_types_exports.array,
  additionalTooltipFields: prop_types_exports.array,
  splitByLayout: prop_types_exports.oneOf(Object.values(visualization_schemas_exports.LAYOUT_TYPE)),
  trellisKey: prop_types_exports.string,
  trellisSplitBy: prop_types_exports.string,
  backgroundColor: prop_types_exports.string,
  defaultFontColor: prop_types_exports.string
};
var Charting = (props) => {
  var _a, _b;
  const container = (0, react_exports.useRef)(null);
  const needsInit = (0, react_exports.useRef)(true);
  const chart = (0, react_exports.useRef)();
  const needsRedraw = (0, react_exports.useRef)(true);
  const api = (0, react_exports.useRef)(new ChartingApiFunctional(chart));
  const timezone = (0, react_exports.useContext)(TimezoneContext_default);
  const selectChartEvent = (0, react_exports.useRef)(null);
  const trellisEnabled = useTrellisEnabled(props.splitByLayout);
  const computeChartingSize = () => {
    if (container.current) {
      const rect = container.current.getBoundingClientRect();
      return {
        height: rect.height,
        width: rect.width
      };
    }
    return {};
  };
  const splunkTheme = useSplunkTheme_default();
  const themeKey = props.themeKey ? props.themeKey : (0, themeUtils_exports.getChartingThemeKey)({ splunkThemeV1: splunkTheme });
  const {
    width,
    height,
    style,
    chartData,
    options,
    colorPalette,
    onClick,
    onSelect,
    onPointMouseOut,
    onPointMouseOver,
    onEventTrigger,
    originalDataSources,
    onDownsamplingThresholdChange,
    xField,
    backgroundColor,
    defaultFontColor,
    trellisKey,
    additionalTooltipFields
  } = props;
  const prevOptions = usePrevious(options);
  const prevTimezone = usePrevious(timezone);
  const handleClick = (chartEvent, type) => {
    let payload = (0, lodash_exports.pick)(
      chartEvent,
      "name2",
      "value2",
      "_span",
      "modifierKey"
    );
    payload.name = payload.name2;
    delete payload.name2;
    if (type === "point.click" /* POINT_CLICK */) {
      payload.value = payload.value2;
      delete payload.value2;
      payload = updateRowPayload(chartEvent.rowContext, payload);
    }
    payload = appendTrellisToPayload(props, payload);
    onClick({
      type,
      originalEvent: chartEvent,
      payload
    });
  };
  const destroyChart = () => {
    if (chart.current) {
      chart.current.destroy();
      chart.current = null;
    }
    needsRedraw.current = true;
    needsInit.current = true;
  };
  const enableSearchZoom = (_b = (_a = chartData == null ? void 0 : chartData.chartDataOptions) == null ? void 0 : _a.enableSearchZoom) != null ? _b : false;
  const recalculateDownsamplingThreshold = react_exports.useCallback(() => {
    if (!onDownsamplingThresholdChange || !xField) {
      return;
    }
    const newThreshold = calculateDownsamplingThreshold({
      enableSearchZoom,
      dataSources: originalDataSources,
      width: Number(width),
      selectChartEvent: selectChartEvent.current,
      xField
    });
    if (Number.isFinite(newThreshold)) {
      onDownsamplingThresholdChange(newThreshold);
    }
  }, [enableSearchZoom, originalDataSources, onDownsamplingThresholdChange, width, xField]);
  react_exports.useEffect(() => {
    recalculateDownsamplingThreshold();
  }, [recalculateDownsamplingThreshold]);
  const handleSelect = useEventCallback_default((chartEvent) => {
    selectChartEvent.current = chartEvent;
    recalculateDownsamplingThreshold();
    const payload = appendTrellisToPayload(
      props,
      (0, lodash_exports.pick)(chartEvent, "startXIndex", "endXIndex", "startXValue", "endXValue")
    );
    if (onSelect && typeof onSelect === "function") {
      onSelect({
        type: "range.select",
        originalEvent: chartEvent,
        payload
      });
      return;
    }
    onEventTrigger({
      type: "range.select",
      originalEvent: chartEvent,
      payload
    });
  });
  const handlePointMouseOut = useEventCallback_default(
    (chartEvent, type) => {
      let payload = (0, lodash_exports.pick)(
        chartEvent,
        "name2",
        "value2",
        "_span",
        "modifierKey",
        "tooltipContext"
      );
      payload.name = payload.name2;
      delete payload.name2;
      payload.value = payload.value2;
      delete payload.value2;
      payload = appendTrellisToPayload(props, updateRowPayload(chartEvent.rowContext, payload));
      onPointMouseOut({
        type,
        originalEvent: chartEvent,
        payload
      });
    }
  );
  const handlePointMouseOver = useEventCallback_default(
    (chartEvent, type) => {
      let payload = (0, lodash_exports.pick)(
        chartEvent,
        "name2",
        "value2",
        "_span",
        "modifierKey",
        "tooltipContext"
      );
      payload.name = payload.name2;
      delete payload.name2;
      payload.value = payload.value2;
      delete payload.value2;
      payload = appendTrellisToPayload(props, updateRowPayload(chartEvent.rowContext, payload));
      onPointMouseOver({
        type,
        originalEvent: chartEvent,
        payload
      });
    }
  );
  const drawChart = () => {
    const updatedOptions = __spreadProps(__spreadValues({}, options), { shouldColorizeTooltipData: false });
    const computedChartSize = computeChartingSize();
    const computedWidth = computedChartSize.width;
    const computedHeight = computedChartSize.height;
    const serializedTimezone = timezone == null ? void 0 : timezone.serializedTimezone;
    const ianaTimezone = timezone == null ? void 0 : timezone.ianaTimezone;
    const utcOffset = timezone == null ? void 0 : timezone.utcOffset;
    if (!computedWidth || !computedHeight) {
      return;
    }
    if (!chartData || !Object.keys(chartData).length) {
      return;
    }
    if (prevOptions) {
      Object.keys(prevOptions).forEach((key) => {
        if (prevOptions[key] && updatedOptions[key] === void 0) {
          updatedOptions[key] = "";
        }
      });
    }
    try {
      if (needsInit.current) {
        destroyChart();
        charting_bundle_default.setTheme(themeKey);
        if (colorPalette.length > 0) {
          charting_bundle_default.setColorPalette(colorPalette);
        }
        chart.current = charting_bundle_default.createChart(container.current, __spreadValues(__spreadValues(__spreadValues(__spreadProps(__spreadValues({}, updatedOptions), {
          drilldown: "all"
        }), typeof serializedTimezone === "string" && {
          "time.serializedTz": serializedTimezone
        }), typeof ianaTimezone === "string" && {
          "time.ianaTimezone": ianaTimezone
        }), typeof utcOffset === "number" && {
          "time.timezoneOffset": utcOffset
        }));
        chart.current.on("pointClick", (e) => {
          handleClick(e, "point.click" /* POINT_CLICK */);
        });
        chart.current.on("pointMouseOver", (e) => {
          handlePointMouseOver(e, "point.mouseover" /* POINT_MOUSE_OVER */);
        });
        chart.current.on("pointMouseOut", (e) => {
          handlePointMouseOut(e, "point.mouseout" /* POINT_MOUSE_OUT */);
        });
        chart.current.on("legendClick", (e) => {
          handleClick(e, "legend.click" /* LEGEND_CLICK */);
        });
        chart.current.on("chartRangeSelect", handleSelect);
      }
      if (needsRedraw.current) {
        charting_bundle_default.setTheme(themeKey);
        if (colorPalette.length > 0) {
          charting_bundle_default.setColorPalette(colorPalette);
        }
        const payload = appendTrellisToPayload(props, {
          width,
          height,
          currentTime: (/* @__PURE__ */ new Date()).getTime()
        });
        chart.current.prepareAndDraw(chartData, updatedOptions, () => {
          onEventTrigger({
            type: "viz.renderedWithData",
            payload
          });
        });
      }
      if (chart.current) {
        if (Math.round(chart.current.height) !== Math.round(computedHeight) || Math.round(chart.current.width) !== Math.round(computedWidth)) {
          chart.current.resize(computedWidth, computedHeight);
        }
      }
      needsInit.current = false;
      needsRedraw.current = false;
    } catch (e) {
      window.console.error("Caught error rendering chart:", e);
    }
  };
  const debouncedDrawChart = (0, lodash_exports.debounce)(drawChart, 5);
  const onContainerMount = (chartingContainer) => {
    container.current = chartingContainer;
    debouncedDrawChart();
  };
  const prevTheme = usePrevious(themeKey);
  const prevOnClick = usePrevious(onClick);
  (0, react_exports.useEffect)(() => {
    debouncedDrawChart();
    props.visualizationApiRef(api.current);
    return () => {
      props.visualizationApiRef(null);
      destroyChart();
    };
  }, []);
  (0, react_exports.useEffect)(() => {
    if (!chart.current || !canUpdateInPlace(prevOptions, options) || // timezone is a simple object so this comparison should be fast
    JSON.stringify(prevTimezone) !== JSON.stringify(timezone) || !props.themeKey && prevTheme !== themeKey || prevOnClick !== onClick) {
      needsInit.current = true;
    }
    needsRedraw.current = true;
    drawChart();
  }, [
    JSON.stringify(options),
    JSON.stringify(chartData.toJSON()),
    JSON.stringify(chartData.annotations),
    timezone == null ? void 0 : timezone.ianaTimezone,
    timezone == null ? void 0 : timezone.utcOffset,
    timezone == null ? void 0 : timezone.serializedTimezone,
    themeKey,
    onClick,
    additionalTooltipFields
  ]);
  return /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, trellisEnabled && /* @__PURE__ */ react_exports.createElement(
    TrellisTitle,
    {
      trellisKey,
      backgroundColor,
      fontColor: defaultFontColor
    }
  ), /* @__PURE__ */ react_exports.createElement(
    ChartingContainer,
    {
      style,
      ref: onContainerMount,
      width,
      height: trellisEnabled ? Number(height) - TRELLIS_TITLE_HEIGHT : height
    },
    /* @__PURE__ */ react_exports.createElement(react_event_listener_default, { target: window, onResize: debouncedDrawChart })
  ));
};
var defaultProps = {
  width: "100%",
  height: 250,
  options: {},
  style: {},
  // todo: need remove it
  onEventTrigger: lodash_exports.noop,
  onClick: lodash_exports.noop,
  onSelect: lodash_exports.noop,
  onPointMouseOver: lodash_exports.noop,
  onPointMouseOut: lodash_exports.noop,
  colorPalette: visualization_color_palettes_exports.VIZ_CATEGORICAL,
  visualizationApiRef: lodash_exports.noop,
  chartData: null,
  themeKey: null,
  onDownsamplingThresholdChange: null,
  originalDataSources: null,
  xField: null,
  y2Fields: [],
  splitByLayout: void 0,
  trellisKey: void 0,
  trellisSplitBy: void 0,
  backgroundColor: "",
  defaultFontColor: "",
  additionalTooltipFields: []
};
Charting.propTypes = propTypes;
Charting.defaultProps = defaultProps;
var ChartingWrapper = (props) => {
  const { chartData } = props;
  if (!chartData) {
    return /* @__PURE__ */ react_exports.createElement(Message_default, { message: (0, i18n_exports._)("No DataSource"), level: "warning" });
  }
  if (!Object.keys(chartData).length) {
    return /* @__PURE__ */ react_exports.createElement(Message_default, { message: (0, i18n_exports._)("No Result"), level: "info" });
  }
  return /* @__PURE__ */ react_exports.createElement(Charting, __spreadValues({}, props));
};
ChartingWrapper.propTypes = propTypes;
ChartingWrapper.defaultProps = defaultProps;
var Charting_default = ChartingWrapper;
//# sourceMappingURL=Charting.js.map
