/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// src/common/EventsDoc.jsx
var EventsDoc_exports = {};
__export(EventsDoc_exports, {
  default: () => EventsDoc_default
});
module.exports = __toCommonJS(EventsDoc_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/react-ui/Heading
var Heading_exports = {};
__export(Heading_exports, {
  default: () => Heading_default
});
var defaultImport3 = __toESM(require("@splunk/react-ui/Heading"));
__reExport(Heading_exports, require("@splunk/react-ui/Heading"));
var Heading_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/react-ui/Markdown
var Markdown_exports = {};
__export(Markdown_exports, {
  default: () => Markdown_default
});
var defaultImport4 = __toESM(require("@splunk/react-ui/Markdown"));
__reExport(Markdown_exports, require("@splunk/react-ui/Markdown"));
var Markdown_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/react-ui/JSONTree
var JSONTree_exports = {};
__export(JSONTree_exports, {
  default: () => JSONTree_default
});
var defaultImport5 = __toESM(require("@splunk/react-ui/JSONTree"));
__reExport(JSONTree_exports, require("@splunk/react-ui/JSONTree"));
var JSONTree_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport6 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// src/common/EventsDoc.jsx
var EventTester = styled_components_default.div`
    margin-top: 50px;
`;
var Event = styled_components_default.div`
    margin-top: 20px;
`;
var EventName = styled_components_default.div`
    color: #5ca300;
    padding-bottom: 5px;
`;
var EventItem = ({ name, desc }) => /* @__PURE__ */ react_default.createElement(Event, null, /* @__PURE__ */ react_default.createElement(EventName, null, name), /* @__PURE__ */ react_default.createElement(Markdown_default, { style: { marginLeft: 40 }, text: desc }));
EventItem.propTypes = {
  name: prop_types_default.string,
  desc: prop_types_default.string
};
var EventsDesc = ({ events, vizType }) => /* @__PURE__ */ react_default.createElement("div", null, /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, Object.keys(events).length !== 0 || vizType === "splunk.events" ? "Events" : "No Events"), vizType === "splunk.events" && /* @__PURE__ */ react_default.createElement(Markdown_default, { text: "Events are dynamically added via the `eventActions` and `fieldActions` options for the Events visualization." }), Object.keys(events).map((eventName) => /* @__PURE__ */ react_default.createElement(EventItem, { key: eventName, name: eventName, desc: events[eventName].description })));
EventsDesc.propTypes = {
  events: prop_types_default.object.isRequired,
  vizType: prop_types_default.string
};
var VisExample = class extends react_exports.PureComponent {
  render() {
    const { options = {}, Visualization, dsState, onEventTrigger, height, width } = this.props;
    return /* @__PURE__ */ react_default.createElement(EventTester, null, /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, "Test Visualization"), /* @__PURE__ */ react_default.createElement(
      Visualization,
      {
        options,
        dataSources: dsState,
        onEventTrigger,
        hasEventHandlers: true,
        height,
        width
      }
    ));
  }
};
VisExample.propTypes = {
  options: prop_types_default.object,
  Visualization: prop_types_default.any,
  dsState: prop_types_default.object,
  onEventTrigger: prop_types_default.func,
  height: prop_types_default.number,
  width: prop_types_default.number
};
var EventExample = ({ event }) => {
  const eventToDisplay = __spreadValues({}, event);
  if (eventToDisplay.originalEvent != null) {
    eventToDisplay.originalEvent = "...Original Event instance...";
  }
  const content = (0, react_exports.useMemo)(
    () => /* @__PURE__ */ react_default.createElement(JSONTree_default, { key: JSON.stringify(eventToDisplay), json: eventToDisplay, expandChildren: true }),
    [eventToDisplay]
  );
  return /* @__PURE__ */ react_default.createElement(react_default.Fragment, null, /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, "Event Monitor"), content);
};
EventExample.propTypes = {
  event: prop_types_default.object
};
var EventsDoc = class extends react_exports.Component {
  constructor(props, context) {
    super(props, context);
    __publicField(this, "handleEvent", (e) => {
      this.setState({
        e
      });
    });
    this.state = {
      e: null
    };
  }
  render() {
    var _a, _b, _c;
    return /* @__PURE__ */ react_default.createElement("div", null, /* @__PURE__ */ react_default.createElement(EventsDesc, { events: this.props.events, vizType: (_c = (_b = (_a = this.props) == null ? void 0 : _a.Visualization) == null ? void 0 : _b.config) == null ? void 0 : _c.key }), /* @__PURE__ */ react_default.createElement(VisExample, __spreadProps(__spreadValues({}, this.props), { onEventTrigger: this.handleEvent })), /* @__PURE__ */ react_default.createElement(EventExample, { event: this.state.e }));
  }
};
EventsDoc.propTypes = {
  options: prop_types_default.object,
  events: prop_types_default.object,
  dsState: prop_types_default.object,
  Visualization: prop_types_default.any
};
var EventsDoc_default = EventsDoc;
//# sourceMappingURL=EventsDoc.js.map
