/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/OptionsDoc.jsx
var OptionsDoc_exports = {};
__export(OptionsDoc_exports, {
  default: () => OptionsDoc_default,
  getType: () => getType
});
module.exports = __toCommonJS(OptionsDoc_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:lodash/isEmpty
var isEmpty_exports = {};
__export(isEmpty_exports, {
  default: () => isEmpty_default
});
var defaultImport3 = __toESM(require("lodash/isEmpty"));
__reExport(isEmpty_exports, require("lodash/isEmpty"));
var isEmpty_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport4 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/react-ui/Heading
var Heading_exports = {};
__export(Heading_exports, {
  default: () => Heading_default
});
var defaultImport5 = __toESM(require("@splunk/react-ui/Heading"));
__reExport(Heading_exports, require("@splunk/react-ui/Heading"));
var Heading_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/react-ui/Markdown
var Markdown_exports = {};
__export(Markdown_exports, {
  default: () => Markdown_default
});
var defaultImport6 = __toESM(require("@splunk/react-ui/Markdown"));
__reExport(Markdown_exports, require("@splunk/react-ui/Markdown"));
var Markdown_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport7 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport8 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport9 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// .storybook/utils/storybookUtils.ts
var getPatternOptions = (patternString) => {
  if (patternString.indexOf("^#[") === 0) {
    return patternString.slice(1).replace(/\$/g, "").split("|^");
  }
  return patternString.replace(/\$/g, "").split("|^").slice(1);
};
var getOptionDisplayType = (option) => {
  const { oneOf, anyOf, type, enum: en, pattern, items } = option;
  let displayTypes = [];
  const conditionalQuote = type === "string" ? '"' : "";
  if (en && Array.isArray(en)) {
    displayTypes = en.map((e) => {
      const enumQuote = typeof e === "string" ? '"' : "";
      return `${enumQuote}${e}${enumQuote}`;
    });
  } else if (type === "array" && items) {
    return `${getOptionDisplayType(items)}[]`;
  } else if (anyOf && Array.isArray(anyOf)) {
    return getOptionDisplayType(anyOf[0]);
  } else if (oneOf && Array.isArray(oneOf)) {
    displayTypes = oneOf.map((item) => getOptionDisplayType(item));
  } else if (Array.isArray(type)) {
    displayTypes = type;
  } else if (pattern) {
    displayTypes = getPatternOptions(pattern).map((p) => `${conditionalQuote}${p}${conditionalQuote}`);
  }
  if (displayTypes.length > 0) {
    return `(${displayTypes.join(" | ")})`;
  }
  return type;
};
var objectTableControl = { control: { type: "object" } };
var disableTableControl = { table: { disable: true } };
var platformOptionArgTypes = {
  context: objectTableControl,
  dataSources: objectTableControl,
  dataSource: disableTableControl,
  options: disableTableControl,
  onEventTrigger: __spreadValues({ action: "eventTrigger" }, disableTableControl),
  hasEventHandlers: disableTableControl
};

// src/common/OptionsDoc.jsx
var Option = styled_components_default.div`
    margin-top: 20px;
`;
var OptionName = styled_components_default.div`
    color: #5ca300;
    padding-bottom: 5px;
`;
var PairContainer = styled_components_default.div`
    margin-left: 40px;
    margin-top: 10px;
`;
var PairTitle = styled_components_default.span`
    display: inline-block;
    color: #8293a7;
    width: 80px;
`;
var PairValue = styled_components_default.span`
    font-family: 'Splunk Platform Mono', monospace;
    white-space: pre;
`;
var PairValueJSON = styled_components_default.div`
    margin-left: 80px;
    pre {
        margin: 0;
    }
    code {
        font-size: 12px;
        font-family: 'Splunk Platform Mono', monospace;
    }
`;
var PropertiesWrapper = styled_components_default.div`
    margin-left: ${(props) => props.isPatternProperty ? 0 : 40}px;
    margin-top: 20px;
`;
var PropertiesContainer = styled_components_default.div`
    margin-left: ${(props) => props.isPatternProperty ? 40 : 0}px;
    margin-top: 10px;
`;
var PropertiesContent = styled_components_default.div`
    margin-left: ${(props) => props.isPatternProperty ? 40 : 0}px;
`;
var isOneOfJsonSchema = (item) => item.oneOf && Array.isArray(item.oneOf);
var getOrType = (item) => {
  let res = "";
  if (isOneOfJsonSchema(item)) {
    res = item.oneOf.map((one) => {
      if (one.type !== "array") {
        return one.type;
      }
      return getArrayType(one, "");
    }).join(" | ");
  } else if (Array.isArray(item.type)) {
    if (isEmpty_default(item.default)) {
      return item.type.join(" | ");
    }
    res = item.type.filter((itemType) => itemType !== "string").join(" | ");
    res += " | ";
    res += `"${item.default}"`;
  }
  return res;
};
var getArrayType = (item, res = "") => {
  if (item.type !== "array") {
    if (Array.isArray(item.type) || isOneOfJsonSchema(item)) {
      return getOrType(item);
    }
    return item.type;
  }
  if (item.type === "array") {
    res += "arrayOf(";
  }
  res += getArrayType(item.items, "");
  res += ")";
  return res;
};
var getType = (item) => {
  if (isOneOfJsonSchema(item)) {
    return `oneOf(${getOrType(item)})`;
  }
  if (item.enum && Array.isArray(item.enum)) {
    const values = !isEmpty_default(item.enum) && typeof item.enum[0] === "string" ? item.enum.map((v) => `"${v}"`).join(", ") : item.enum.join(", ");
    return `oneOf([${values}])`;
  }
  if (Array.isArray(item.type)) {
    return getOrType(item);
  }
  if (item.type === "array") {
    if ("items" in item) {
      return `arrayOf(${getType(item.items)})`;
    }
    return "array";
  }
  return item.type;
};
var getDefaultValue = (defaultValue) => {
  if (typeof defaultValue === "boolean" || typeof defaultValue === "number") {
    return defaultValue.toString();
  }
  if (Array.isArray(defaultValue)) {
    if (defaultValue.length > 1 && typeof defaultValue[0] === "object") {
      return defaultValue;
    }
    const values = defaultValue.map((v) => JSON.stringify(v)).join(", ");
    return `[${values}]`;
  }
  return defaultValue;
};
var Pair = ({ title, content }) => /* @__PURE__ */ react_default.createElement(PairContainer, null, /* @__PURE__ */ react_default.createElement(PairTitle, null, `${title}:`), Array.isArray(content) ? /* @__PURE__ */ react_default.createElement(PairValueJSON, null, /* @__PURE__ */ react_default.createElement("pre", null, /* @__PURE__ */ react_default.createElement("code", null, JSON.stringify(content, null, 2)))) : /* @__PURE__ */ react_default.createElement(PairValue, null, content));
Pair.propTypes = {
  title: prop_types_default.string,
  content: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.arrayOf(prop_types_default.object)])
};
var PropertyItems = ({ isPatternProperty = false, propsItems }) => /* @__PURE__ */ react_default.createElement(PropertiesContainer, { isPatternProperty }, isPatternProperty ? /* @__PURE__ */ react_default.createElement(PairTitle, null, (0, i18n_exports._)("[fieldName]:")) : null, /* @__PURE__ */ react_default.createElement(PropertiesContent, { isPatternProperty }, propsItems));
PropertyItems.propTypes = {
  isPatternProperty: prop_types_default.bool,
  propsItems: prop_types_default.array
};
var OptionItem = ({ name, type, desc, defaultValue, enumerable, PropertiesSection }) => /* @__PURE__ */ react_default.createElement(Option, null, /* @__PURE__ */ react_default.createElement(OptionName, null, name), desc ? /* @__PURE__ */ react_default.createElement(Markdown_default, { style: { marginLeft: 40 }, text: desc }) : null, /* @__PURE__ */ react_default.createElement(Pair, { title: (0, i18n_exports._)("Type"), content: type }), (enumerable == null ? void 0 : enumerable.length) > 0 && /* @__PURE__ */ react_default.createElement(
  Pair,
  {
    title: (0, i18n_exports._)("oneOf"),
    content: `(${enumerable.map(
      (entry) => `${typeof entry === "string" ? '"' : ""}${entry}${typeof entry === "string" ? '"' : ""}`
    ).join(" | ")})`
  }
), defaultValue && /* @__PURE__ */ react_default.createElement(Pair, { title: (0, i18n_exports._)("Default"), content: defaultValue }), PropertiesSection);
OptionItem.propTypes = {
  name: prop_types_default.string,
  type: prop_types_default.string,
  desc: prop_types_default.string,
  enumerable: prop_types_default.arrayOf(prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number])),
  defaultValue: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.arrayOf(prop_types_default.object)]),
  PropertiesSection: prop_types_default.element
};
OptionItem.default = {
  PropertiesItem: null
};
var getPropertiesSection = (properties, patternProperties) => {
  let allProperties = [];
  let isPatternProperty = false;
  if (!isEmpty_default(properties)) {
    allProperties = [properties];
  } else if (!isEmpty_default(patternProperties)) {
    Object.keys(patternProperties).forEach((patternKey) => {
      const propsInPattern = patternProperties[patternKey].properties;
      if (propsInPattern) {
        allProperties.push(propsInPattern);
      }
    });
    isPatternProperty = true;
  }
  if (allProperties.length) {
    const allPropsItems = allProperties.map((props) => {
      const propsItems = Object.keys(props).map((pKey) => {
        var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q;
        const p = props[pKey];
        let pType = ((_a = p.anyOf) == null ? void 0 : _a[0]) ? getOptionDisplayType(__spreadProps(__spreadValues({}, (_b = p.anyOf) == null ? void 0 : _b[0]), { enum: p.enum })) : getOptionDisplayType(__spreadProps(__spreadValues({}, p), { enum: p.enum }));
        const pDefault = getDefaultValue(p.default);
        let pEnumerable;
        if (typeof ((_d = (_c = p.anyOf) == null ? void 0 : _c[0]) == null ? void 0 : _d.pattern) === "string") {
          pEnumerable = getPatternOptions(p.anyOf[0].pattern);
        } else if (((_h = (_g = (_f = (_e = p.anyOf) == null ? void 0 : _e[0]) == null ? void 0 : _f.items) == null ? void 0 : _g.enum) == null ? void 0 : _h.length) > 0) {
          pType = pType.replace(/\((.+?)\)/g, "string");
          pEnumerable = p.anyOf[0].items.enum;
        } else if (((_m = (_l = (_k = (_j = (_i = p.anyOf) == null ? void 0 : _i[0]) == null ? void 0 : _j.items) == null ? void 0 : _k.items) == null ? void 0 : _l.enum) == null ? void 0 : _m.length) > 0) {
          pType = pType.replace(/\((.+?)\)/g, "string");
          pEnumerable = p.anyOf[0].items.items.enum;
        } else if (p.enum) {
          pEnumerable = p.enum;
        }
        if (pEnumerable == null ? void 0 : pEnumerable.length) {
          pType = ((_o = (_n = p.anyOf) == null ? void 0 : _n[0]) == null ? void 0 : _o.type) !== "array" ? (_q = (_p = p.anyOf) == null ? void 0 : _p[0]) == null ? void 0 : _q.type : pType;
          if (Array.isArray(pType)) {
            pType = pType.join(" | ");
          }
        }
        return /* @__PURE__ */ react_default.createElement(
          OptionItem,
          {
            key: pKey,
            name: pKey,
            type: pType,
            enumerable: pEnumerable,
            desc: p.description,
            defaultValue: pDefault
          }
        );
      });
      return /* @__PURE__ */ react_default.createElement(
        PropertyItems,
        {
          key: propsItems,
          isPatternProperty,
          propsItems
        }
      );
    });
    return /* @__PURE__ */ react_default.createElement(PropertiesWrapper, { isPatternProperty }, allPropsItems);
  }
  return null;
};
var OptionsDoc = ({ options, description }) => /* @__PURE__ */ react_default.createElement("div", null, options.length === 0 ? /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, " No Options") : /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, "Options"), description && /* @__PURE__ */ react_default.createElement("div", null, description), Object.entries(options).map(([key, item]) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o;
  let type;
  let enumerable = [];
  let PropertiesSection = null;
  if (typeof ((_b = (_a = item.anyOf) == null ? void 0 : _a[0]) == null ? void 0 : _b.pattern) === "string") {
    enumerable = getPatternOptions(item.anyOf[0].pattern);
  } else if ((_d = (_c = item.anyOf) == null ? void 0 : _c[0]) == null ? void 0 : _d.enum) {
    enumerable = (_f = (_e = item.anyOf) == null ? void 0 : _e[0]) == null ? void 0 : _f.enum;
  } else if (item.enum) {
    enumerable = item.enum;
  }
  if (((_h = (_g = item.anyOf) == null ? void 0 : _g[0]) == null ? void 0 : _h.type) === "array" && "anyOf" in ((_j = (_i = item.anyOf) == null ? void 0 : _i[0]) == null ? void 0 : _j.items)) {
    type = getOptionDisplayType(item);
    const { patternProperties } = item;
    const option = (_m = (_l = (_k = item.anyOf) == null ? void 0 : _k[0]) == null ? void 0 : _l.items) == null ? void 0 : _m.anyOf;
    const mergedOptions = option.reduce((prev, next) => (0, lodash_exports.merge)(prev, next), {});
    const { properties } = mergedOptions;
    PropertiesSection = getPropertiesSection(properties, patternProperties);
    return /* @__PURE__ */ react_default.createElement(
      OptionItem,
      {
        key,
        name: key,
        type,
        enumerable,
        desc: item.description,
        PropertiesSection
      }
    );
  }
  if (item.type === "object") {
    type = item.type;
    const { properties } = item;
    const { patternProperties } = item;
    PropertiesSection = getPropertiesSection(properties, patternProperties);
  } else if (enumerable == null ? void 0 : enumerable.length) {
    type = (_o = (_n = item.anyOf) == null ? void 0 : _n[0]) == null ? void 0 : _o.type;
    if (Array.isArray(type)) {
      type = type.join(" | ");
    }
  } else {
    type = getOptionDisplayType(__spreadProps(__spreadValues({}, item.anyOf[0]), { enum: item.enum }));
  }
  return /* @__PURE__ */ react_default.createElement(
    OptionItem,
    {
      key,
      name: key,
      type,
      enumerable,
      desc: item.description,
      defaultValue: getDefaultValue(item.default),
      PropertiesSection
    }
  );
}));
OptionsDoc.propTypes = {
  options: prop_types_default.object.isRequired,
  description: prop_types_default.string
};
var OptionsDoc_default = OptionsDoc;
//# sourceMappingURL=OptionsDoc.js.map
