/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/ThemesDoc.jsx
var ThemesDoc_exports = {};
__export(ThemesDoc_exports, {
  default: () => ThemesDoc_default
});
module.exports = __toCommonJS(ThemesDoc_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/react-ui/Heading
var Heading_exports = {};
__export(Heading_exports, {
  default: () => Heading_default
});
var defaultImport3 = __toESM(require("@splunk/react-ui/Heading"));
__reExport(Heading_exports, require("@splunk/react-ui/Heading"));
var Heading_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport4 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:lodash/omit
var omit_exports = {};
__export(omit_exports, {
  default: () => omit_default
});
var defaultImport5 = __toESM(require("lodash/omit"));
__reExport(omit_exports, require("lodash/omit"));
var omit_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:lodash/cloneDeep
var cloneDeep_exports = {};
__export(cloneDeep_exports, {
  default: () => cloneDeep_default
});
var defaultImport6 = __toESM(require("lodash/cloneDeep"));
__reExport(cloneDeep_exports, require("lodash/cloneDeep"));
var cloneDeep_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/react-ui/ColumnLayout
var ColumnLayout_exports = {};
__export(ColumnLayout_exports, {
  default: () => ColumnLayout_default
});
var defaultImport7 = __toESM(require("@splunk/react-ui/ColumnLayout"));
__reExport(ColumnLayout_exports, require("@splunk/react-ui/ColumnLayout"));
var ColumnLayout_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/react-ui/Select
var Select_exports = {};
__export(Select_exports, {
  default: () => Select_default
});
var defaultImport8 = __toESM(require("@splunk/react-ui/Select"));
__reExport(Select_exports, require("@splunk/react-ui/Select"));
var Select_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/react-ui/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport9 = __toESM(require("@splunk/react-ui/Message"));
__reExport(Message_exports, require("@splunk/react-ui/Message"));
var Message_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/react-ui/Tooltip
var Tooltip_exports = {};
__export(Tooltip_exports, {
  default: () => Tooltip_default
});
var defaultImport10 = __toESM(require("@splunk/react-ui/Tooltip"));
__reExport(Tooltip_exports, require("@splunk/react-ui/Tooltip"));
var Tooltip_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/themes/SplunkThemeProvider
var SplunkThemeProvider_exports = {};
__export(SplunkThemeProvider_exports, {
  default: () => SplunkThemeProvider_default
});
var defaultImport11 = __toESM(require("@splunk/themes/SplunkThemeProvider"));
__reExport(SplunkThemeProvider_exports, require("@splunk/themes/SplunkThemeProvider"));
var SplunkThemeProvider_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/visualization-themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport13 = __toESM(require("@splunk/visualization-themes/variables"));
__reExport(variables_exports, require("@splunk/visualization-themes/variables"));
var variables_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// src/common/ThemesDoc.jsx
var ThemeVar = styled_components_default.div`
    margin-top: 20px;
    cursor: pointer;
`;
var ThemeVarName = styled_components_default.div`
    color: #5ca300;
    padding-bottom: 5px;
    display: inline-block;
    padding-right: 5px;
    font-weight: ${(props) => props.highlighted ? "bold" : "normal"};
`;
var PairContainer = styled_components_default.div`
    margin-left: 40px;
    margin-top: 10px;
`;
var PairTitle = styled_components_default.span`
    display: inline-block;
    color: #8293a7;
    width: 80px;
`;
var ColorPreview = styled_components_default.div`
    width: 20px;
    height: 20px;
    background: ${(props) => props.color};
    display: inline-block;
    vertical-align: bottom;
    margin-right: 5px;
    border: 1px solid rgba(0, 0, 0, 0.3);
    border-radius: 5px;
`;
var Pair = ({ title, text }) => /* @__PURE__ */ react_default.createElement(PairContainer, null, /* @__PURE__ */ react_default.createElement(PairTitle, null, `${title}:`), (0, colorUtils_exports.isColor)(text) && /* @__PURE__ */ react_default.createElement(ColorPreview, { color: text }), /* @__PURE__ */ react_default.createElement("samp", null, text));
Pair.propTypes = {
  title: prop_types_default.string,
  text: prop_types_default.string
};
var themeFamilyMapping = {
  enterprise: {
    colorScheme: {
      dark: "enterpriseDark",
      light: "enterprise"
    }
  },
  prisma: {
    colorScheme: {
      dark: "scp",
      light: "enterprise"
    }
  }
};
var themeIdToVariant = {
  enterpriseLightComfortable: {
    colorScheme: "light",
    density: "comfortable",
    family: "enterprise",
    label: "Enterprise Light Comfortable"
  },
  enterpriseLightCompact: {
    colorScheme: "light",
    density: "compact",
    family: "enterprise",
    label: "Enterprise Light Compact"
  },
  enterpriseDarkComfortable: {
    colorScheme: "dark",
    density: "comfortable",
    family: "enterprise",
    label: "Enterprise Dark Comfortable"
  },
  enterpriseDarkCompact: {
    colorScheme: "dark",
    density: "compact",
    family: "enterprise",
    label: "Enterprise Dark Compact"
  },
  prismaLightComfortable: {
    colorScheme: "light",
    density: "comfortable",
    family: "prisma",
    label: "Prisma Light Comfortable"
  },
  prismaLightCompact: {
    colorScheme: "light",
    density: "compact",
    family: "prisma",
    label: "Prisma Light Compact"
  },
  prismaDarkComfortable: {
    colorScheme: "dark",
    density: "comfortable",
    family: "prisma",
    label: "Prisma Dark Comfortable"
  },
  prismaDarkCompact: {
    colorScheme: "dark",
    density: "compact",
    family: "prisma",
    label: "Prisma Dark Compact"
  }
};
var ThemesDoc = (props) => {
  const { renderVisualization, themes: themeVars } = props;
  const [highlightedThemeVariable, setHighlightedThemeVariable] = (0, react_exports.useState)("");
  const [selectedTheme, setSelectedTheme] = (0, react_exports.useState)(themeIdToVariant.enterpriseLightComfortable);
  const previewTheme = cloneDeep_default(themeVars);
  if ((0, colorUtils_exports.isColor)(themeVars[highlightedThemeVariable])) {
    previewTheme[highlightedThemeVariable] = () => "red";
  }
  return /* @__PURE__ */ react_default.createElement(ColumnLayout_default, { style: { marginTop: -20 } }, /* @__PURE__ */ react_default.createElement(ColumnLayout_default.Row, null, /* @__PURE__ */ react_default.createElement(ColumnLayout_default.Column, { span: 12 }, /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, "Theme"), /* @__PURE__ */ react_default.createElement(Select_default, { value: selectedTheme, onChange: (e, { value }) => setSelectedTheme(value) }, Object.keys(themeIdToVariant).map((themeId) => /* @__PURE__ */ react_default.createElement(
    Select_default.Option,
    {
      key: themeId,
      label: themeIdToVariant[themeId].label,
      value: themeIdToVariant[themeId]
    }
  ))))), /* @__PURE__ */ react_default.createElement(ColumnLayout_default.Row, null, /* @__PURE__ */ react_default.createElement(ColumnLayout_default.Column, { colStyle: { padding: 10 }, span: 4 }, /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, "Preview"), /* @__PURE__ */ react_default.createElement(
    SplunkThemeProvider_default,
    {
      family: selectedTheme.family,
      colorScheme: selectedTheme.colorScheme,
      density: selectedTheme.density
    },
    renderVisualization()
  ), /* @__PURE__ */ react_default.createElement(Message_default, { type: "info" }, "This preview may differ from the visualization's default look and feel. ", /* @__PURE__ */ react_default.createElement("br", null), "It exists to show areas affected by theme variables.")), /* @__PURE__ */ react_default.createElement(ColumnLayout_default.Column, { colStyle: { padding: 10 }, span: 8 }, /* @__PURE__ */ react_default.createElement(Heading_default, { level: 4 }, "Variables"), Object.keys(previewTheme).map((varKey) => {
    var _a, _b;
    const themeValue = previewTheme[varKey]({
      theme: { splunkThemeV1: omit_default(selectedTheme, ["label"]) }
    });
    const isFromSharedVariables = ((_b = variables_exports == null ? void 0 : variables_exports[(_a = themeFamilyMapping == null ? void 0 : themeFamilyMapping[selectedTheme.family]) == null ? void 0 : _a[selectedTheme.colorScheme]]) == null ? void 0 : _b[varKey]) === themeValue;
    let isJSON;
    try {
      isJSON = typeof JSON.parse(themeValue) === "object";
    } catch (e) {
    }
    return !isJSON && /* @__PURE__ */ react_default.createElement(
      ThemeVar,
      {
        key: varKey,
        onMouseOver: () => setHighlightedThemeVariable(varKey),
        onMouseOut: () => setHighlightedThemeVariable("")
      },
      /* @__PURE__ */ react_default.createElement(
        ThemeVarName,
        {
          highlighted: varKey === highlightedThemeVariable
        },
        `${varKey}`
      ),
      isFromSharedVariables && /* @__PURE__ */ react_default.createElement(Tooltip_default, { content: "This is a shared theme variable from @splunk/visualization-themes" }),
      /* @__PURE__ */ react_default.createElement(Pair, { title: "Value", text: themeValue })
    );
  }))));
};
ThemesDoc.propTypes = {
  themes: prop_types_default.object.isRequired,
  // @TODO: replace with themes object from viz config when we add docs/descs to theme vars
  renderVisualization: prop_types_default.func.isRequired
};
var ThemesDoc_default = ThemesDoc;
//# sourceMappingURL=ThemesDoc.js.map
