/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/utils/testHelper.tsx
var testHelper_exports = {};
__export(testHelper_exports, {
  renderWithTheme: () => renderWithTheme
});
module.exports = __toCommonJS(testHelper_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@testing-library/react
var react_exports2 = {};
__export(react_exports2, {
  default: () => react_default2
});
var defaultImport2 = __toESM(require("@testing-library/react"));
__reExport(react_exports2, require("@testing-library/react"));
var react_default2 = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/themes/SplunkThemeProvider
var SplunkThemeProvider_exports = {};
__export(SplunkThemeProvider_exports, {
  default: () => SplunkThemeProvider_default
});
var defaultImport3 = __toESM(require("@splunk/themes/SplunkThemeProvider"));
__reExport(SplunkThemeProvider_exports, require("@splunk/themes/SplunkThemeProvider"));
var SplunkThemeProvider_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/common/utils/testHelper.tsx
var renderWithTheme = (Component, themeToTest = {}) => (0, react_exports2.render)(
  /* @__PURE__ */ react_exports.createElement(
    SplunkThemeProvider_default,
    {
      additionalThemeProperties: __spreadValues({}, themeToTest),
      colorScheme: "light",
      density: "comfortable",
      family: "enterprise"
    },
    Component
  )
);
//# sourceMappingURL=testHelper.js.map
