/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/withDashboardViz.tsx
var withDashboardViz_exports = {};
__export(withDashboardViz_exports, {
  default: () => withDashboardViz_default
});
module.exports = __toCommonJS(withDashboardViz_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport2 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport3 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport4 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport5 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport7 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport8 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport9 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport10 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport11 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport12 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport13 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport14 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport15 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport16 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport17 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport18 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport19 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys, target) => keys.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport20 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config } = Visualization;
  const { themes } = config;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes == null ? void 0 : themes.defaultBackgroundColor) == null ? void 0 : _a.call(themes, props);
    const icon = (_b = config.placeholderIcon) != null ? _b : config.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport21 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// src/common/utils/dataUtils.ts
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport22 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport23 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// src/common/utils/trellisUtils.ts
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps = () => {
    },
    computeVizPropsBeforeEval = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;
//# sourceMappingURL=withDashboardViz.js.map
