/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Bubble/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport4 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport5 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport6 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport7 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport8 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}
var insertLayout = (layout, index, ...layoutItems) => [
  // copy part of the array before the specified index
  ...layout.slice(0, index),
  // inserted layout item
  ...layoutItems,
  // copy part of the array after the specified index
  ...layout.slice(index)
];

// src/common/editorConfig/AxesChartDataConfig.ts
var isTrellisFeatureFlagOn = ({ featureFlags }) => {
  return Boolean(featureFlags == null ? void 0 : featureFlags.visualizations_enableTrellis);
};
var isTrellisEnabled = ({ options, featureFlags }) => {
  const { splitByLayout = visualization_schemas_exports.LAYOUT_TYPE.Off } = options;
  return isTrellisFeatureFlagOn({ featureFlags }) && splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};
var AxesChartDataConfig = {
  label: (0, i18n_exports._)("Data configurations"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("X"),
        option: "x",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Y"),
        option: "y",
        editor: "editor.columnMultiSelector",
        editorProps: {
          dataSourceKey: "primary",
          filterByTypes: ["number"],
          supportsDSL: true,
          expectedDataPrimitive: ["series", "frame"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Additional tooltip fields"),
        option: "additionalTooltipFields",
        editor: "editor.columnMultiSelectionByFieldNameEditor"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Result limit"),
        option: "resultLimit",
        editor: "editor.number",
        editorProps: {
          dataSourceKey: "primary"
        }
      }
    ]
  ]
};
var AxesChartDataConfigBar = {
  label: AxesChartDataConfig.label,
  // insert Y2 after Y
  layout: insertLayout(AxesChartDataConfig.layout, 2, [
    {
      label: (0, i18n_exports._)("Y2"),
      option: "y2",
      editor: "editor.columnMultiSelector",
      editorProps: {
        dataSourceKey: "primary",
        filterByTypes: ["number"],
        supportsDSL: true,
        expectedDataPrimitive: ["series", "frame"]
      },
      isDisabled: isTrellisEnabled
    }
  ])
};
var AxesChartDataConfigScatter = {
  label: AxesChartDataConfig.label,
  layout: [
    [
      {
        label: (0, i18n_exports._)("X"),
        option: "x",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Y"),
        option: "y",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          filterByTypes: ["number"],
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Category"),
        option: "category",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "primary",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Result limit"),
        option: "resultLimit",
        editor: "editor.number",
        editorProps: {
          dataSourceKey: "primary"
        }
      }
    ]
  ]
};
var AxesChartDataConfigBubble = {
  label: AxesChartDataConfigScatter.label,
  // layout: insert Size after Category
  layout: insertLayout(AxesChartDataConfigScatter.layout, 3, [
    {
      label: (0, i18n_exports._)("Size"),
      option: "size",
      editor: "editor.columnSelector",
      editorProps: {
        dataSourceKey: "primary",
        supportsDSL: true,
        expectedDataPrimitive: ["series"]
      }
    }
  ])
};
var AxesChartDataConfigAreaColumnLine = {
  label: AxesChartDataConfigBar.label,
  layout: [
    ...AxesChartDataConfigBar.layout,
    [
      {
        label: (0, i18n_exports._)("Annotation x"),
        option: "annotationX",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "annotation",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Annotation labels"),
        option: "annotationLabel",
        editor: "editor.columnSelector",
        editorProps: {
          dataSourceKey: "annotation",
          supportsDSL: true,
          expectedDataPrimitive: ["series"]
        }
      }
    ]
  ]
};

// src/common/editorConfig/AxesChartXGridAndLabels.ts
var AxesChartXGridAndLabelsCommon = {
  label: (0, i18n_exports._)("X-axis grid and labels"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("Axis title"),
        option: "xAxisTitleVisibility",
        editor: "editor.toggle"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis title text"),
        option: "xAxisTitleText",
        editor: "editor.text",
        showEditor: ({ options }) => options.xAxisTitleVisibility === "show" || options.xAxisTitleVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Label visibility"),
        option: "xAxisLabelVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ]
  ]
};
var AxesChartXGridAndLabels = {
  label: AxesChartXGridAndLabelsCommon.label,
  layout: [
    ...AxesChartXGridAndLabelsCommon.layout,
    [
      {
        label: (0, i18n_exports._)("Label rotation"),
        option: "xAxisLabelRotation",
        editor: "editor.select",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("-90"), value: -90 },
            { label: (0, i18n_exports._)("-45"), value: -45 },
            { label: (0, i18n_exports._)("0"), value: 0 },
            { label: (0, i18n_exports._)("45"), value: 45 },
            { label: (0, i18n_exports._)("90"), value: 90 }
          ]
        },
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Number of time label parts"),
        option: "xAxisMaxLabelParts",
        editor: "editor.number",
        editorProps: {
          min: 1,
          max: 3
        },
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis line visibility"),
        option: "xAxisLineVisibility",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major gridlines"),
        option: "showXMajorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick visibility"),
        option: "xAxisMajorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick size (px)"),
        option: "xAxisMajorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.xAxisMajorTickVisibility === "show" || options.xAxisMajorTickVisibility === "auto" || options.xAxisMajorTickVisibility === void 0
      }
    ]
  ]
};
var AxesChartXGridAndLabelsBubbleScatter = {
  label: AxesChartXGridAndLabelsCommon.label,
  layout: [
    ...insertLayout(AxesChartXGridAndLabelsCommon.layout, 2, [
      {
        label: (0, i18n_exports._)("Axis scale"),
        option: "xAxisScale",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Linear"), value: "linear" },
            { label: (0, i18n_exports._)("Log"), value: "log" }
          ]
        }
      }
    ]),
    [
      {
        label: (0, i18n_exports._)("Label rotation"),
        option: "xAxisLabelRotation",
        editor: "editor.select",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("-90"), value: -90 },
            { label: (0, i18n_exports._)("-45"), value: -45 },
            { label: (0, i18n_exports._)("0"), value: 0 },
            { label: (0, i18n_exports._)("45"), value: 45 },
            { label: (0, i18n_exports._)("90"), value: 90 }
          ]
        },
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Round axis labels"),
        option: "showRoundedXAxisLabels",
        editor: "editor.checkbox",
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("SI prefix abbreviation for labels"),
        option: "xAxisAbbreviation",
        editor: "editor.checkbox",
        showEditor: ({ options }) => options.xAxisLabelVisibility === "show" || options.xAxisLabelVisibility === "auto" || options.xAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Include zero"),
        option: "showXAxisWithZero",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Extend to whole grid"),
        option: "showXAxisExtendedRange",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minimum axis value"),
        option: "xAxisMin",
        editor: "editor.number"
      },
      {
        label: (0, i18n_exports._)("Maximum axis value"),
        option: "xAxisMax",
        editor: "editor.number"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis line visibility"),
        option: "xAxisLineVisibility",
        editor: "editor.checkbox"
      }
    ],
    // this option is disabled for bubble and scatter
    // [
    //     {
    //         label: _('Major gridlines'),
    //         option: 'showXMajorGridLines',
    //         editor: 'editor.checkbox',
    //     },
    // ],
    [
      {
        label: (0, i18n_exports._)("Major tick visibility"),
        option: "xAxisMajorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick size (px)"),
        option: "xAxisMajorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.xAxisMajorTickVisibility === "show" || options.xAxisMajorTickVisibility === "auto" || options.xAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick interval spacing"),
        option: "xAxisMajorTickInterval",
        editor: "editor.number",
        showEditor: ({ options }) => options.xAxisMajorTickVisibility === "show" || options.xAxisMajorTickVisibility === "auto" || options.xAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor gridlines"),
        option: "showXMinorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick visibility"),
        option: "xAxisMinorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick size (px)"),
        option: "xAxisMinorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.xAxisMinorTickVisibility === "show" || options.xAxisMinorTickVisibility === "auto" || options.xAxisMinorTickVisibility === void 0
      }
    ]
  ]
};

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes3,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes3
    }
  }
];
var BackgroundColor_default = background;

// src/common/editorConfig/TrellisEditors.ts
var isTrellisFeatureFlagOn2 = ({ featureFlags }) => {
  return Boolean(featureFlags == null ? void 0 : featureFlags.visualizations_enableTrellis);
};
var isTrellisEnabled2 = ({ options, featureFlags }) => {
  const { splitByLayout = visualization_schemas_exports.LAYOUT_TYPE.Off } = options;
  return isTrellisFeatureFlagOn2({ featureFlags }) && splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};
var TrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Split by"),
      option: "trellisSplitBy",
      editor: "editor.trellisSplitBy",
      editorProps: {
        dataSourceKey: "primary"
      },
      showEditor: isTrellisEnabled2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Number of columns"),
      option: "trellisColumns",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      placeholder: (0, i18n_exports._)("Auto"),
      showEditor: isTrellisEnabled2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Min column width"),
      option: "trellisMinColumnWidth",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled2
    },
    {
      label: (0, i18n_exports._)("Row height"),
      option: "trellisRowHeight",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled2
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Max number of components per page"),
      option: "trellisPageCount",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled2
    }
  ]
];
var TimechartTrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn2,
      // add help text for timecharts
      editorProps: {
        help: (0, i18n_exports._)(
          "Y2-axis and overlay field configurations are not supported when trellis is enabled."
        ),
        helpFormat: "under"
      }
    }
  ],
  ...TrellisEditorConfig.slice(1),
  [
    {
      label: (0, i18n_exports._)("Shared y-axis scale"),
      option: "trellisSharedScale",
      editor: "editor.checkbox",
      showEditor: isTrellisEnabled2
    }
  ]
];
var TrellisBackgroundColorEditor = {
  label: (0, i18n_exports._)("Trellis background"),
  option: "trellisBackgroundColor",
  editor: "editor.color",
  showEditor: isTrellisEnabled2
};

// src/common/editorConfig/AxesChartColorAndStyle.ts
var themes = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props)
};
var AxesChartColorAndStyle = {
  label: (0, i18n_exports._)("Color and style"),
  layout: [
    BackgroundColor_default({ themes }),
    [
      {
        label: (0, i18n_exports._)("Series colors"),
        option: "seriesColors",
        editor: "editor.seriesColors"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Series colors by field name"),
        option: "seriesColorsByField",
        editor: "editor.seriesColorsByField"
      }
    ]
  ]
};
var AxesChartColorAndStyleWithTrellis = __spreadProps(__spreadValues({}, AxesChartColorAndStyle), {
  layout: [
    AxesChartColorAndStyle.layout[0],
    [
      __spreadProps(__spreadValues({}, TrellisBackgroundColorEditor), {
        editorProps: {
          themes
        }
      })
    ],
    ...AxesChartColorAndStyle.layout.slice(1)
  ]
});
var AxesChartColorAndStyle_default = AxesChartColorAndStyle;

// src/common/editorConfig/AxesChartLegend.ts
var AxesChartLegend = {
  label: (0, i18n_exports._)("Legend"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("Legend display"),
        option: "legendDisplay",
        editor: "editor.select",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Right"), value: "right" },
            { label: (0, i18n_exports._)("Left"), value: "left" },
            { label: (0, i18n_exports._)("Top"), value: "top" },
            { label: (0, i18n_exports._)("Bottom"), value: "bottom" },
            { label: (0, i18n_exports._)("Off"), value: "off" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Legend truncation"),
        option: "legendTruncation",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("A..."), value: "ellipsisEnd" },
            { label: (0, i18n_exports._)("A...Z"), value: "ellipsisMiddle" },
            { label: (0, i18n_exports._)("...Z"), value: "ellipsisStart" },
            { label: (0, i18n_exports._)("Off"), value: "ellipsisOff" }
          ]
        },
        showEditor: ({ options }) => options.legendDisplay === "left" || options.legendDisplay === "right" || options.legendDisplay === "top" || options.legendDisplay === "bottom" || options.legendDisplay === void 0
      }
    ]
  ]
};
var AxesChartLegend_default = AxesChartLegend;

// src/common/editorConfig/AxesChartYGridAndLabels.ts
var AxesChartYGridAndLabels = {
  label: (0, i18n_exports._)("Y-axis grid and labels"),
  layout: [
    [
      {
        label: (0, i18n_exports._)("Axis title"),
        option: "yAxisTitleVisibility",
        editor: "editor.toggle"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis title text"),
        option: "yAxisTitleText",
        editor: "editor.text",
        showEditor: ({ options }) => options.yAxisTitleVisibility === "show" || options.yAxisTitleVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Scale"),
        option: "yAxisScale",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Linear"), value: "linear" },
            { label: (0, i18n_exports._)("Log"), value: "log" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Label visibility"),
        option: "yAxisLabelVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("SI prefix abbreviation for labels"),
        option: "yAxisAbbreviation",
        editor: "editor.checkbox",
        showEditor: ({ options }) => options.yAxisLabelVisibility === "show" || options.yAxisLabelVisibility === "auto" || options.yAxisLabelVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Include zero"),
        option: "showYAxisWithZero",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Extend to whole grid"),
        option: "showYAxisExtendedRange",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minimum axis value"),
        option: "yAxisMin",
        editor: "editor.number"
      },
      {
        label: (0, i18n_exports._)("Maximum axis value"),
        option: "yAxisMax",
        editor: "editor.number"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Axis line visibility"),
        option: "yAxisLineVisibility",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major gridlines"),
        option: "showYMajorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick visibility"),
        option: "yAxisMajorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick size (px)"),
        option: "yAxisMajorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.yAxisMajorTickVisibility === "show" || options.yAxisMajorTickVisibility === "auto" || options.yAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Major tick interval spacing"),
        option: "yAxisMajorTickInterval",
        editor: "editor.number",
        showEditor: ({ options }) => options.yAxisMajorTickVisibility === "show" || options.yAxisMajorTickVisibility === "auto" || options.yAxisMajorTickVisibility === void 0
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor gridlines"),
        option: "showYMinorGridLines",
        editor: "editor.checkbox"
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick visibility"),
        option: "yAxisMinorTickVisibility",
        editor: "editor.radioBar",
        editorProps: {
          values: [
            { label: (0, i18n_exports._)("Auto"), value: "auto" },
            { label: (0, i18n_exports._)("Show"), value: "show" },
            { label: (0, i18n_exports._)("Hide"), value: "hide" }
          ]
        }
      }
    ],
    [
      {
        label: (0, i18n_exports._)("Minor tick size (px)"),
        option: "yAxisMinorTickSize",
        editor: "editor.slider",
        editorProps: {
          min: 0,
          max: 10,
          step: 1
        },
        showEditor: ({ options }) => options.yAxisMinorTickVisibility === "show" || options.yAxisMinorTickVisibility === "auto" || options.yAxisMinorTickVisibility === void 0
      }
    ]
  ]
};
var AxesChartYGridAndLabels_default = AxesChartYGridAndLabels;

// src/Bubble/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [
    // Note: SCP-14090 disable ui for optional datasources. We may need to add it back later
    // {
    //     name: 'annotation',
    //     description: 'DataSource that populates event annotations',
    // },
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {};
var themes2 = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props)
};
var editorConfig = [
  AxesChartDataConfigBubble,
  {
    label: AxesChartColorAndStyle_default.label,
    layout: [
      ...AxesChartColorAndStyle_default.layout.slice(0, 2),
      [
        {
          label: (0, i18n_exports._)("Series colors by category name"),
          option: "seriesColorsByField",
          editor: "editor.seriesColorsByField",
          editorProps: {
            isCategorical: true
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Maximum bubble size"),
          option: "bubbleSizeMax",
          editor: "editor.slider",
          editorProps: {
            min: 0,
            max: 200,
            step: 1
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Minimum bubble size"),
          option: "bubbleSizeMin",
          editor: "editor.slider",
          editorProps: {
            min: 0,
            max: 200,
            step: 1
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Calculation method for bubble size"),
          option: "bubbleSizeMethod",
          editor: "editor.radioBar",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Area"), value: "area" },
              { label: (0, i18n_exports._)("Diameter"), value: "diameter" }
            ]
          }
        }
      ]
    ]
  },
  AxesChartLegend_default,
  AxesChartXGridAndLabelsBubbleScatter,
  AxesChartYGridAndLabels_default
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.bubble",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Bubble"),
  category: "Correlation" /* CORRELATION */,
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Bubble,
  placeholderIcon: placeholders_exports.Bubble,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.bubbleOptionsSchema,
  editorConfig,
  events: {
    "legend.click": {
      description: "triggered when user clicks on chart legend"
    },
    "point.click": {
      description: "triggered when user clicks on a point in the bubble chart"
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "placeholder" /* PLACEHOLDER */, "events" /* EVENTS */],
  themes: themes2
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=Bubble.config.js.map
