/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/ParallelCoordinates/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport3 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport4 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport5 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport7 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport8 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes2,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes2
    }
  }
];
var BackgroundColor_default = background;

// src/ParallelCoordinates/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 700,
  initialHeight: 400
};
var themes = {
  defaultBackgroundColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  axisLineColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.gray45(props),
      light: variables_default.gray60(props)
    },
    prisma: {
      dark: variables_default.neutral400(props),
      light: variables_default.syntaxGray(props)
    }
  })(props),
  axisLineHighlightColor: (props) => pick_default({
    enterprise: variables_default.textColor(props),
    prisma: variables_default.contentColorActive(props)
  })(props),
  axisTitleColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.textGray(props),
      light: variables_default.textColor(props)
    },
    prisma: variables_default.contentColorDefault(props)
  })(props),
  axisLabelColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.textGray(props),
      light: variables_default.textColor(props)
    },
    prisma: variables_default.contentColorDefault(props)
  })(props),
  filterButtonDisabledColor: (props) => pick_default({
    enterprise: variables_default.textDisabledColor(props),
    prisma: variables_default.contentColorDisabled(props)
  })(props),
  filterButtonActiveColor: (props) => pick_default({
    enterprise: variables_default.focusColor(props),
    prisma: variables_default.interactiveColorPrimary(props)
  })(props),
  filterTextColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.textGray(props),
      light: variables_default.textColor(props)
    },
    prisma: variables_default.contentColorDefault(props)
  })(props),
  truncatedTextColor: (props) => pick_default({
    enterprise: variables_default.textGray(props),
    prisma: variables_default.contentColorMuted(props)
  })(props),
  filterSelectionColor: (props) => pick_default({
    enterprise: {
      dark: "#FFFFFF",
      light: "#000000"
    },
    prisma: {
      dark: "#FFFFFF",
      light: "#000000"
    }
  })(props),
  textShadowColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.black(props),
      light: variables_default.backgroundColor(props)
    },
    prisma: variables_default.backgroundColorSection(props)
  })(props)
};
var EDITOR_LABEL_WIDTH = 100;
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Show null axis"),
          option: "showNullAxis",
          editor: "editor.toggle",
          editorProps: {
            labelWidth: EDITOR_LABEL_WIDTH
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Lines"),
          option: "lineColor",
          editor: "editor.color",
          editorProps: {
            themes
          }
        },
        {
          label: (0, i18n_exports._)("Line opacity (%)"),
          option: "lineOpacity",
          editor: "editor.percent",
          editorProps: {
            themes,
            min: 0
          }
        }
      ],
      BackgroundColor_default({ themes })
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.parallelcoordinates",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Parallel coordinates"),
  category: "Correlation" /* CORRELATION */,
  status: "preview",
  /**
   * viz icon
   */
  icon: visualization_icons_exports.ParallelCoordinates,
  placeholderIcon: placeholders_exports.ParallelCoordinates,
  dataContract,
  size,
  optionsSchema: visualization_schemas_exports.parallelCoordinatesOptionsSchema,
  editorConfig,
  events: {},
  // To be completed
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */],
  // will there be more??
  themes,
  requiredProps: []
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=ParallelCoordinates.config.js.map
