/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Sankey/index.ts
var Sankey_exports = {};
__export(Sankey_exports, {
  PureSankey: () => PureSankey_default,
  computeVizProps: () => computeVizProps,
  config: () => config_default,
  default: () => Sankey_default,
  showPlaceHolderIcon: () => showPlaceHolderIcon,
  themes: () => themes2
});
module.exports = __toCommonJS(Sankey_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualizations-shared/dataSourceUtils
var dataSourceUtils_exports = {};
__export(dataSourceUtils_exports, {
  default: () => dataSourceUtils_default
});
var defaultImport2 = __toESM(require("@splunk/visualizations-shared/dataSourceUtils"));
__reExport(dataSourceUtils_exports, require("@splunk/visualizations-shared/dataSourceUtils"));
var dataSourceUtils_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport3 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport4 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/themes/getSettingsFromThemedProps
var getSettingsFromThemedProps_exports = {};
__export(getSettingsFromThemedProps_exports, {
  default: () => getSettingsFromThemedProps_default
});
var defaultImport5 = __toESM(require("@splunk/themes/getSettingsFromThemedProps"));
__reExport(getSettingsFromThemedProps_exports, require("@splunk/themes/getSettingsFromThemedProps"));
var getSettingsFromThemedProps_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport6 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualizations-shared/SanitizeProps
var SanitizeProps_exports = {};
__export(SanitizeProps_exports, {
  default: () => SanitizeProps_default
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/SanitizeProps"));
__reExport(SanitizeProps_exports, require("@splunk/visualizations-shared/SanitizeProps"));
var SanitizeProps_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualization-context/TimezoneContext
var TimezoneContext_exports = {};
__export(TimezoneContext_exports, {
  default: () => TimezoneContext_default
});
var defaultImport8 = __toESM(require("@splunk/visualization-context/TimezoneContext"));
__reExport(TimezoneContext_exports, require("@splunk/visualization-context/TimezoneContext"));
var TimezoneContext_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
var defaultImport9 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport10 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport11 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport12 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport13 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/async-dynamic-options-evaluator
var async_dynamic_options_evaluator_exports = {};
__export(async_dynamic_options_evaluator_exports, {
  default: () => async_dynamic_options_evaluator_default
});
var defaultImport14 = __toESM(require("@splunk/async-dynamic-options-evaluator"));
__reExport(async_dynamic_options_evaluator_exports, require("@splunk/async-dynamic-options-evaluator"));
var async_dynamic_options_evaluator_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport15 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport16 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// src/common/interfaces/VizActionHandler.ts
var DefaultVizActionHandler = class {
  focus() {
  }
  snapshot() {
    return null;
  }
};

// src/common/SplunkVisualization.tsx
var INITIAL_HEIGHT = 250;
var SplunkVisualization = class {
};
SplunkVisualization.propTypes = {
  /**
   * display mode
   */
  mode: prop_types_exports.oneOf(["view", "edit", "export"]).isRequired,
  /**
   * width in pixel or string, defaults to 100%
   */
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * height in pixel or string
   */
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]).isRequired,
  /**
   * visualization context used for dynamic option evaluation
   */
  context: prop_types_exports.object,
  /**
   * visualization formatting options
   */
  options: prop_types_exports.object,
  /**
   * A callback to update formatting options
   */
  onOptionsChange: prop_types_exports.func,
  /**
   * datasource state which include data and request params, object key indicate the datasource type.
   */
  dataSources: prop_types_exports.objectOf(
    prop_types_exports.shape({
      /**
       * current request params
       */
      requestParams: prop_types_exports.object,
      /**
       * current dataset
       */
      data: prop_types_exports.shape({
        fields: prop_types_exports.array,
        columns: prop_types_exports.array
      }),
      /**
       * error
       */
      error: prop_types_exports.shape({
        level: prop_types_exports.string,
        message: prop_types_exports.string
      }),
      /**
       * meta data that came with the dataset
       */
      meta: prop_types_exports.object
    })
  ),
  /**
   * A callback to trigger event
   */
  onEventTrigger: prop_types_exports.func,
  /**
   * Inform viz if there are handlers listening to events
   */
  hasEventHandlers: prop_types_exports.bool,
  /**
   * A callback to communicate computed props to a consumer
   */
  onComputedProps: prop_types_exports.func,
  /**
   * A callback to obtain visualization api
   */
  vizActionHandlerRef: prop_types_exports.func,
  loading: prop_types_exports.bool,
  theme: prop_types_exports.object,
  /**
   * A callback to request new data with updated request params
   */
  onRequestParamsChange: prop_types_exports.func
};
/**
 *
 */
SplunkVisualization.defaultProps = {
  // BaseVisualization in dashboard-visualizations uses 100% for width but 250 for height
  width: "100%",
  height: INITIAL_HEIGHT,
  dataSources: {},
  onEventTrigger: () => ({}),
  mode: "view",
  hasEventHandlers: false,
  options: {},
  context: {},
  onOptionsChange: () => ({}),
  vizActionHandlerRef: () => new DefaultVizActionHandler(),
  onComputedProps: () => ({}),
  loading: false,
  onRequestParamsChange: lodash_exports.noop
};
var SplunkVisualization_default = SplunkVisualization;

// src/common/interfaces/DataSource.ts
var validSortDirs = ["asc", "desc", "none"];

// src/common/hooks/getSorting.ts
var SortParamsPropTypes = prop_types_exports.shape({
  currentSortKey: prop_types_exports.string,
  currentSortDir: prop_types_exports.oneOf(validSortDirs),
  onSort: prop_types_exports.func
});
var getSortingParams = ({ requestParams, onRequestParamsChange }) => {
  let currentSortKey;
  let currentSortDir;
  const nextSortDirMap = {
    asc: "desc",
    desc: "asc",
    none: "asc"
  };
  let onSort;
  if (typeof onRequestParamsChange === "function") {
    if (requestParams && (0, lodash_exports.has)(requestParams, "sort")) {
      currentSortKey = Object.keys(requestParams.sort).shift();
      currentSortDir = requestParams.sort[currentSortKey];
    }
    onSort = (e, { sortKey, sortDir }) => {
      if (typeof sortKey === "string") {
        const nextSortDir = (0, lodash_exports.has)(nextSortDirMap, sortDir) ? nextSortDirMap[sortDir] : "none";
        onRequestParamsChange(__spreadValues(__spreadValues({}, requestParams), { offset: 0, sort: { [sortKey]: nextSortDir } }));
      } else {
        onRequestParamsChange(requestParams);
      }
    };
  }
  return {
    currentSortKey,
    currentSortDir,
    onSort
  };
};

// src/common/hooks/getPagination.ts
var PaginatorParamsPropTypes = prop_types_exports.shape({
  isPaging: prop_types_exports.bool,
  current: prop_types_exports.number,
  totalPages: prop_types_exports.number,
  onChange: prop_types_exports.func
});
var getPaginationParams = ({
  requestParams,
  meta,
  onRequestParamsChange
}) => {
  const totalCount = meta && meta.totalCount || 0;
  const offset = requestParams && requestParams.offset || 0;
  const count = requestParams && requestParams.count;
  const totalPages = typeof count === "number" && count > 0 ? Math.ceil(totalCount / count) : 0;
  const current = typeof count === "number" && count > 0 ? Math.floor(offset / count) + 1 : 0;
  const isPaging = totalPages > 1 && typeof onRequestParamsChange === "function";
  const onChangeHandler = (e, { page, count: countArg }) => {
    const newParams = (0, lodash_exports.cloneDeep)(requestParams);
    if (typeof countArg === "number") {
      newParams.count = countArg;
      newParams.offset = 0;
    }
    const pageCount = typeof newParams.count === "number" ? newParams.count : 10;
    if (typeof page === "number" && page > 0) {
      newParams.count = pageCount;
      newParams.offset = (page - 1) * pageCount;
    }
    onRequestParamsChange(newParams);
  };
  return {
    isPaging,
    current,
    totalPages,
    onChange: typeof onRequestParamsChange === "function" ? onChangeHandler : lodash_exports.noop
  };
};

// src/common/hooks/useDeepMemo.ts
var useDeepMemo = (fn, dependencies) => {
  const ref = (0, react_exports.useRef)();
  if (!ref.current || !(0, lodash_exports.isEqual)(dependencies, ref.current.dependencies)) {
    ref.current = {
      dependencies,
      value: fn()
    };
  }
  return ref.current.value;
};

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport17 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/visualizations-shared/Message
var Message_exports = {};
__export(Message_exports, {
  default: () => Message_default
});
var defaultImport18 = __toESM(require("@splunk/visualizations-shared/Message"));
__reExport(Message_exports, require("@splunk/visualizations-shared/Message"));
var Message_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/visualizations-shared/style
var style_exports = {};
__export(style_exports, {
  default: () => style_default
});
var defaultImport19 = __toESM(require("@splunk/visualizations-shared/style"));
__reExport(style_exports, require("@splunk/visualizations-shared/style"));
var style_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/visualizations-shared/SizeAwareWrapper
var SizeAwareWrapper_exports = {};
__export(SizeAwareWrapper_exports, {
  default: () => SizeAwareWrapper_default
});
var defaultImport20 = __toESM(require("@splunk/visualizations-shared/SizeAwareWrapper"));
__reExport(SizeAwareWrapper_exports, require("@splunk/visualizations-shared/SizeAwareWrapper"));
var SizeAwareWrapper_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// src/common/hocs/FixedSizeContainer.tsx
var Item = styled_components_default.div.attrs(({ width }) => ({
  style: {
    width: (0, style_exports.toPx)(width)
  }
}))`
    position: relative;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var FixSizeItem = styled_components_default.div.attrs(({ width, height }) => ({
  style: __spreadValues(__spreadValues({}, width && { width: (0, style_exports.toPx)(width) }), height && { height: (0, style_exports.toPx)(height) })
}))`
    position: relative;
    flex-direction: column;
    flex: 1;
    display: flex;
    background-color: ${(props) => (0, colorUtils_exports.isColor)(props.backgroundColor) && props.backgroundColor || props.theme.defaultBackgroundColor}};
`;
var ItemContent = styled_components_default.div`
    position: relative;
    min-height: 100px;
    width: 100%;
`;
var FixSizeItemContent = styled_components_default.div`
    min-height: 0px;
    flex: 1;
    position: relative;
    box-sizing: border-box;
`;
var withFixedSizeContainer = (Viz) => {
  const FixedSizeContainer = (props) => {
    const { width, height, backgroundColor } = props;
    const cachedHandleResize = react_exports.useCallback((w, h) => {
      setContainerWidth(w);
      setContainerHeight(h);
    }, []);
    const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
    const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
    if (!height) {
      return /* @__PURE__ */ react_exports.createElement(Item, { "data-test": "item", width, backgroundColor }, /* @__PURE__ */ react_exports.createElement(ItemContent, null, /* @__PURE__ */ react_exports.createElement(Viz, __spreadValues({}, props))));
    }
    return /* @__PURE__ */ react_exports.createElement(
      FixSizeItem,
      {
        "data-test": "fix-size-item",
        "data-splunk-visualization-version": "27.5.0 - 5cfbc7064",
        width,
        height,
        backgroundColor
      },
      /* @__PURE__ */ react_exports.createElement(FixSizeItemContent, null, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), /* @__PURE__ */ react_exports.createElement(Viz, __spreadProps(__spreadValues({}, props), { width: containerWidth, height: containerHeight })))
    );
  };
  FixedSizeContainer.displayName = "withFixedSizeContainer";
  return FixedSizeContainer;
};
var FixedSizeContainer_default = withFixedSizeContainer;

// src/common/components/MissingPropsMessage.tsx
var isMissing = (v) => {
  return v === null || v === void 0;
};
var missingKeys = (keys, target) => keys.filter((k) => isMissing(target[k]));
var propTypes = {
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  missingProps: prop_types_exports.arrayOf(prop_types_exports.string)
};
var MissingPropsMessage = (props) => {
  const { width, height, missingProps } = props;
  return /* @__PURE__ */ react_exports.createElement(
    Message_default,
    {
      "data-test": "message",
      width,
      height,
      message: (0, i18n_exports._)(`Missing property: ${missingProps.join(", ")}`)
    }
  );
};
MissingPropsMessage.propTypes = propTypes;
MissingPropsMessage.defaultProps = {
  width: "100%",
  height: 250
};
var MissingPropsMessage_default = FixedSizeContainer_default(MissingPropsMessage);

// src/common/utils/hocUtils.ts
var extendStaticWrapperProps = ({
  Wrapper,
  Visualization
}) => {
  const extendProperties = ["propTypes", "defaultProps", "config"];
  extendProperties.forEach((prop) => {
    if (Visualization[prop]) {
      Wrapper[prop] = Visualization[prop];
    }
  });
};

// src/common/hocs/withEditModeCover.tsx
var Cover = styled_components_default.div`
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;
`;
var Blocker = styled_components_default.div.attrs({
  "data-splunk-visualization-version": "27.5.0 - 5cfbc7064"
})`
    position: relative;
    width: 100%;
    height: 100%;
`;
var withEditModeCover = (Visualization, disableEditModeCover) => {
  const Wrapper = (props) => {
    const { mode } = props;
    const showEditCover = mode === "edit" && !disableEditModeCover;
    return /* @__PURE__ */ react_exports.createElement(Blocker, null, /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props)), showEditCover && /* @__PURE__ */ react_exports.createElement(Cover, { "data-test": "edit-mode-cover" }));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withEditModeCover_default = withEditModeCover;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport21 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// src/common/components/IconPlaceholder.tsx
var shouldShowIconPlaceholder = (dataSources, loading = false) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noData = data === void 0;
  const fields = (0, lodash_exports.get)(dataSources, "primary.data.fields[0]", void 0);
  const noFields = fields === void 0;
  return loading || noData || noFields;
};
var propTypes2 = {
  icon: prop_types_exports.func,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: prop_types_exports.string,
  iconColor: prop_types_exports.string
};
var IconPlaceholder = (props) => {
  const { width, height, icon, iconColor } = props;
  if (icon) {
    return react_exports.createElement(icon, {
      style: {
        left: "50%",
        top: "50%",
        color: iconColor,
        opacity: 0.15,
        position: "absolute",
        transform: "translate(-50%, -50%)"
      },
      width: "50%",
      height: "50%",
      "data-test": "icon-placeholder"
    });
  }
  return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, level: "warning", message: (0, i18n_exports._)("No DataSource Connected") });
};
IconPlaceholder.propTypes = propTypes2;
IconPlaceholder.defaultProps = {
  width: "100%",
  height: 250
};
var IconPlaceholder_default = FixedSizeContainer_default(IconPlaceholder);

// src/common/hocs/withPlaceholder.tsx
var withPlaceholder = (Visualization, useIconPlaceholder = shouldShowIconPlaceholder) => {
  const { config: config2 } = Visualization;
  const { themes: themes3 } = config2;
  const Wrapper = (props) => {
    var _a, _b;
    const { dataSources, loading, options, height, width } = props;
    const showPlaceholder = useIconPlaceholder(dataSources, loading, options);
    const bgColorFromTheme = (0, colorUtils_exports.isColor)(options == null ? void 0 : options.backgroundColor) ? options == null ? void 0 : options.backgroundColor : (_a = themes3 == null ? void 0 : themes3.defaultBackgroundColor) == null ? void 0 : _a.call(themes3, props);
    const icon = (_b = config2.placeholderIcon) != null ? _b : config2.icon;
    const iconColor = variables_default.contentColorActive(props);
    if (config2.supports.includes("placeholder" /* PLACEHOLDER */) && showPlaceholder) {
      return /* @__PURE__ */ react_exports.createElement(
        IconPlaceholder_default,
        {
          "data-test": "icon-placeholder",
          icon,
          width,
          height,
          backgroundColor: bgColorFromTheme,
          iconColor
        }
      );
    }
    return /* @__PURE__ */ react_exports.createElement(Visualization, __spreadValues({}, props));
  };
  extendStaticWrapperProps({ Wrapper, Visualization });
  return Wrapper;
};
var withPlaceholder_default = withPlaceholder;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport22 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// src/common/utils/dataUtils.ts
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};

// src/common/hooks/usePrevious.ts
function usePrevious(value) {
  const ref = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    ref.current = value;
  });
  return ref.current;
}

// src/common/hooks/useGetXAndYFields.tsx
var useGetXAndYFields = ({
  shouldEvaluateDSL,
  options,
  context,
  dataSources
}) => {
  const { dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint } = (0, react_exports.useMemo)(() => {
    var _a, _b, _c;
    if (!shouldEvaluateDSL) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    if (!((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) == null ? void 0 : _c.length)) {
      return {
        dataSourcesWithOnlyOnePoint: null,
        dataFrameWithOnlyOnePoint: null
      };
    }
    const { primary: primaryDS } = dataSources;
    const columnsWithOnlyOnePoint = primaryDS.data.columns.map((column) => {
      return [column[0]];
    });
    const filteredDataSources = {
      primary: __spreadProps(__spreadValues({}, primaryDS), {
        data: __spreadProps(__spreadValues({}, primaryDS.data), {
          columns: columnsWithOnlyOnePoint
        })
      })
    };
    return {
      dataSourcesWithOnlyOnePoint: filteredDataSources,
      dataFrameWithOnlyOnePoint: Options_exports.Options.dataFrameFromDataSource(filteredDataSources)
    };
  }, [dataSources, shouldEvaluateDSL]);
  const xAndYFieldsWithTypes = (0, react_exports.useMemo)(() => {
    try {
      if (!dataSourcesWithOnlyOnePoint || !dataFrameWithOnlyOnePoint) {
        return options;
      }
      if (!(options == null ? void 0 : options.x) || !(options == null ? void 0 : options.y) && !(options == null ? void 0 : options.y2)) {
        return options;
      }
      const optionsToEvaluate = {
        x: options.x,
        xField: "> x | getField()",
        y: options.y,
        yFields: options.y ? "> y | getField()" : void 0,
        y2: options.y2,
        y2Fields: options.y2 ? "> y2 | getField()" : void 0,
        fieldTypes: "> primary | getType()"
      };
      const { xField = "", yFields = [], y2Fields = [], fieldTypes } = Options_exports.Options.evaluate(
        { options: optionsToEvaluate, context },
        dataSourcesWithOnlyOnePoint,
        () => {
        },
        dataFrameWithOnlyOnePoint
      );
      return {
        xField,
        yFields: [...yFields, ...y2Fields],
        fieldTypes
      };
    } catch (e) {
      return {
        xField: void 0,
        yFields: [],
        fieldTypes: []
      };
    }
  }, [options, context, dataSourcesWithOnlyOnePoint, dataFrameWithOnlyOnePoint]);
  return xAndYFieldsWithTypes;
};
var useGetXAndYFields_default = useGetXAndYFields;

// src/common/hooks/useDownsampleDataSources.tsx
var downsampleVizOptionProperties = ["nullValueDisplay"];
var useDownsampleDataSources = ({
  dataSources,
  options,
  context,
  threshold,
  isDownsamplingEnabled
}) => {
  const isFirstUseEffectCall = (0, react_exports.useRef)(true);
  const xAndYFieldsWithTypes = useGetXAndYFields_default({
    shouldEvaluateDSL: isDownsamplingEnabled,
    options,
    context,
    dataSources
  });
  const downsampleVizOptions = (0, react_exports.useMemo)(() => (0, lodash_exports.pick)(options, downsampleVizOptionProperties), [options]);
  const downsampleDSOptions = (0, react_exports.useMemo)(
    () => __spreadValues(__spreadValues({}, downsampleVizOptions), xAndYFieldsWithTypes),
    [xAndYFieldsWithTypes, downsampleVizOptions]
  );
  const previousDownsampleDSOptions = usePrevious(downsampleDSOptions);
  const previousDataSources = usePrevious(dataSources);
  const previousThreshold = usePrevious(threshold);
  const [downsampledDataSources, setDownsampledDataSources] = (0, react_exports.useState)(() => {
    return isDownsamplingEnabled ? downsampleDataSources({
      dataSources,
      threshold,
      options: downsampleDSOptions
    }) : dataSources;
  });
  const debouncedDownsampleDataSources = (0, react_exports.useMemo)(() => {
    return (0, lodash_exports.debounce)(
      (downsampleOptions) => {
        const downsampledResult = downsampleDataSources(downsampleOptions);
        setDownsampledDataSources(downsampledResult);
      },
      100,
      { trailing: true }
    );
  }, []);
  (0, react_exports.useEffect)(() => {
    if (isFirstUseEffectCall.current) {
      isFirstUseEffectCall.current = false;
      return;
    }
    if (!isDownsamplingEnabled) {
      setDownsampledDataSources(dataSources);
      return;
    }
    if ((0, lodash_exports.isEqual)(previousDownsampleDSOptions, downsampleDSOptions) && previousDataSources === dataSources && previousThreshold === threshold) {
      return;
    }
    debouncedDownsampleDataSources({
      dataSources,
      options: downsampleDSOptions,
      // Dont want to re-downsample everytime the options change
      threshold
    });
  }, [
    dataSources,
    downsampleDSOptions,
    debouncedDownsampleDataSources,
    xAndYFieldsWithTypes,
    threshold,
    isDownsamplingEnabled,
    previousDataSources,
    previousThreshold,
    previousDownsampleDSOptions
  ]);
  return downsampledDataSources;
};
var useDownsampleDataSources_default = useDownsampleDataSources;

// esm-externals:@splunk/visualization-context/FeatureFlags
var FeatureFlags_exports = {};
__export(FeatureFlags_exports, {
  default: () => FeatureFlags_default
});
var defaultImport23 = __toESM(require("@splunk/visualization-context/FeatureFlags"));
__reExport(FeatureFlags_exports, require("@splunk/visualization-context/FeatureFlags"));
var FeatureFlags_default = "default" in defaultImport23 ? defaultImport23.default : defaultImport23;

// src/common/utils/featureFlagUtils.ts
var getFeatureFlag = (context, flagName) => {
  if (context && Object.keys(context).find((key) => key === flagName)) {
    return context[flagName];
  }
  if (Object.keys(FeatureFlags_default).find((key) => key === flagName)) {
    return FeatureFlags_default[flagName];
  }
  return false;
};

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport24 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport24 ? defaultImport24.default : defaultImport24;

// src/common/utils/trellisUtils.ts
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};

// src/common/withDashboardViz.tsx
var withDashboardViz = (opts) => {
  const {
    ReactViz,
    vizConfig,
    computeVizProps: computeVizProps2 = () => {
    },
    computeVizPropsBeforeEval = () => {
    },
    disableEditModeCover,
    useIconPlaceholder
  } = opts;
  const SanitizedReactViz = (0, SanitizeProps_exports.withSanitizedProps)(ReactViz);
  const defaultOptions = (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(vizConfig.optionsSchema, "default");
  const DashboardViz = (props) => {
    var _a;
    const {
      mode,
      hasEventHandlers,
      dataSources,
      // type of { [key: string]: DataSource }
      options,
      context = {},
      width,
      height,
      onComputedProps,
      onEventTrigger,
      theme,
      onRequestParamsChange
    } = props;
    const { serializedTimezone } = react_exports.useContext(TimezoneContext_default);
    if (serializedTimezone) {
      if (!moment_default.getDefaultSplunkTimezone()) {
        moment_default.setDefaultSplunkTimezone(serializedTimezone);
      }
    }
    const themeFunc = (themeVar) => {
      var _a2, _b;
      return (_b = (_a2 = vizConfig.themes)[themeVar]) == null ? void 0 : _b.call(_a2, props);
    };
    const bgColorFromTheme = themeFunc("defaultBackgroundColor");
    const {
      family: currentThemeFamily,
      colorScheme: currentThemeColorScheme,
      density: currentThemeDensity
    } = getSettingsFromThemedProps_default({ theme });
    let evaluatedOptions = {};
    const [evaluatedOptionsAsync, setEvaluatedOptionsAsync] = react_exports.useState({});
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const [visualizationID] = react_exports.useState(`${vizConfig.name} - ${(0, id_exports.createGUID)()}`);
    const [dataSourcesInState, setDataSourcesInState] = react_exports.useState({});
    const [dataFramesInState, setDataFramesInState] = react_exports.useState();
    const [useAsyncEvaluatedOptions, setUseAsyncEvaluatedOptions] = react_exports.useState(
      Boolean(getFeatureFlag(featureFlagContext, "visualizations_useWebWorkersForDSL"))
    );
    const isDownsamplingEnabledByFeatureFlag = Boolean(
      featureFlagContext == null ? void 0 : featureFlagContext.visualizations_enableDownsampling
    );
    const isTrellisFeatureFlagOn = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableTrellis
    );
    const isTrellisOn = isTrellisFeatureFlagOn && ((_a = vizConfig == null ? void 0 : vizConfig.supports) == null ? void 0 : _a.includes("trellis" /* TRELLIS */)) && (options == null ? void 0 : options.splitByLayout) === "trellis" /* TRELLIS */;
    const isMounted = react_exports.useRef(true);
    const optionsToEvaluate = react_exports.useMemo(() => {
      var _a2;
      const legendDisplay = turnOffLegendDisplayWhenTrellisIsOn(isTrellisOn, options);
      const computedOptions = (_a2 = computeVizPropsBeforeEval(options)) != null ? _a2 : {};
      return {
        context: (0, lodash_exports.defaultsDeep)({}, context, vizConfig.defaultContext),
        options: (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
          {},
          legendDisplay,
          computedOptions,
          options,
          defaultOptions
        )
      };
    }, [isTrellisOn, options, context]);
    const [threshold, setThreshold] = react_exports.useState(Number(width));
    const onDownsamplingThresholdChange = react_exports.useCallback((newThreshold) => {
      setThreshold(newThreshold);
    }, []);
    const isDownsamplingEnabled = react_exports.useMemo(() => {
      return isDownsamplingEnabledByFeatureFlag && isDownsamplingEnabledForViz({ vizConfig });
    }, [isDownsamplingEnabledByFeatureFlag]);
    const downsamplingProps = react_exports.useMemo(() => {
      if (!isDownsamplingEnabled) {
        return {};
      }
      return {
        onDownsamplingThresholdChange,
        originalDataSources: dataSources
      };
    }, [dataSources, isDownsamplingEnabled, onDownsamplingThresholdChange]);
    const downsampledDataSources = useDownsampleDataSources_default({
      options: optionsToEvaluate.options,
      context: optionsToEvaluate.context,
      dataSources,
      threshold,
      isDownsamplingEnabled
    });
    evaluatedOptions = useDeepMemo(() => {
      try {
        if (useAsyncEvaluatedOptions) {
          const asyncDynamicOptionsEvaluatorParams = {
            visualizationID,
            props,
            options: optionsToEvaluate,
            dataSources: downsampledDataSources,
            theme: vizConfig.themes,
            bypassCloneDeepOptionScope: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
            ),
            lazyLoadingDataFrame: Boolean(
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            )
          };
          async_dynamic_options_evaluator_default.evaluate(asyncDynamicOptionsEvaluatorParams).then((results) => {
            setEvaluatedOptionsAsync(results.results);
          }).catch(() => {
            if (isMounted.current) {
              setUseAsyncEvaluatedOptions(false);
            }
          });
        } else {
          let dataFrames = dataFramesInState;
          if (downsampledDataSources !== dataSourcesInState) {
            setDataSourcesInState(downsampledDataSources);
            dataFrames = Options_exports.Options.dataFrameFromDataSource(
              downsampledDataSources,
              getFeatureFlag(featureFlagContext, "visualizations_lazyLoadingDataFrame")
            );
            setDataFramesInState(dataFrames);
          }
          const result = Options_exports.Options.evaluate(
            optionsToEvaluate,
            downsampledDataSources,
            themeFunc,
            dataFrames,
            getFeatureFlag(featureFlagContext, "visualizations_bypassCloneDeepOptionScope")
          );
          return result;
        }
      } catch (e) {
        console.error(`unexpected error evaluating options: ${e.message}`);
        return {};
      }
      return {};
    }, [
      currentThemeFamily,
      currentThemeColorScheme,
      currentThemeDensity,
      optionsToEvaluate,
      downsampledDataSources,
      serializedTimezone,
      useAsyncEvaluatedOptions
    ]);
    const evaluatedOptionsToUse = !useAsyncEvaluatedOptions ? evaluatedOptions : evaluatedOptionsAsync;
    const clonedEvaluatedOptions = __spreadValues({}, evaluatedOptionsToUse);
    if (isTrellisOn) {
      clonedEvaluatedOptions.backgroundColor = clonedEvaluatedOptions == null ? void 0 : clonedEvaluatedOptions.trellisBackgroundColor;
    }
    react_exports.useEffect(() => {
      onComputedProps(clonedEvaluatedOptions);
    });
    react_exports.useEffect(() => {
      return () => {
        if (useAsyncEvaluatedOptions) {
          isMounted.current = false;
          async_dynamic_options_evaluator_default.reset(visualizationID);
        }
      };
    }, []);
    const { requiredProps = [], supports } = vizConfig;
    const missing = missingKeys(requiredProps, evaluatedOptionsToUse);
    if (missing.length > 0 && supports.includes("placeholder" /* PLACEHOLDER */) && vizConfig.key !== "splunk.singlevalue") {
      return /* @__PURE__ */ react_exports.createElement(
        MissingPropsMessage_default,
        {
          "data-test": "missing-props-message",
          width,
          height,
          missingProps: missing,
          backgroundColor: bgColorFromTheme
        }
      );
    }
    const eventCallbackProps = {};
    if (hasEventHandlers && mode === "view" && vizConfig.supports.indexOf("events" /* EVENTS */) > -1) {
      const supportedEvents = vizConfig.events;
      Object.keys(supportedEvents).forEach((eventName) => {
        const { parentKeys, payloadKeys } = supportedEvents[eventName];
        const eventCallbackPropName = (0, lodash_exports.camelCase)(`on.${eventName}`);
        let payload = {};
        if (Array.isArray(payloadKeys) && payloadKeys.length) {
          payloadKeys.forEach((p) => {
            payload[p] = evaluatedOptionsToUse[p];
          });
        }
        eventCallbackProps[eventCallbackPropName] = (ev) => {
          if (ev && ev.payload) {
            payload = ev.payload;
          }
          return onEventTrigger({ originalEvent: ev, payload, type: eventName });
        };
        if (parentKeys) {
          for (let i = parentKeys.length - 1; i >= 0; i -= 1) {
            const newObject = {};
            newObject[parentKeys[i]] = eventCallbackProps[eventCallbackPropName];
            eventCallbackProps[eventCallbackPropName] = newObject;
          }
        }
      });
    }
    const computedVizProps = computeVizProps2(__spreadProps(__spreadValues(__spreadValues(__spreadValues({}, props), evaluatedOptionsToUse), eventCallbackProps), {
      themeFunc
    }));
    let dataSourceMetadata = {};
    const OptionKey = "paginateDataSourceKey";
    const optsKey = (0, lodash_exports.has)(evaluatedOptionsToUse, OptionKey) && evaluatedOptionsToUse[OptionKey];
    const paginateDataSourceKey = typeof optsKey === "string" ? optsKey : "primary";
    if (vizConfig.supports.indexOf("page-and-sort" /* PAGE_AND_SORT */) > -1 && (0, lodash_exports.has)(dataSources, paginateDataSourceKey)) {
      const requestParams = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "requestParams"], {});
      const meta = (0, lodash_exports.get)(dataSources, [paginateDataSourceKey, "meta"], {});
      const handleRequestParamsChange = (payload) => onRequestParamsChange(paginateDataSourceKey, payload);
      const sortParams = getSortingParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      const paginatorParams = getPaginationParams({
        requestParams,
        meta,
        onRequestParamsChange: handleRequestParamsChange
      });
      dataSourceMetadata = {
        sortParams,
        paginatorParams
      };
    }
    if (useAsyncEvaluatedOptions && Object.keys(evaluatedOptionsToUse).length === 0) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      SanitizedReactViz,
      __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({
        mode,
        width,
        height
      }, downsamplingProps), evaluatedOptionsToUse), computedVizProps), eventCallbackProps), dataSourceMetadata)
    );
  };
  DashboardViz.propTypes = __spreadValues(__spreadValues({}, SplunkVisualization_default.propTypes), ReactViz.propTypes);
  DashboardViz.defaultProps = __spreadProps(__spreadValues(__spreadValues({}, SplunkVisualization_default.defaultProps), ReactViz.defaultProps), {
    // using withTheme requires component to receive theme prop. In case the consumer did not provide ThemeProvider, a default empty object will prevent warnings.
    theme: {}
  });
  DashboardViz.config = vizConfig;
  return (0, styled_components_exports.withTheme)(
    withPlaceholder_default(withEditModeCover_default(DashboardViz, disableEditModeCover), useIconPlaceholder)
  );
};
var withDashboardViz_default = withDashboardViz;

// esm-externals:@splunk/visualization-color-palettes
var visualization_color_palettes_exports = {};
__export(visualization_color_palettes_exports, {
  default: () => visualization_color_palettes_default
});
var defaultImport25 = __toESM(require("@splunk/visualization-color-palettes"));
__reExport(visualization_color_palettes_exports, require("@splunk/visualization-color-palettes"));
var visualization_color_palettes_default = "default" in defaultImport25 ? defaultImport25.default : defaultImport25;

// esm-externals:d3-interpolate
var d3_interpolate_exports = {};
__export(d3_interpolate_exports, {
  default: () => d3_interpolate_default
});
var defaultImport26 = __toESM(require("d3-interpolate"));
__reExport(d3_interpolate_exports, require("d3-interpolate"));
var d3_interpolate_default = "default" in defaultImport26 ? defaultImport26.default : defaultImport26;

// esm-externals:d3-array
var d3_array_exports = {};
__export(d3_array_exports, {
  default: () => d3_array_default
});
var defaultImport27 = __toESM(require("d3-array"));
__reExport(d3_array_exports, require("d3-array"));
var d3_array_default = "default" in defaultImport27 ? defaultImport27.default : defaultImport27;

// esm-externals:d3-collection
var d3_collection_exports = {};
__export(d3_collection_exports, {
  default: () => d3_collection_default
});
var defaultImport28 = __toESM(require("d3-collection"));
__reExport(d3_collection_exports, require("d3-collection"));
var d3_collection_default = "default" in defaultImport28 ? defaultImport28.default : defaultImport28;

// src/Sankey/PureSankey/lib/sankey.js
var d3_sankey = function() {
  let sankey = {}, nodeWidth = 24, nodePadding = 8, size2 = [1, 1], nodes = [], links = [], components = [];
  sankey.nodeWidth = function(_7) {
    if (!arguments.length) return nodeWidth;
    nodeWidth = +_7;
    return sankey;
  };
  sankey.nodePadding = function(_7) {
    if (!arguments.length) return nodePadding;
    nodePadding = +_7;
    return sankey;
  };
  sankey.nodes = function(_7) {
    if (!arguments.length) return nodes;
    nodes = _7;
    return sankey;
  };
  sankey.links = function(_7) {
    if (!arguments.length) return links;
    links = _7;
    return sankey;
  };
  sankey.size = function(_7) {
    if (!arguments.length) return size2;
    size2 = _7;
    return sankey;
  };
  sankey.layout = function(iterations) {
    computeNodeLinks();
    computeNodeValues();
    computeNodeStructure();
    computeNodeBreadths();
    computeNodeDepths(iterations);
    computeLinkDepths();
    return sankey;
  };
  sankey.relayout = function() {
    computeLinkDepths();
    return sankey;
  };
  sankey.reversibleLink = function() {
    let curvature = 0.5;
    function forwardLink(part, d) {
      let x0 = d.source.x + d.source.dx, x1 = d.target.x, xi = (0, d3_interpolate_exports.interpolateNumber)(x0, x1), x2 = xi(curvature), x3 = xi(1 - curvature), y0 = d.source.y + d.sy, y1 = d.target.y + d.ty, y2 = d.source.y + d.sy + d.dy, y3 = d.target.y + d.ty + d.dy;
      switch (part) {
        case 0:
          return "M" + x0 + "," + y0 + "L" + x0 + "," + (y0 + d.dy);
        case 1:
          return "M" + x0 + "," + y0 + "C" + x2 + "," + y0 + " " + x3 + "," + y1 + " " + x1 + "," + y1 + "L" + x1 + "," + y3 + "C" + x3 + "," + y3 + " " + x2 + "," + y2 + " " + x0 + "," + y2 + "Z";
        case 2:
          return "M" + x1 + "," + y1 + "L" + x1 + "," + (y1 + d.dy);
      }
    }
    function backwardLink(part, d) {
      let curveExtension = 30;
      let curveDepth = 15;
      function getDir(d2) {
        return d2.source.y + d2.sy > d2.target.y + d2.ty ? -1 : 1;
      }
      function p(x, y) {
        return x + "," + y + " ";
      }
      let dt = getDir(d) * curveDepth, x0 = d.source.x + d.source.dx, y0 = d.source.y + d.sy, x1 = d.target.x, y1 = d.target.y + d.ty;
      switch (part) {
        case 0:
          return "M" + p(x0, y0) + "C" + p(x0, y0) + p(x0 + curveExtension, y0) + p(x0 + curveExtension, y0 + dt) + "L" + p(x0 + curveExtension, y0 + dt + d.dy) + "C" + p(x0 + curveExtension, y0 + d.dy) + p(x0, y0 + d.dy) + p(x0, y0 + d.dy) + "Z";
        case 1:
          return "M" + p(x0 + curveExtension, y0 + dt) + "C" + p(x0 + curveExtension, y0 + 3 * dt) + p(x1 - curveExtension, y1 - 3 * dt) + p(x1 - curveExtension, y1 - dt) + "L" + p(x1 - curveExtension, y1 - dt + d.dy) + "C" + p(x1 - curveExtension, y1 - 3 * dt + d.dy) + p(x0 + curveExtension, y0 + 3 * dt + d.dy) + p(x0 + curveExtension, y0 + dt + d.dy) + "Z";
        case 2:
          return "M" + p(x1 - curveExtension, y1 - dt) + "C" + p(x1 - curveExtension, y1) + p(x1, y1) + p(x1, y1) + "L" + p(x1, y1 + d.dy) + "C" + p(x1, y1 + d.dy) + p(x1 - curveExtension, y1 + d.dy) + p(x1 - curveExtension, y1 + d.dy - dt) + "Z";
      }
    }
    return function(part) {
      return function(d) {
        if (d.source.x < d.target.x) {
          return forwardLink(part, d);
        } else {
          return backwardLink(part, d);
        }
      };
    };
  };
  sankey.link = function() {
    let curvature = 0.5;
    function link(d) {
      let x0 = d.source.x + d.source.dx, x1 = d.target.x, xi = (0, d3_interpolate_exports.interpolateNumber)(x0, x1), x2 = xi(curvature), x3 = xi(1 - curvature), y0 = d.source.y + d.sy + d.dy / 2, y1 = d.target.y + d.ty + d.dy / 2;
      return "M" + x0 + "," + y0 + "C" + x2 + "," + y0 + " " + x3 + "," + y1 + " " + x1 + "," + y1;
    }
    link.curvature = function(_7) {
      if (!arguments.length) return curvature;
      curvature = +_7;
      return link;
    };
    return link;
  };
  function computeNodeLinks() {
    nodes.forEach(function(node) {
      node.sourceLinks = [];
      node.targetLinks = [];
    });
    links.forEach(function(link) {
      let source = link.source, target = link.target;
      if (typeof source === "number") source = link.source = nodes[link.source];
      if (typeof target === "number") target = link.target = nodes[link.target];
      source.sourceLinks.push(link);
      target.targetLinks.push(link);
    });
  }
  function computeNodeValues() {
    nodes.forEach(function(node) {
      if (!node.value)
        node.value = Math.max((0, d3_array_exports.sum)(node.sourceLinks, value), (0, d3_array_exports.sum)(node.targetLinks, value));
    });
  }
  function computeNodeStructure() {
    let nodeStack = [], index = 0;
    nodes.forEach(function(node) {
      if (!node.index) {
        connect(node);
      }
    });
    function connect(node) {
      node.index = index++;
      node.lowIndex = node.index;
      node.onStack = true;
      nodeStack.push(node);
      if (node.sourceLinks) {
        node.sourceLinks.forEach(function(sourceLink) {
          let target = sourceLink.target;
          if (!target.hasOwnProperty("index")) {
            connect(target);
            node.lowIndex = Math.min(node.lowIndex, target.lowIndex);
          } else if (target.onStack) {
            node.lowIndex = Math.min(node.lowIndex, target.index);
          }
        });
        if (node.lowIndex === node.index) {
          let component = [], currentNode;
          do {
            currentNode = nodeStack.pop();
            currentNode.onStack = false;
            component.push(currentNode);
          } while (currentNode != node);
          components.push({
            root: node,
            scc: component
          });
        }
      }
    }
    components.forEach(function(component, i) {
      component.index = i;
      component.scc.forEach(function(node) {
        node.component = i;
      });
    });
  }
  function computeNodeBreadths() {
    layerComponents();
    components.forEach(function(component, i) {
      bfs(component.root, function(node) {
        let result = node.sourceLinks.filter(function(sourceLink) {
          return sourceLink.target.component == i;
        }).map(function(sourceLink) {
          return sourceLink.target;
        });
        return result;
      });
    });
    let max = 0;
    let componentsByBreadth = (0, d3_collection_exports.nest)().key(function(d) {
      return d.x;
    }).sortKeys(d3_array_exports.ascending).entries(components).map(function(d) {
      return d.values;
    });
    max = -1;
    let nextMax = -1;
    componentsByBreadth.forEach(function(c) {
      c.forEach(function(component) {
        component.x = max + 1;
        component.scc.forEach(function(node) {
          if (node.layer) node.x = node.layer;
          else node.x = component.x + node.x;
          nextMax = Math.max(nextMax, node.x);
        });
      });
      max = nextMax;
    });
    nodes.filter(function(node) {
      let outLinks = node.sourceLinks.filter(function(link) {
        return link.source.name != link.target.name;
      });
      return outLinks.length == 0;
    }).forEach(function(node) {
      node.x = node.layer ? node.x : max;
    });
    scaleNodeBreadths((size2[0] - nodeWidth) / Math.max(max, 1));
    function flatten(a) {
      return [].concat.apply([], a);
    }
    function layerComponents() {
      let remainingComponents = components, nextComponents, visitedIndex, x = 0;
      while (remainingComponents.length) {
        nextComponents = [];
        visitedIndex = {};
        remainingComponents.forEach(function(component) {
          component.x = x;
          component.scc.forEach(function(n) {
            n.sourceLinks.forEach(function(l) {
              if (!visitedIndex.hasOwnProperty(l.target.component) && l.target.component != component.index) {
                nextComponents.push(components[l.target.component]);
                visitedIndex[l.target.component] = true;
              }
            });
          });
        });
        remainingComponents = nextComponents;
        ++x;
      }
    }
    function bfs(node, extractTargets) {
      let queue = [node], currentCount = 1, nextCount = 0;
      let x = 0;
      while (currentCount > 0) {
        let currentNode = queue.shift();
        currentCount--;
        if (!currentNode.hasOwnProperty("x")) {
          currentNode.x = x;
          currentNode.dx = nodeWidth;
          let targets = extractTargets(currentNode);
          queue = queue.concat(targets);
          nextCount += targets.length;
        }
        if (currentCount == 0) {
          x++;
          currentCount = nextCount;
          nextCount = 0;
        }
      }
    }
  }
  function moveSourcesRight() {
    nodes.forEach(function(node) {
      if (!node.targetLinks.length) {
        node.x = (0, d3_array_exports.min)(node.sourceLinks, function(d) {
          return d.target.x;
        }) - 1;
      }
    });
  }
  function moveSinksRight(x) {
    nodes.forEach(function(node) {
      if (!node.sourceLinks.length) {
        node.x = x - 1;
      }
    });
  }
  function scaleNodeBreadths(kx) {
    nodes.forEach(function(node) {
      node.x *= kx;
    });
  }
  function computeNodeDepths(iterations) {
    let nodesByBreadth = (0, d3_collection_exports.nest)().key(function(d) {
      return d.x;
    }).sortKeys(d3_array_exports.ascending).entries(nodes).map(function(d) {
      return d.values;
    });
    initializeNodeDepth();
    resolveCollisions();
    for (let alpha = 1; iterations > 0; --iterations) {
      relaxRightToLeft(alpha *= 0.99);
      resolveCollisions();
      relaxLeftToRight(alpha);
      resolveCollisions();
    }
    function initializeNodeDepth() {
      let ky = (0, d3_array_exports.min)(nodesByBreadth, function(nodes2) {
        return (size2[1] - (nodes2.length - 1) * nodePadding) / (0, d3_array_exports.sum)(nodes2, value);
      });
      nodesByBreadth.forEach(function(nodes2) {
        nodes2.forEach(function(node, i) {
          node.y = i;
          node.dy = node.value * ky;
        });
      });
      links.forEach(function(link) {
        link.dy = link.value * ky;
      });
    }
    function relaxLeftToRight(alpha) {
      nodesByBreadth.forEach(function(nodes2, breadth) {
        nodes2.forEach(function(node) {
          if (node.targetLinks.length) {
            let y = (0, d3_array_exports.sum)(node.targetLinks, weightedSource) / (0, d3_array_exports.sum)(node.targetLinks, value);
            node.y += (y - center(node)) * alpha;
          }
        });
      });
      function weightedSource(link) {
        return center(link.source) * link.value;
      }
    }
    function relaxRightToLeft(alpha) {
      nodesByBreadth.slice().reverse().forEach(function(nodes2) {
        nodes2.forEach(function(node) {
          if (node.sourceLinks.length) {
            let y = (0, d3_array_exports.sum)(node.sourceLinks, weightedTarget) / (0, d3_array_exports.sum)(node.sourceLinks, value);
            node.y += (y - center(node)) * alpha;
          }
        });
      });
      function weightedTarget(link) {
        return center(link.target) * link.value;
      }
    }
    function resolveCollisions() {
      nodesByBreadth.forEach(function(nodes2) {
        let node, dy, y0 = 0, n = nodes2.length, i;
        nodes2.sort(ascendingDepth);
        for (i = 0; i < n; ++i) {
          node = nodes2[i];
          if (node) {
            dy = y0 - node.y;
            if (dy > 0) node.y += dy;
            y0 = node.y + node.dy + nodePadding;
          }
        }
        dy = y0 - nodePadding - size2[1];
        if (node && dy > 0) {
          y0 = node.y -= dy;
          for (i = n - 2; i >= 0; --i) {
            node = nodes2[i];
            dy = node.y + node.dy + nodePadding - y0;
            if (dy > 0) node.y -= dy;
            y0 = node.y;
          }
        }
      });
    }
    function ascendingDepth(a, b) {
      return a.y - b.y;
    }
  }
  function computeLinkDepths() {
    nodes.forEach(function(node) {
      const parallelrendering = false;
      if (parallelrendering) {
      } else node.sourceLinks.sort(ascendingTargetDepth);
      node.targetLinks.sort(ascendingSourceDepth);
    });
    nodes.forEach(function(node) {
      let sy = 0, ty = 0;
      node.sourceLinks.forEach(function(link) {
        link.sy = sy;
        sy += link.dy;
      });
      node.targetLinks.forEach(function(link) {
        link.ty = ty;
        ty += link.dy;
      });
    });
    function ascendingSourceDepth(a, b) {
      return a.source.y - b.source.y;
    }
    function ascendingTargetDepth(a, b) {
      return a.target.y - b.target.y;
    }
  }
  function center(node) {
    return node.y + node.dy / 2;
  }
  function value(link) {
    return link.value;
  }
  return sankey;
};

// src/common/components/VizStyleWrapper.jsx
var VizStyleWrapper = styled_components_default.div.attrs(({ dataTestKey }) => ({
  "data-test": dataTestKey,
  "data-testid": dataTestKey
}))`
    display: flex;
    justify-content: center;
    flex-direction: column;
    width: 100%;
    height: 100%;
    background-color: ${(props) => props.backgroundColor};
`;
VizStyleWrapper.displayName = "VizStyleWrapper";
var VizStyleWrapper_default = VizStyleWrapper;

// esm-externals:d3-scale
var d3_scale_exports = {};
__export(d3_scale_exports, {
  default: () => d3_scale_default
});
var defaultImport29 = __toESM(require("d3-scale"));
__reExport(d3_scale_exports, require("d3-scale"));
var d3_scale_default = "default" in defaultImport29 ? defaultImport29.default : defaultImport29;

// esm-externals:@splunk/visualization-encoding/utils/types
var types_exports = {};
__export(types_exports, {
  default: () => types_default
});
var defaultImport30 = __toESM(require("@splunk/visualization-encoding/utils/types"));
__reExport(types_exports, require("@splunk/visualization-encoding/utils/types"));
var types_default = "default" in defaultImport30 ? defaultImport30.default : defaultImport30;

// src/Sankey/PureSankey/SankeyUtils.ts
var insertNodeIfNotExist = (sankeyData, nodeName) => {
  let { nodes } = sankeyData;
  nodes = nodes || [];
  if (typeof nodeName !== "string") {
    console.error("Node not created, invalid nodename:", nodeName);
    return;
  }
  nodeName = nodeName.trim();
  if (!nodes.find((node) => node.name.toLocaleLowerCase() === nodeName.toLocaleLowerCase())) {
    nodes.push({ name: nodeName });
  }
};
var insertLink = (sankeyData, sourceFieldIdx, targetFieldIdx, linkValue, index) => {
  let { links } = sankeyData;
  links = links || [];
  links.push({
    source: sourceFieldIdx,
    target: targetFieldIdx,
    value: linkValue,
    index
  });
};
var getNodesIndex = (sankeyData, nodeName) => {
  if (!sankeyData || !sankeyData.nodes || !sankeyData.nodes.length) {
    return -1;
  }
  return sankeyData.nodes.findIndex((node) => node.name.toLocaleLowerCase() === nodeName.toLocaleLowerCase());
};
var getColorCategoryMapping = ({
  category,
  colorMode,
  seriesColors,
  linkColors
}) => {
  if (colorMode !== "categorical") {
    return linkColors;
  }
  return seriesColors ? (0, d3_scale_exports.scaleOrdinal)().domain(category).range(seriesColors).unknown(seriesColors[0]) : null;
};
var convertInputToSankeyDataFormat = (columns, sourceFieldIdx, targetFieldIdx, linkValueFieldIdx, resultLimit) => {
  if (!columns || !Array.isArray(columns) || !columns.length || !columns[sourceFieldIdx] || !columns[targetFieldIdx] || !columns[linkValueFieldIdx] || columns.length < 3 || !Array.isArray(columns[sourceFieldIdx]) || !Array.isArray(columns[targetFieldIdx]) || !Array.isArray(columns[linkValueFieldIdx]) || !columns[sourceFieldIdx] || typeof columns[sourceFieldIdx][0] !== "string" || !columns[targetFieldIdx] || typeof columns[targetFieldIdx][0] !== "string") {
    return null;
  }
  const sankeyData = {
    nodes: [],
    links: []
  };
  const maxlen = Math.min(
    columns[sourceFieldIdx].length,
    columns[targetFieldIdx].length,
    columns[linkValueFieldIdx].length,
    resultLimit
  );
  for (let i = 0; i < maxlen; i += 1) {
    if (typeof columns[sourceFieldIdx][i] === "string" && typeof columns[targetFieldIdx][i] === "string" && (0, types_exports.isNumber)(columns[linkValueFieldIdx][i])) {
      const sourceNodeName = columns[sourceFieldIdx][i].trim();
      const targetNodeName = columns[targetFieldIdx][i].trim();
      insertNodeIfNotExist(sankeyData, sourceNodeName);
      insertNodeIfNotExist(sankeyData, targetNodeName);
      const sourceNodeIdx = getNodesIndex(sankeyData, sourceNodeName);
      const targetNodeIdx = getNodesIndex(sankeyData, targetNodeName);
      const linkExist = sankeyData.links.find((link) => {
        return link.source === sourceNodeIdx && link.target === targetNodeIdx;
      });
      const linkValue = +columns[linkValueFieldIdx][i];
      if (linkExist) {
        linkExist.value += linkValue;
      } else {
        insertLink(sankeyData, sourceNodeIdx, targetNodeIdx, linkValue, i);
      }
    } else {
      console.error(
        "Link excluded. Invalid type in column input, row :- ",
        i,
        `[${columns[sourceFieldIdx][i]}, ${columns[targetFieldIdx][i]}, ${columns[linkValueFieldIdx][i]}]`
      );
    }
  }
  return sankeyData;
};
var getNodeId = (node) => {
  if (!node) {
    return "";
  }
  return `node-${node.index}`;
};
var getLinkId = (link) => {
  if (!link) {
    return "";
  }
  return `link-${link.id}`;
};
var getAllNodeNames = (sankeyData) => {
  if (!sankeyData || !sankeyData.nodes || !sankeyData.nodes.length) {
    return [];
  }
  return sankeyData.nodes.map((node) => node.name);
};
var extractLinkMidPoint = (pathStr) => {
  if (!pathStr) {
    return null;
  }
  const mIndex = pathStr.indexOf("M");
  const cIndexFirst = pathStr.indexOf("C");
  const lIndex = pathStr.indexOf("L");
  const cIndexLast = pathStr.lastIndexOf("C");
  const zIndex = pathStr.lastIndexOf("Z");
  if (mIndex < 0 || cIndexLast < 0 || cIndexLast < 0 || zIndex < 0) {
    console.error("Extract link midpoint error. Invalid path -", pathStr);
    return null;
  }
  const section1 = pathStr.slice(mIndex + 1, cIndexFirst).trim();
  const section2 = pathStr.slice(cIndexFirst + 1, lIndex).trim();
  const section3 = pathStr.slice(lIndex + 1, cIndexLast).trim();
  const section4 = pathStr.slice(cIndexLast + 1, zIndex).trim();
  if (!section1.length || !section2.length || !section3.length || !section4.length) {
    console.error("Extract link midpoint error. Invalid path -", pathStr);
    return null;
  }
  const points = [];
  points.push(section1.split(",").map((i) => Number.parseFloat(i)));
  const point2Arr = section2.split(" ");
  points.push(point2Arr[point2Arr.length - 1].split(",").map((i) => Number.parseFloat(i)));
  points.push(section3.split(",").map((i) => Number.parseFloat(i)));
  const point4Arr = section4.split(" ");
  points.push(point4Arr[point4Arr.length - 1].split(",").map((i) => Number.parseFloat(i)));
  const width = Math.abs(points[0][0] - points[1][0]) / 2;
  const x = Math.min(points[0][0], points[1][0]) + width;
  const height = Math.abs(points[0][1] - points[2][1]) / 2;
  const y = Math.min(points[0][1], points[2][1]) + height;
  return { x, y };
};
var getAllConnectedLinks = (links, nodeIdx) => {
  const result = { links: [], sourceNodes: [], targetNodes: [] };
  if (!links || !links.length) {
    return result;
  }
  links.forEach((link) => {
    if (link.source.index === nodeIdx || link.target.index === nodeIdx) {
      const linkAdded = result.links.find((l) => l.id === link.id);
      if (!linkAdded) {
        result.links.push(link);
      }
      const sourceNodeAdded = result.sourceNodes.find((n) => n.index === link.source.index);
      if (!sourceNodeAdded) {
        result.sourceNodes.push(link.source);
      }
      const targetNodeAdded = result.targetNodes.find((n) => n.index === link.target.index);
      if (!targetNodeAdded) {
        result.targetNodes.push(link.target);
      }
    }
  });
  return result;
};
var computeAllConnectedLinksToNodes = (nodes, links) => {
  const connectionsMap = {};
  if (!nodes || !links) {
    return connectionsMap;
  }
  nodes.forEach((node) => {
    const connections = getAllConnectedLinks(links, node.index);
    connectionsMap[node.index] = connections;
  });
  return connectionsMap;
};
var checkDigitsOnly = (input) => {
  return /^\d+$/.test(input);
};
var truncateSVGTextWithEllipsis = (textElement, textString, width) => {
  if (textElement && textElement.getSubStringLength !== void 0) {
    textElement.textContent = textString;
    if (textElement.getSubStringLength(0, textString.length) >= width) {
      for (let x = textString.length - 3; x > 0; x -= 3) {
        if (textElement.getSubStringLength(0, x) <= width) {
          textElement.textContent = `${textString.substring(0, x)}...`;
          return;
        }
      }
      textElement.textContent = "...";
    }
  }
};

// src/Sankey/PureSankey/SankeyNode.tsx
var MAX_NODE_TEXT_WIDTH = 150;
var getNodeOpacity = (nodeIndex, activeNodes) => {
  if (!activeNodes || !activeNodes.length) {
    return DEFAULT_NODE_OPACITY;
  }
  const isActiveNode = activeNodes.find((node) => node.index === nodeIndex);
  return isActiveNode ? DEFAULT_NODE_OPACITY : INACTIVE_OPACITY;
};
var getNodeHeight = (node) => {
  return node.dy < 0 ? 1 : node.dy;
};
var NodeGroup = styled_components_default.g`
    opacity: ${(props) => getNodeOpacity(props.node.index, props.activeNodes)};
    &:hover {
        cursor: pointer;
    }
`;
NodeGroup.displayName = "NodeGroup";
var NodeRect = styled_components_default.rect`
    fill: ${(props) => typeof props.colorCategoryMapping === "function" ? props.colorCategoryMapping(props.node.name) : DEFAULT_NODE_COLOR};
`;
var NodeText = styled_components_default.text`
    text-anchor: ${(props) => props.node.x < props.chartWidth / 2 ? "start" : "end"};
    font-size: 12px;
    font-family: ${DEFAULT_FONT_FAMILY};
    letter-spacing: 0.02em;
    fill: ${(props) => props.nodeTextColor};
`;
var SankeyNode = (props) => {
  const {
    node,
    activeNodes,
    nodeWidth,
    chartWidth,
    handleMouseOver,
    handleMouseLeave,
    handleNodeClick,
    colorCategoryMapping,
    nodeTextColor
  } = props;
  const nodeTextRef = (0, react_exports.useRef)();
  (0, react_exports.useEffect)(() => {
    truncateSVGTextWithEllipsis(nodeTextRef.current, node.name, MAX_NODE_TEXT_WIDTH);
  });
  const nodeClickHandler = (0, react_exports.useCallback)(() => handleNodeClick(node), [node]);
  return /* @__PURE__ */ react_exports.createElement(
    NodeGroup,
    {
      node,
      activeNodes,
      className: "node",
      key: `node-${node.index}`,
      "data-test": `node-${node.index}`,
      transform: `translate(${node.x},${node.y})`,
      onClick: nodeClickHandler
    },
    /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, /* @__PURE__ */ react_exports.createElement(
      NodeRect,
      {
        node,
        height: getNodeHeight(node),
        width: nodeWidth,
        colorCategoryMapping,
        onMouseOver: (ev) => handleMouseOver(ev),
        onMouseLeave: (ev) => handleMouseLeave(ev)
      }
    ), /* @__PURE__ */ react_exports.createElement(
      NodeText,
      {
        ref: nodeTextRef,
        node,
        chartWidth,
        x: node.x < chartWidth / 2 ? 6 + nodeWidth : -6,
        y: node.dy / 2,
        dy: ".35em",
        nodeTextColor
      },
      node.name
    ))
  );
};
SankeyNode.propTypes = {
  node: prop_types_exports.object,
  activeNodes: prop_types_exports.arrayOf(prop_types_exports.object),
  nodeWidth: prop_types_exports.number,
  chartWidth: prop_types_exports.number,
  handleMouseOver: prop_types_exports.func,
  handleMouseLeave: prop_types_exports.func,
  colorCategoryMapping: prop_types_exports.oneOfType([prop_types_exports.func, prop_types_exports.arrayOf(prop_types_exports.string)]),
  nodeTextColor: prop_types_exports.string
};
SankeyNode.defaultProps = {
  handleMouseOver: () => {
  },
  handleMouseLeave: () => {
  }
};
var SankeyNode_default = SankeyNode;

// src/Sankey/PureSankey/SankeyLink.tsx
var getLinkFill = (link, colorCategoryMapping, colorMode) => {
  if (colorMode === "categorical") {
    return colorCategoryMapping ? colorCategoryMapping(link.source.name) : DEFAULT_LINK_COLOR;
  }
  return colorCategoryMapping && colorCategoryMapping[link.index] ? colorCategoryMapping[link.index] : DEFAULT_LINK_COLOR;
};
var getLinkOpacity = (link, activeLinks, linkOpacity) => {
  if (!activeLinks || !activeLinks.length) {
    return linkOpacity;
  }
  const isActiveLink = activeLinks.find((l) => l.id === link.id);
  return isActiveLink ? linkOpacity : INACTIVE_OPACITY;
};
var StyledSankeyLink = styled_components_default.g`
    &:hover {
        cursor: pointer;
    }
`;
var SankeyLink = (props) => {
  const {
    link,
    colorCategoryMapping,
    activeLinks,
    linkOpacity,
    colorMode,
    path,
    handleMouseOver,
    handleMouseLeave,
    handleLinkClick
  } = props;
  const circlePoints = extractLinkMidPoint(path(1)(link));
  const linkClickHandler = (0, react_exports.useCallback)(() => handleLinkClick(link), [link]);
  return /* @__PURE__ */ react_exports.createElement(
    StyledSankeyLink,
    {
      className: "link",
      key: link.id,
      id: link.id,
      "data-test": link.id,
      fill: getLinkFill(link, colorCategoryMapping, colorMode),
      opacity: getLinkOpacity(link, activeLinks, linkOpacity),
      onClick: linkClickHandler,
      onMouseOver: (ev) => {
        handleMouseOver(ev);
      },
      onMouseLeave: (ev) => {
        const relatedTarget = ev.relatedTarget;
        let isRelatedTargetPopover = false;
        if (relatedTarget && relatedTarget.classList) {
          const { classList } = relatedTarget;
          classList.forEach((name) => {
            if (name.toLocaleLowerCase().indexOf("sankeytooltip") > -1 || name.toLocaleLowerCase().indexOf("popoverstyles") > -1) {
              isRelatedTargetPopover = true;
            }
          });
        }
        if (!isRelatedTargetPopover) {
          handleMouseLeave(ev);
        }
      }
    },
    /* @__PURE__ */ react_exports.createElement("path", { d: path(0)(link) }),
    /* @__PURE__ */ react_exports.createElement("path", { d: path(1)(link) }),
    /* @__PURE__ */ react_exports.createElement("path", { d: path(2)(link) }),
    circlePoints && /* @__PURE__ */ react_exports.createElement("circle", { cx: circlePoints.x, cy: circlePoints.y, r: 5, fill: "transparent" })
  );
};
SankeyLink.propTypes = {
  link: prop_types_exports.object,
  activeLinks: prop_types_exports.arrayOf(prop_types_exports.object),
  linkOpacity: prop_types_exports.number,
  path: prop_types_exports.func,
  handleMouseOver: prop_types_exports.func,
  handleMouseLeave: prop_types_exports.func,
  colorCategoryMapping: prop_types_exports.oneOfType([prop_types_exports.func, prop_types_exports.arrayOf(prop_types_exports.string)])
};
SankeyLink.defaultProps = {
  handleMouseOver: () => {
  },
  handleMouseLeave: () => {
  }
};
var SankeyLink_default = SankeyLink;

// esm-externals:@splunk/react-ui/Popover
var Popover_exports = {};
__export(Popover_exports, {
  default: () => Popover_default
});
var defaultImport31 = __toESM(require("@splunk/react-ui/Popover"));
__reExport(Popover_exports, require("@splunk/react-ui/Popover"));
var Popover_default = "default" in defaultImport31 ? defaultImport31.default : defaultImport31;

// src/Sankey/PureSankey/SankeyTooltip.tsx
var DEFAULT_PLACEMENT = "below";
var StyledTooltipContainer = styled_components_default.div`
    display: flex;
    min-width: 200px;
    max-width: 300px;
    padding: 16px;
    flex-direction: column;
`;
var StyledTooltipSection = styled_components_default.div`
    display: flex;
    flex-direction: column;
    > div:nth-child(1) {
        margin-top: 8px;
    }
    > div:last-child {
        margin-bottom: 8px;
    }
`;
var StyledTooltipHeader = styled_components_default.div`
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    font-size: 14px;
    color: ${(props) => props.headerColor};
`;
var StyledTooltipLinkHeader = styled_components_default.div`
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    font-size: 14px;
    margin-bottom: 8px;
    color: ${(props) => props.linkHeaderColor};
`;
var StyledTooltipRow = styled_components_default.div`
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    font-size: 12px;
    color: ${(props) => props.rowColor};
    margin-bottom: 6px;
`;
var StyledTooltipLeftCell = styled_components_default.div`
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    align-items: center;
`;
var StyledTooltipRightCell = styled_components_default.div`
    margin-left: 5px;
`;
var ColorTile = styled_components_default.div`
    width: 6px;
    height: 16px;
    background-color: ${(props) => typeof props.colorCategoryMapping === "function" ? props.colorCategoryMapping(props.node.name) : DEFAULT_NODE_COLOR};}
`;
var NodeValue = styled_components_default.div`
    margin-left: 8px;
    max-width: 200px;
    text-overflow: ellipsis;
    overflow: hidden;
    white-space: nowrap;
`;
var SankeyTooltip = (props) => {
  const {
    mode,
    node,
    link,
    open,
    connectionsMap,
    anchor,
    linkValue,
    colorCategoryMapping,
    width,
    tooltipRowColor,
    tooltipLinkHeaderColor,
    tooltipHeaderColor,
    handleTooltipRequestClose
  } = props;
  const showSection = (connection, nodeData, section) => {
    if (!connection) {
      return false;
    }
    const connectionNodes = section === "source" ? connection.sourceNodes : connection.targetNodes;
    const filteredNodes = connectionNodes.filter((cNode) => cNode.index !== nodeData.index);
    return filteredNodes.length > 0;
  };
  const getPopoverPlacement = (anchorElement) => {
    if (!anchorElement) {
      return DEFAULT_PLACEMENT;
    }
    const bBox = anchorElement.getBoundingClientRect();
    if (bBox.x <= 15) {
      return "right";
    }
    if (bBox.x >= width - 15) {
      return "left";
    }
    return DEFAULT_PLACEMENT;
  };
  const renderNodeToolTip = () => {
    if (!node) {
      return null;
    }
    const connections = connectionsMap[node.index];
    return /* @__PURE__ */ react_exports.createElement(
      Popover_default,
      {
        open,
        anchor,
        onRequestClose: () => handleTooltipRequestClose(),
        defaultPlacement: getPopoverPlacement(anchor)
      },
      /* @__PURE__ */ react_exports.createElement(StyledTooltipContainer, { className: "sankeyToolTip" }, /* @__PURE__ */ react_exports.createElement(StyledTooltipRow, { rowColor: tooltipRowColor, "data-test": "main-row" }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, { "data-test": "main-row-name" }, /* @__PURE__ */ react_exports.createElement(ColorTile, { node, colorCategoryMapping }), /* @__PURE__ */ react_exports.createElement(NodeValue, null, node == null ? void 0 : node.name)), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, { "data-test": "main-row-value" }, (0, numberUtils_exports.formatNumber)(node == null ? void 0 : node.value, 0, { useTrendUnits: true }))), showSection(connections, node, "source") && /* @__PURE__ */ react_exports.createElement(StyledTooltipHeader, { headerColor: tooltipHeaderColor }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, "Source"), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, null, linkValue)), /* @__PURE__ */ react_exports.createElement(StyledTooltipSection, null, connections && connections.sourceNodes.map((sNode, idx) => {
        var _a, _b;
        if ((sNode == null ? void 0 : sNode.index) !== (node == null ? void 0 : node.index) || ((_a = connections.sourceNodes[idx]) == null ? void 0 : _a.index) === ((_b = connections.targetNodes[idx]) == null ? void 0 : _b.index)) {
          return /* @__PURE__ */ react_exports.createElement(
            StyledTooltipRow,
            {
              key: sNode.index,
              rowColor: tooltipRowColor,
              "data-test": "source-row"
            },
            /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, /* @__PURE__ */ react_exports.createElement(
              ColorTile,
              {
                node: sNode,
                colorCategoryMapping
              }
            ), /* @__PURE__ */ react_exports.createElement(NodeValue, { "data-test": "source-row-name" }, sNode == null ? void 0 : sNode.name)),
            /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, { "data-test": "source-row-value" }, (0, numberUtils_exports.formatNumber)(sNode == null ? void 0 : sNode.value, 0, { useTrendUnits: true }))
          );
        }
        return null;
      })), showSection(connections, node, "target") && /* @__PURE__ */ react_exports.createElement(StyledTooltipHeader, { headerColor: tooltipHeaderColor }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, "Target"), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, null, linkValue)), /* @__PURE__ */ react_exports.createElement(StyledTooltipSection, null, connections && connections.targetNodes.map((tNode, idx) => {
        var _a, _b;
        if ((tNode == null ? void 0 : tNode.index) !== (node == null ? void 0 : node.index) || ((_a = connections.sourceNodes[idx]) == null ? void 0 : _a.index) === ((_b = connections.targetNodes[idx]) == null ? void 0 : _b.index)) {
          return /* @__PURE__ */ react_exports.createElement(
            StyledTooltipRow,
            {
              key: tNode.index,
              rowColor: tooltipRowColor,
              "data-test": "target-row"
            },
            /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, /* @__PURE__ */ react_exports.createElement(
              ColorTile,
              {
                node: tNode,
                colorCategoryMapping
              }
            ), /* @__PURE__ */ react_exports.createElement(NodeValue, { "data-test": "target-row-name" }, tNode == null ? void 0 : tNode.name)),
            /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, { "data-test": "target-row-value" }, (0, numberUtils_exports.formatNumber)(tNode == null ? void 0 : tNode.value, 0, { useTrendUnits: true }))
          );
        }
        return null;
      })))
    );
  };
  const renderLinkToolTip = () => {
    var _a, _b, _c, _d;
    if (!link) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(Popover_default, { open, anchor, onRequestClose: () => handleTooltipRequestClose() }, /* @__PURE__ */ react_exports.createElement(StyledTooltipContainer, { className: "sankeyToolTip", "data-test": "sankey-tooltip" }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLinkHeader, { linkHeaderColor: tooltipLinkHeaderColor, "data-test": "main-row" }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, { "data-test": "main-row-name" }, "Link Size"), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, { "data-test": "main-row-value" }, (0, numberUtils_exports.formatNumber)(link == null ? void 0 : link.value, 0, { useTrendUnits: true }))), /* @__PURE__ */ react_exports.createElement(StyledTooltipHeader, { headerColor: tooltipHeaderColor }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, "Source"), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, null, linkValue)), /* @__PURE__ */ react_exports.createElement(StyledTooltipSection, null, /* @__PURE__ */ react_exports.createElement(StyledTooltipRow, { rowColor: tooltipRowColor, "data-test": "source-row" }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, /* @__PURE__ */ react_exports.createElement(ColorTile, { node: link == null ? void 0 : link.source, colorCategoryMapping }), /* @__PURE__ */ react_exports.createElement(NodeValue, { "data-test": "source-row-name" }, (_a = link == null ? void 0 : link.source) == null ? void 0 : _a.name)), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, { "data-test": "source-row-value" }, (0, numberUtils_exports.formatNumber)((_b = link == null ? void 0 : link.source) == null ? void 0 : _b.value, 0, { useTrendUnits: true }), " "))), /* @__PURE__ */ react_exports.createElement(StyledTooltipHeader, { headerColor: tooltipHeaderColor }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, "Target"), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, null, linkValue)), /* @__PURE__ */ react_exports.createElement(StyledTooltipSection, null, /* @__PURE__ */ react_exports.createElement(StyledTooltipRow, { rowColor: tooltipRowColor, "data-test": "target-row" }, /* @__PURE__ */ react_exports.createElement(StyledTooltipLeftCell, null, /* @__PURE__ */ react_exports.createElement(ColorTile, { node: link == null ? void 0 : link.target, colorCategoryMapping }), /* @__PURE__ */ react_exports.createElement(NodeValue, { "data-test": "target-row-name" }, (_c = link == null ? void 0 : link.target) == null ? void 0 : _c.name)), /* @__PURE__ */ react_exports.createElement(StyledTooltipRightCell, { "data-test": "target-row-value" }, (0, numberUtils_exports.formatNumber)((_d = link == null ? void 0 : link.target) == null ? void 0 : _d.value, 0, { useTrendUnits: true }))))));
  };
  return mode === "node" ? renderNodeToolTip() : renderLinkToolTip();
};
SankeyTooltip.propTypes = {
  mode: prop_types_exports.string,
  node: prop_types_exports.object,
  linkValue: prop_types_exports.string,
  open: prop_types_exports.bool,
  connectionsMap: prop_types_exports.object,
  anchor: prop_types_exports.object,
  colorCategoryMapping: prop_types_exports.oneOfType([prop_types_exports.func, prop_types_exports.arrayOf(prop_types_exports.string)]),
  tooltipRowColor: prop_types_exports.string,
  tooltipLinkHeaderColor: prop_types_exports.string,
  tooltipHeaderColor: prop_types_exports.string,
  width: prop_types_exports.number,
  height: prop_types_exports.number,
  handleTooltipRequestClose: prop_types_exports.func
};
SankeyTooltip.defaultProps = {
  handleTooltipRequestClose: () => {
  }
};
var SankeyTooltip_default = SankeyTooltip;

// src/Sankey/PureSankey/PureSankey.tsx
var DEFAULT_FONT_FAMILY = '"Splunk Platform Sans", "Proxima Nova", "Helvetica Neue", Helvetica, Arial, sans-serif';
var DEFAULT_NODE_COLOR = "#909090";
var DEFAULT_LINK_COLOR = "#909090";
var DEFAULT_SERIES_COLOR = visualization_color_palettes_exports.VIZ_CATEGORICAL;
var DEFAULT_LINK_OPACITY = 0.5;
var DEFAULT_NODE_OPACITY = 1;
var INACTIVE_OPACITY = 0.05;
var CHART_MIN_WIDTH = 300;
var CHART_MIN_HEIGHT = 200;
var DEFAULT_CHART_WIDTH = 600;
var DEFAULT_CHART_HEIGHT = 300;
var DEFAULT_SOURCE_INDEX = 0;
var DEFAULT_TARGET_INDEX = 1;
var DEFAULT_LINK_VALUE_INDEX = 2;
var SankeyContainer = styled_components_default.div`
    overflow: hidden;
    ${(props) => (0, style_exports.toDimension)((0, lodash_exports.pick)(props, ["width", "height"]))};
`;
var PureSankey = (props) => {
  const {
    width,
    height,
    columns,
    columnsFromDataSource,
    fields,
    colorMode,
    nodeWidth,
    nodePadding,
    resultLimit,
    seriesColors,
    linkColors,
    linkOpacity,
    linkValueField,
    backgroundColor,
    nodeTextColor,
    tooltipRowColor,
    tooltipLinkHeaderColor,
    tooltipHeaderColor,
    onNodeClick,
    onLinkClick
  } = props;
  const [containerWidth, setContainerWidth] = react_exports.useState(Number(props.width));
  const [containerHeight, setContainerHeight] = react_exports.useState(Number(props.height));
  const cachedHandleResize = react_exports.useCallback((w, h) => {
    setContainerWidth(w);
    setContainerHeight(h);
  }, []);
  const margin = {
    top: 17,
    right: 25,
    bottom: 17,
    left: 30
  };
  const translatePos = { x: 28, y: 17 };
  const [activeLinks, setActiveLinks] = (0, react_exports.useState)([]);
  const [activeNodes, setActiveNodes] = (0, react_exports.useState)([]);
  const [nodeHovered, setNodeHovered] = (0, react_exports.useState)(null);
  const [hoveredNodeElement, setHoveredNodeElement] = (0, react_exports.useState)(null);
  const [openNodeToolTip, setOpenNodeToolTip] = (0, react_exports.useState)(false);
  const [hoveredLinkElement, setHoveredLinkElement] = (0, react_exports.useState)(null);
  const [openLinkToolTip, setOpenLinkToolTip] = (0, react_exports.useState)(false);
  const sankeyContainerElement = (0, react_exports.useRef)(null);
  const [sankeyWidth, setSankeyWidth] = (0, react_exports.useState)(DEFAULT_CHART_WIDTH - margin.left - margin.right);
  const [sankeyHeight, setSankeyHeight] = (0, react_exports.useState)(DEFAULT_CHART_HEIGHT - margin.top - margin.bottom);
  const handleNodeClick = (0, react_exports.useCallback)((node) => {
    if (node) {
      onNodeClick({
        type: "node.click",
        payload: {
          nodeValue: node.value,
          nodeName: node.name
        }
      });
    }
  }, []);
  const handleLinkClick = (0, react_exports.useCallback)(
    (link) => {
      if (link) {
        const payload = { name: linkValueField, value: link.value };
        fields.forEach((field, idx) => {
          const rowToken = `row.${field}.value`;
          payload[rowToken] = columns[idx][link.index];
        });
        onLinkClick({
          type: "link.click",
          payload
        });
      }
    },
    [fields, columns, linkValueField]
  );
  (0, react_exports.useEffect)(() => {
    if (sankeyContainerElement && sankeyContainerElement.current) {
      const w = sankeyContainerElement.current.getBoundingClientRect().width;
      const h = sankeyContainerElement.current.getBoundingClientRect().height;
      const sWidth = checkDigitsOnly(width) ? parseInt(width, 10) : w;
      const sHeight = checkDigitsOnly(height) ? parseInt(height, 10) : h;
      setSankeyWidth(sWidth - margin.left - margin.right);
      setSankeyHeight(sHeight - margin.top - margin.bottom);
    }
  }, [width, height]);
  const sankeyData = convertInputToSankeyDataFormat(
    columnsFromDataSource,
    DEFAULT_SOURCE_INDEX,
    DEFAULT_TARGET_INDEX,
    DEFAULT_LINK_VALUE_INDEX,
    resultLimit
  );
  if (!sankeyData || !columnsFromDataSource || !Array.isArray(columnsFromDataSource) || columnsFromDataSource.length < 3) {
    return /* @__PURE__ */ react_exports.createElement(Message_default, { width, height, message: (0, i18n_exports._)("Invalid data to render"), level: "info" });
  }
  const sortAndAssignLinkIds = (links) => {
    links.sort((a, b) => a.dy - b.dy);
    links.forEach((link) => {
      link.id = `link-${link.source.index}-${link.target.index}`;
    });
  };
  const d3sankey = d3_sankey().nodeWidth(nodeWidth).nodePadding(nodePadding).size([sankeyWidth, sankeyHeight]);
  const path = d3sankey.reversibleLink();
  d3sankey.nodes(sankeyData.nodes).links(sankeyData.links).layout(500);
  sortAndAssignLinkIds(sankeyData.links);
  const nodeConnectionsMap = computeAllConnectedLinksToNodes(
    sankeyData.nodes,
    sankeyData.links
  );
  const uniqCategory = getAllNodeNames(sankeyData);
  const colorCategoryMapping = getColorCategoryMapping({
    category: uniqCategory,
    colorMode,
    seriesColors,
    linkColors
  });
  const resetStates = () => {
    setActiveLinks([]);
    setActiveNodes([]);
    setHoveredLinkElement(null);
    setHoveredNodeElement(null);
    setNodeHovered(null);
    setOpenLinkToolTip(false);
    setOpenNodeToolTip(false);
  };
  const renderVisualization = () => {
    if (containerWidth < CHART_MIN_WIDTH || containerHeight < CHART_MIN_HEIGHT) {
      return /* @__PURE__ */ react_exports.createElement(
        Message_default,
        {
          width: containerWidth,
          height: containerHeight,
          message: (0, i18n_exports._)("Too small to render content"),
          level: "info"
        }
      );
    }
    const renderLinks = (links) => {
      return links.map((link) => {
        return /* @__PURE__ */ react_exports.createElement(
          SankeyLink_default,
          {
            link,
            activeLinks,
            linkOpacity,
            path,
            key: getLinkId(link),
            "data-test": getLinkId(link),
            colorCategoryMapping,
            colorMode,
            handleMouseOver: (ev) => {
              setActiveLinks([link]);
              setActiveNodes([link.source, link.target]);
              setHoveredLinkElement(ev.currentTarget.querySelector("circle"));
              setOpenNodeToolTip(false);
              setOpenLinkToolTip(true);
            },
            handleMouseLeave: () => {
              resetStates();
            },
            handleLinkClick
          }
        );
      });
    };
    const renderNodes = (nodes) => {
      const chartWidth = typeof width === "number" ? width : Number.parseInt(width, 10);
      return nodes.map((node) => {
        return /* @__PURE__ */ react_exports.createElement(
          SankeyNode_default,
          {
            node,
            key: getNodeId(node),
            "data-test": getNodeId(node),
            activeNodes,
            nodeWidth,
            chartWidth,
            colorCategoryMapping,
            nodeTextColor,
            handleMouseOver: (ev) => {
              const connections = nodeConnectionsMap[node.index];
              setActiveLinks(connections.links);
              setNodeHovered(node);
              setActiveNodes([...connections.sourceNodes, ...connections.targetNodes]);
              setHoveredNodeElement(ev.currentTarget);
              setOpenLinkToolTip(false);
              setOpenNodeToolTip(true);
            },
            handleMouseLeave: () => resetStates(),
            handleNodeClick
          }
        );
      });
    };
    return /* @__PURE__ */ react_exports.createElement(
      VizStyleWrapper_default,
      {
        backgroundColor,
        dataTestKey: "SankeyWrapper",
        onMouseLeave: () => resetStates()
      },
      /* @__PURE__ */ react_exports.createElement("svg", { height: "100%", width: "100%", "data-test": "sankey-svg" }, /* @__PURE__ */ react_exports.createElement("g", { transform: `translate(${translatePos.x},${translatePos.y})` }, /* @__PURE__ */ react_exports.createElement("g", { className: "link-group", "data-test": "link-group" }, renderLinks(sankeyData.links), openLinkToolTip && /* @__PURE__ */ react_exports.createElement(
        SankeyTooltip_default,
        {
          mode: "link",
          open: openLinkToolTip,
          handleTooltipRequestClose: () => resetStates(),
          linkValue: linkValueField,
          connectionsMap: nodeConnectionsMap,
          anchor: hoveredLinkElement,
          link: activeLinks[0],
          height: sankeyHeight,
          width: sankeyWidth,
          colorCategoryMapping,
          tooltipRowColor,
          tooltipLinkHeaderColor,
          tooltipHeaderColor
        }
      )), /* @__PURE__ */ react_exports.createElement("g", { className: "node-group", "data-test": "node-group" }, renderNodes(sankeyData.nodes), openNodeToolTip && /* @__PURE__ */ react_exports.createElement(
        SankeyTooltip_default,
        {
          mode: "node",
          open: openNodeToolTip,
          handleTooltipRequestClose: () => resetStates(),
          linkValue: linkValueField,
          connectionsMap: nodeConnectionsMap,
          anchor: hoveredNodeElement,
          node: nodeHovered,
          height: sankeyHeight,
          width: sankeyWidth,
          colorCategoryMapping,
          tooltipRowColor,
          tooltipLinkHeaderColor,
          tooltipHeaderColor
        }
      ))))
    );
  };
  return /* @__PURE__ */ react_exports.createElement(SankeyContainer, { height, width, ref: sankeyContainerElement }, /* @__PURE__ */ react_exports.createElement(SizeAwareWrapper_default, { width, height, onResize: cachedHandleResize }), renderVisualization());
};
PureSankey.propTypes = {
  columns: prop_types_exports.array,
  columnsFromDataSource: prop_types_exports.array,
  fields: prop_types_exports.array,
  width: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  height: prop_types_exports.oneOfType([prop_types_exports.string, prop_types_exports.number]),
  // need this to satisfy props interface
  // eslint-disable-next-line react/no-unused-prop-types
  mode: prop_types_exports.string,
  colorMode: prop_types_exports.string,
  nodeWidth: prop_types_exports.number,
  nodePadding: prop_types_exports.number,
  resultLimit: prop_types_exports.number,
  seriesColors: prop_types_exports.arrayOf(prop_types_exports.string),
  linkColors: prop_types_exports.arrayOf(prop_types_exports.string),
  linkOpacity: prop_types_exports.number,
  linkValueField: prop_types_exports.string,
  backgroundColor: prop_types_exports.string,
  nodeTextColor: prop_types_exports.string,
  tooltipRowColor: prop_types_exports.string,
  tooltipLinkHeaderColor: prop_types_exports.string,
  tooltipHeaderColor: prop_types_exports.string
};
PureSankey.defaultProps = {
  columnsFromDataSource: [],
  columns: [],
  fields: [],
  width: DEFAULT_CHART_WIDTH,
  height: DEFAULT_CHART_HEIGHT,
  mode: "view",
  colorMode: "categorical",
  nodeWidth: 12,
  nodePadding: 18,
  resultLimit: 1e3,
  seriesColors: DEFAULT_SERIES_COLOR,
  linkColors: [],
  linkOpacity: DEFAULT_LINK_OPACITY,
  linkValueField: "value",
  backgroundColor: "#0b0c0e",
  nodeTextColor: "rgba(255, 255, 255, 0.98)",
  tooltipRowColor: "rgba(255, 255, 255, 0.98)",
  tooltipLinkHeaderColor: "rgba(255, 255, 255, 0.98)",
  tooltipHeaderColor: "rgba(255, 255, 255, 0.5)",
  onNodeClick: lodash_exports.noop,
  onLinkClick: lodash_exports.noop
};
var PureSankey_default = PureSankey;

// esm-externals:@splunk/visualization-icons
var visualization_icons_exports = {};
__export(visualization_icons_exports, {
  default: () => visualization_icons_default
});
var defaultImport32 = __toESM(require("@splunk/visualization-icons"));
__reExport(visualization_icons_exports, require("@splunk/visualization-icons"));
var visualization_icons_default = "default" in defaultImport32 ? defaultImport32.default : defaultImport32;

// esm-externals:@splunk/visualization-icons/placeholders
var placeholders_exports = {};
__export(placeholders_exports, {
  default: () => placeholders_default
});
var defaultImport33 = __toESM(require("@splunk/visualization-icons/placeholders"));
__reExport(placeholders_exports, require("@splunk/visualization-icons/placeholders"));
var placeholders_default = "default" in defaultImport33 ? defaultImport33.default : defaultImport33;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport34 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport34 ? defaultImport34.default : defaultImport34;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport35 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport35 ? defaultImport35.default : defaultImport35;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport36 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport36 ? defaultImport36.default : defaultImport36;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport37 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport37 ? defaultImport37.default : defaultImport37;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/DynamicLinkColorsEditor.js
var getDynamicLinkColorsEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Link"),
  option: "linkColors",
  context: "linkColorRangeConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.linkColors),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: link"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          linkValues: defaultContext2.linkColorRangeConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          linkValues: defaultContext2.linkColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Link"),
        value: "linkValues"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes3,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes3
    }
  }
];
var BackgroundColor_default = background;

// src/Sankey/config.ts
var defaultContext = {
  linkColorRangeConfig: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ],
  linkColorMatchConfig: [{ match: "", value: "#5C33FF" }]
};
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 600,
  initialHeight: 300
};
var themes = {
  defaultBackgroundColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.black(props),
      light: themes_exports.variables.backgroundColor(props)
    },
    prisma: themes_exports.variables.backgroundColorSidebar(props)
  })(props),
  nodeTextColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.textColor(props),
      light: themes_exports.variables.textColor(props)
    },
    prisma: themes_exports.variables.contentColorActive(props)
  })(props),
  tooltipRowColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.textColor(props),
      light: themes_exports.variables.textColor(props)
    },
    prisma: themes_exports.variables.contentColorActive(props)
  })(props),
  tooltipLinkHeaderColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.textColor(props),
      light: themes_exports.variables.textColor(props)
    },
    prisma: themes_exports.variables.contentColorActive(props)
  })(props),
  tooltipHeaderColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.textGray(props),
      light: themes_exports.variables.textGray(props)
    },
    prisma: themes_exports.variables.contentColorMuted(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data configurations"),
    layout: [
      [
        {
          label: "Link value",
          editor: "editor.columnSelector",
          option: "linkValues",
          context: "linkValuesContext",
          editorProps: {
            dataSourceKey: "primary",
            filterByTypes: ["number"]
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Color mode"),
          option: "colorMode",
          editor: "editor.radioBar",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Categorical"), value: "categorical" },
              { label: (0, i18n_exports._)("Dynamic"), value: "dynamic" }
            ]
          }
        }
      ],
      [
        __spreadProps(__spreadValues({}, getDynamicLinkColorsEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })), {
          showEditor: ({ options }) => options.colorMode === "dynamic"
        })
      ],
      BackgroundColor_default({ themes })
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.sankey",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Sankey"),
  category: "Flow" /* FLOW */,
  status: "preview",
  /**
   * viz icon
   */
  icon: visualization_icons_exports.Sankey,
  placeholderIcon: placeholders_exports.Sankey,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.sankeyOptionsSchema,
  editorConfig,
  events: {
    "node.click": {
      description: "Triggered when user clicks on a node"
    },
    "link.click": {
      description: "Triggered when user clicks on a link"
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "placeholder" /* PLACEHOLDER */],
  themes,
  requiredProps: []
};
var config_default = enhanceConfig(config);

// src/Sankey/Sankey.tsx
var showPlaceHolderIcon = (dataSources) => {
  var _a, _b;
  const columns = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns;
  const noColumns = !(Array.isArray(columns) && columns.length);
  const dataSourceState = (0, dataSourceUtils_exports.getDataSourceStateInfo)(dataSources == null ? void 0 : dataSources.primary);
  return dataSourceState.hasError || dataSourceState.isLoading || dataSourceState.isMissing || noColumns;
};
var computeVizProps = ({
  themeFunc,
  dataSources,
  linkValues,
  seriesColors,
  linkColors,
  onNodeClick,
  onLinkClick
}) => {
  var _a, _b, _c, _d, _e;
  const themeColorVariables = [
    "defaultBackgroundColor",
    "nodeTextColor",
    "tooltipRowColor",
    "tooltipLinkHeaderColor",
    "tooltipHeaderColor"
  ];
  const themeColors = {};
  themeColorVariables.forEach((variable) => {
    themeColors[variable] = themeFunc(variable);
  });
  linkColors = (0, colorUtils_exports.sanitizeArrayOfColors)(linkColors);
  seriesColors = (0, colorUtils_exports.isArrayOfColors)(seriesColors) ? seriesColors : void 0;
  const { columns, fields } = dataSources.primary.data;
  let columnsFromDataSource = [];
  let linkValueField = "";
  const fieldNames = [];
  if (((_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns) && ((_e = (_d = (_c = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns) == null ? void 0 : _e.length) >= 2 && Array.isArray(linkValues)) {
    columnsFromDataSource = columns ? [columns[0], columns[1], linkValues] : null;
    const linkIndex = columns.findIndex((col) => (0, lodash_exports.isEqual)(col, linkValues));
    if (fields) {
      fields.forEach((field, idx) => {
        let fieldName = "";
        if (typeof field === "object" && field !== null) {
          fieldName = field.name;
        } else {
          fieldName = field != null ? field : "";
        }
        if (idx === linkIndex) {
          linkValueField = fieldName;
        }
        fieldNames.push(fieldName);
      });
    }
  }
  return __spreadProps(__spreadValues({}, themeColors), {
    columns,
    fields: fieldNames,
    columnsFromDataSource,
    linkValueField,
    seriesColors,
    linkColors,
    onNodeClick,
    onLinkClick
  });
};
var Sankey = withDashboardViz_default({
  ReactViz: PureSankey_default,
  vizConfig: config_default,
  computeVizProps,
  useIconPlaceholder: (dataSources) => showPlaceHolderIcon(dataSources)
});
var { themes: themes2 } = config_default;
var Sankey_default = Sankey;
//# sourceMappingURL=Sankey.js.map
