/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/SingleValueBasic/index.ts
var SingleValueBasic_exports = {};
__export(SingleValueBasic_exports, {
  SingleValueTrendValue: () => SingleValueTrendValue,
  default: () => SingleValueBasic_default
});
module.exports = __toCommonJS(SingleValueBasic_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport3 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport4 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport5 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualizations-shared/domUtils
var domUtils_exports = {};
__export(domUtils_exports, {
  default: () => domUtils_default
});
var defaultImport6 = __toESM(require("@splunk/visualizations-shared/domUtils"));
__reExport(domUtils_exports, require("@splunk/visualizations-shared/domUtils"));
var domUtils_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualizations-shared/propUtils
var propUtils_exports = {};
__export(propUtils_exports, {
  default: () => propUtils_default
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/propUtils"));
__reExport(propUtils_exports, require("@splunk/visualizations-shared/propUtils"));
var propUtils_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport8 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/common/utils/singleValueUtils.js
var DEFAULT_FONT_FAMILY = '"Splunk Platform Sans", "Proxima Nova", "Helvetica Neue", Helvetica, Arial, sans-serif';
var getAligment = (align) => {
  const alignMap = {
    left: "start",
    center: "center",
    right: "end"
  };
  return alignMap[align] || "center";
};

// esm-externals:@splunk/react-icons/enterprise/ArrowUp
var ArrowUp_exports = {};
__export(ArrowUp_exports, {
  default: () => ArrowUp_default
});
var defaultImport9 = __toESM(require("@splunk/react-icons/enterprise/ArrowUp"));
__reExport(ArrowUp_exports, require("@splunk/react-icons/enterprise/ArrowUp"));
var ArrowUp_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/react-icons/enterprise/ArrowDown
var ArrowDown_exports = {};
__export(ArrowDown_exports, {
  default: () => ArrowDown_default
});
var defaultImport10 = __toESM(require("@splunk/react-icons/enterprise/ArrowDown"));
__reExport(ArrowDown_exports, require("@splunk/react-icons/enterprise/ArrowDown"));
var ArrowDown_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport11 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// src/SingleValueBasic/TrendValue.jsx
var Column = styled_components_default.div`
    display: flex;
    flex-direction: row;
    justify-content: ${(props) => props.justify || "flex-end"};
    height: ${(props) => props.size || 12}px;
    ${(props) => props.size ? `margin: 0 ${parseInt(props.size, 10) * 0.2 || 5}px;` : ""};
`;
var Text = styled_components_default.div`
    white-space: nowrap;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color || "#000"};
    font-family: ${DEFAULT_FONT_FAMILY};
    height: ${(props) => props.size || 12}px;
    line-height: ${(props) => props.size || 12}px;
    display: flex;
    align-self: baseline;
    ${(props) => props.size ? `margin-left: ${parseInt(props.size, 10) * 0.2 || 5}px;` : ""};
`;
var TrendValue = ({ fontSize, color, value, text }) => {
  let TrendIndicator = false;
  let ariaLabel = false;
  if (parseFloat(value, 10) > 0) {
    TrendIndicator = ArrowUp_default;
    ariaLabel = (0, i18n_exports._)("increase");
  } else if (parseFloat(value, 10) < 0) {
    TrendIndicator = ArrowDown_default;
    ariaLabel = (0, i18n_exports._)("decrease");
  }
  return /* @__PURE__ */ react_default.createElement(Column, { justify: "flex-end", size: fontSize }, /* @__PURE__ */ react_default.createElement(Text, { "data-test": "trendValueIndicator", size: fontSize, color }, TrendIndicator && /* @__PURE__ */ react_default.createElement(TrendIndicator, { "aria-label": ariaLabel })), /* @__PURE__ */ react_default.createElement(Text, { "data-test": "trendValue", size: fontSize, color }, `${text}`));
};
TrendValue.propTypes = {
  fontSize: prop_types_default.number,
  color: prop_types_default.string,
  value: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  text: prop_types_default.string
};
var TrendValue_default = TrendValue;

// esm-externals:cssesc
var cssesc_exports = {};
__export(cssesc_exports, {
  default: () => cssesc_default
});
var defaultImport12 = __toESM(require("cssesc"));
__reExport(cssesc_exports, require("cssesc"));
var cssesc_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// src/SingleValueBasic/MajorValue.jsx
var Row = styled_components_default.div`
    display: flex;
    flex-direction: row;
    align-items: flex-end;
    justify-content: left;
    height: ${(props) => props.size}px;
    line-height: ${(props) => props.size}px;
`;
var Text2 = styled_components_default.div`
    white-space: nowrap;
    height: 100%;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color};
    font-family: ${DEFAULT_FONT_FAMILY};
    font-weight: bold;
    &:hover {
        text-decoration: ${(props) => props.showUnderline ? "underline" : "inherit"};
        cursor: ${(props) => props.showUnderline ? "pointer" : "inherit"};
    }
    ${(props) => {
  if (!props.pseudoContent || !props.pseudoContentPosition) {
    return "";
  }
  return `&:${props.pseudoContentPosition} {
            // by default this pseudo element would inherit text-decoration from main element
            // and text-decoration could not be overwritten.
            // adding display: inline-block makes text decoration independent from main element.
            // => the unit will not be underlined if a user hovers over the main value
            display: inline-block;
            font-size: ${props.pseudoContentFontSize}px;
            position: relative;
            font-weight: normal;
            content: ${props.pseudoContent};
        }`;
}}
`;
var validUnitPositions = ["before", "after"];
var MajorValue = ({ color, fontSize, unitPosition, title, value, onValueClick, unit }) => {
  let sanitizedUnit;
  let sanitizedUnitPosition;
  if (typeof unit === "string") {
    sanitizedUnit = cssesc_default(unit, { wrap: true, quotes: "double" });
    if (typeof unitPosition === "string" && validUnitPositions.includes(unitPosition)) {
      sanitizedUnitPosition = unitPosition;
    } else {
      sanitizedUnitPosition = "after";
    }
  }
  const handleKeyDown = (e) => {
    if (e.keyCode !== 13) {
      return;
    }
    e.preventDefault();
    onValueClick(e);
  };
  return /* @__PURE__ */ react_default.createElement(Row, { size: fontSize }, /* @__PURE__ */ react_default.createElement(
    Text2,
    {
      "data-test": "majorValue",
      color,
      onClick: (e) => typeof onValueClick === "function" && onValueClick(e),
      showUnderline: !!onValueClick,
      size: fontSize,
      title,
      pseudoContent: sanitizedUnit,
      pseudoContentPosition: sanitizedUnitPosition,
      pseudoContentFontSize: fontSize * 0.6,
      tabIndex: "0",
      role: "button",
      onKeyDown: handleKeyDown
    },
    value
  ));
};
MajorValue.propTypes = {
  color: prop_types_default.string,
  fontSize: prop_types_default.number,
  unit: prop_types_default.string,
  unitPosition: prop_types_default.oneOf(validUnitPositions),
  value: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  title: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  onValueClick: prop_types_default.oneOfType([prop_types_default.bool, prop_types_default.func])
};
var MajorValue_default = MajorValue;

// src/SingleValueBasic/SingleValueBasic.jsx
var Column2 = styled_components_default.div`
    display: flex;
    flex-direction: column;
    align-self: center;
    justify-content: center;
`;
var Row2 = styled_components_default.div`
    display: flex;
    flex-direction: row;
    align-items: ${(props) => props.alignItems || "center"};
    justify-content: ${(props) => getAligment(props.align)};
`;
var Text3 = styled_components_default.div`
    font-weight: normal;
    white-space: nowrap;
    font-size: ${(props) => props.size || 12}px;
    color: ${(props) => props.color || "#000"};
    font-family: ${DEFAULT_FONT_FAMILY};
    height: ${(props) => props.size || 12}px;
    line-height: 1.2;
    margin: ${(props) => props.margin || "inherit"};
`;
var SingleValueBasic = (_a) => {
  var props = __objRest(_a, []);
  const {
    majorColor,
    majorTextFontSize,
    majorText,
    majorValueTitle,
    trendColor,
    trendTextFontSize,
    trendText,
    showTrendIndicator,
    unit,
    unitPosition,
    underLabel,
    underLabelFontSize,
    underLabelColor,
    onValueClick,
    align
  } = props;
  const trendIndicatorEnabled = trendText !== "" && showTrendIndicator;
  return /* @__PURE__ */ react_default.createElement(Column2, null, /* @__PURE__ */ react_default.createElement(
    Row2,
    {
      alignItems: "baseline",
      align,
      "data-test": `single-value-row-align-${getAligment(align)}`
    },
    /* @__PURE__ */ react_default.createElement(
      MajorValue_default,
      {
        color: majorColor,
        fontSize: majorTextFontSize,
        unit,
        unitPosition,
        value: majorText,
        title: majorValueTitle,
        onValueClick
      }
    ),
    trendIndicatorEnabled && // Passing the same value for value and text is a temporary hold until completion of https://jira.splunk.com/browse/SCP-21371
    /* @__PURE__ */ react_default.createElement(
      TrendValue_default,
      {
        fontSize: trendTextFontSize,
        color: trendColor,
        value: trendText,
        text: trendText
      }
    )
  ), underLabel && /* @__PURE__ */ react_default.createElement(
    Row2,
    {
      justify: "center",
      align,
      "data-test": `single-value-row-align-${getAligment(align)}`
    },
    /* @__PURE__ */ react_default.createElement(
      Text3,
      {
        "data-test": "underLabel",
        size: underLabelFontSize,
        color: underLabelColor,
        margin: "0 6px"
      },
      underLabel
    )
  ));
};
SingleValueBasic.propTypes = {
  majorText: prop_types_default.string,
  majorColor: prop_types_default.string,
  majorTextFontSize: prop_types_default.number,
  majorValueTitle: prop_types_default.string,
  trendText: prop_types_default.string,
  trendTextFontSize: prop_types_default.number,
  trendColor: prop_types_default.string,
  showTrendIndicator: prop_types_default.bool,
  unit: prop_types_default.string,
  unitPosition: prop_types_default.oneOf(["before", "after"]),
  underLabel: prop_types_default.string,
  underLabelFontSize: prop_types_default.number,
  underLabelColor: prop_types_default.string,
  onValueClick: prop_types_default.oneOfType([prop_types_default.bool, prop_types_default.func]),
  align: prop_types_default.string
};
var SingleValueTrendValue = TrendValue_default;
var SingleValueBasic_default = SingleValueBasic;
//# sourceMappingURL=SingleValueBasic.js.map
