/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/SingleValueIcon/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport4 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport5 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport6 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// src/common/configContext/singleValueContext.ts
var defaultContext = {
  trendColorConfig: [
    {
      to: 0,
      value: "#9E2520"
    },
    {
      from: 0,
      value: "#1C6B2D"
    }
  ],
  majorColorConfig: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ],
  majorColorMatchConfig: [{ match: "", value: "#5C33FF" }],
  trendValueCopy: "> trendValue",
  divisor: "> majorValue | subtract(trendValueCopy) | divideBy(100)",
  trendValuePercent: "> trendValue | divideBy(divisor)"
};

// src/common/editorConfig/StaticMajorAndTrendLayout.js
var StaticMajorAndTrendLayout = [
  [
    {
      label: (0, i18n_exports._)("Unit position"),
      // todo: we need a new editor combining unit and position
      option: "unitPosition",
      editor: "editor.select",
      editorProps: {
        values: [
          { label: (0, i18n_exports._)("Before"), value: "before" },
          { label: (0, i18n_exports._)("After"), value: "after" }
        ]
      },
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    },
    {
      label: (0, i18n_exports._)("Unit label"),
      option: "unit",
      editor: "editor.text",
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Precision"),
      option: "numberPrecision",
      editor: "editor.number",
      editorProps: {
        min: 0,
        max: 20
      },
      showEditor: ({ options }) => options.showValue || options.showValue === void 0
    }
  ]
];
var StaticMajorAndTrendLayout_default = StaticMajorAndTrendLayout;

// src/common/editorConfig/StaticBackgroundColorEditor.js
var StaticBackgroundColorEditor = {
  label: (0, i18n_exports._)("Background color"),
  option: "backgroundColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.backgroundColor)
};
var StaticBackgroundColorEditor_default = StaticBackgroundColorEditor;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/common/editorConfig/StaticIconColorEditor.js
var StaticIconColorEditor = [
  {
    label: (0, i18n_exports._)("Icon"),
    option: "iconColor",
    editor: "editor.color",
    showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.iconColor),
    editorProps: {
      labelPosition: "top",
      value: null,
      palette: [null, ...colorConstants_exports.COLOR_EDITOR_PALETTE]
    }
  }
];
var StaticIconColorEditor_default = StaticIconColorEditor;

// src/common/editorConfig/StaticMajorColorEditor.js
var StaticMajorColorEditor = {
  label: (0, i18n_exports._)("Major value"),
  option: "majorColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.majorColor)
};
var StaticMajorColorEditor_default = StaticMajorColorEditor;

// src/common/editorConfig/StaticTrendColorEditor.js
var StaticTrendColorEditor = {
  label: (0, i18n_exports._)("Trend value"),
  option: "trendColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.trendColor),
  isDisabled: ({ options }) => options.trendDisplay === "off"
};
var StaticTrendColorEditor_default = StaticTrendColorEditor;

// src/common/editorConfig/DynamicMajorColorEditor.js
var getDynamicMajorColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Major value"),
  option: "majorColor",
  context: "majorColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.majorColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: major value"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          majorValue: defaultContext2.majorColorConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          majorValue: defaultContext2.majorColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Major value"),
        value: "majorValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/DynamicTrendColorEditor.js
var getDynamicTrendColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Trend value"),
  option: "trendColor",
  context: "trendColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.trendColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: trend value"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          trendValue: defaultContext2.trendColorConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Trend value"),
        value: "trendValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/DynamicBackgroundColorEditor.js
var getDynamicBackgroundColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Background color"),
  option: "backgroundColor",
  context: "backgroundColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.backgroundColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: background"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          majorValue: defaultContext2.majorColorConfig,
          trendValue: defaultContext2.trendColorConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          majorValue: defaultContext2.majorColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Major Value"),
        value: "majorValue"
      },
      {
        label: (0, i18n_exports._)("Trend"),
        value: "trendValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/TrellisEditors.ts
var isTrellisFeatureFlagOn = ({ featureFlags }) => {
  return Boolean(featureFlags == null ? void 0 : featureFlags.visualizations_enableTrellis);
};
var isTrellisEnabled = ({ options, featureFlags }) => {
  const { splitByLayout = visualization_schemas_exports.LAYOUT_TYPE.Off } = options;
  return isTrellisFeatureFlagOn({ featureFlags }) && splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis;
};
var TrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Split by"),
      option: "trellisSplitBy",
      editor: "editor.trellisSplitBy",
      editorProps: {
        dataSourceKey: "primary"
      },
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Number of columns"),
      option: "trellisColumns",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      placeholder: (0, i18n_exports._)("Auto"),
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Min column width"),
      option: "trellisMinColumnWidth",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    },
    {
      label: (0, i18n_exports._)("Row height"),
      option: "trellisRowHeight",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    }
  ],
  [
    {
      label: (0, i18n_exports._)("Max number of components per page"),
      option: "trellisPageCount",
      editor: "editor.number",
      editorProps: {
        min: 1
      },
      showEditor: isTrellisEnabled
    }
  ]
];
var TimechartTrellisEditorConfig = [
  [
    {
      label: (0, i18n_exports._)("Trellis layout"),
      option: "splitByLayout",
      editor: "editor.toggle",
      showEditor: isTrellisFeatureFlagOn,
      // add help text for timecharts
      editorProps: {
        help: (0, i18n_exports._)(
          "Y2-axis and overlay field configurations are not supported when trellis is enabled."
        ),
        helpFormat: "under"
      }
    }
  ],
  ...TrellisEditorConfig.slice(1),
  [
    {
      label: (0, i18n_exports._)("Shared y-axis scale"),
      option: "trellisSharedScale",
      editor: "editor.checkbox",
      showEditor: isTrellisEnabled
    }
  ]
];
var TrellisBackgroundColorEditor = {
  label: (0, i18n_exports._)("Trellis background"),
  option: "trellisBackgroundColor",
  editor: "editor.color",
  showEditor: isTrellisEnabled
};

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport8 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}
function hasCompatibleContexts(vizContext, presetContext) {
  const presetContextKeys = Object.keys(presetContext);
  return presetContextKeys.every(
    (contextKey) => presetContext[contextKey] === void 0 && vizContext[contextKey] === void 0 || presetContext[contextKey] !== void 0 && vizContext[contextKey] !== void 0
  );
}
function hasCompatibleOptions(vizOptions, presetOptions) {
  const presetOptionKeys = Object.keys(presetOptions);
  return presetOptionKeys.every(
    (optionKey) => (0, configUtils_exports.isDynamicOption)(presetOptions[optionKey]) === (0, configUtils_exports.isDynamicOption)(vizOptions[optionKey])
  );
}
function getInitialPreset(vizContext, vizOptions, presets2) {
  return presets2.find((preset) => {
    const presetContext = (0, lodash_exports.get)(preset, ["value", "context"], {});
    const presetOptions = (0, lodash_exports.get)(preset, ["value", "options"], {});
    const presetContextKeys = Object.keys(presetContext);
    const presetOptionKeys = Object.keys(presetOptions);
    if (presetContextKeys.length === 0 || presetOptionKeys.length === 0) return false;
    return hasCompatibleContexts(vizContext, presetContext) && hasCompatibleOptions(vizOptions, presetOptions);
  });
}

// src/SingleValueIcon/config.ts
var dataContract = {
  requiredDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  optionalDataSources: [],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 250,
  initialHeight: 250
};
var basePresetContext = {
  iconColorEditorConfig: void 0,
  majorColorEditorConfig: void 0,
  trendColorEditorConfig: void 0,
  backgroundColorEditorConfig: void 0
};
var basePresetOptions = {
  iconColor: void 0,
  majorColor: void 0,
  trendColor: void 0,
  backgroundColor: void 0
};
var presets = [
  {
    // dummy context variables to allow for resetting of unused context states
    label: (0, i18n_exports._)("None"),
    name: "singleValueIcon.none",
    value: {
      context: __spreadValues({}, basePresetContext),
      options: __spreadValues({}, basePresetOptions)
    }
  },
  {
    label: (0, i18n_exports._)("Icon"),
    name: "singleValueIcon.icon",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        iconColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        iconColor: "> majorValue | rangeValue(iconColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Major value"),
    name: "singleValueIcon.majorValue",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        majorColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        majorColor: "> majorValue | rangeValue(majorColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Trend value"),
    name: "singleValueIcon.trend",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        trendColorEditorConfig: defaultContext.trendColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        trendColor: "> trendValue | rangeValue(trendColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Icon and Major value"),
    name: "singleValueIcon.iconAndMajorValue",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        iconColorEditorConfig: defaultContext.majorColorConfig,
        majorColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        iconColor: "> majorValue | rangeValue(iconColorEditorConfig)",
        majorColor: "> majorValue | rangeValue(majorColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Background"),
    name: "singleValueIcon.background",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        backgroundColorEditorConfig: defaultContext.majorColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        backgroundColor: "> majorValue | rangeValue(backgroundColorEditorConfig)"
      })
    }
  }
];
var themes = {
  defaultFontColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.textColor(props),
      light: variables_default.gray20(props)
    },
    prisma: variables_default.contentColorActive(props)
  })(props),
  defaultBlockFontColor: (props) => pick_default({
    enterprise: variables_default.white(props),
    prisma: variables_default.contentColorActive(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Data configurations"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Value"),
          editor: "editor.columnSelector",
          option: "majorValue",
          context: "valuesContext",
          editorProps: {
            dataSourceKey: "primary",
            prepareValue: (definition) => {
              const {
                options: { majorValue: baseSPL }
              } = definition;
              return {
                context: {},
                options: {
                  majorValue: `${baseSPL} | lastPoint()`,
                  trendValue: `${baseSPL} | delta(-2)`
                }
              };
            }
          },
          isDisabled: ({ options }) => options.splitByLayout === visualization_schemas_exports.LAYOUT_TYPE.Trellis
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Data display"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Show major and trend value"),
          option: "showValue",
          editor: "editor.toggle"
        }
      ],
      ...StaticMajorAndTrendLayout_default,
      [
        {
          label: (0, i18n_exports._)("Trend display"),
          option: "trendDisplay",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Percent"), value: "percent" },
              { label: (0, i18n_exports._)("Absolute"), value: "absolute" },
              { label: (0, i18n_exports._)("Off"), value: "off" }
            ]
          },
          showEditor: ({ options }) => options.showValue || options.showValue === void 0
        }
      ],
      ...TrellisEditorConfig
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Dynamic elements"),
          key: "presetSelector",
          editor: "editor.presetSelector",
          editorProps: {
            presets,
            value: ({ context, options }) => {
              const initialPreset = getInitialPreset(context, options, presets);
              return initialPreset && initialPreset.label || null;
            }
          }
        }
      ],
      StaticIconColorEditor_default,
      [
        {
          label: (0, i18n_exports._)("Icon"),
          option: "iconColor",
          context: "iconColorEditorConfig",
          editor: "editor.dynamicColor",
          showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.iconColor),
          editorProps: {
            labelPosition: "top",
            flyoutTitle: "Dynamic coloring: icon",
            formatters: [
              {
                label: (0, i18n_exports._)("Ranges"),
                value: "rangeValue",
                defaults: {
                  trendValue: defaultContext.trendColorConfig,
                  majorValue: defaultContext.majorColorConfig
                }
              },
              {
                label: (0, i18n_exports._)("Matches"),
                value: "matchValue",
                defaults: {
                  majorValue: defaultContext.majorColorMatchConfig
                }
              }
            ],
            dataSelectors: [
              {
                label: (0, i18n_exports._)("Major value"),
                value: "majorValue"
              },
              {
                label: (0, i18n_exports._)("Trend"),
                value: "trendValue"
              }
            ],
            defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig
          }
        }
      ],
      [
        __spreadProps(__spreadValues({}, StaticMajorColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicMajorColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        __spreadProps(__spreadValues({}, StaticTrendColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicTrendColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        __spreadProps(__spreadValues({}, StaticBackgroundColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [
        __spreadProps(__spreadValues({}, TrellisBackgroundColorEditor), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicBackgroundColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        {
          label: (0, i18n_exports._)("Major value size (px)"),
          option: "majorFontSize",
          editor: "editor.number",
          editorProps: {
            min: 1
          },
          placeholder: (0, i18n_exports._)("Auto"),
          showEditor: ({ options }) => options.showValue || options.showValue === void 0
        },
        {
          label: (0, i18n_exports._)("Trend value size (px)"),
          option: "trendFontSize",
          editor: "editor.number",
          editorProps: {
            min: 1
          },
          placeholder: (0, i18n_exports._)("Auto"),
          showEditor: ({ options }) => options.showValue || options.showValue === void 0,
          isDisabled: ({ options }) => options.trendDisplay === "off"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Major value abbreviation"),
          option: "shouldAbbreviateMajorValue",
          editor: "editor.checkbox"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Trend value abbreviation"),
          option: "shouldAbbreviateTrendValue",
          editor: "editor.checkbox"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Alignment"),
          editor: "editor.radioBar",
          option: "align",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Left"), value: "left" },
              { label: (0, i18n_exports._)("Center"), value: "center" },
              { label: (0, i18n_exports._)("Right"), value: "right" }
            ]
          },
          showEditor: ({ options }) => options.showValue || options.showValue === void 0
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.singlevalueicon",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Single value icon"),
  category: "Single Value" /* SINGLE_VALUE */,
  /**
   * viz icon
   */
  icon: null,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.singleValueIconOptionsSchema,
  editorConfig,
  events: {
    "value.click": {
      description: "trigger when user clicks major value or icon",
      payloadKeys: ["majorValue", "trendValue", "icon"]
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */, "trellis" /* TRELLIS */],
  themes
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=SingleValueIcon.config.js.map
