/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/ChartingApi.ts
var ChartingApi_exports = {};
__export(ChartingApi_exports, {
  ChartingApiFunctional: () => ChartingApiFunctional
});
module.exports = __toCommonJS(ChartingApi_exports);
var ChartingApiFunctional = class {
  // eslint-disable-next-line no-useless-constructor
  constructor(chartRef) {
    this.chartRef = chartRef;
  }
  /**
   * Allows users to programmatically highlight a point on the chart
   *
   * @memberof ChartingApiFunctional
   */
  highlight({ xValue, seriesName } = { xValue: "", seriesName: "" }) {
    this.getChart().highlight(xValue, seriesName);
  }
  /**
   * Allows users to programmatically unhighlight all points on the chart
   *
   * @memberof ChartingApiFunctional
   */
  unHighlight() {
    this.getChart().unHighlight();
  }
  // returns chart object
  getChart() {
    var _a;
    return (_a = this.chartRef) == null ? void 0 : _a.current;
  }
};
//# sourceMappingURL=ChartingApi.js.map
