/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/OverviewDoc.tsx
var OverviewDoc_exports = {};
__export(OverviewDoc_exports, {
  default: () => OverviewDoc_default
});
module.exports = __toCommonJS(OverviewDoc_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport3 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/react-ui/Paragraph
var Paragraph_exports = {};
__export(Paragraph_exports, {
  default: () => Paragraph_default
});
var defaultImport4 = __toESM(require("@splunk/react-ui/Paragraph"));
__reExport(Paragraph_exports, require("@splunk/react-ui/Paragraph"));
var Paragraph_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/react-ui/Heading
var Heading_exports = {};
__export(Heading_exports, {
  default: () => Heading_default
});
var defaultImport5 = __toESM(require("@splunk/react-ui/Heading"));
__reExport(Heading_exports, require("@splunk/react-ui/Heading"));
var Heading_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/react-ui/List
var List_exports = {};
__export(List_exports, {
  default: () => List_default
});
var defaultImport6 = __toESM(require("@splunk/react-ui/List"));
__reExport(List_exports, require("@splunk/react-ui/List"));
var List_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/react-ui/Chip
var Chip_exports = {};
__export(Chip_exports, {
  default: () => Chip_default
});
var defaultImport7 = __toESM(require("@splunk/react-ui/Chip"));
__reExport(Chip_exports, require("@splunk/react-ui/Chip"));
var Chip_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/react-icons/enterprise/ChartLine
var ChartLine_exports = {};
__export(ChartLine_exports, {
  default: () => ChartLine_default
});
var defaultImport8 = __toESM(require("@splunk/react-icons/enterprise/ChartLine"));
__reExport(ChartLine_exports, require("@splunk/react-icons/enterprise/ChartLine"));
var ChartLine_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/react-icons/enterprise/ChartBar
var ChartBar_exports = {};
__export(ChartBar_exports, {
  default: () => ChartBar_default
});
var defaultImport9 = __toESM(require("@splunk/react-icons/enterprise/ChartBar"));
__reExport(ChartBar_exports, require("@splunk/react-icons/enterprise/ChartBar"));
var ChartBar_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/react-icons/enterprise/ChartScatter
var ChartScatter_exports = {};
__export(ChartScatter_exports, {
  default: () => ChartScatter_default
});
var defaultImport10 = __toESM(require("@splunk/react-icons/enterprise/ChartScatter"));
__reExport(ChartScatter_exports, require("@splunk/react-icons/enterprise/ChartScatter"));
var ChartScatter_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/react-icons/enterprise/ChoroplethMap
var ChoroplethMap_exports = {};
__export(ChoroplethMap_exports, {
  default: () => ChoroplethMap_default
});
var defaultImport11 = __toESM(require("@splunk/react-icons/enterprise/ChoroplethMap"));
__reExport(ChoroplethMap_exports, require("@splunk/react-icons/enterprise/ChoroplethMap"));
var ChoroplethMap_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:@splunk/react-icons/enterprise/SplitBy
var SplitBy_exports = {};
__export(SplitBy_exports, {
  default: () => SplitBy_default
});
var defaultImport12 = __toESM(require("@splunk/react-icons/enterprise/SplitBy"));
__reExport(SplitBy_exports, require("@splunk/react-icons/enterprise/SplitBy"));
var SplitBy_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:@splunk/react-docs/DocExample
var DocExample_exports = {};
__export(DocExample_exports, {
  default: () => DocExample_default
});
var defaultImport13 = __toESM(require("@splunk/react-docs/DocExample"));
__reExport(DocExample_exports, require("@splunk/react-docs/DocExample"));
var DocExample_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/react-ui/Button
var Button_exports = {};
__export(Button_exports, {
  default: () => Button_default
});
var defaultImport14 = __toESM(require("@splunk/react-ui/Button"));
__reExport(Button_exports, require("@splunk/react-ui/Button"));
var Button_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:@splunk/react-ui/Code
var Code_exports = {};
__export(Code_exports, {
  default: () => Code_default
});
var defaultImport15 = __toESM(require("@splunk/react-ui/Code"));
__reExport(Code_exports, require("@splunk/react-ui/Code"));
var Code_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// esm-externals:@splunk/react-ui/TransitionOpen
var TransitionOpen_exports = {};
__export(TransitionOpen_exports, {
  default: () => TransitionOpen_default
});
var defaultImport16 = __toESM(require("@splunk/react-ui/TransitionOpen"));
__reExport(TransitionOpen_exports, require("@splunk/react-ui/TransitionOpen"));
var TransitionOpen_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/react-icons/SquaresLayered
var SquaresLayered_exports = {};
__export(SquaresLayered_exports, {
  default: () => SquaresLayered_default
});
var defaultImport17 = __toESM(require("@splunk/react-icons/SquaresLayered"));
__reExport(SquaresLayered_exports, require("@splunk/react-icons/SquaresLayered"));
var SquaresLayered_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/react-icons/Checkmark
var Checkmark_exports = {};
__export(Checkmark_exports, {
  default: () => Checkmark_default
});
var defaultImport18 = __toESM(require("@splunk/react-icons/Checkmark"));
__reExport(Checkmark_exports, require("@splunk/react-icons/Checkmark"));
var Checkmark_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/react-icons/EyeSlashed
var EyeSlashed_exports = {};
__export(EyeSlashed_exports, {
  default: () => EyeSlashed_default
});
var defaultImport19 = __toESM(require("@splunk/react-icons/EyeSlashed"));
__reExport(EyeSlashed_exports, require("@splunk/react-icons/EyeSlashed"));
var EyeSlashed_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// esm-externals:@splunk/react-icons/WindowChevronsSlash
var WindowChevronsSlash_exports = {};
__export(WindowChevronsSlash_exports, {
  default: () => WindowChevronsSlash_default
});
var defaultImport20 = __toESM(require("@splunk/react-icons/WindowChevronsSlash"));
__reExport(WindowChevronsSlash_exports, require("@splunk/react-icons/WindowChevronsSlash"));
var WindowChevronsSlash_default = "default" in defaultImport20 ? defaultImport20.default : defaultImport20;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport21 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport21 ? defaultImport21.default : defaultImport21;

// esm-externals:@splunk/react-docs/UtilPage
var UtilPage_exports = {};
__export(UtilPage_exports, {
  default: () => UtilPage_default
});
var defaultImport22 = __toESM(require("@splunk/react-docs/UtilPage"));
__reExport(UtilPage_exports, require("@splunk/react-docs/UtilPage"));
var UtilPage_default = "default" in defaultImport22 ? defaultImport22.default : defaultImport22;

// src/common/docUtils.tsx
var formatCodeStringToObject = (codeString, regexMatch) => {
  const match = regexMatch.exec(codeString);
  if (!match) return null;
  const stringToParse = `{${match[1]}}`;
  const removedCommas = stringToParse.replace(/,(?!\s*?[-{["'\w])/g, "");
  const backQuotes = removedCommas.replace(/"/g, "`");
  const doubleQuotes = backQuotes.replace(/'/g, '"');
  const singleQuotes = doubleQuotes.replace(/`/g, "'");
  const quotesAroundKeys = singleQuotes.replace(/\b(\w+)\s*:(?=\s)/g, '"$1":');
  let retval = null;
  try {
    retval = JSON.parse(quotesAroundKeys);
  } catch (e) {
    console.error(e);
  }
  return retval;
};
var extractDataFromReactCode = (codeString) => {
  var _a;
  const primaryRegex = /dataSources={{([\s\S]*?primary:[\s\S]*?)}}/;
  const { primary } = (_a = formatCodeStringToObject(codeString, primaryRegex)) != null ? _a : {};
  const optionsRegex = /options={{([\s\S]*?)}}/;
  const options = formatCodeStringToObject(codeString, optionsRegex);
  const contextRegex = /context={{([\s\S]*?)}}/;
  const context = formatCodeStringToObject(codeString, contextRegex);
  return { primary, options, context };
};
var convertToDashboardJSON = (codeString, type) => {
  const { options, primary, context } = extractDataFromReactCode(codeString);
  return __spreadProps(__spreadValues({
    visualizations: {
      test_viz: __spreadValues(__spreadValues(__spreadValues({
        type
      }, options ? { options } : {}), primary ? { dataSources: { primary: "primary" } } : {}), context ? { context } : {})
    }
  }, primary ? { dataSources: { primary: { type: "ds.test", options: primary } } } : {}), {
    defaults: {
      dataSources: {
        global: {
          options: {
            queryParameters: {
              latest: "$global_time.latest$",
              earliest: "$global_time.earliest$"
            }
          }
        }
      }
    },
    inputs: {
      input_global_trp: {
        type: "input.timerange",
        options: {
          token: "global_time",
          defaultValue: "-24h@h,now"
        },
        title: "Global Time Range"
      }
    },
    layout: {
      type: "absolute",
      options: {},
      structure: [
        {
          item: "test_viz",
          type: "block",
          position: {
            x: 0,
            y: 0,
            w: 800,
            h: 500
          }
        }
      ],
      globalInputs: ["input_global_trp"]
    }
  });
};

// src/common/DocExampleWithVizSandbox.tsx
var DocExampleWithVizSandbox = (props) => {
  const { type, title, code, example, hideSandbox = false, description } = props;
  const [isCopied, setIsCopied] = react_exports.useState(false);
  const [showCode, setShowCode] = react_exports.useState(false);
  const isMounted = react_exports.useRef(true);
  const toggleShowCode = react_exports.useCallback(() => {
    setShowCode((state) => !state);
  }, []);
  react_exports.useEffect(() => {
    return () => {
      isMounted.current = false;
      setIsCopied(false);
    };
  }, []);
  if (hideSandbox) return /* @__PURE__ */ react_exports.createElement(DocExample_default, { title, code, example });
  const objDefn = convertToDashboardJSON(code, type);
  const prettyJson = JSON.stringify(objDefn, null, 4);
  const copyToClipBoard = () => {
    if ("clipboard" in navigator) {
      navigator.clipboard.writeText(prettyJson);
      setIsCopied(true);
    }
    setTimeout(() => {
      if (isMounted.current) {
        setIsCopied(false);
      }
    }, 5e3);
  };
  const renderAdditionalActions = () => [
    /* @__PURE__ */ react_exports.createElement(
      Button_default,
      {
        key: "show-dashboard-definition",
        appearance: "toggle",
        onClick: toggleShowCode,
        icon: showCode ? /* @__PURE__ */ react_exports.createElement(EyeSlashed_default, null) : /* @__PURE__ */ react_exports.createElement(WindowChevronsSlash_default, null),
        label: showCode ? (0, i18n_exports._)("Hide dashboard definition") : (0, i18n_exports._)("Show dashboard definition")
      }
    )
  ];
  return /* @__PURE__ */ react_exports.createElement(
    DocExample_default,
    {
      renderAdditionalActions,
      title,
      code,
      example,
      description
    },
    /* @__PURE__ */ react_exports.createElement(
      TransitionOpen_default,
      {
        animation: "slideFromTop",
        open: showCode,
        retainFocus: false,
        takeFocus: false,
        renderChildrenWhenCollapsed: false,
        animateOnMount: false
      },
      /* @__PURE__ */ react_exports.createElement("div", { style: { display: "flex", justifyContent: "space-between" } }, /* @__PURE__ */ react_exports.createElement(Code_default, { value: prettyJson, language: "json" }), /* @__PURE__ */ react_exports.createElement(
        Button_default,
        {
          onClick: copyToClipBoard,
          icon: isCopied ? /* @__PURE__ */ react_exports.createElement(Checkmark_default, null) : /* @__PURE__ */ react_exports.createElement(SquaresLayered_default, null),
          label: isCopied ? (0, i18n_exports._)("Copied") : (0, i18n_exports._)("Copy to clipboard"),
          style: { height: "30px", maxWidth: "164px" }
        }
      ))
    )
  );
};
DocExampleWithVizSandbox.propTypes = {
  type: prop_types_exports.string,
  title: prop_types_exports.string,
  code: prop_types_exports.string,
  example: prop_types_exports.func,
  hideSandbox: prop_types_exports.bool
};
var DocExampleWithVizSandbox_default = DocExampleWithVizSandbox;

// src/common/OverviewDoc.tsx
var chipIconStyles = {
  color: "white"
};
var chipType = {
  ["Trends" /* TRENDS */]: {
    backgroundColor: "#66AAF9",
    icon: /* @__PURE__ */ react_exports.createElement(ChartLine_default, { style: chipIconStyles })
  },
  ["Comparisons" /* COMPARISONS */]: {
    backgroundColor: "#45D4BA",
    icon: /* @__PURE__ */ react_exports.createElement(ChartBar_default, { style: chipIconStyles })
  },
  ["Correlation" /* CORRELATION */]: {
    backgroundColor: "#FB865C",
    icon: /* @__PURE__ */ react_exports.createElement(ChartScatter_default, { style: chipIconStyles })
  },
  ["Spatial" /* SPATIAL */]: {
    backgroundColor: "#E85B79",
    icon: /* @__PURE__ */ react_exports.createElement(ChoroplethMap_default, { style: chipIconStyles })
  },
  ["Flow" /* FLOW */]: {
    backgroundColor: "#9980FF",
    icon: /* @__PURE__ */ react_exports.createElement(SplitBy_default, { style: chipIconStyles })
  }
};
var StyledChip = styled_components_default(Chip_default)`
    [data-test='label'] {
        color: white;
    }
    margin-left: 10px;
    margin-bottom: 10px;
`;
var Variations = ({ variations, variationCode, type }) => /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, variations.map(
  (v) => {
    var _a;
    const variationObj = variationCode[v.key];
    return /* @__PURE__ */ react_exports.createElement(
      DocExampleWithVizSandbox_default,
      __spreadValues({
        hideSandbox: (_a = v.hideSandbox) != null ? _a : false,
        type,
        key: v.key,
        code: variationObj.code,
        example: variationObj.example
      }, v)
    );
  }
));
Variations.propTypes = {
  variations: prop_types_exports.array,
  variationCode: prop_types_exports.object,
  type: prop_types_exports.string
};
var Tip = ({ tip }) => /* @__PURE__ */ react_exports.createElement(List_default.Item, null, tip);
Tip.propTypes = {
  tip: prop_types_exports.string
};
var Tips = ({ tips }) => /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, /* @__PURE__ */ react_exports.createElement(Heading_default, { level: 3 }, "Tips"), /* @__PURE__ */ react_exports.createElement(List_default, null, tips.map(
  (tip) => /* @__PURE__ */ react_exports.createElement(Tip, { key: tip, tip })
)));
Tips.propTypes = {
  tips: prop_types_exports.array
};
var OverviewDoc = (props) => {
  const { typeOfViz, type, overview, tips, variations } = props.overview;
  const { variationCode } = props;
  const vizTypeDisplayNameMap = {
    ["Trends" /* TRENDS */]: "Trend",
    ["Comparisons" /* COMPARISONS */]: "Comparison"
  };
  const vizType = vizTypeDisplayNameMap[typeOfViz] || typeOfViz;
  return /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, vizType && /* @__PURE__ */ react_exports.createElement(react_exports.Fragment, null, "Chart Type", /* @__PURE__ */ react_exports.createElement(
    StyledChip,
    {
      "data-test": "viz-type-chip",
      backgroundColor: chipType[typeOfViz].backgroundColor,
      icon: chipType[typeOfViz].icon
    },
    vizType
  )), /* @__PURE__ */ react_exports.createElement(Paragraph_default, { "data-test": "overview-description" }, overview), /* @__PURE__ */ react_exports.createElement(Tips, { "data-test": "tips", tips }), variationCode && /* @__PURE__ */ react_exports.createElement(Variations, { variations, type, variationCode }));
};
OverviewDoc.propTypes = {
  overview: prop_types_exports.object,
  variationCode: prop_types_exports.object
};
var OverviewDoc_default = OverviewDoc;
//# sourceMappingURL=OverviewDoc.js.map
