/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/utils/mapUtils.ts
var mapUtils_exports = {};
__export(mapUtils_exports, {
  columnsNullToZeros: () => columnsNullToZeros
});
module.exports = __toCommonJS(mapUtils_exports);

// esm-externals:@splunk/visualization-encoding/utils/types
var types_exports = {};
__export(types_exports, {
  default: () => types_default
});
var defaultImport = __toESM(require("@splunk/visualization-encoding/utils/types"));
__reExport(types_exports, require("@splunk/visualization-encoding/utils/types"));
var types_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-encoding/utils/dsl
var dsl_exports = {};
__export(dsl_exports, {
  default: () => dsl_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-encoding/utils/dsl"));
__reExport(dsl_exports, require("@splunk/visualization-encoding/utils/dsl"));
var dsl_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualizations-shared/hocUtils
var hocUtils_exports = {};
__export(hocUtils_exports, {
  default: () => hocUtils_default
});
var defaultImport3 = __toESM(require("@splunk/visualizations-shared/hocUtils"));
__reExport(hocUtils_exports, require("@splunk/visualizations-shared/hocUtils"));
var hocUtils_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualizations-shared/JSONSchemaUtils
var JSONSchemaUtils_exports = {};
__export(JSONSchemaUtils_exports, {
  default: () => JSONSchemaUtils_default
});
var defaultImport4 = __toESM(require("@splunk/visualizations-shared/JSONSchemaUtils"));
__reExport(JSONSchemaUtils_exports, require("@splunk/visualizations-shared/JSONSchemaUtils"));
var JSONSchemaUtils_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport5 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport6 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport7 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualizations-shared/iconUtils
var iconUtils_exports = {};
__export(iconUtils_exports, {
  default: () => iconUtils_default
});
var defaultImport8 = __toESM(require("@splunk/visualizations-shared/iconUtils"));
__reExport(iconUtils_exports, require("@splunk/visualizations-shared/iconUtils"));
var iconUtils_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/visualizations-shared/colorUtils
var colorUtils_exports = {};
__export(colorUtils_exports, {
  default: () => colorUtils_default
});
var defaultImport9 = __toESM(require("@splunk/visualizations-shared/colorUtils"));
__reExport(colorUtils_exports, require("@splunk/visualizations-shared/colorUtils"));
var colorUtils_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/visualizations-shared/RemoteIcon
var RemoteIcon_exports = {};
__export(RemoteIcon_exports, {
  default: () => RemoteIcon_default
});
var defaultImport10 = __toESM(require("@splunk/visualizations-shared/RemoteIcon"));
__reExport(RemoteIcon_exports, require("@splunk/visualizations-shared/RemoteIcon"));
var RemoteIcon_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// esm-externals:@splunk/visualization-context/FeatureFlagContext
var FeatureFlagContext_exports = {};
__export(FeatureFlagContext_exports, {
  default: () => FeatureFlagContext_default
});
var defaultImport11 = __toESM(require("@splunk/visualization-context/FeatureFlagContext"));
__reExport(FeatureFlagContext_exports, require("@splunk/visualization-context/FeatureFlagContext"));
var FeatureFlagContext_default = "default" in defaultImport11 ? defaultImport11.default : defaultImport11;

// esm-externals:d3-scale
var d3_scale_exports = {};
__export(d3_scale_exports, {
  default: () => d3_scale_default
});
var defaultImport12 = __toESM(require("d3-scale"));
__reExport(d3_scale_exports, require("d3-scale"));
var d3_scale_default = "default" in defaultImport12 ? defaultImport12.default : defaultImport12;

// esm-externals:chroma-js
var chroma_js_exports = {};
__export(chroma_js_exports, {
  default: () => chroma_js_default
});
var defaultImport13 = __toESM(require("chroma-js"));
__reExport(chroma_js_exports, require("chroma-js"));
var chroma_js_default = "default" in defaultImport13 ? defaultImport13.default : defaultImport13;

// esm-externals:@splunk/visualization-color-palettes
var visualization_color_palettes_exports = {};
__export(visualization_color_palettes_exports, {
  default: () => visualization_color_palettes_default
});
var defaultImport14 = __toESM(require("@splunk/visualization-color-palettes"));
__reExport(visualization_color_palettes_exports, require("@splunk/visualization-color-palettes"));
var visualization_color_palettes_default = "default" in defaultImport14 ? defaultImport14.default : defaultImport14;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport15 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport15 ? defaultImport15.default : defaultImport15;

// src/Map/PureMap/MapUtils.ts
var MIN_BUBBLE_RADIUS = 7.11;
var MAX_BUBBLE_RADIUS = 45.26;
var matchBubbleSize = (dataRange, data) => {
  const size = (0, d3_scale_exports.scalePow)().exponent(0.2).domain(dataRange).range([MIN_BUBBLE_RADIUS, MAX_BUBBLE_RADIUS])(
    data
  );
  if (size > MAX_BUBBLE_RADIUS) {
    return MAX_BUBBLE_RADIUS;
  }
  if (size < MIN_BUBBLE_RADIUS) {
    return MIN_BUBBLE_RADIUS;
  }
  return size;
};

// esm-externals:maplibre-gl
var maplibre_gl_exports = {};
__export(maplibre_gl_exports, {
  default: () => maplibre_gl_default
});
var defaultImport16 = __toESM(require("maplibre-gl"));
__reExport(maplibre_gl_exports, require("maplibre-gl"));
var maplibre_gl_default = "default" in defaultImport16 ? defaultImport16.default : defaultImport16;

// esm-externals:@splunk/react-ui/Popover
var Popover_exports = {};
__export(Popover_exports, {
  default: () => Popover_default
});
var defaultImport17 = __toESM(require("@splunk/react-ui/Popover"));
__reExport(Popover_exports, require("@splunk/react-ui/Popover"));
var Popover_default = "default" in defaultImport17 ? defaultImport17.default : defaultImport17;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport18 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport18 ? defaultImport18.default : defaultImport18;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport19 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport19 ? defaultImport19.default : defaultImport19;

// src/Map/PureMap/Tooltip.tsx
var StyledPopover = styled_components_default(Popover_default)`
    width: 250px;
    font-size: 12px;
`;
var StyledTable = styled_components_default.table`
    margin: 2px 6px 2px 6px;
    table-layout: fixed;
    width: calc(100% - 12px);
`;
var StyledTitleColumn = styled_components_default.td`
    opacity: 0.85;
`;
var StyledValueColumn = styled_components_default.td`
    text-align: right;
`;
var StyledColorBlock = styled_components_default.div`
    background-color: ${(props) => props.color};
    display: inline-block;
    margin-right: 4px;
    border-radius: 2px;
    width: 6px;
    height: 11px;
    transform: translateY(1px);
`;
var StyledFieldLabel = styled_components_default.span`
    display: inline-block;
    white-space: nowrap;
`;
var StyledIconWrapper = styled_components_default.span`
    margin-left: 4px;
    display: inline-block;
    vertical-align: middle;
`;
var StyledTooltipHeader = styled_components_default.thead`
    th {
        height: 16px;
        color: ${themes_exports.variables.contentColorActive};
        padding: 0;
    }

    span {
        display: block;
        white-space: nowrap;
        overflow: hidden;
        text-overflow: ellipsis;
        width: 100%;
    }
`;
var convertDegToDMS = (decimalDegree, type) => {
  const truncate = (n) => n > 0 ? Math.floor(n) : Math.ceil(n);
  const absoluteDegree = Math.abs(decimalDegree);
  let degrees = truncate(absoluteDegree);
  let minutes = truncate((absoluteDegree - degrees) * 60);
  let seconds = Math.round((absoluteDegree - degrees - minutes / 60) * 3600);
  if (seconds === 60) {
    minutes += 1;
    seconds = 0;
  }
  if (minutes === 60) {
    degrees += 1;
    minutes = 0;
  }
  let direction;
  if (type === "longitude") {
    direction = decimalDegree < 0 ? "W" : "E";
  } else if (type === "latitude") {
    direction = decimalDegree < 0 ? "S" : "N";
  }
  return `${degrees}\xB0 ${minutes}' ${seconds}" ${direction}`;
};
var Tooltip = ({
  open,
  anchor,
  latitude,
  longitude,
  areaId,
  areaValue,
  additionalFields = [],
  showCoordinates = true,
  tooltipHeader = null
}) => {
  const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
  const isTooltipIconFlagEnabled = Boolean(
    featureFlagContext && featureFlagContext.visualizations_enableTooltipIcon
  );
  return /* @__PURE__ */ react_exports.createElement(
    StyledPopover,
    {
      open,
      animation: false,
      anchor,
      "data-test": "map-marker-tooltip",
      defaultPlacement: "above"
    },
    /* @__PURE__ */ react_exports.createElement(StyledTable, null, tooltipHeader && /* @__PURE__ */ react_exports.createElement(StyledTooltipHeader, { "data-test": "tooltip-header" }, /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement("th", { colSpan: 2 }, /* @__PURE__ */ react_exports.createElement("span", { "data-test": "tooltip-header-value" }, tooltipHeader)))), /* @__PURE__ */ react_exports.createElement("tbody", null, areaId && areaValue && /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, { "data-test": "area-id" }, areaId), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "area-value" }, areaValue)), Boolean(showCoordinates && latitude) && /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, null, (0, i18n_exports._)("Latitude")), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "latitude" }, convertDegToDMS(latitude, "latitude"))), Boolean(showCoordinates && longitude) && /* @__PURE__ */ react_exports.createElement("tr", null, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, null, (0, i18n_exports._)("Longitude")), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "longitude" }, convertDegToDMS(longitude, "longitude"))), additionalFields.filter(({ value }) => value && String(value) !== "0").map(({ name, value, color, icon }, index) => /* @__PURE__ */ react_exports.createElement("tr", { key: String(index) }, /* @__PURE__ */ react_exports.createElement(StyledTitleColumn, { "data-test": "field-title" }, color ? /* @__PURE__ */ react_exports.createElement(StyledColorBlock, { "data-test": "field-color", color }) : null, /* @__PURE__ */ react_exports.createElement(StyledFieldLabel, null, name, isTooltipIconFlagEnabled && icon && ((0, iconUtils_exports.isRemoteIcon)(icon) || (0, iconUtils_exports.isDataURI)(icon)) ? /* @__PURE__ */ react_exports.createElement(StyledIconWrapper, { "data-test": "field-icon" }, /* @__PURE__ */ react_exports.createElement(RemoteIcon_default, { iconURL: icon, width: 16, height: 16 })) : null)), /* @__PURE__ */ react_exports.createElement(StyledValueColumn, { "data-test": "field-value" }, value)))))
  );
};
var Tooltip_default = Tooltip;

// src/Map/PureMap/MarkerWrapper.tsx
var MarkerWrapper = (_a) => {
  var _b = _a, {
    longitude,
    latitude,
    areaId,
    areaValue,
    additionalFields = [],
    tooltipHeader = null,
    map,
    isChoroplethTooltipOpen,
    children,
    showCoordinates = true
  } = _b, otherProps = __objRest(_b, [
    "longitude",
    "latitude",
    "areaId",
    "areaValue",
    "additionalFields",
    "tooltipHeader",
    "map",
    "isChoroplethTooltipOpen",
    "children",
    "showCoordinates"
  ]);
  const container = react_exports.useRef();
  const marker = react_exports.useRef();
  const [isTooltipOpen, setTooltipOpenStatus] = react_exports.useState(false);
  const isChoroplethTooltip = react_exports.useCallback(() => isChoroplethTooltipOpen !== void 0, [
    isChoroplethTooltipOpen
  ]);
  const openTooltip = react_exports.useCallback(() => setTooltipOpenStatus(true), []);
  const closeTooltip = react_exports.useCallback(() => setTooltipOpenStatus(false), []);
  const cleanupMarker = react_exports.useCallback(() => {
    if (marker.current) {
      marker.current.remove();
      marker.current = void 0;
    }
  }, []);
  react_exports.useEffect(() => {
    try {
      if (marker.current) {
        marker.current.setLngLat([longitude, latitude]);
      } else {
        marker.current = new maplibre_gl_exports.Marker({ element: container.current });
        marker.current.setLngLat([longitude, latitude]);
        marker.current.addTo(map.current);
      }
    } catch (error) {
      console.error(error);
      cleanupMarker();
    }
  }, [latitude, longitude, map]);
  react_exports.useEffect(() => cleanupMarker, []);
  const filteredAdditionalFields = additionalFields.filter(({ value }) => value && String(value) !== "0");
  const showTooltip = showCoordinates || filteredAdditionalFields.length || areaId && areaValue;
  return /* @__PURE__ */ react_exports.createElement("div", { style: { visibility: isChoroplethTooltip() ? "hidden" : "visible" } }, /* @__PURE__ */ react_exports.createElement(
    "div",
    __spreadValues({
      style: { visibility: isChoroplethTooltip() ? "hidden" : "visible" },
      ref: container,
      "data-test": "map-marker",
      onMouseOver: openTooltip,
      onMouseLeave: closeTooltip,
      onFocus: openTooltip,
      onBlur: closeTooltip
    }, otherProps),
    children
  ), /* @__PURE__ */ react_exports.createElement("div", null, showTooltip && /* @__PURE__ */ react_exports.createElement(
    Tooltip_default,
    {
      open: isChoroplethTooltip() ? isChoroplethTooltipOpen : isTooltipOpen,
      anchor: container.current,
      latitude: isChoroplethTooltip() ? null : latitude,
      longitude: isChoroplethTooltip() ? null : longitude,
      areaId,
      areaValue,
      additionalFields,
      showCoordinates,
      tooltipHeader
    }
  )));
};
var MarkerWrapper_default = MarkerWrapper;

// src/Map/PureMap/BubbleLayer.tsx
var GEO_LAT_AND_LONG_FIELD = ["_geo_long_field", "_geo_lat_field"];
var ICON_DISPLAY_CUTOFF = 16;
var PieSegment = react_exports.memo(
  ({
    start,
    end,
    radius,
    color,
    themeColor,
    segmentMetadata,
    handleBubbleClick
  }) => {
    const { name, value } = segmentMetadata != null ? segmentMetadata : {};
    const handleSegmentClick = react_exports.useCallback(
      (e) => {
        handleBubbleClick(e, name, value);
      },
      [name, value, handleBubbleClick]
    );
    if (end - start === 1) {
      return /* @__PURE__ */ react_exports.createElement(
        "circle",
        {
          onClick: handleSegmentClick,
          cx: radius,
          cy: radius,
          r: radius,
          fill: color,
          fillOpacity: 0.5,
          strokeWidth: 1.5,
          stroke: color
        }
      );
    }
    const a0 = 2 * Math.PI * (start - 0.25);
    const a1 = 2 * Math.PI * (end - 0.25);
    const x0 = Math.cos(a0);
    const y0 = Math.sin(a0);
    const x1 = Math.cos(a1);
    const y1 = Math.sin(a1);
    const arc = end - start > 0.5 ? 1 : 0;
    return /* @__PURE__ */ react_exports.createElement(
      "path",
      {
        onClick: handleSegmentClick,
        d: `M ${radius} ${radius} L ${radius + radius * x0} ${radius + radius * y0} A ${radius} ${radius} 0 ${arc} 1 ${radius + radius * x1} ${radius + radius * y1} L ${radius} ${radius} A 0 0 0 ${arc} 0 ${radius} ${radius}`,
        fill: color,
        fillOpacity: 0.8,
        stroke: themeColor,
        strokeWidth: 2,
        strokeOpacity: 0.3
      }
    );
  }
);
PieSegment.displayName = "MapBubblePieSegment";
var StyledMarkerWrapper = styled_components_default(MarkerWrapper_default)`
    cursor: pointer;
`;
var Bubble = react_exports.memo(
  ({
    originalValues,
    valueRange,
    colors,
    themeColor,
    isPie,
    latitude,
    longitude,
    bubbleSize,
    additionalFields = [],
    tooltipHeader = null,
    map,
    handleMapClick,
    icon,
    showCoordinates
  }) => {
    const featureFlagContext = react_exports.useContext(FeatureFlagContext_default);
    const isBubbleMapIconFlagEnabled = Boolean(
      featureFlagContext && featureFlagContext.visualizations_enableBubbleMapIcon
    );
    const onBubbleClick = react_exports.useCallback(
      (e, name, value) => {
        handleMapClick(e, name, value);
        e.stopPropagation();
      },
      [handleMapClick]
    );
    const allZeros = originalValues.every((v) => v === 0);
    const values = originalValues.map((v) => v > 0 ? v : 0);
    const total = values.reduce((totalValue, v) => totalValue + v, 0);
    const radius = matchBubbleSize(valueRange, total);
    const bubble = react_exports.useMemo(() => {
      if (allZeros || !originalValues.length) return null;
      const offsets = [];
      let runningTotal = 0;
      values.forEach((count) => {
        offsets.push(runningTotal);
        runningTotal += count;
      });
      const width = radius * 2;
      return /* @__PURE__ */ react_exports.createElement("svg", { width, height: width, viewBox: `-3 -3 ${width + 6} ${width + 6}` }, isPie && /* @__PURE__ */ react_exports.createElement(
        "circle",
        {
          cx: radius,
          cy: radius,
          r: radius,
          fill: "none",
          strokeWidth: 2,
          stroke: themeColor,
          strokeOpacity: 0.3
        }
      ), values.map((v, i) => /* @__PURE__ */ react_exports.createElement(
        PieSegment,
        {
          key: String(i),
          start: offsets[i] / total,
          end: (offsets[i] + v) / total,
          radius,
          color: colors[i],
          themeColor,
          segmentMetadata: bubbleSize[i],
          handleBubbleClick: onBubbleClick
        }
      )));
    }, [
      bubbleSize,
      colors,
      isPie,
      onBubbleClick,
      originalValues,
      themeColor,
      allZeros,
      radius,
      total,
      values
    ]);
    if (!bubble) {
      return null;
    }
    return /* @__PURE__ */ react_exports.createElement(
      StyledMarkerWrapper,
      {
        longitude,
        latitude,
        additionalFields: [...bubbleSize, ...additionalFields],
        tooltipHeader,
        map,
        "data-test-type": "bubble",
        showCoordinates
      },
      bubble,
      isBubbleMapIconFlagEnabled && radius >= ICON_DISPLAY_CUTOFF && icon && ((0, iconUtils_exports.isRemoteIcon)(icon) || (0, iconUtils_exports.isDataURI)(icon)) && /* @__PURE__ */ react_exports.createElement(
        "div",
        {
          "data-test": "bubble-icon-wrapper",
          style: {
            position: "absolute",
            top: `${radius}px`,
            left: `${radius}px`,
            transform: "translate(-50%, -50%)",
            pointerEvents: "none"
          }
        },
        /* @__PURE__ */ react_exports.createElement(RemoteIcon_default, { iconURL: icon, width: radius * 0.8, height: radius * 0.8 })
      )
    );
  }
);
Bubble.displayName = "MapBubble";

// src/common/utils/mapUtils.ts
var columnsNullToZeros = (config, dataSources, options) => {
  var _a, _b;
  const { primary } = dataSources;
  const { columns, fields } = primary.data;
  let newColumns = columns;
  const mergedOptions = (0, hocUtils_exports.deepMergeWithArrayPrimitiveOverrides)(
    {},
    options,
    (0, JSONSchemaUtils_exports.pickFieldFromJSONSchema)(config.optionsSchema, "default")
  );
  if (((_b = (_a = mergedOptions.layers) == null ? void 0 : _a[0]) == null ? void 0 : _b.type) === "bubble") {
    const latitudeField = (0, dsl_exports.getFieldsFromDSL)(mergedOptions.layers[0].latitude, dataSources)[0] || "";
    const longitudeField = (0, dsl_exports.getFieldsFromDSL)(mergedOptions.layers[0].longitude, dataSources)[0] || "";
    const stringsFields = (0, dsl_exports.getFieldsFromDSL)("> primary | frameBySeriesTypes('string')", dataSources);
    const excludedFields = Array.from(
      /* @__PURE__ */ new Set([
        latitudeField,
        longitudeField,
        "geobin",
        "name",
        ...stringsFields,
        ...GEO_LAT_AND_LONG_FIELD
      ])
    );
    const indicesToEvaluate = new Set(
      fields.reduce((arr, e, i) => {
        const field = typeof e === "string" ? e : e.name.toString();
        if (!excludedFields.includes(field)) {
          arr.push(i);
        }
        return arr;
      }, [])
    );
    newColumns = columns.map((column, i) => {
      if (indicesToEvaluate.has(i)) {
        return column.map((value) => !value || !(0, types_exports.isNumber)(value) ? 0 : +value);
      }
      return column;
    });
  }
  const modifiedDatasources = __spreadProps(__spreadValues({}, dataSources), {
    primary: __spreadProps(__spreadValues({}, primary), {
      data: __spreadProps(__spreadValues({}, primary.data), {
        columns: newColumns
      })
    })
  });
  return modifiedDatasources;
};
//# sourceMappingURL=mapUtils.js.map
