/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/utils/singleValueUtils.js
var singleValueUtils_exports = {};
__export(singleValueUtils_exports, {
  DEFAULT_FONT: () => DEFAULT_FONT,
  DEFAULT_FONT_FAMILY: () => DEFAULT_FONT_FAMILY,
  SVR_PADDING: () => SVR_PADDING,
  adjustRGB: () => adjustRGB,
  computeColors: () => computeColors,
  computeFontSize: () => computeFontSize,
  computeSingleValueContent: () => computeSingleValueContent,
  computeSingleValueRadialContent: () => computeSingleValueRadialContent,
  computeText: () => computeText,
  darken: () => darken,
  getAligment: () => getAligment,
  getDefaultColorWithBg: () => getDefaultColorWithBg,
  getFormattedColor: () => getFormattedColor,
  getGraphColors: () => getGraphColors,
  getMajorAndTrend: () => getMajorAndTrend,
  getMajorColor: () => getMajorColor,
  getMajorFontSize: () => getMajorFontSize,
  getMajorText: () => getMajorText,
  getTrendColor: () => getTrendColor,
  getTrendColorWithPercent: () => getTrendColorWithPercent,
  getTrendFontSize: () => getTrendFontSize,
  getTrendText: () => getTrendText,
  getUnderLabel: () => getUnderLabel,
  getUnderLabelHeight: () => getUnderLabelHeight,
  handleValueClickCallback: () => handleValueClickCallback,
  hasBackground: () => hasBackground,
  isIdenticalColor: () => isIdenticalColor,
  isLoadingOrNoColumns: () => isLoadingOrNoColumns,
  lighten: () => lighten,
  minimallyTruncateStringToWidth: () => minimallyTruncateStringToWidth,
  shouldShowTrend: () => shouldShowTrend,
  updateVizInSmallSpace: () => updateVizInSmallSpace
});
module.exports = __toCommonJS(singleValueUtils_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport2 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualizations-shared/domUtils
var domUtils_exports = {};
__export(domUtils_exports, {
  default: () => domUtils_default
});
var defaultImport3 = __toESM(require("@splunk/visualizations-shared/domUtils"));
__reExport(domUtils_exports, require("@splunk/visualizations-shared/domUtils"));
var domUtils_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualizations-shared/propUtils
var propUtils_exports = {};
__export(propUtils_exports, {
  default: () => propUtils_default
});
var defaultImport4 = __toESM(require("@splunk/visualizations-shared/propUtils"));
__reExport(propUtils_exports, require("@splunk/visualizations-shared/propUtils"));
var propUtils_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport5 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// src/common/utils/singleValueUtils.js
var DEFAULT_FONT = 12;
var DEFAULT_FONT_FAMILY = '"Splunk Platform Sans", "Proxima Nova", "Helvetica Neue", Helvetica, Arial, sans-serif';
var SVR_PADDING = { top: 12, bottom: 12, left: 16, right: 16 };
var getAligment = (align) => {
  const alignMap = {
    left: "start",
    center: "center",
    right: "end"
  };
  return alignMap[align] || "center";
};
var shouldShowTrend = (trendDisplay) => trendDisplay === "absolute" || trendDisplay === "percent";
var isLoadingOrNoColumns = (dataSources, loading) => {
  const data = (0, lodash_exports.get)(dataSources, "primary.data.columns[0]", void 0);
  const noColumns = data === void 0;
  return loading || noColumns;
};
var getFormattedColor = (color, defaultColor) => (0, propUtils_exports.formatColor)(color) || (0, propUtils_exports.formatColor)(defaultColor);
var hasBackground = (backgroundColor) => !!backgroundColor && backgroundColor !== "transparent";
var isIdenticalColor = (colorA, colorB) => !!colorA && !!colorB && (0, propUtils_exports.formatColor)(colorA.toLowerCase()) === (0, propUtils_exports.formatColor)(colorB.toLowerCase());
var getDefaultColorWithBg = ({ backgroundColor, defaultFontColor, defaultBlockFontColor }) => isIdenticalColor(backgroundColor, defaultBlockFontColor) ? defaultFontColor : defaultBlockFontColor;
var getMajorColor = ({ majorColor, backgroundColor, defaultFontColor, defaultBlockFontColor }) => {
  if (hasBackground(backgroundColor) && !majorColor) {
    return getDefaultColorWithBg({
      backgroundColor,
      defaultFontColor,
      defaultBlockFontColor
    });
  }
  return getFormattedColor(majorColor, defaultFontColor);
};
var getTrendColor = ({
  trendColor,
  trendValue,
  majorValue,
  customizedBgColor,
  trendDisplay,
  defaultColors
}) => {
  if (trendColor) {
    return trendColor;
  }
  if (Number.isNaN(Number(trendValue))) {
    return void 0;
  }
  const { defaultFontColor, defaultBlockFontColor, defaultBackgroundColor } = defaultColors;
  if (hasBackground(customizedBgColor) && !isIdenticalColor(customizedBgColor, defaultBackgroundColor) && !isIdenticalColor(customizedBgColor, defaultBlockFontColor)) {
    return defaultBlockFontColor;
  }
  const isInvalidTrend = trendDisplay === "percent" && trendValue === parseFloat(majorValue);
  if (trendValue === 0 || isInvalidTrend) {
    return defaultFontColor;
  }
  return trendValue > 0 ? colorConstants_exports.DELTA_GREEN : colorConstants_exports.DELTA_RED;
};
var computeColors = (props, defaultColors) => {
  const backgroundColor = getFormattedColor(props.backgroundColor, defaultColors.defaultBackgroundColor);
  const backgroundEnabled = hasBackground(backgroundColor);
  const majorColor = getMajorColor({
    majorColor: props.majorColor,
    backgroundColor,
    defaultFontColor: defaultColors.defaultFontColor,
    defaultBlockFontColor: defaultColors.defaultBlockFontColor
  });
  const trendColor = getTrendColor({
    trendColor: props.trendColor,
    trendValue: props.trendValue,
    majorValue: props.majorValue,
    customizedBgColor: props.backgroundColor,
    trendDisplay: props.trendDisplay,
    defaultColors
  });
  const underLabelColor = majorColor;
  return {
    backgroundColor,
    backgroundEnabled,
    majorColor,
    trendColor,
    underLabelColor
  };
};
var computeText = ({
  value,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateValue
}) => {
  let text = (0, numberUtils_exports.isNumerial)(value) ? (0, numberUtils_exports.formatNumber)(value, numberPrecision, {
    useThousandSeparators: shouldUseThousandSeparators,
    // todo: need update formatNumber
    useTrendUnits: shouldAbbreviateValue
  }) : value;
  text = text || "";
  return text;
};
var getMajorText = ({
  majorValueDisplay,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateMajorValue
}) => computeText({
  value: majorValueDisplay === null ? "N/A" : majorValueDisplay,
  // if majorValueDisplay is null, use `N/A`.
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateValue: shouldAbbreviateMajorValue
});
var getTrendText = ({
  majorValue,
  trendValue,
  trendDisplay,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue
}) => {
  const compute = (value) => computeText({
    value,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateValue: shouldAbbreviateTrendValue
  });
  if (trendValue === "" || !(0, numberUtils_exports.isNumerial)(trendValue)) {
    return "";
  }
  const showPercent = trendDisplay === "percent";
  if (!showPercent) {
    return compute(trendValue);
  }
  const diff = Math.abs(trendValue - majorValue);
  let val = trendValue / diff * 100;
  if (trendValue === 0 && diff === 0) {
    val = 0;
  }
  if (!Number.isFinite(val)) {
    return "N/A";
  }
  const text = compute(val);
  return `${text}%`;
};
var computeFontSize = (text, { width, height }, fontFamily = DEFAULT_FONT_FAMILY, fontWeight = "normal") => {
  const widthInDefaultFont = (0, domUtils_exports.computeTextSize)(text, `${fontWeight} ${DEFAULT_FONT}px ${fontFamily}`);
  const fontSize = Math.min(
    width / widthInDefaultFont * DEFAULT_FONT,
    height / DEFAULT_FONT * DEFAULT_FONT
  );
  return parseInt(fontSize, 10);
};
var getMajorFontSize = ({ width, height, unit, majorText, spaceRatio = 1 }) => {
  const majorTextCalc = unit ? `${unit}${majorText}` : majorText;
  return computeFontSize(majorTextCalc, {
    width: width * spaceRatio,
    height
  });
};
var getTrendFontSize = ({ width, height, trendText, spaceRatio = 1 }) => {
  let trendFontSize = 12;
  if (spaceRatio > 0) {
    trendFontSize = computeFontSize(trendText, {
      width: width * spaceRatio,
      height
    });
    trendFontSize = parseInt(trendFontSize, 10) * spaceRatio;
  }
  return trendFontSize;
};
var getUnderLabelHeight = (height) => height > DEFAULT_FONT ? DEFAULT_FONT : height;
var getUnderLabel = ({ underLabel, width, height }) => (
  // todo: may need truncate underLabel later
  computeFontSize(underLabel, {
    width,
    height
  })
);
var getMajorAndTrend = ({
  width,
  height,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  trendDisplay,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue,
  shouldAbbreviateMajorValue
}) => {
  const majorTextSpaceRatio = (0, numberUtils_exports.isNumerial)(trendValue) && shouldShowTrend(trendDisplay) ? 0.6 : 1;
  const textContentWidth = width * 0.9;
  const textContentHeight = height * 0.9;
  const majorText = getMajorText({
    majorValueDisplay,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateMajorValue
  });
  const majorTextFontSize = majorFontSize || getMajorFontSize({
    width: textContentWidth,
    height: textContentHeight,
    unit,
    majorText,
    spaceRatio: majorTextSpaceRatio
  });
  const trendText = getTrendText({
    majorValue,
    trendValue,
    trendDisplay,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue
  });
  const trendTextFontSize = trendFontSize || getTrendFontSize({
    width: textContentWidth,
    height: textContentHeight,
    trendText,
    spaceRatio: 1 - majorTextSpaceRatio
  });
  return {
    majorText,
    majorTextFontSize,
    trendText,
    trendTextFontSize
  };
};
var updateVizInSmallSpace = ({
  width,
  height,
  toRemoveList,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  majorTextFontSize,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue
}) => {
  let removeIndex = 0;
  let newProps = {};
  let newMajorAndTrend = {};
  let newTextSize = majorTextFontSize;
  while (newTextSize < 12 && removeIndex < toRemoveList.length) {
    const toRemove = toRemoveList[removeIndex];
    newProps = __spreadValues(__spreadValues({}, newProps), {
      [toRemove.key]: toRemove.value
    });
    newMajorAndTrend = getMajorAndTrend(__spreadValues({
      majorValue,
      majorValueDisplay,
      trendValue,
      majorFontSize,
      trendFontSize,
      width,
      height,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue
    }, newProps));
    newTextSize = newMajorAndTrend.majorTextFontSize;
    removeIndex += 1;
  }
  if (newTextSize < 12) {
    const truncateValue = `${(majorValueDisplay || majorValue).toString().slice(0, 3)}...`;
    newMajorAndTrend = getMajorAndTrend(__spreadValues({
      majorValue,
      majorValueDisplay: truncateValue,
      trendValue,
      majorFontSize,
      trendFontSize,
      width,
      height,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue
    }, newProps));
  }
  return { newMajorAndTrend, updatedProps: newProps };
};
var computeSingleValueContent = ({
  contentWidth,
  contentHeight,
  containerWidth,
  containerHeight,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  trendDisplay,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue,
  shouldAbbreviateMajorValue,
  toRemoveList
}) => {
  let { majorText, trendText, majorTextFontSize, trendTextFontSize } = getMajorAndTrend({
    majorValue,
    majorValueDisplay: majorValueDisplay || majorValue,
    trendValue,
    majorFontSize,
    trendFontSize,
    trendDisplay,
    width: contentWidth,
    height: contentHeight,
    unit,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue,
    shouldAbbreviateMajorValue
  });
  const majorValueTitle = majorText;
  let smallVizProps = {};
  if (majorTextFontSize < 12) {
    const { newMajorAndTrend, updatedProps } = updateVizInSmallSpace({
      width: containerWidth,
      height: containerHeight,
      toRemoveList,
      majorValue,
      majorValueDisplay: majorValueDisplay || majorValue,
      trendValue,
      majorFontSize,
      trendFontSize,
      majorTextFontSize,
      unit,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue
    });
    ({ majorText, trendText, majorTextFontSize, trendTextFontSize } = newMajorAndTrend);
    smallVizProps = updatedProps;
  }
  return {
    majorText,
    trendText,
    majorTextFontSize,
    trendTextFontSize,
    majorValueTitle,
    smallVizProps
  };
};
var minimallyTruncateStringToWidth = ({
  text,
  fontSize = DEFAULT_FONT,
  fontFamily = DEFAULT_FONT_FAMILY,
  fontWeight = "normal",
  containerWidth
}) => {
  let textWidth = (0, domUtils_exports.computeTextSize)(text, `${fontWeight} ${fontSize}px ${fontFamily}`);
  let modifiedText = text;
  const ellipsesLength = (0, domUtils_exports.computeTextSize)("...", `${fontWeight} ${fontSize}px ${fontFamily}`);
  if (containerWidth - ellipsesLength > 0 && textWidth > containerWidth) {
    while (textWidth + ellipsesLength > containerWidth && modifiedText.length > 1) {
      modifiedText = modifiedText.substring(0, modifiedText.length - 1);
      textWidth = (0, domUtils_exports.computeTextSize)(modifiedText, `normal ${fontSize}px ${fontFamily}`);
    }
    modifiedText = `${modifiedText}...`;
  }
  return modifiedText;
};
var computeSingleValueRadialContent = ({
  contentWidth,
  contentHeight,
  containerWidth,
  containerHeight,
  majorValue,
  majorValueDisplay,
  trendValue,
  majorFontSize,
  trendFontSize,
  trendDisplay,
  unit,
  numberPrecision,
  shouldUseThousandSeparators,
  shouldAbbreviateTrendValue,
  shouldAbbreviateMajorValue,
  smallViz
}) => {
  let { majorText, trendText, majorTextFontSize, trendTextFontSize } = getMajorAndTrend({
    majorValue,
    majorValueDisplay: majorValueDisplay || majorValue,
    trendValue,
    majorFontSize,
    trendFontSize,
    trendDisplay,
    width: contentWidth,
    height: contentHeight,
    unit,
    numberPrecision,
    shouldUseThousandSeparators,
    shouldAbbreviateTrendValue,
    shouldAbbreviateMajorValue
  });
  const majorValueTitle = majorText;
  let smallVizProps = {};
  if (smallViz) {
    const truncateValue = minimallyTruncateStringToWidth({
      text: majorValueDisplay || majorValue,
      fontWeight: "bold",
      fontSize: 12,
      containerWidth
    });
    ({ majorText, trendText, majorTextFontSize, trendTextFontSize } = getMajorAndTrend({
      majorValueDisplay: truncateValue,
      majorValue,
      trendValue,
      majorFontSize,
      trendFontSize,
      width: containerWidth,
      height: containerHeight,
      unit,
      trendDisplay,
      numberPrecision,
      shouldUseThousandSeparators,
      shouldAbbreviateTrendValue,
      shouldAbbreviateMajorValue
    }));
    smallVizProps = {
      trendDisplay,
      unit
    };
  }
  return {
    majorText,
    trendText,
    majorTextFontSize,
    trendTextFontSize,
    majorValueTitle,
    smallVizProps
  };
};
var getGraphColors = ({
  backgroundEnabled,
  backgroundColor,
  defaultColors,
  customColorFormatter
}) => {
  if (backgroundEnabled) {
    if (backgroundColor && typeof customColorFormatter === "function") {
      return customColorFormatter(backgroundColor);
    }
  }
  return defaultColors.none;
};
var adjustRGB = (rgb, delta) => {
  if (rgb === 255) {
    return rgb - delta;
  }
  if (rgb === 0) {
    return rgb + delta;
  }
  return rgb;
};
var changeColor = (color, ratio) => {
  const hex = color.replace(/(0x|#)/, "");
  const r = parseInt(hex.substr(0, 2), 16);
  const g = parseInt(hex.substr(2, 2), 16);
  const b = parseInt(hex.substr(4, 2), 16);
  let newR = Math.max(Math.min(Math.floor(r * ratio), 255), 0);
  let newG = Math.max(Math.min(Math.floor(g * ratio), 255), 0);
  let newB = Math.max(Math.min(Math.floor(b * ratio), 255), 0);
  if (newR === r && newG === g && newB === b) {
    if (newR === 0 && newG === 0 && newB === 0) {
      if (ratio > 1) {
        newR = adjustRGB(newR, 80);
        newG = adjustRGB(newG, 80);
        newB = adjustRGB(newB, 80);
      } else {
        newR = adjustRGB(newR, 40);
        newG = adjustRGB(newG, 40);
        newB = adjustRGB(newB, 40);
      }
    } else if (newR === 255 && newG === 255 && newB === 255) {
      if (ratio > 1) {
        newR = adjustRGB(newR, 20);
        newG = adjustRGB(newG, 20);
        newB = adjustRGB(newB, 20);
      } else {
        newR = adjustRGB(newR, 80);
        newG = adjustRGB(newG, 80);
        newB = adjustRGB(newB, 80);
      }
    } else {
      newR = adjustRGB(newR, 20);
      newG = adjustRGB(newG, 20);
      newB = adjustRGB(newB, 20);
    }
  }
  return `#${newR.toString(16).padStart(2, 0)}${newG.toString(16).padStart(2, 0)}${newB.toString(16).padStart(2, 0)}`;
};
var lighten = (color) => changeColor(color, 1.3);
var darken = (color) => changeColor(color, 0.5);
var handleValueClickCallback = (ev, majorValue, majorValueField, trendValue, onValueClick, trellisEnabled = false, trellisSplitBy = "", trellisKey = "") => onValueClick(__spreadProps(__spreadValues({}, ev), {
  payload: __spreadValues({
    trendValue,
    value: majorValue,
    name: majorValueField
  }, trellisEnabled && { "trellis.name": trellisSplitBy, "trellis.value": trellisKey })
}));
var getTrendColorWithPercent = (options) => {
  const shouldUsePercentTrendColor = options.trendColor === "> trendValue | rangeValue(trendColorEditorConfig)" && options.trendDisplay === "percent";
  return shouldUsePercentTrendColor ? { trendColor: "> trendValuePercent | rangeValue(trendColorEditorConfig)" } : {};
};
//# sourceMappingURL=singleValueUtils.js.map
